/* commands.c */
/* implementation of most of the character commands */

#include "boss.h"
#include "main.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void move_char(integer dir)
{
  /*{ Moves player from one space to another. }*/

  integer  test_row,test_col;
  integer  i1,i2;

  test_row = char_row;
  test_col = char_col;

  if (py.flags.confused > 0) {   /*{ Confused? }*/
    if (randint(4) > 1) {  /*{ 75% random movement }*/
      if (dir != 5) {   /*{ Never random if sitting}*/
	dir = randint(9);
	find_flag = false;
      }
    }
  }

  if (move_dir(dir,&test_row,&test_col)) {   /*{ Legal move?           }*/
    //with cave[test_row][test_col] do;
    if (cave[test_row][test_col].cptr < 2) { /*{ No creature?          }*/
      if (cave[test_row][test_col].fopen) {  /*{ Open floor spot       }*/
	if ((find_flag) &&
	    ((is_in(cave[char_row][char_col].fval,earth_set)) ==
	     (is_in(cave[test_row][test_col].fval,water_set)))) {
	  /* switching between water and dirt stops running */
	  find_flag = false;
	  move_char(5);
	} else {
	  
	  /*{ Move character record (-1)            }*/
	  move_rec(char_row,char_col,test_row,test_col);
	  /*{ Check for new panel                   }*/
	  if (get_panel(test_row,test_col,false)) {
	    draw_cave();
	  }
	  /*{ Check to see if he should stop        }*/
	  if (find_flag) {
	    area_affect(dir,test_row,test_col);
	  }
	  /*{ Check to see if he notices something  }*/
	  if (py.flags.blind < 1) {
	    if ((randint(200) < xperc()) || (search_flag)) {
	      search(test_row,test_col,py.misc.srh);
	    }
	  }
	  /*{ An object is beneath him...           }*/
	  
	  if (cave[test_row][test_col].tptr > 0) {
	    carry(test_row,test_col);
	  }
	  
	  /*{ Move the light source                 }*/
	  move_light(char_row,char_col,test_row,test_col);
	  
	  /*{ A room of light should be lit...      }*/
	  if (cave[test_row][test_col].fval == lopen_floor.ftval) {
	    if (py.flags.blind < 1) {
	      if (!(cave[test_row][test_col].pl)) {
		light_room(test_row,test_col);
	      }
	    }
	    /*{ In doorway of light-room?             }*/
	  } else if ((cave[test_row][test_col].fval == 5) || 
		     (cave[test_row][test_col].fval == 6)) {
	    if (py.flags.blind < 1) {
	      for (i1=(test_row-1); i1<=(test_row+1); i1++) {
		for (i2=(test_col-1); i2<=(test_col+1); i2++) {
		  if (in_bounds(i1,i2)) {
		    //with cave[i1][i2] do;
		    if (cave[i1][i2].fval == lopen_floor.ftval) {
		      if (!(cave[i1][i2].pl)) {
			light_room(i1,i2);
		      }
		    }
		  }
		}
	      }
	    }
	  }
	  /*{ Make final assignments of char co-ords}*/
	  char_row = test_row;
	  char_col = test_col;
	}	  
      } else {
	/*{ Can't move onto floor space }*/
	/*{ Try a new direction if in find mode   }*/
	if (!(pick_dir(dir))) {
	  if (find_flag) {
	    find_flag = false;
	    move_char(5);
	  } else if (cave[test_row][test_col].tptr > 0) {
	    reset_flag = true;
	    if (t_list[cave[test_row][test_col].tptr].tval == 103/*Rubble*/) {
	      msg_print("There is rubble blocking your way.");
	    }else if (t_list[cave[test_row][test_col].tptr].tval==105/*Closed_door*/){
	      msg_print("There is a closed door blocking your way.");
	    }
	  } else {
	    reset_flag = true;
	  }
	} /* end if pick_dir */
      }
      
    } else {       /*{ Attacking a creature! }*/
      
      if (find_flag) {
	find_flag = false;
	move_light(char_row,char_col,char_row,char_col);
      }
      
      if (py.flags.afraid < 1) {   /*{ Coward?       }*/
	py_attack(test_row,test_col);
      } else {                           /*{ Coward!       }*/
	msg_print("Help! A Monster!!!!!");
      }
      
    } /* end if attacing */
  } /* end if legal move */

  LEAVE("move_char","m");
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void ask_to_quit()
{
  char  yn;

  if (get_com("Quit without saving? (Y/N)", &yn)) {
    switch (yn) {
    case 'y': case 'Y':
      if (total_winner_num > 0) {
	moria_flag = true;
	death = true;
      } else {
	clear_from(1);
	exit_game();
      }
      break;
      
    default:
      break;
    }
  }

  erase_line(1,1);
  put_qio();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void go_up()
{
  /*{ Go up one level }*/
 
  //with cave[char_row][char_col]. do;
  if (cave[char_row][char_col].tptr > 0) {
    if (t_list[cave[char_row][char_col].tptr].tval == 107) {
      dun_level -= t_list[cave[char_row][char_col].tptr].subval;
      if (dun_level < 0) { dun_level = 0; }
      moria_flag = true;
      msg_print("You enter a maze of up staircases.");
      msg_print("You pass through a one-way door.");
    } else {
      msg_print("I see no up staircase here.");
    }
  } else {
    msg_print("I see no up staircase here.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void go_down()
{ 
  /*{ Go down one level }*/

  //with cave[char_row][char_col]. do;
  if (cave[char_row][char_col].tptr > 0) {
    if (t_list[cave[char_row][char_col].tptr].tval == 108) {
      if (dun_level < 0) {
	dun_level++;
	msg_print("You go down the stairs");
      } else {
	dun_level += t_list[cave[char_row][char_col].tptr].subval;
	if (dun_level > townlist[town_num].max_depth) {
	  dun_level = townlist[town_num].max_depth;
	}
	msg_print("You enter a maze of down staircases.");
	msg_print("You pass through a one-way door.");
	  }
      moria_flag = true;
    } else {
      msg_print("I see no down staircase here.");
    }
  } else {
    msg_print("I see no down staircase here.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void openobject()
{
  /*{ Opens a closed door or closed chest.}*/

  integer   y,x,tmp;
  boolean   flag;

  y = char_row;
  x = char_col;

  if (get_dir("Which direction?",&tmp,&tmp,&y,&x)) {
    //with cave[y][x]. do;
    if (cave[y][x].tptr > 0) {
                              /*{ Closed door }*/
      if (t_list[cave[y][x].tptr].tval == 105) {
	//with t_list[cave[y][x].tptr]. do;
	if (t_list[cave[y][x].tptr].p1 > 0) {  /*{ It's locked.}*/
	  //with py.misc. do;
	  tmp = PM.disarm + PM.lev + 2*todis_adj() + int_adj();
	  if (py.flags.confused > 0) {
	    msg_print("You are too confused to pick the lock.");
	  } else if ((tmp-t_list[cave[y][x].tptr].p1) > randint(100)) {
	    py.misc.exp = py.misc.exp + 5;
	    prt_experience();
	    t_list[cave[y][x].tptr].p1 = 0;
	  } else {
	    msg_print("You have not convinced the door to open.");
	  }
	} else if (t_list[cave[y][x].tptr].p1 < 0) {  /*{ It's stuck }*/
	  msg_print("It appears to be stuck.");
	}

	if (t_list[cave[y][x].tptr].p1 == 0) {
	  t_list[cave[y][x].tptr] = door_list[1];
	  cave[y][x].fopen = true;
	  lite_spot(y,x);
	  switch (randint(2)) {
	  case 1: msg_print("Glad to be of service..."); break;
	  case 2: msg_print("Please enjoy your trip through this door.");break;
	  }
	}


	/*{ Open a closed chest.}*/
      } else if (t_list[cave[y][x].tptr].tval == 2) {
	//with py.misc do;
	tmp = PM.disarm + PM.lev + 2*todis_adj() + int_adj();
	//with t_list[cave[y][x].tptr]. do;
	flag = false;
	if (uand(0x00000001,t_list[cave[y][x].tptr].flags) != 0) {
	  if (py.flags.confused > 0) {
	    msg_print("You are too confused to pick the lock.");
	  } else if ((tmp-(2*t_list[cave[y][x].tptr].level)) > randint(100)) {
	    msg_print("You have picked the lock.");
	    flag = true;
	    py.misc.exp = py.misc.exp + t_list[cave[y][x].tptr].level;
	    prt_experience();
	  } else {
	    msg_print("You failed to pick the lock.");
	  }
	} else {
	  flag = true;
	}

	if (flag) {
	  t_list[cave[y][x].tptr].flags &= 0xFFFFFFFE;
	  if (strstr(t_list[cave[y][x].tptr].name, " (")) {
	    *(strstr(t_list[cave[y][x].tptr].name, " (")) = 0;
	  }
	  strcat(t_list[cave[y][x].tptr].name, " (Empty)");
	  known2(t_list[cave[y][x].tptr].name);
	  t_list[cave[y][x].tptr].cost = 0;
	}
	flag = false;

	/*{ Was chest still trapped?  (Snicker) }*/
	if (uand(0x00000001,t_list[cave[y][x].tptr].flags) == 0) {
	  chest_trap(y,x);
	  if (cave[y][x].tptr > 0) {
	    flag = true;
	  }
	}

	/*{ Chest treasure is allocted as if a creature had been killed.}*/
	if (flag) {
	  monster_death(y,x,t_list[cave[y][x].tptr].flags);
	  t_list[cave[y][x].tptr].flags = 0;
	}

      } else {
	msg_print("I do not see anything you can open there.");
      }
    } else {
      msg_print("I do not see anything you can open there.");
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void closeobject()
{
  /*{ Closes an open door.}*/

  integer   y,x,tmp;
  vtype     out_val;

  y = char_row;
  x = char_col;

  if (get_dir("Which direction?",&tmp,&tmp,&y,&x)) {
    //with cave[y][x]. do;
    if (cave[y][x].tptr > 0) {
      if (t_list[cave[y][x].tptr].tval == 104) {
	if (cave[y][x].cptr == 0) {
	  if (t_list[cave[y][x].tptr].p1 == 0) {
	    t_list[cave[y][x].tptr] = door_list[2];
	    cave[y][x].fopen = false;
	    lite_spot(y,x);
	  } else {
	    msg_print("The door appears to be broken.");
	  }
	} else {
	  sprintf(out_val, "The %s is in your way!", 
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	}
      } else {
	msg_print("I do not see anything you can close there.");
      }
    } else {
      msg_print("I do not see anything you can close there.");
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void inven_drop(integer item_val, integer y, integer x)
{
  /*{ Drops an item from inventory to given location }*/

  integer  i1;

  //with cave[y][x]. do;
  if (cave[y][x].tptr > 0) { pusht(cave[y][x].tptr); }
  inven_destroy(item_val);
  popt(&i1);
  t_list[i1] = temporary_slot;
  cave[y][x].tptr = i1;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void drop()
{
  /*{ Drop an object being carried.  Note: Only one object per floor spot.}*/

  integer  com_val;
  boolean  redraw;
  vtype    out_val, out_val2;

  if (inven_ctr > 0) {
    if (get_item(&com_val,"Drop which item?",&redraw,1,inven_ctr)) {
      if (redraw) { draw_cave(); }
      //with cave[char_row][char_col]. do;
      if (cave[char_row][char_col].tptr > 0) {
	msg_print("There is something there already.");
      } else {
	inven_drop(com_val,char_row,char_col);
	objdes(out_val,1,true,'t');
	sprintf(out_val2, "Dropped %s", out_val);
	prt_cur_weight();
	msg_print(out_val2);
      }
      } else if (redraw) {
              draw_cave();
      }
  } else {
    msg_print("You are not carrying anything.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void examine_book()
{
  /*{ Examine a Book }*/

  integer  i1,i3,item_val,tval;
  boolean  redraw = false;
  vtype    out_val;
  obj_set  light_reading = {90,91,92};
  obj_set  class1 = {1,2,7};
  obj_set  class2 = {3,4};
  obj_set  class3 = {5,6};

  if (!(find_range(light_reading,&i1,&i3))) {
    msg_print("You are not carrying any books.");
  } else if (get_item(&item_val,"Browse which book?",&redraw,i1,i3)) {
    //with inventory[item_val]. do;
    tval = inventory[item_val].tval;
    if ((! is_in(py.misc.pskill, class1) ) && (tval == 90)) {
      msg_print("You can't read technical books.");
    } else if ((! is_in(py.misc.pskill, class2) ) && (tval == 91)) {
      msg_print("The words in this book boggle your mind.");
    } else if ((! is_in(py.misc.pskill, class3) ) && (tval == 92)) {
      msg_print("The slang in this book confounds you.");
    } else {
      redraw = true;
      i1 = 0;
      clear_from(1);
      sprintf(out_val,"   Name                         Level  Rsrc   Known");
      prt(out_val,1,1);
      for (i3 = inventory[item_val].ac; 
	   i3 <= inventory[item_val].toac; i3++) {
	//with skill_list[i3]. do;
	i1++;
	if (skill_list[i3].slevel < 99) {
	  sprintf(out_val,"%c) %-30s%2d     %2d    %s",
		  (int)i1+96,
		  skill_list[i3].sname, 
		  skill_list[i3].slevel, 
		  skill_list[i3].smana, 
		  (skill_list[i3].learned ? "true" : "false"));
	  prt(out_val,i1+1,1);
	} else {
	  prt("",i1+1,1);
	}
      }
      pause_game(PAUSE_LINE);
    }
  }
  if (redraw) { draw_cave(); }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void shell_out_command()
{
  if (0) {
    clear_from(1);
    writeln("[Entering DCL shell, type \"EOJ\" to resume your game]");
    writeln("");
    controly();
    //shell_out();
    no_controly();
    clear_from(1);
    draw_cave();
  } else {
    msg_print("Use ^Z instead");
  }
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void print_location()
{
  vtype out_val;

  if ((py.flags.blind > 0) || no_light()) {
    msg_print("You can't see your map.");
  } else {
    sprintf(out_val,
	    "Section [%ld,%ld]; Location = [%ld,%ld]",
	    (trunc((char_row-1)/OUTPAGE_HEIGHT)+1),
	    (trunc((char_col-1)/OUTPAGE_WIDTH )+1),
	    char_row,char_col);
    msg_print(out_val);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void print_map_or_char()
{
  char command;
  
  if (get_com("Print Map (m) or Character Sheet (s)?",&command)) {
    switch (command) {
    case 's': case 'S':
      character_print();
      break;
      
    case 'm': case 'M':
      if ((py.flags.blind > 0) || (no_light())) {
	msg_print("You can't see to draw a map.");
      } else {
	print_map();
      }
      break;
      
    default:
      break;
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void jamdoor()
{
  /*{ Jam a closed door }*/

  integer   y,x,tmp,i1,i2;
  vtype     out_val;
  obj_set   spikes = {13};

  y = char_row;
  x = char_col;

  if (get_dir("Which direction?",&tmp,&tmp,&y,&x)) {
    //with cave[y][x]. do;
    if (cave[y][x].tptr > 0) {
      //with t_list[cave[y][x].tptr]. do;
      if (t_list[cave[y][x].tptr].tval == 105) {
	if (cave[y][x].cptr == 0) {
	  if (find_range(spikes,&i1,&i2)) {
	    msg_print("You jam the door with a spike.");
	    //with inventory[i1]. do;
	    if (inventory[i1].number > 1) {
	      inventory[i1].number--;
	    } else {
	      inven_destroy(i1);
	    }
	    t_list[cave[y][x].tptr].p1 = -abs(t_list[cave[y][x].tptr].p1) - 20;
	  } else {
	    msg_print("But you have no spikes...");
	  }
	} else {
	  sprintf(out_val, "The %s is in your way!", 
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	}
      } else if (t_list[cave[y][x].tptr].tval == 104) {
	msg_print("The door must be closed first.");
      }
    } else {
      msg_print("That isn't a door!");
    }
  } else {
    msg_print("That isn't a door!");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void search_on()
{
  /*{ Search Mode enhancement }*/
  search_flag = true;
  change_speed(+1);
  py.flags.status |= 0x00000100;
  prt_search();
  //with py.flags do;
  PF.food_digested++;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void search_off()
{
  search_flag = false;
  find_flag   = false;
  move_char(5);
  change_speed(-1);
  py.flags.status &= 0xFFFFFEFF;
  prt_search();
  //with py.flags do;
  PF.food_digested--;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void bash()
{
  /*
    { Bash open a door or chest
    Note: Affected by strength and weight of character }
  */
  integer   y,x,tmp;
  integer   old_ptodam,old_ptohit,old_bth;
  vtype     out_val;
  char     *yell;

  y = char_row;
  x = char_col;

  if (get_dir("Which direction?",&tmp,&tmp,&y,&x)) {
    //with cave[y][x]. do;
    if (cave[y][x].cptr > 1) {
      if (py.flags.afraid > 0) {
	msg_print("You are afraid!");
      } else {
	/*{ Save old values of attacking}*/
	temporary_slot = equipment[23];
	old_ptohit = py.misc.ptohit;
	old_ptodam = py.misc.ptodam;
	old_bth = py.misc.bth;
	/*{ Use these values }*/
	
	equipment[23] = blank_treasure;
	//with equipment[23]. do;
	strcpy(equipment[23].damage, equipment[27].damage);
	equipment[23].weight = py.stat.cstr;
	equipment[23].tval   = 1;
	
	//with py do;
	py.misc.bth = trunc((py.stat.cstr+py.misc.wt)/5.0);
	py.misc.ptohit = 0;
	py.misc.ptodam = trunc(py.misc.wt/75.0) + 1;
	
	if (py_attack(y,x)) {
	  if ( cave[y][x].cptr > 0 ) { /* maybe they killed it */
	    //with m_list[cave[y][x].cptr]. do;
	    m_list[cave[y][x].cptr].stuned += randint(2) + 1;
	    if (m_list[cave[y][x].cptr].stuned > 12) { 
	      m_list[cave[y][x].cptr].stuned = 12; }
	  }
	  sprintf(out_val, "The %s appears stunned!", 
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	}
      }
      
      /*{ Restore old values }*/
      equipment[23] = temporary_slot;
      py.misc.ptohit = old_ptohit;
      py.misc.ptodam = old_ptodam;
      py.misc.bth = old_bth;
      if (randint(50) > py.stat.cdex) {
	msg_print("You are off-balance.");
	py.flags.paralysis = randint(3);
      }
      
    } else if (cave[y][x].tptr > 0) {
    
      //with t_list[cave[y][x].tptr]. do;
      if (t_list[cave[y][x].tptr].tval == 105) {
	msg_print("You smash into the door!");
	//with py do;
	
	if (test_hit(py.misc.wt+py.stat.cstr,0,0,
		     abs(t_list[cave[y][x].tptr].p1)+150)) {
	  switch (randint(10)) {
	  case 1: case 2: case 3: case 4: case 5:
	    yell = "The door crashes open."; break;
	  case 6: 
	    yell = "The door flys off its hinges."; break;
	  case 7: 
	    yell = "The door screams in agony!";    break;
	  case 8: 
	    yell = "\"Intruder Alert!\"";           break;
	  case 9: 
	    yell = "The door swears to get its revenge!"; break;
	  case 10: 
	    yell = "\"Warning.  You have entered a restricted zone!\""; break;
	  }
	  msg_print(yell); 
	  if (strchr(yell,'!') != NULL) {
	    aggravate_monster(20);
	  }
	  t_list[cave[y][x].tptr] = door_list[1];
	  t_list[cave[y][x].tptr].p1 = 1;
	  cave[y][x].fopen = true;
	  lite_spot(y,x);
	} else {
	  msg_flag = false;
	  msg_print("The door holds firm.");
	  py.flags.paralysis = 2;
	}
      } else if (t_list[cave[y][x].tptr].tval == 2) {
	if (randint(10) == 1) {
	  msg_print("You have destroyed the chest...");
	  msg_print("and it's contents!");
	  strcpy(t_list[cave[y][x].tptr].name, "& ruined chest");
	  t_list[cave[y][x].tptr].flags = 0;
	} else if (uand(0x00000001,t_list[cave[y][x].tptr].flags) != 0) {
	  if (randint(10) == 1) {
	    msg_print("The lock breaks open!");
	    t_list[cave[y][x].tptr].flags &= 0xFFFFFFFE;
	  }
	}
      }
    } else {
      msg_print("I do not see anything you can bash there.");
    }
  } else {
    msg_print("I do not see anything you can bash there.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void disarm_trap()
{
  /*{ Disarms a trap }*/

  integer  y,x,i1,tdir;
  integer  tot,t1,t2,t3,t4,t5;
  char    *a_char;

  y = char_row;
  x = char_col;

  if (get_dir("Which direction?",&tdir,&i1,&y,&x)) {
    //with cave[y][x]. do;
    if (cave[y][x].tptr > 0) {
      t1 = py.misc.disarm; /*{ Ability to disarm }*/
      t2 = py.misc.lev;    /*{ Level adjustment }*/
      t3 = 2*todis_adj();  /*{ Dexterity adjustment }*/
      t4 = int_adj();      /*{ Intelligence adjustment}*/
      tot = t1 + t2 + t3 + t4;
      
      if (py.flags.blind > 0) {
	tot = trunc(tot/5.0);
      } else if (no_light()) {
	tot = trunc(tot/2.0);
      }
      if (py.flags.confused > 0) {
	tot = trunc(tot/3.0);
      }
      i1 = t_list[cave[y][x].tptr].tval;
      t5 = t_list[cave[y][x].tptr].level;
      
      if (i1 == 102) {   /*{ Floor trap }*/
	//with t_list[cave[y][x].tptr]. do;
	if ((tot - t5) > randint(100)) {
	  msg_print("You have disarmed the trap.");
	  py.misc.exp += t_list[cave[y][x].tptr].p1;
	  cave[y][x].fm = false;
	  pusht(cave[y][x].tptr);
	  cave[y][x].tptr = 0;
	  move_char(tdir);
	  lite_spot(y,x);
	  prt_experience();
	} else if (randint(tot) > 5) {
	  msg_print("You failed to disarm the trap.");
	} else {
	  msg_print("You set the trap off!");
	  move_char(tdir);
	}
      } else if (i1 == 2) {   /*{ Chest trap }*/
	//with t_list[cave[y][x].tptr]. do;
	if (strchr(t_list[cave[y][x].tptr].name,'^') != NULL) {
	  msg_print("I don't see a trap...");
	} else if (uand(0x000001F0,t_list[cave[y][x].tptr].flags) != 0) {
	  if ((tot - t5) > randint(100)) {
	    t_list[cave[y][x].tptr].flags &= 0xFFFFFE0F;
	    a_char = strstr(t_list[cave[y][x].tptr].name," (");
	    if (a_char != NULL) {
	      a_char = '\000';
	    }
	    if (uand(0x00000001,t_list[cave[y][x].tptr].flags) != 0) {
	      strcat(t_list[cave[y][x].tptr].name, " (Locked)");
	    } else {
	      strcat(t_list[cave[y][x].tptr].name, " (Disarmed)");
	    }
	    msg_print("You have disarmed the chest.");
	    known2(t_list[cave[y][x].tptr].name);
	    py.misc.exp += t5;
	    prt_experience();
	  } else if (randint(tot) > 5) {
	    msg_print("You failed to disarm the chest.");
	  } else {
	    msg_print("You set a trap off!");
	    known2(t_list[cave[y][x].tptr].name);
	    chest_trap(y,x);
	  }
	} else {
	  msg_print("The chest was not trapped.");
	}
      } else {
	msg_print("I do not see anything to disarm there.");
      }
    } else {
      msg_print("I do not see anything to disarm there.");
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void refill_lamp()
{
  /*{ Refill the players lamp}*/

  integer  i1,i2,i3;
  obj_set  batteries = {77};

  i3 = equipment[33].subval;
  if ((i3 > 0) && (i3 < 10)) {
    if (find_range(batteries,&i1,&i2)) {
      msg_print("Your lantern is charged up.");
      //with equipment[33]. do;
      equipment[33].p1 += inventory[i1].p1;
      if (equipment[33].p1 > OBJ_LAMP_MAX) { 
	equipment[33].p1 = OBJ_LAMP_MAX;
      }
      desc_remain(i1);
      inven_destroy(i1);
    } else {
      msg_print("You have no batteries.");
    }
  } else {
    msg_print("But you are not wielding a lantern.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void rest()
{
  /*{ Resting allows a player to safely restore his hp }*/

  integer  rest_num;
  vtype    rest_str;

  prt("Rest for how long? ",1,1);
  get_string(rest_str,1,20,10);

  rest_num = atoi(rest_str);

  if (rest_num > 0) {
    if (search_flag) {
      search_off();
    }
    py.flags.rest = rest_num;
    py.flags.status |= 0x00000200;
    prt_rest();
    //with py.flags do;
    PF.food_digested--;
    switch (randint(7)) {
    case 1:    msg_print("Press any key to stop vegging...");        break;
    case 2:    msg_print("Press any key to quit resting...");        break;
    case 3:    msg_print("Hit any key to get back to work...");      break;
    case 4:    msg_print("You know, the BOSS *is* waiting...");      break;
    case 5:    msg_print("Lazy bum...");                             break;
    case 6:    msg_print("ZZZZZZzzzzzzzzzzz...");                    break;
    case 7:    msg_print("You dream of rainbows and lollipops...");  break;
    }
    put_qio();
    
  } else {
    erase_line(msg_line,msg_line);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void display_kill_list()
{
  integer   i1,i2,total;
  integer   tmp[52+1];
  vtype     outval;
  char     *out_val;

  clear_from(1);
  total = 0;

  for (i1 = 1; i1 <= 52; i1++) {
    tmp[i1] = 0;
  }
  for (i1 = 1; i1 <= max_creatures; i1++) {
    i2 = pindex(alpha_set,c_list[i1].cchar);
    tmp[i2] += kill_list[i1];
    total   += kill_list[i1];
  }

  prt(
   "Total creatures killed for each on-screen character representation:",1,5);

  for (i2 = 1; i2 <= 13; i2++) {
    sprintf(outval, "%c :  ", (int)i2+96);
    prt_num(outval,tmp[i2],i2+2,13); 
  }
  for (i2 = 14; i2 <= 26; i2++) {
    sprintf(outval, "%c :  ", (int)i2+96);
    prt_num(outval,tmp[i2],i2+2-13,28); 
  }
  for (i2 = 1; i2 <= 13; i2++) {
    sprintf(outval, "%c :  ", (int)i2+64);
    prt_num(outval,tmp[i2+26],i2+2,43); 
  }
  for (i2 = 14; i2 <= 26; i2++) {
    sprintf(outval, "%c :  ", (int)i2+64);
    prt_num(outval,tmp[i2+26],i2+2-13,58); 
  }
  prt_num("Total Creatures Killed : ",total,17,24);

  if (total <= 21) {
    out_val = "(you must be a pacifist.)";
  } else if (total <= 100) {
    out_val = "(a good beginning.)";
  } else if (total <= 400) {
    out_val = "(you sure fight a lot.)";
  } else if (total <= 800) {
    out_val = "(KILL!  KILL!  KILL!)";
  } else if (total <= 1600) {
    out_val = "(the rest are waiting for you.)";
  } else {
    out_val = "(the Boss is gonna get you.)";
  }

  prt(out_val,18,24);
  pause_game(24);
  draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void look()
{
  /*
    { Look at an object, trap, or monster
    Note: Looking is a free move, see where invoked.}
  */
  integer   i1,i2,y,x;
  integer   dir,dummy;
  vtype     out_val;
  boolean   flag;

  flag = false;
  y = char_row;
  x = char_col;

  if (get_dir("Look which direction?",&dir,&dummy,&y,&x)) {
    if (py.flags.blind < 1) {
      y = char_row;
      x = char_col;
      i1 = 0;

      do {
	move_dir(dir,&y,&x);
	//with cave[y][x]. do;
	if (cave[y][x].cptr > 1) {
	  if (m_list[cave[y][x].cptr].ml) {
	    i2 = m_list[cave[y][x].cptr].mptr;
	    if (wizard) {
	      sprintf(out_val,"You see a %s. (%d hps.)",
		      c_list[i2].name,m_list[cave[y][x].cptr].hp);
	    } else {
	      sprintf(out_val,"You see a %s. ",c_list[i2].name);
	    }
	    msg_print(out_val);
	    flag = true;
	  }
	}
	
	if ((cave[y][x].tl) || (cave[y][x].pl) || (cave[y][x].fm)) {
	  
	  if (cave[y][x].tptr > 0) {
	    if (t_list[cave[y][x].tptr].tval == 109) {
	      msg_print("You see a granite wall.");
	    } else if (t_list[cave[y][x].tptr].tval != 101) {
	      temporary_slot = t_list[cave[y][x].tptr];
	      objdes(out_val,1,true,'t');
	      msg_print2("You see ", out_val);
	      flag = true;
	    }
	  }	    

	  if (!cave[y][x].fopen) {
	    flag = true;
	    switch (cave[y][x].fval) {
	    case 10 : msg_print("You see a granite wall."); break;
	    case 11 : msg_print("You see some dark rock."); break;
	    case 12 : msg_print("You see a quartz vein.");  break;
	    case 15 : msg_print("You see a granite wall."); break;
	    default : break;
	    }
	  }
	}
	i1++;
      } while (! ((! cave[y][x].fopen) || (i1 > MAX_SIGHT)) );
      
      if (!flag) {
	msg_print("You see nothing of interest in that direction.");
      }
    } else {
      msg_print("You can't see a damn thing!");
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void tunnel()
{
  /*
    { Tunnels through rubble and walls
    Must take into account: secret doors, special tools }
  */
  integer  y,x,i1,tabil;

  y = char_row;
  x = char_col;

  if (get_dir("Which direction?",&i1,&i1,&y,&x)) {
    //with cave[y][x]. do;
    /*{ Compute the digging ability of player; based on strength, 
      and type of tool used }*/
    tabil = py.stat.cstr;
    if (equipment[23].tval > 0) {
      //with equipment[23]. do;
      if (uand(0x20000000,equipment[23].flags) != 0) {
	tabil += 25 + equipment[23].p1*50;
      }
    }

    /*{ Regular walls; Granite, magma intrusion, quartz vein
      Don't forget the boundry walls, made of titanium (255)}*/
    
    switch (cave[y][x].fval) {
    case 10 : 
      i1 = randint(1200) + 80;
      if (twall(y,x,tabil,i1)) {
	msg_print("You have finished the tunnel.");
      } else {
	msg_print("You tunnel into the granite wall.");
      }
      break;
      
    case 11 : 
      i1 = randint(600) + 10;
      if (twall(y,x,tabil,i1)) {
	msg_print("You have finished the tunnel.");
      } else {
	msg_print("You tunnel into the magma intrusion.");
      }
      break;
      
    case 12 : 
      i1 = randint(400) + 10;
      if (twall(y,x,tabil,i1)) {
	msg_print("You have finished the tunnel.");
      } else {
	msg_print("You tunnel into the quartz vein.");
      }
      break;
      
    case 15 : 
      msg_print("This seems to be permanent rock.");
      break;
      
    default:
      /* Is there an object in the way? (Rubble and secret doors) */
      if (cave[y][x].tptr > 0) {
	
	/*{ Rubble.}*/
	if (t_list[cave[y][x].tptr].tval == 103) {
	  if (tabil > randint(180)) {
	    pusht(cave[y][x].tptr);
	    cave[y][x].tptr = 0;
	    cave[y][x].fm = false;
	    cave[y][x].fopen = true;
	    msg_print("You have removed the rubble.");
	    if (randint(10) == 1) {
	      place_object(y,x);
	      if (test_light(y,x)) {
		msg_print("You have found something!");
	      }
	    }
	    lite_spot(y,x);
	  } else {
	    msg_print("You dig in the rubble...");
	  }
	  
	  /*{ Secret doors...}    */
	} else if (t_list[cave[y][x].tptr].tval == 109) {
	  msg_print("You tunnel into the granite wall.");
	  search(char_row,char_col,py.misc.srh);
	  
	} else {
	  msg_print("You can't tunnel through that.");
	}
      } else {
	msg_print("Tunnel through what?  Empty air???");
      }
      break;
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean berzerk()
{
  /*{Wrestler Berzerk}*/

  integer   y,x,i3,i5,num_attacks;
  boolean   tmp, return_value;

  return_value = false;

  if (py.flags.afraid > 0) {
    msg_print("Your mind is too full of fear!");
  } else if (py.flags.special > 0) {
    msg_print("You are too fatigued from your last fury!");
  } else {
    tmp = false;
    num_attacks = (py.misc.lev + 2) div 3;
    for (i3 = 1; i3 <= num_attacks; i3++) {
      for (i5 = 1; i5 <= 8; i5++) {
	y = char_row + berz_y[i5];
	x = char_col + berz_x[i5];
	if (cave[y][x].cptr > 1) {
	  py_attack(y,x); /*{Attack Creature}*/
	  tmp = true;
	}
      }
    }
    if (tmp) {
      return_value = true;
      py.flags.special = 100;
    }
  }

  return return_value;
};    
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void fo__facts_fire(integer *tpth, integer *tdam, integer *tdis, 
		    integer item_val)
{
  integer  rounds = 1;
  vtype    out_val, out_val2;

  //with temporary_slot. do;     /*{ammo bonuses}*/
  *tpth = temporary_slot.tohit;
  *tdam = temporary_slot.todam * DAM_PLUS_ADJ;
  /*{ weight is used for calculating critical hits. }*/
  temporary_slot.weight = 100 + 50 * temporary_slot.tohit;  

  //with equipment[23]. do;     /*{gun bonuses}*/
  *tdis  = equipment[23].p1;
  *tpth += equipment[23].tohit + (equipment[23].p1 div 10);
  *tdam += damroll(equipment[23].damage);
  if (equipment[23].tval == 19) {
    rounds = inventory[item_val].number;
    if (rounds > equipment[23].todam) {
      rounds = equipment[23].todam;
    }
    *tdam *= rounds;
  }

  //with inventory[item_val]. do;
  inventory[item_val].number -= rounds;
  inven_weight -= inventory[item_val].weight * rounds;
  objdes(out_val,item_val,true,'i');
  out_val[strlen(out_val)-2] = 0;
  sprintf(out_val2, "You have %s.", out_val);
  msg_print(out_val2);
  if (inventory[item_val].number < 1) {
    inven_destroy(item_val);
  }
  prt_cur_weight();
};
//////////////////////////////////////////////////////////////////////
void fire_object()
{
  /*{ Fire a Weapon that has ammo.}*/

  integer   item_val,tbth,tpth,tdam,tdis;
  integer   y_dumy,x_dumy,dumy,i1,i2,i3;
  integer   y,x,oldy,oldx,dir,cur_dis;
  boolean   redraw,flag;
  vtype     out_val, out_val2;
  obj_set   propper_ammo = {};

  propper_ammo[0] = equipment[23].subval;

  redraw = false;
  if (inven_ctr == 0) {
    msg_print("But you are not carrying anything.");

  } else if (!(find_range(propper_ammo,&i2,&i3))) {
    msg_print("You are not carrying any compatible ammo.");

  } else if (get_item(&item_val,"Use which ammo clip?",&redraw,i2,i3)) {
    if (redraw) {
      draw_cave();
    }
    y_dumy = char_row;
    x_dumy = char_col;
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      if (py.flags.confused > 0) {
	msg_print("You are confused...");
	do {
	  dir = randint(9);
	} while (dir == 5);
      }
      temporary_slot = inventory[item_val];
      temporary_slot.number = 1;
      fo__facts_fire(&tpth,&tdam,&tdis,item_val);
      y = char_row;
      x = char_col;
      if (temporary_slot.tval == 9) {  /*{laser weapon}*/
	light_line(dir,y,x,tdam,true);
      } else {
	//with temporary_slot. do;
	flag = false;
	oldy = char_row;
	oldx = char_col;
	cur_dis = 0;
	do {
	  move_dir(dir,&y,&x);
	  cur_dis++;
	  if (test_light(oldy,oldx)) {
	    lite_spot(oldy,oldx);
	  }
	  if (cur_dis > tdis) {
	    flag = true;
	  }
	  //with cave[y][x]. do;
	  if ((cave[y][x].fopen) && (!(flag))) {
	    if (cave[y][x].cptr > 1) {
	      flag = true;
	      //with m_list[cave[y][x].cptr]. do;
	      tbth = py.misc.bthb - cur_dis;
	      if (test_hit(tbth,py.misc.lev,tpth,
			   c_list[m_list[cave[y][x].cptr].mptr].ac)) {
		i1 = m_list[cave[y][x].cptr].mptr;
		objdes(out_val,1,false,'t');
		sprintf(out_val2, "The %s hits the %s. ", out_val,
			c_list[i1].name);
		msg_print(out_val2);
		tdam = tot_dam(&temporary_slot,tdam,&c_list[i1]);
		//with temporary_slot. do
		tdam = critical_blow(temporary_slot.weight,tpth,tdam);
		i1 = mon_take_hit(cave[y][x].cptr,tdam);
		if (i1 > 0) {
		  sprintf(out_val2, "You have killed the %s. ",
			  c_list[i1].name);
		  msg_print(out_val2);
		}
	      }
	    }
	  }
	  oldy = y;
	  oldx = x;
	} while (!flag);
      }
    }
  } else {
    if (redraw) {
      draw_cave();
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void to__inven_throw(integer item_val)
{
  temporary_slot = inventory[item_val];
  temporary_slot.number = 1;
  //with inventory[item_val]. do;
  if ((inventory[item_val].number > 1) && (inventory[item_val].subval > 511)) {
    inventory[item_val].number--;
    inven_weight -= inventory[item_val].weight;
  } else {
    inven_destroy(item_val);
  }
  prt_cur_weight();
};
//////////////////////////////////////////////////////////////////////
void to__facts(integer *tbth, integer *tpth, integer *tdam, integer *tdis)
{
  integer  tmp_weight;

  //with temporary_slot. do;
  if (temporary_slot.weight < 1) {
    tmp_weight = 1;
  } else {
    tmp_weight = temporary_slot.weight;
  }

  if (temporary_slot.tval == 82) {
    *tdam = damroll(temporary_slot.damage) + temporary_slot.todam*2;
    *tbth = py.misc.bthb;
    *tpth = py.misc.ptohit  + temporary_slot.tohit*2;
    *tdis = trunc(((py.stat.cstr+25)*10)/tmp_weight);
    if (*tdis > 18) { *tdis = 18; }
  } else {
    *tdam = damroll(temporary_slot.damage) + temporary_slot.todam;
    *tbth = trunc(py.misc.bthb*0.75);
    *tpth = py.misc.ptohit  + temporary_slot.tohit;
    *tdis = trunc(((py.stat.cstr+25)*10)/tmp_weight);
    if (*tdis > 10) { *tdis = 8; }
  }
};
//////////////////////////////////////////////////////////////////////
void to__drop_throw(integer y, integer x)
{
  /*{if item misses or has no target, then drop it somewhere.}*/

  integer   i1,i2,i3,cur_pos;
  boolean   flag = false;
  vtype     out_val, out_val2;

  i1 = y;
  i2 = x;
  i3 = 0;

  if (randint(10) > 1) {
    do {
      if (in_bounds(i1,i2)) {
	//with cave[i1][i2]. do;
	if (cave[i1][i2].fopen) {
	  if (cave[i1][i2].tptr == 0) {
	    flag = true;
	  }
	}
      }
      if (!flag) {
	i1 = y + randint(3) - 2;
	i2 = x + randint(3) - 2;
	i3 = i3 + 1;
      }
    } while (!((flag) || (i3 > 9)));
  }
  
  if (flag) {
    popt(&cur_pos);
    cave[i1][i2].tptr = cur_pos;
    t_list[cur_pos] = temporary_slot;
    if (test_light(i1,i2)) {
      lite_spot(i1,i2);
    }
  } else {
    objdes(out_val,1,false,'t');
    sprintf(out_val2, "The %s dissapears.", out_val);
    msg_print(out_val2);
  }
};
//////////////////////////////////////////////////////////////////////
void throw_object()
{
  /*{ Hurl an object across the dungeon. 
    -if tval is thrown weapon, bonus to hit}*/

  integer   item_val,tbth,tpth,tdam,tdis;
  integer   y_dumy,x_dumy,dumy;
  integer   y,x,oldy,oldx,dir,cur_dis,i1;
  boolean   redraw,flag;
  vtype     out_val, out_val2;
 
  redraw = false;
  if (inven_ctr == 0) {
    msg_print("But you are not carrying anything.");
  } else if (get_item(&item_val,"Hurl which item?",&redraw,1,inven_ctr)) {
    if (redraw) {
      draw_cave();
      redraw = false;
    }
    y_dumy = char_row;
    x_dumy = char_col;
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {

      desc_remain(item_val);

      if (py.flags.confused > 0) {
        msg_print("You are confused...");
        do {
          dir = randint(9);
        } while (dir == 5);
      }

      to__inven_throw(item_val);
      to__facts(&tbth,&tpth,&tdam,&tdis);
      //with temporary_slot. do;
      flag = false;
      y = char_row;
      x = char_col;
      oldy = char_row;
      oldx = char_col;
      cur_dis = 0;

      if (temporary_slot.tval == 84) {
        fire_ball(temporary_slot.p1,dir,char_row,char_col,
                  damroll(temporary_slot.damage)+temporary_slot.todam,
                  2,true,"explosion");
      } else {
        do {
          move_dir(dir,&y,&x);
          cur_dis++;
          if (test_light(oldy,oldx)) {
            lite_spot(oldy,oldx);
          }

          if (cur_dis > tdis) { flag = true; }

	  //with cave[y][x]. do;
	  if (cave[y][x].fopen && !flag) {

	    if (cave[y][x].cptr > 1) {
	      flag = true;
	      //with m_list[cave[y][x].cptr]. do;
	      tbth -= cur_dis;
	      if (test_hit(tbth,py.misc.lev,tpth,
			   c_list[m_list[cave[y][x].cptr].mptr].ac)) {
		i1 = m_list[cave[y][x].cptr].mptr;
		
		objdes(out_val,1,false,'t');
		if (strlen(out_val)+strlen(c_list[i1].name) > 60) {
		  strcpy(out_val2, "It");
		} else {
		  sprintf(out_val2, "The %s", out_val);
		}
		sprintf(out_val, "%s hits the %s. ", 
			out_val2, c_list[i1].name);
		msg_print(out_val);
		
		tdam = tot_dam(&temporary_slot,tdam,&c_list[i1]);
		//with temporary_slot. do;
		tdam = critical_blow(temporary_slot.weight,tpth,tdam);
		i1 = mon_take_hit(cave[y][x].cptr,tdam);
		if (i1 > 0) {
		  sprintf(out_val, "You have killed the %s. ", 
			  c_list[i1].name);
		  msg_print( out_val );
		}
		
	      } else {
		to__drop_throw(oldy,oldx);
	      }
	    } else {
	      if (panel_contains(y,x)) {
		if (test_light(y,x)) {
		  print(temporary_slot.tchar,y,x);
		}
	      }
            }        
          } else {
            flag = true;
            to__drop_throw(oldy,oldx);
          }

          oldy = y;
          oldx = x;
        } while (!flag);
      }
    }
  } else {
    if (redraw) {
      draw_cave();
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void execute_command(integer *com_val)
{
  integer x, y, dir_val;

  /*{ Commands are executed in following CASE statement }*/
  switch (*com_val) {
    
  case 0:       /* \0        */
  case 3:       /* ^C        */     /* signalquit in io.c catches this */
  case '@':     /* duh       */
    //case 25:  /*{^Y = exit}*/  changed to be save
    ask_to_quit();
    reset_flag = true;
    break;

  case 13:            /* {^M = repeat} */
    msg_print(old_msg);
    reset_flag = true;
    break;
    
  case 16 :          /* {^P = password} */
    toggle_wizard_mode();
    reset_flag = true;
    break;
    
  case 18 :        /* {^R = redraw}  This should never happen... */
    draw_cave();
    reset_flag = true;
    break;

  case 25:      /*  {^Y = save and exit, was exit without saving }*/
    if (total_winner_num > 0) {
      msg_print("You are a Total Winner, your character must be retired...");
      msg_print("Use <Control>-C to when you are ready to quit.");
    } else {
      if (search_flag) { search_off(); }
      save_char(false); /* might not return */
    }
    break;

  case  26:   /*{^Z = suspend  (we never get this, look at signalsuspend) }*/
    reset_flag = true;
    break;

  case 32 :
    prt("Type '?' for help...",1,1);
    reset_flag = true;
    break;

  case 36 :      /* {$  = Shell }  This does nothing, use ^Z */
    shell_out_command();
    reset_flag = true;
    break;

  case 46 :   /*{. = find }*/
    y = char_row;
    x = char_col;
    if (get_dir("Which direction?", &dir_val, com_val,&y,&x)) {
      find_flag = true;
      move_char(dir_val);
    }
    break;

  case 47 :    /*   {/ = identify }*/
    ident_char();
    reset_flag = true;
    break;

    /* { Move dir 1-4 and 6-9 } */
  case 49 :  case 50 :  case 51 :  case 52 :
  case 54 :  case 55 :  case 56 :  case 57 :
    move_char(*com_val - 48);  
    break;
    
  case 53 :          /*{ Rest one turn }*/
    move_char(*com_val - 48);
    usleep(100);     /*{ Sleep 1/10 a second }*/
    flush();
    break;
    
  case 60:           /*{ < = go up }*/
    go_up();
    break;
    
  case 62:           /*{ > = go down }*/
    go_down();
    break;
    
  case 63 :         /*{? = help }*/
    help();
    reset_flag = true;   /*{ Free move }*/
    break;
    
    /*
      case 65:
      {          { Debug feature for weight
                          tmp1 := 0;
                          for i1 := 1 to inven_max do
                            with inventory[i1] do
                              tmp1 := tmp1 + weight*number;
                          writev(out_val,inven_weight:1,' | ',tmp1:1);
                          msg_print(out_val);
                        END;}
    */

  case 66 :    
    bash();   /*{B = bash }*/
    break;
    
  case 67 :     /*  {C = character}*/
    change_name();
    draw_cave();
    reset_flag = true;
    break;

  case 68 :    /* {D = disarm } */
    disarm_trap();
    break;
    
  case 69 :  /*  {E = eat} */    
    eat(); 
    break;
    
  case 70 :    /* {F = refill } */
    refill_lamp();
    break;
    
  case 72 :    /* {H = moria hlp}*/
    moria_help("");
    draw_cave();
    reset_flag = true;
    break;
    
  case 76 :    /* {L = location }*/
    print_location();
    reset_flag = true;   /*{ Free move }*/
    break;
    
  case 77:     /* {M = Mix Potions} */
    mix_potions();
    break;
    
  case 80:     /* {P = print map or character sheet}*/
    print_map_or_char();
    reset_flag = true;   /*{ Free move }*/
    break;
    
  case 81 :    /* {Q = toggle -more-}*/
    more_flag = !more_flag;
    if (more_flag) {
      prt("Question -More- enabled.",1,1);
    } else {
      prt("Question -More- disabled.",1,1);
    }
    reset_flag = true;
    break;
    
  case 82 :  /* {R = rest } */
    rest(); 
    break;
    
  case 83 :  /* {S = srh mode } */
    if (search_flag) {
      search_off();
      reset_flag = true; /*{ Free move }*/
    } else if (py.flags.blind > 0) {
      msg_print("You are incapable of searching while blind.");
    } else {
      search_on();
      reset_flag = true; /*{ Free move }*/
    }
    break;
    
  case 84 :    /* {T = tunnel } */
    tunnel();  
    break;
    
  case 86 :    /* {V = version} */
    game_version();  
    reset_flag = true;
    break;
    
  case 87 :    /*{W = toggle wall pattern}*/
    wall_flag = !wall_flag;
    draw_cave();
    if (wall_flag) {
      prt("Cool wall patterns enabled.",1,1);
    } else {
      prt("No more annoying wall patterns.",1,1);
    }
    reset_flag = true;
    break;
    
  case 97 :  /* {a = aim } */
    aim();
    break;
    
  case 98 : /* { b = browse or berzerk } */
    if (py.misc.pclass == 0) {
      reset_flag = berzerk();
    } else {
      examine_book();
    }
    break;
    
  case 99 :  /* {c = close} */
    closeobject();
    break;
    
  case 100:  /* {d = drop } */
    drop(); 
    break;
    
  case 101:          /*{ e = equipment }*/
    if (inven_command('e',0,0)) { draw_cave(); }
    reset_flag = true;
    break;
    
  case 102:   /* {f = fire} */
    if (equipment[23].tval == 19 || equipment[23].tval == 20) {
      fire_object();
    } else {
      msg_print("You are not wielding a gun!");
      reset_flag = true;
    }
    break;

  case 104:    /* {h = hurl} */
    throw_object();  
    break;

  case 105:          /*{ i = inventory }*/
    if (inven_command('i',0,0)) { draw_cave(); }
    reset_flag = true;
    break;

  case 106:    /* {j = jam} */
    jamdoor();
    break;

  case 107:    /* {k = kill list}*/
    display_kill_list();
    reset_flag = true;
    break;

  case 108:    /* {l = look }*/
    look();
    reset_flag = true;
    break;

  case 109:    /*  {m = magick}*/
    switch (py.misc.pskill) {
    case 1: case 2: case 7:
      use_tech_skills();
      break;
    case 5: case 6:
      use_con_skills();
      break;
    default:
      msg_print("You feel like a skilless oaf.");
      reset_flag = true;
    }
    break;

  case 111:
    openobject();    /*{ o = open }*/
    break;

  case 112:  /* {p = pray } */   
    pray(); 
    break;

  case 113:    /*  {q = quaff} */
    quaff();  
    break;

  case 114:    /* {r = read } */   
    read_floppy(); 
    break;

  case 115:  /* {s = search } */
    if (py.flags.blind > 0) {  
      msg_print("You are incapable of searching while blind.");
    } else {
      search(char_row,char_col,py.misc.srh);
    }
    break;

  case 116:    /* {t = unwear }*/
    if (inven_command('t',0,0)) { draw_cave(); }
    reset_flag = true;
    break;

  case 117:  /* {u = use staff} */  
    use();  
    break;

  case 119:    /* {w = wear }*/
    if (inven_command('w',0,0)) { draw_cave(); }
    reset_flag = true;
    break;

  case 120:    /* {x = exchange }*/
    if (inven_command('x',0,0)) { draw_cave(); }
    reset_flag = true;
    break;

  default:
    reset_flag = true;       /*{ Wizard commands are free moves}*/

    if (!wizard) {
      prt("Type '?' for help...",1,1);
    } else {
      switch (*com_val) {

      case  1 : really_heal_character(); break; // ^A = cure all
      case  2 : beckon_creature();       break; // ^B = call creature by number
	/* 3 is taken (quit game) */
//      case  4 : change_location();       break; // ^D = up/down/change-town
//      case  5 : change_character();      break; // ^E = wizchar
      case  6 : mass_genocide();         break; // ^F = genocide
      case  7 : wizard_alloc_object();   break; // ^G = treasure
      case  8 : wizard_help();           break; // ^H = wizhelp
      case  9 : identify_all();          break; // ^I = identify
      case 10 : wizard_exp();            break; // ^J = gain exp
      case 11 : wizard_summon();         break; // ^K = summon
      case 12 : wizard_light();          break; // ^L = wizard light
	/* 13 is taken (old messages) */
//      case 14 : print_stuff_to_file();   break; // ^N = 
      case 15 : force_wierdness();       break; // ^O = pick a random weirdness
	/* 16 is taken (password) */
//      case 17 : make_nice_character();   break; // ^Q  (was ^C)
	/* 18 is taken (redraw)   */
      case 20 : teleport(100);           break; // ^T = teleport
//      case 21 : show_values();           break; // ^U = character dubugging
//      case 22 : restore_char();          break; // ^V = restore
//      case 23 : wizard_create();         break; // ^W = create
//      case 24 : item_stats();            break; // ^X = examine a item
	/* 25 is taken (save game) */
	/* 26 is taken (suspend)   */
      case 92 : mon_info();              break; //  \ = monster info utility

      default : 
	prt("Type '?' for help...",1,1);
	reset_flag = true;
	break;
      }
    }
    break;

  }  
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/* END FILE commands.c */
