/* constants.h */
/* The global constants for boss */

/*
  {Note to the Wizard:
  Tweaking these constants can *GREATLY* change the game.
  Two years+ of constant tuning have generated these values.
  Minor adjustments are encouraged, but you must be very
  careful not to unbalance the game.  Moria/Boss was meant to be
  challenging, not a give away.  Many adjustments can cause
  cause the game to act strangely, or even cause errors. }
  */  

/*
  I think all this stuff can go away...

  { QIOW constants, see $IODEF in STARLET.MLB }

  IO$_WRITEVBLK = %B'0000000000110000';  {   48D, 0030H   }
  IO$_TTYREADALL= %B'0000000000111010';  {   58D, 003AH   }
  IO$M_NOECHO   = %B'0000000001000000';  {   64D, 0040H   }
  IO$M_NOWAIT   = %B'0000000010000000';  {  128D, 0080H   }
  IO$M_PURGE    = %B'0000100000000000';  { 2048D, 0800H	}
  
  IO$MOR_OUTPUT = IO$_WRITEVBLK;
  IO$MOR_INPUT  = IO$_TTYREADALL + IO$M_NOECHO;
  IO$MOR_DELAY  = IO$MOR_INPUT   + IO$M_NOWAIT;
  IO$MOR_IPURGE = IO$MOR_DELAY   + IO$M_PURGE;
  */

/*
  IO bug exists at high baud rates (baud >= 9600).  This bug
  is believed to be in the device driver.  It can be avoided by
  hibernating the process a small amount of time before perform-
  ing a QIOW read operation.
  */
#define	IO_MOR_IOPAUSE 5  /*{ x/100 secs of sleep before inkey}*/

/*
  { ENCRYPTION CONSTANTS                                          
  NOTE: These numbers were pulled from the air, and can be      
  changed.  If changed, characters produced from other    
  versions will fail to restore}
  */
#define	ENCRYPT_SEED1  342342
#define	ENCRYPT_SEED2  342944081

/*{ DUNGEON SIZE PARAMETERS }*/
#define	MAX_HEIGHT      66    /*{ Multiple of 11; >= 22 }*/
#define	MAX_WIDTH       198   /*{ Multiple of 33; >= 66 }*/
#define	SCREEN_HEIGHT   22	/*{ screen is intended to }*/
#define	SCREEN_WIDTH    66	/*{ show four panels.     }*/
 
/*{ OUTPUT DUNGEON SECTION SIZES }*/
#define	OUTPAGE_HEIGHT  44    /*{ 44 lines of dungeon/section }*/
#define	OUTPAGE_WIDTH   99    /*{ 100 columns of dungeon/section }*/
 
/*{ DUNGEON GENERATION VALUES
  NOTE: The entire design of dungeon can be changed by only
        slight adjustments here. }*/
#define	DUN_TUN_RND   36 /*{ Rand dir (4 is min) }*/
#define	DUN_TUN_CHG   70 /*{ Chance of changing dir (99 max) }*/
#define	DUN_TUN_FND   12 /*{ Distance for auto find to kick in }*/
#define	DUN_TUN_CON   15 /*{ Chance of extra tunneling }*/
#define	DUN_ROO_MEA   32 /*{ Mean of # of rooms, std dev=2 }*/
#define	DUN_TUN_PEN   25 /*{ % chance of room doors }*/
#define	DUN_TUN_JCT   15 /*{ % chance of doors at tunnel junctons }*/
#define	DUN_STR_DEN   5  /*{ Density of streamers }*/
#define	DUN_STR_RNG   2  /*{ Width of streamers }*/
#define	DUN_STR_MAG   3  /*{ # of magma streamers }*/
#define	DUN_STR_MC    95 /*{ 1/x chance of treasure/magma }*/
#define	DUN_STR_QUA   2  /*{ # of quartz streamers }*/
#define	DUN_STR_QC    55 /*{ 1/x chance of treasure/quartz }*/
#define	DUN_UNUSUAL   300/*{ Level/x chance of unusual room }*/
                           
/*{ STORE CONSTANTS }*/
#define	SALE_VAL      0.90  /*{ amount of daily leftover discount}*/
#define	MAX_TOWNS     8     /*{ total number of towns }*/
#define	MAX_STORES    11    /*{ # of different stores }*/
#define	MAX_DOORS     12    /*{ # of different building doors}*/
#define	MAX_BDOORS    4     /*{# of doors inside tall building}*/
#define	STORE_INVEN_MAX  24 /*{ Max # of discrete objs in inven  }*/
#define	STORE_CHOICES  26   /*{ # of items to choose stock from  }*/
#define	STORE_MAX_INVEN  20 /*{ Max diff objs in stock before auto sell}*/
#define	STORE_MIN_INVEN  14 /*{ Min diff objs in stock before auto buy}*/
#define	STORE_TURN_AROUND  5/*{ Amt of buying and selling normally }*/
#define	BMSTORE_TURN_AROUND  20/*{ Amt of buying and selling normally }*/
#define	MAX_CHAR_INVEN_INIT  8 /*{Size of begining char inventory}*/
#define	COST_ADJ  1.00      /*{ Adjust prices for buying and selling  }*/
 
/*{ TREASURE CONSTANTS }*/
#define MAX_OBJECTS 450
#define MAX_INVENTORY_INIT 300
#define	INVEN_MAX  52      /*{ Size of inventory array }*/
#define	EQUIP_MAX  35      /*{ Highest numbered slot in equipment array}*/
#define	INVEN_PER_PAGE  13 /*{# of inventory items show on each page.}*/
#define	MAX_OBJ_LEVEL  50  /*{ Max level of magic in dungeon }*/
#define	OBJ_GREAT  30      /*{ 1/n Chance of item being a Great Item }*/
#define	MAX_STAIR  3	     /*{# of stair types. -RLG}*/
#define	MAX_GOLD   30      /*{ # of different types of gold }*/
#define	MAX_TALLOC  225    /*{ Max objects/level }*/
#define	TREAS_ROOM_ALLOC  8/*{ Amt of objects for rooms }*/
#define	TREAS_ANY_ALLOC   2/*{ Amt of objects for corridors }*/
#define	TREAS_GOLD_ALLOC  3/*{ Amt of gold (and gems) }*/

/*{ MAGIC TREASURE GENERATION CONSTANTS
    NOTE: Number of special objects, and degree of enchantments
        can be adjusted here. }*/
#define	OBJ_STD_ADJ  1.25    /*{ Adjust STD/level }  {Process name:}*/
#define	OBJ_STD_MIN  7       /*{ Minimum STD } */
#define	OBJ_TOWN_LEVEL  5    /*{ Town object generation level }*/
#define	OBJ_BASE_MAGIC  20   /*{ Min % chance that item is magic }*/
#define	OBJ_BASE_MAX  70     /*{ Max % chance that item is magic }*/
#define	OBJ_DIV_SPECIAL  7   /*{ magic_chance/# = special chance}*/
#define	OBJ_DIV_UNIQUE   14  /*{ magic_chance/# = unique chance  - RLG}*/
#define	OBJ_DIV_CURSED   2   /*{ magic_chance/# = cursed chance}*/

#define	GURGLE  "-b0ssmaster-"

/*{ CONSTANTS DESCRIBING LIMITS OF CERTAIN OBJECTS }*/
#define	OBJ_LAMP_MAX  15000 /*{ Max amt that lamp can be filled}*/
#define	OBJ_BOLT_RANGE  18  /*{ Max range of bolts and balls }*/
                              /*{ matches max_spell_dis        }*/

/*{ CREATURE CONTANTS }*/
#define MAX_CREATURES 400 
#define	MAX_ATTACK_DESC  45  /*{Max creature att desc. max# is "repelled"}*/
#define	MAX_HIT_DESC  10  /*{Max player 'hit the monster' descriptions.}*/
#define	MAX_MALLOC  100/*{ Max that can be allocated }*/
#define	MAX_MALLOC_CHANCE  170 /*{ 1/x chance of new monster each round }*/
#define	MAX_MONS_LEVEL  50 /*{ Max level of creatures }*/
#define	MAX_SIGHT   20 /*{ Max dist a creature can be seen }*/
#define	MAX_SPELL_DIS  18 /*{ Max dist creat. spell can be cast }*/
#define	MAX_MON_MULT  30 /*{ Max reproductions on a level }*/
#define	MON_MULT_ADJ  10 /*{ High value slows multiplication }*/
#define	MON_NASTY  50 /*{ Dun_power/x chance of high level creature }*/
#define	MIN_MALLOC_LEVEL  40 /*{ Min # of monsters/level }*/
#define	MIN_MALLOC_TD   8 /*{ # of people on town level (day) }*/
#define	MIN_MALLOC_TN   8 /*{ # of people on town level (night)}*/
#define	EXTRA_MONSTERS  9 /*{ Total number of extra monsters beyond
			the normal list.  Whole list contains:
                      monsters, police, badguys, Boss }*/
#define	NUM_OF_POLICE   2 /*{ Total number of police in creature list. }*/
#define	WIN_MON_APPEAR  92/*{ Dun_power where winning creatures begin. }*/
#define	MON_SUMMON_ADJ  4 /*{ Adjust level of summoned creatures }*/
#define	MON_DRAIN_LIFE  2 /*{ % of player exp drained/hit }*/
 
/*{ TRAP CONSTANTS }*/
#define	MAX_TRAPA  19 /*{ # of defined traps }*/
#define	MAX_TRAPB  20 /*{ Includes secret doors }*/
 
/*{ DESCRIPTIVE CONSTANTS }*/
#define	MAX_COLORS     75 /*{ Used with potions, and coupons }*/
#define	MAX_MUSH       29 /*{ Used with mushrooms }*/
#define	MAX_WOODS      40 /*{ Used with staves }*/
#define	MAX_METALS     31 /*{ Used with wands }*/
#define	MAX_ROCKS      53 /*{ Used with rings }*/
#define	MAX_AMULETS    39 /*{ Used with amulets.  no, really? }*/
#define	MAX_SYLLABLES  80 /*{ Must be divisible by four. Floppy Titles.}*/
 
/*{ PLAYER CONSTANTS }*/
#define	MAX_HIGH_SCORES  100   //{ Maximum number of high scores to keep }
#define	MAX_PLAYER_LEVEL  42  /*{ Max possible char level }*/
#define	MAX_RACES  8 /*{ # of defined races }*/
#define	MAX_CLASS  9 /*{ # of defined classes }*/
#define	MAX_SKILLS  34 /*{ new skill list maximum }*/
#define	USE_DEVICE  3 /*{ x> Harder devices x< Easier devices }*/
#define	MAX_BACKGROUND  153 /*{ # of types of histories for univ }*/
#define	PLAYER_FOOD_FULL  7500/*{ Getting full }*/
#define	PLAYER_FOOD_MAX  12500/*{ Max food value, beyond is wasted  }*/
#define	PLAYER_FOOD_FAINT  180 /*{ Char begins fainting }*/
#define	PLAYER_FOOD_WEAK  650    /*{ Warn player that he is getting very low}*/
#define	PLAYER_FOOD_ALERT  1100    /*{ Warn player that he is getting low }*/
#define	PLAYER_REGEN_FAINT   0.002 /*{ Regen factor  fainting }*/
#define	PLAYER_REGEN_WEAK    0.004 /*{ Regen factor  weak }*/
#define	PLAYER_REGEN_NORMAL  0.006 /*{ Regen factor  full }*/
#define	PLAYER_REGEN_HPBASE  0.025 /*{ Min amt hp regen }*/
#define	PLAYER_REGEN_MNBASE  0.075 /*{ Min amt mana regen }*/
#define	PLAYER_WEIGHT_CAP    60    /*{ 100*(1/10 pounds)/strength pt }*/
 
/*{ BASE TO HIT CONSTANTS }*/
#define	BTH_LEV_ADJ   5 /*{ Adjust BTH/level }*/
#define	BTH_PLUS_ADJ  3 /*{ Adjust BTH/plus-to-hit }*/
#define	DAM_PLUS_ADJ  3 /*{ Adjust damage/plus-to-dam }*/
#define	BTH_HIT  12	/*{ Automatic hit 1/bth_hit }*/

/*{ MISC }*/
/*NULL  CHR(0)    { doesn't it always? }*/
#define	DAY_LIMIT  100 /*{ the Boss wins after 100 days, player loses -jeb}*/
#define	PAUSE_LINE  24

#define OBJ_SET_MAX  255 // type obj_set is supposed to be 0..255
#define MAX_OBJ_SET  30  // max items allowed in an obj_set[]

#define	MAX_MESSAGES 50   //{ Previous messages that in buffer	}

/* return values for master_file_verify */
#define MF_CHAR_OK          0
#define MF_CHAR_NOT_FOUND   1
#define MF_CHAR_MISMATCH    2

/* values for game_state */

#define GS_IGNORE_CTRL_C    0
#define GS_ALLOW_CTRL_C     1
#define GS_LOADING          2
#define GS_GET_COMMAND      3
#define GS_HELP             4

/* skill numbers in class_type.skill_no and p_misc.pskill */
#define  SKILL_NONE        0
#define  SKILL_SCIENTIST   1
#define  SKILL_SOLDIER     2
#define  SKILL_GURU        3
#define  SKILL_WANDERER    4
#define  SKILL_CONARTIST   5
#define  SKILL_THIEF       6
#define  SKILL_JOURNALIST  7

#define  RACE_ELITE        0
#define  RACE_HEFTY        1
#define  RACE_MAD          2
#define  RACE_WISE         3
#define  RACE_LUCKY        4
#define  RACE_HEALTHY      5
#define  RACE_SEXY         6
#define  RACE_ALIEN        7

/* the unix code I took starts at 0,0 and the vms code starts at 1,1 */
#define prt(s,r,c)          Prt((s),(r)-1,(c)-1)
#define put_buffer(s,r,c)   Put_Buffer((s),(r)-1,(c)-1)
#define erase_line(r,c)     Erase_Line((r)-1,(c)-1)
#define clear_from(r)       Clear_From((r)-1)
#define print(s,r,c)        Print((s),(r)-1,(c)-1)
#define get_string(s,r,c,l) Get_String((s),(r)-1,(c)-1,(l))
#define pause_line(r)       Pause_Line((r)-1)
#define pause_exit(r,d)     Pause_Exit((r)-1,(d))
#define print_null(r,c) (move_cursor((r)-panel_row_prt-1,(c)-panel_col_prt-1))

/* msecs to pause after drawing parts of explosions */
#define DRAW_BALL_DELAY 30

/* end constants.h */
