/* creature.c */
/* Creatures movement and attacking are done from here */

#include "boss.h"
#include "main.h"

typedef integer mm_type[5+1];   // mm_type = array [1..5] of integer;

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
static void update_mon(integer monptr)
{
    /*{ Updates screen when monsters move about  }*/

    boolean   flag = false;
    integer   x,y,mptr;

    //with m_list[monptr]. do;
    x    = m_list[monptr].fx;
    y    = m_list[monptr].fy;
    mptr = m_list[monptr].mptr;
    //with cave[y][x]. do;

    /*{ all this stuff means: can you see the monster? }*/
    if (m_list[monptr].cdis <= MAX_SIGHT) { 
	if (py.flags.blind < 1) {
	    if (panel_contains(y,x)) {
		if (los(char_row,char_col,y,x)) {
		    //with c_list[mptr]. do;
		    /*{we can see him?  cool! }*/
		    /*{ Normal sight. }*/
		    if ((cave[y][x].pl) || (cave[y][x].tl)) {
			if (py.flags.see_inv) {
			    flag = true;
			} else if (uand(0x10000,c_list[mptr].cmove) == 0) {
			    flag = true;
			}
			/*{ Infra vision. }*/
		    } else if (py.flags.see_infra > 0) {
			if (m_list[monptr].cdis <= py.flags.see_infra) {
			    if (uand(0x2000,c_list[mptr].cdefense) != 0) {
				flag = true;
			    }
			}
		    }
		}
	    }
	}
    }

    if (flag) {
	/*{ Light it up. }*/
	if (!m_list[monptr].ml) {
	    print(c_list[m_list[monptr].mptr].cchar,y,x);
	    m_list[monptr].ml = true;
	    
	    if (search_flag) {
		search_off();
	    }
	    
	    if (py.flags.rest > 0) {
		rest_off();
	    }
	    
	    flush();
	    
	    if (find_flag) {
		find_flag = false;
		move_char(5);
	    }
	}
    } else if (m_list[monptr].ml) {
	/*{ Turn it off.}*/
      m_list[monptr].ml = false;
	if (cave[y][x].tl || cave[y][x].pl) {
	    lite_spot(y,x);
	} else {
	    unlite_spot(y,x);
	}
    }

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void get_moves(integer monptr, mm_type mm)
{
    /*{ Choose correct directions for monster movement }*/
    /*  
     * This is so much nicer in imoria, I should check to see
     * if they have the same effect.
     */

    integer   y,ay,x,ax,move_val;

    y  = m_list[monptr].fy - char_row;
    x  = m_list[monptr].fx - char_col;
    ay = abs(y);
    ax = abs(x);

    if (y < 0) {
	move_val = 8;
    } else {
	move_val = 0;
    }

    if (x > 0) {
	move_val += 4;
    }

    if (ay > (ax*1.7321)) {   /*{ pi/2, in case you were wondering }*/
	move_val = move_val + 2;
    } else if (ax > (ay*1.7321)) {
	move_val++;
    }

    switch (move_val) {
    case 0     :   
	mm[1] = 9;
	if (ay > ax) {
	    mm[2] = 8;
	    mm[3] = 6;
	    mm[4] = 7;
	    mm[5] = 3;
	} else {
	    mm[2] = 6;
	    mm[3] = 8;
	    mm[4] = 3;
	    mm[5] = 7;
	}
	break;

    case 1: case 9   :   
	mm[1] = 6;
	if (y < 0) {
	    mm[2] = 3;
	    mm[3] = 9;
	    mm[4] = 2;
	    mm[5] = 8;
	} else {
	    mm[2] = 9;
	    mm[3] = 3;
	    mm[4] = 8;
	    mm[5] = 2;
	}
	break;
	
    case 2: case 6   :   
	mm[1] = 8;
	if (x < 0) {
	    mm[2] = 9;
	    mm[3] = 7;
	    mm[4] = 6;
	    mm[5] = 4;
	} else {
	    mm[2] = 7;
	    mm[3] = 9;
	    mm[4] = 4;
	    mm[5] = 6;
	}
	break;
	
    case 4     :   
	mm[1] = 7;
	if (ay > ax) {
	    mm[2] = 8;
	    mm[3] = 4;
	    mm[4] = 9;
	    mm[5] = 1;
	} else {
	    mm[2] = 4;
	    mm[3] = 8;
	    mm[4] = 1;
	    mm[5] = 9;
	}
	break;
	
    case 5: case 13  :   
	mm[1] = 4;
	if (y < 0) {
	    mm[2] = 1;
	    mm[3] = 7;
	    mm[4] = 8;
	    mm[5] = 2;
	} else {
	    mm[2] = 7;
	    mm[3] = 1;
	    mm[4] = 2;
	    mm[5] = 8;
	}
	break;

    case 8     :   
	mm[1] = 3;
	if (ay > ax) {
	    mm[2] = 2;
	    mm[3] = 6;
	    mm[4] = 1;
	    mm[5] = 9;
	} else {
	    mm[2] = 6;
	    mm[3] = 2;
	    mm[4] = 9;
	    mm[5] = 1;
	}
	break;

    case 10: case 14 :   
	mm[1] = 2;
	if (x < 0) {
	    mm[2] = 1;
	    mm[3] = 3;
	    mm[4] = 4;
	    mm[5] = 6;
	} else {
	    mm[2] = 3;
	    mm[3] = 1;
	    mm[4] = 6;
	    mm[5] = 4;
	}
	break;
	
    case 12    :   
	mm[1] = 1;
	if (ay > ax) {
	    mm[2] = 2;
	    mm[3] = 4;
	    mm[4] = 3;
	    mm[5] = 7;
	} else {
	    mm[2] = 4;
	    mm[3] = 2;
	    mm[4] = 7;
	    mm[5] = 3;
	}
	break;
    }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean monster_spell_effects(integer thrown_spell, integer monptr, 
			      char *cdesc, char *ddesc)
{
  /* return true if monster moves */

  integer   x, y;
  real      r1;
  boolean   did_move = false;
  vtype     outval;

  switch (thrown_spell) {
    
  case 5 :   /*{Teleport Short} */
    teleport_away(monptr,4);
    did_move = true;
    break;
    
  case 6 :  /* {Teleport Long } */
    teleport_away(monptr,MAX_SIGHT);
    did_move = true;
    break;
    
  case 7 :  /* {Teleport To   } */
    strcat(cdesc, "beckons you near.");
    msg_print(cdesc);
    msg_print(" ");
    teleport_to(m_list[monptr].fy,m_list[monptr].fx);
    break;
    
  case 8 :  /* {Light Wound   } */
    strcat(cdesc, "hurls a frisbee at you");
    msg_print(cdesc);
    if (player_saves(wis_adj()+py.misc.lev)) {
      msg_print("You dodge out of the way...");
    } else {
      take_hit(damroll("2d8"),ddesc);
    }
    break;

  case 9 :  /* {Serious Wound } */
    strcat(cdesc, "sends an energy bolt your way.");
    msg_print(cdesc);                     
    if (player_saves(wis_adj()+py.misc.lev)) {
      msg_print("You duck just in time...");
    } else {
      take_hit(damroll("8d8"),ddesc);
    }
    break;

  case 10 :  /* {Hold Person   } */
	strcat(cdesc, "shoots a freeze ray at you.");
	msg_print(cdesc);
	if (py.flags.free_act) {
	    msg_print("You are unaffected...");
	} else if (player_saves(wis_adj()+py.misc.lev)) {
	    msg_print("You shake out of it...");
	} else if (py.flags.paralysis > 0) {
	    py.flags.paralysis=py.flags.paralysis+2;
	    msg_print("You are stuck even more!");
	} else {
	    py.flags.paralysis=randint(5)+4;
	    msg_print("You are held in place!");
	}
	break;

    case 11 :  /* {Cause Blindnes} */
	strcat(cdesc, "throws sand in your face.");
	msg_print(cdesc);
	if (player_saves(wis_adj()+py.misc.lev)) {
	    msg_print("You grit your teeth and bear it...");
	} else if (py.flags.blind > 0) { 
	    py.flags.blind = py.flags.blind + 5;
	} else {
	    py.flags.blind = py.flags.blind+12+randint(3);
	    msg_print(" ");
	}
	break;

    case 12 :  /* {Cause Confuse } */
	strcat(cdesc, "tries to confuse you.");
	msg_print(cdesc);
	if (player_saves(wis_adj()+py.misc.lev)) {
	    msg_print("You resist the attempt...");
	} else if (py.flags.confused > 0) {
	    py.flags.confused = py.flags.confused + 2;
	} else {
	    py.flags.confused = randint(5) + 3;
	}
	break;

    case 13 :  /* {Cause Fear} */
	strcat(cdesc, "tries to scare you.");
	msg_print(cdesc);
	if (player_saves(wis_adj()+py.misc.lev)) {
	    msg_print("Your bravery holds true...");
	} else if (py.flags.afraid > 0) {
	    py.flags.afraid = py.flags.afraid + 2;
	} else {
	    py.flags.afraid = randint(5) + 3;
	}
	break;

    case 14 :  /* {Summon Monster} */
	strcat(cdesc, "summons an underling!");
	msg_print(cdesc);
	y = char_row;
	x = char_col;
	summon_monster(&y,&x,false);
	check_mon_lite(y,x);
	break;

    case 15 :  /* {Summon Undead} */
	strcat(cdesc, "summons a mutant!");
	msg_print(cdesc);
	y = char_row;
	x = char_col;
	summon_undead(&y,&x);
	check_mon_lite(y,x);
	break;

    case 16 :  /* {Slow Person  } */
	strcat(cdesc, "attempts to tangle you in taffy.");
	msg_print(cdesc);
	if (py.flags.free_act) {
	    msg_print("You are unaffected...");
	} else if (player_saves(wis_adj()+py.misc.lev)) {
	    msg_print("You lick the taffy right off!.");
	} else if (py.flags.slow > 0) {
	    py.flags.slow = py.flags.slow + 2;
	} else {
	    py.flags.slow = randint(5) + 3;
	}
	break;

    case 17 :  /* {Drain Mana } */
	if (trunc(py.misc.cmana) > 0) {
	  sprintf(outval, "%s%s", cdesc, "drains resources from you!");
	    msg_print(outval);
	    sprintf(outval, "%s%s", cdesc, "appears more powerful...");
	    msg_print(outval);
	    r1 = randint(c_list[m_list[monptr].mptr].level);
	    if (r1 > py.misc.cmana) { r1 = py.misc.cmana; }
	    py.misc.cmana = py.misc.cmana - r1;
	    m_list[monptr].hp += 5*trunc(r1);
	}
	break;
	
    case 20 :  /* {Breathe Light} */
	strcat(cdesc, "shoots lightning at you!");
	msg_print(cdesc);
	explosion(1,char_row,char_col,
		  trunc(m_list[monptr].hp/3.0),2,true,"lightning");
	break;
	
    case 21 :  /* {Breathe Gas } */
	strcat(cdesc, "throws a gas grenade at you!");
	msg_print(cdesc);
	explosion(2,char_row,char_col,
		  trunc(m_list[monptr].hp/3.0),2,true,"poisonous gas");
	break;
	
    case 22 :  /* {Breath Acid } */
	strcat(cdesc, "douses you with acid.");
	msg_print(cdesc);
	explosion(3,char_row,char_col,
		  trunc(m_list[monptr].hp/3.0),2,true,"acid");
	break;

    case 23 :  /* {Breath Frost } */
	strcat(cdesc, "covers you with frost.");
	msg_print(cdesc);
	explosion(4,char_row,char_col,
		  trunc(m_list[monptr].hp/3.0),2,true,"frost");
	break;

    case 24 :  /* {Breath Fire } */
	strcat(cdesc, "blasts you with fire.");
	msg_print(cdesc);
	explosion(5,char_row,char_col,
		  trunc(m_list[monptr].hp/3.0),2,true,"fire");
	break;

    default:
	msg_print("Creature cast unknown spell.");
	cdesc = "";
	break;

    }

    return did_move;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean cast_spell(integer  monptr, boolean *took_turn)
{ 
    /*
      { Creatures can cast spells too. 
      cast_spell = true if creature changes position
      took_turn  = true if creature casts a spell }
      */

    unsigned   i1;
    integer    i2,i3,chance,thrown_spell;
    integer    spell_choice[31+1];
    vtype      cdesc,ddesc;
    boolean    flag;
    boolean    did_move;

    //with m_list[monptr]. do;
    //with c_list[m_list[monptr].mptr]. do;

    chance = (uand(c_list[m_list[monptr].mptr].spells,0x0000000F));

    /*{ 1 in x chance of casting spell }*/
    if (randint(chance) != 1) {
	did_move    = false;
	*took_turn  = false;

	/*{ Must be within certain range }*/
    } else if (m_list[monptr].cdis > MAX_SPELL_DIS) {
	did_move    = false;
	*took_turn  = false;

	/*{ Must have unobstructed Line-Of-Sight }*/
    } else if (!(los(char_row,char_col,m_list[monptr].fy,m_list[monptr].fx))) {
	did_move    = false;
	*took_turn  = false;
    } else {
	
	/*{ Creature is going to cast a spell }*/
	did_move    = false;
	*took_turn  = true;
	
	/*{ Describe the attack }*/
	flag = true;
	if (!m_list[monptr].ml) {
	    flag = false;
	} else if ((uand(0x10000,c_list[m_list[monptr].mptr].cmove) != 0) &&
		   (!(py.flags.see_inv))) {
	    flag = false;
	} else if (py.flags.blind > 0) {
	    flag = false;
	}

	if (flag) {
	  sprintf(cdesc, "The %s ", c_list[m_list[monptr].mptr].name);
	} else {
	  strcpy(cdesc, "It ");
	}


	/*{ For "DIED_FROM" string }*/
	if (uand(0x80000000,c_list[m_list[monptr].mptr].cmove) != 0) {
	  sprintf(ddesc, "The %s", c_list[m_list[monptr].mptr].name);
	} else {
	  sprintf(ddesc, "& %s", c_list[m_list[monptr].mptr].name);
	}
	strcpy(temporary_slot.name, ddesc);
	temporary_slot.number = 1;
	objdes(ddesc,1,true,'t');

	/*{ End DIED_FROM. Extract all possible spells into spell_choice }*/
	i1 = uand(c_list[m_list[monptr].mptr].spells,0xFFFFFFF0);
	i3 = 0;
	for (;i1 != 0;) {
	    i2 = bit_pos(&i1) + 1;  /* XXXX is the +1 needed? */
	    i3++;
	    spell_choice[i3] = i2;
	}

	/*{ Choose a spell to cast }*/
	thrown_spell = spell_choice[randint(i3)];

	/*{ Cast the spell... }*/
	did_move = monster_spell_effects(thrown_spell, monptr, cdesc, ddesc);

   }

    return did_move;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean monster_hits(integer a_type, integer monptr)
{
    boolean flag  = false;
    integer level = c_list[m_list[monptr].mptr].level;
    integer intel = c_list[m_list[monptr].mptr].intel;

    /*{ hit conditions for various attacks }*/

    //with py.misc do;
    switch (a_type) {

    case 1  :  /* {Normal attack } */
	if (test_hit(60+intel,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 2  :  /* {Poison Strength} */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 3  :  /* {Confusion attack} */
	if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 4  :  /* {Fear attack } */
	if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 5  :  /* {Fire attack } */
	if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 6  :  /* {Acid attack } */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 7  :  /* {Cold attack } */
	if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 8  :  /* {Lightning attack} */
	if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 9  :  /* {Corrosion attack} */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 10 :  /* {Blindness attack} */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;

    case 11 :  /* {Paralysis attack} */
	if (test_hit(4,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 12 :  /* {Steal Money } */
	if (test_hit(8,level,0,py.misc.lev)) {
	    if (py.misc.au > 0) {
		flag = true;
	    }
	}
	break;
	
    case 13 :  /* {Steal Object } */
	if (test_hit(5,level,0,py.misc.lev)) {
	    if (inven_ctr > 0) {
		flag = true;
	    }
	}
	break;
	
    case 14 :  /* {Poison } */
	if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 15 :  /* {Lose dexterity} */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 16 :  /* {Lose constitution} */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 17 :  /* {Lose intelligence} */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 18 :  /* {Lose wisdom} */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 19 :  /* {Lose experience} */
	if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 20 :  /* {Aggravate monsters} */
	flag = true;
	break;
	
    case 21 :  /* {Disenchant } */
	if (test_hit(7,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 22 :  /* {Eat food } */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 23 :  /* {Eat light } */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 24 :  /* {Eat charges } */
	if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 25 :  /* {Vampire bite } */
	if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 26 :  /* {Turn to stone } */
      if (test_hit(10,level,0,PM.pac+PM.ptoac)) {
	  flag = true;
      }
      break;
      
    case 29 :  /* {Vargouillian bite } */
	if (test_hit(3,level,0,PM.pac+PM.ptoac)) { 
	    flag = true;
	}
	break;
	
    case 30 :  /* {Cause disease} */
	if ((randint(124) > py.stat.ccon) ||
	    (randint(100) > 95)) {
	    flag = true;
	}
	break;
	
    case 31 :  /* {Lose charisma} */
	if (test_hit(0,level,0,PM.pac+PM.ptoac)) {
	    flag = true;
	}
	break;
	
    case 99 :
	flag = true;
	break;

    default:
	break;
    }
    
    return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean monster_hit_effects(integer a_type, integer monptr, integer dam, 
			    char *cdesc, char *ddesc, char *damstr)
{
    /* returns true if monster moves */

    boolean   did_move = false;
    boolean   flag;
    integer   i1, i2;

    obj_set   food_set = {80};
    obj_set   drainable_set = {55,60,65};

    switch (a_type) {
    case 1  :  /*  {Normal attack  } */
	dam = damroll(damstr);
	//with py.misc do;
	dam -= (integer)(((PM.pac+PM.ptoac)/300.0)*dam + .5);
	take_hit(dam,ddesc);
	prt_chp();
	break;

    case 2  :  /*  {Poison Strength} */
	take_hit(damroll(damstr),ddesc);
	if (py.flags.sustain_str) {
	    msg_print("You feel weaker for a moment, then it passes.");
	} else if (randint(2) == 1) {
	    msg_print("You feel weaker.");
	    py.stat.cstr = de_statp(py.stat.cstr);
	    prt_strength();
	}
	prt_chp();
	break;

    case 3  :  /*  {Confusion attack} */
	//with py.flags do;
	take_hit(damroll(damstr),ddesc);
	if (randint(50) > py.stat.cint) {
	    if (PF.confused < 1) {
		msg_print("You feel confused.");
		PF.confused += randint(c_list[m_list[monptr].mptr].intel);
	    }
	    PF.confused += 3;
	}
	prt_chp();
	break;

    case 4  :  /*  {Fear attack } */
	//with py.flags do;
	take_hit(damroll(damstr),ddesc);
	if (player_saves(wis_adj())) {
	  msg_print("You resist the effects!");
	} else if (PF.afraid < 1) {
	    msg_print("You are suddenly afraid!");
	    PF.afraid += 3 + randint(c_list[m_list[monptr].mptr].level);
	} else {
	  PF.afraid += 3;
	}
	prt_chp();
	break;

    case 5  :  /*  {Fire attack } */
	msg_print("You are enveloped in flames!");
	fire_dam(damroll(damstr),ddesc);
	break;

    case 6  :  /*  {Acid attack } */
	msg_print("You are covered in acid!");
	acid_dam(damroll(damstr),ddesc);
	break;

    case 7  :  /*  {Cold attack } */
	msg_print("You are covered with frost!");
	cold_dam(damroll(damstr),ddesc);
	break;

    case 8  :  /*  {Lightning attack} */
	msg_print("Lightning strikes you!");
	light_dam(damroll(damstr),ddesc);
	break;

    case 9  :  /*  {Corrosion attack} */
	msg_print("A stinging red gas swirls about you.");
	corrode_gas(randint(8),ddesc);
	take_hit(damroll(damstr),ddesc);
	prt_chp();
	break;

    case 10 :  /*  {Blindness attack} */
	//with py.flags do;
	take_hit(damroll(damstr),ddesc);
	if (PF.blind < 1) {
	    PF.blind += 10 + randint(c_list[m_list[monptr].mptr].level);
	    msg_print("Your eyes begin to sting.");
	    msg_print(" ");
	}
	PF.blind += 5;
	prt_chp();
	break;

    case 11 :  /*  {Paralysis attack} */
	//with py.flags do;
	take_hit(damroll(damstr),ddesc);
	if (player_saves(con_adj())) {
	    msg_print("You resist the effects!");
	} else if (PF.paralysis < 1) {
	    if (PF.free_act) {
		msg_print("You are unaffected.");
	    } else {
		PF.paralysis = randint(c_list[m_list[monptr].mptr].level) + 3;
		msg_print("You are paralyzed.");
	    }
	}
	prt_chp();
	break;

    case 12 :  /*  {Steal Money } */
	//with py.misc do;
	/*{ 5% guaranteed sucess. }*/
	if (((randint(100) > 95) ||
	     (randint(60) < py.stat.cdex))
	    && (py.flags.paralysis < 1)) {
	    msg_print("You quickly protect your money pouch!");
	} else {
	    i1 = trunc(PM.au/10) + randint(25);
	    if (i1 > PM.au) {
		PM.au = 0;
	    } else {
		PM.au -= i1;
	    }
	    msg_print("Your purse feels lighter.");
	    prt_gold();
	}
	if (randint(2) == 1) {
	    msg_print("There is a puff of smoke!");
	    teleport_away(monptr,MAX_SIGHT);
	    did_move = true;
	}
	break;

    case 13 :  /*  {Steal Object } */
	//with py.stat do
	    /*{ 5% guaranteed sucess. }*/
           if (((randint(100) > 95) ||
		(randint(60) < py.stat.cdex))
	       && (py.flags.paralysis < 1)) {
	       msg_print("You grab hold of your backpack!");
	   } else {
	       i1 = randint(inven_ctr);
	       inven_destroy(i1);
	       msg_print("Your backpack feels lighter.");
	   }
	if (randint(2) == 1) {
	    msg_print("There is a puff of smoke!");
	    teleport_away(monptr,MAX_SIGHT);
	    did_move = true;
	}
	break;

    case 14 :  /*  {Poison } */
	//with py.flags do
      take_hit(damroll(damstr),ddesc);
      prt_chp();
      msg_print("You feel very sick.");
      PF.poisoned += randint(c_list[m_list[monptr].mptr].level)+5;
      Opusii_vomit(randint(c_list[m_list[monptr].mptr].level)+5);
      break;

    case 15 :  /*  {Lose dexterity } */
	//with py.flags do;
	take_hit(damroll(damstr),ddesc);
	if (PF.sustain_dex) {
	    msg_print("You feel clumsy for a moment, then it passes.");
	} else {
	    msg_print("You feel more clumsy.");
	    py.stat.cdex = de_statp(py.stat.cdex);
	    prt_dexterity();
	}
	prt_chp();
	break;

    case 16 :  /*  {Lose constitution } */
	//with py.flags do
      take_hit(damroll(damstr),ddesc);
	if (PF.sustain_con) {
	  msg_print("Your body resists the effects of the disease.");
	} else {
	  msg_print("Your health is damaged!");
	  py.stat.ccon = de_statp(py.stat.ccon);
	  prt_constitution();
	}
	prt_chp();
	break;

    case 17 :  /*  {Lose intelligence } */
	//with py.flags do;
	take_hit(damroll(damstr),ddesc);
	if (PF.sustain_int) {
	    msg_print("You feel your memories fading...");
	    msg_print("Your memories are suddenly restored!");
	} else {
	    msg_print("You feel your memories fading...");
	    py.stat.cint=de_statp(py.stat.cint);
	    prt_intelligence();
	}
	prt_chp();
	break;

    case 18 :  /*  {Lose wisdom  } */
	//with py.flags do;
	take_hit(damroll(damstr),ddesc);
	if (PF.sustain_wis) {
	    msg_print("Your wisdom is sustained.");
	} else {
	    msg_print("You feel less astute.");
	    py.stat.cwis = de_statp(py.stat.cwis);
	    prt_wisdom();
	}
	prt_chp();
	break;

    case 19:  /*  {Lose experience  } */
	msg_print("You feel your life draining away!");
	i1 = damroll(damstr)+
	    (py.misc.exp div 100)*MON_DRAIN_LIFE;
	lose_exp(i1);
	break;

    case 20:  /*  {Aggravate monster} */
	aggravate_monster(5);
	break;

    case 21:  /*  {Disenchant } */
      flag = false;
      switch (randint(6)) {
      case 1 : i1 = 23; break;
      case 2 : i1 = 26; break;
      case 3 : i1 = 27; break;
      case 4 : i1 = 32; break;
      case 5 : i1 = 28; break;
      case 6 : i1 = 24; break;
      }

      //with equipment[i1]. do
      if (equipment[i1].tohit > 0) {
	equipment[i1].tohit -= randint(2);
	flag = true;
      }
      if (equipment[i1].todam > 0) {
	equipment[i1].todam -= randint(2);
	flag = true;
      }
      if (equipment[i1].toac > 0) {
	equipment[i1].toac -= randint(2);
	flag = true;
      }
      
      if (flag) {
	msg_print("There is a static feeling in the air...");
	py_bonuses(&blank_treasure,1);
      }
      break;
      
    case 22:  /*  {Eat food } */
	if (find_range(food_set,&i1,&i2)) {
	  inven_destroy(i1);
	} else {
	  strcat(cdesc, "is unsatiated.");
	  msg_print(cdesc);
	}
	break;

    case 23:  /*  {Eat light } */
	//with equipment[33]. do;
	if (equipment[33].p1 > 0) {
	  equipment[33].p1 -= 250 + randint(250);
	    if (equipment[33].p1 < 1) { equipment[33].p1 = 1; }
	    msg_print("Your light dims...");
	}
	break;

    case 24:  /*  {Eat charges } */
	if (inven_ctr > 0) {
	    i1 = randint(inven_ctr);
	    //with inventory[i1]. do;
	    if (is_in(inventory[i1].tval, drainable_set)) {
		if (inventory[i1].p1 > 0) {
		    m_list[monptr].hp += 5 * inventory[i1].p1;
		    inventory[i1].p1 = 0;
		    msg_print("Energy drains from your pack!");
		}
	    }	
	}
	break;

case 25:  /*  {Vampire Bite -MWK} */
    /*{Lose experience}*/
    msg_print("You feel your life draining away!");
    i1= damroll(damstr) + (py.misc.exp div 100)*MON_DRAIN_LIFE;
    lose_exp(i1);

    /*{Poison Strength}*/
    take_hit(damroll(damstr),ddesc);
    if (py.flags.sustain_str) {
	msg_print("You feel weaker for a moment, then it passes.");
    } else {
	if (randint(2) == 1) {
	    msg_print("You feel weaker.");
	    py.stat.cstr = de_statp(py.stat.cstr);
	    prt_strength();
	}
    }
    prt_chp();
    break;

    case 26 :   /* {turn to stone -jeb} */
	if (randint(100) > 50) {
	    py.flags.petrified += randint(20); 
	    if (py.flags.petrified < 40) {
		msg_print("Your blood thickens!");
	    } else if (py.flags.petrified < 80) {
		msg_print("You need a rubdown!");
	    } else if (py.flags.petrified < 120) {
		msg_print("Your joints stiffen...");
	    } else if (py.flags.petrified < 160) {
		msg_print("Your skin turns stoney grey!");
	    } else if (py.flags.petrified < 200) {
		msg_print("You can barely move!");
	    } else {
		msg_print("You are thoroughly stoned.");
	    }

	    if (py.flags.petrified > 200) {
		py.misc.chp = -1;
		take_hit(0,ddesc);
	    }
	}
	break;

    case 27 :  /*  {Mind Flayer} */
	if ((randint(60) < py.stat.cdex) &&
	    (randint(5) == 5)) {
	    msg_print("The Mind Flayer's tentacles touch you.");
	    msg_print("Your neurons have been sucked out.");
	    py.stat.cint = 3;
	    prt_intelligence();
	    msg_print("Your head feels lighter.");
	    msg_print("");
	    take_hit(0,ddesc);
	}
	break;

    case 28 :  /*  {Hell Horse/Nightmare} */
	//with py.flags do;
	PF.blind += randint(5);
	msg_print("Your eyes sting.");
	take_hit(damroll(damstr),ddesc);
	break;

    case 29 :  /*  {Vargouillian Attack-NBT} */
	/*{ Lose Max H.P. by 1d6 }*/
	take_hit(damroll(damstr),ddesc);
	if (py.flags.sustain_str) {
	    msg_print("You feel weaker for a moment, then it passes.");
	    
	    /*{ If player fails save vs poison, nail the muther }*/
	    
	} else if (randint(3) > 1) {
	    msg_print("Your hit points are drained!");
	    //with py.misc do;
	    PM.mhp -= randint(6);
	    if (PM.mhp < PM.chp) {
		PM.chp = PM.mhp;
	    }
	    prt_mhp();
	    prt_chp();
	}
	prt_chp();
	break;

    case 30 :  /*  {infect player with disease(s)  --jeb} */
      py.flags.diseased++;
      strcat(cdesc, "gives you a social disease.");
      msg_print(cdesc);
      break;

    case 31 :  /*  {Lose charisma  } */
	//with py.flags do;
	take_hit(damroll(damstr),ddesc);
	if (PF.sustain_chr) {
	    msg_print("Your charisma is sustained.");
	} else {
	    msg_print("Your charisma is drained.");
	    py.stat.cchr = de_statp(py.stat.cchr);
	    prt_charisma();
	}
	prt_chp();
	break;

    case 99 :  
	break;

    default:
	break;
    }

    return did_move;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean make_attack(integer monptr)
{
  /* returns true if monster moved */
  
  /*{ Make an attack on the player (chuckle...) }*/
  
  integer   a_type,adesc,dam,i7;
  vtype     attstr,attx,cdesc,ddesc;
  dtype     damstr;
  boolean   flag;
  boolean   did_move = false;
  char     *achar;
  
  //with m_list[monptr]. do;
  //with c_list[m_list[monptr].mptr]. do;
  strcpy(attstr, c_list[m_list[monptr].mptr].damage);
  
  if ((uand(0x10000,c_list[m_list[monptr].mptr].cmove) != 0) &&
      (!(py.flags.see_inv))) {
    strcpy(cdesc, "It ");
  } else if (py.flags.blind > 0) {
    strcpy(cdesc, "It ");
  } else if (!m_list[monptr].ml) {
    strcpy(cdesc, "It ");
  } else {
    sprintf(cdesc,  "The %s ", c_list[m_list[monptr].mptr].name);
  }
  
  /*{ For "DIED_FROM" string }*/
  if (uand(0x80000000,c_list[m_list[monptr].mptr].cmove) != 0) {
    sprintf(ddesc, "The %s", c_list[m_list[monptr].mptr].name);
  } else {
    sprintf(ddesc, "& %s", c_list[m_list[monptr].mptr].name);
  }
  strcpy(temporary_slot.name, ddesc);
  temporary_slot.number = 1;
  objdes(ddesc,1,true,'t');
  /*{ End DIED_FROM }*/
  
  
  /* attstr looks like this: "1 32 4d4|2 21 0d0" */
  for ( ; attstr[0] != 0 ; ) {
    
    achar = strchr(attstr,'|');
    if (achar != NULL) {
      strcpy(attx, attstr);
      achar = strchr(attx, '|');
      (*achar) = 0;
      achar++;
      strcpy(attstr, achar);
    } else {
      strcpy(attx, attstr);
      attstr[0] = 0;
    }
    
    sscanf(attx, "%ld %ld %s", &a_type, &adesc, damstr);

    flag = false;
    if (py.flags.protevil > 0) {
      if (uand(c_list[m_list[monptr].mptr].cdefense,0x0004) != 0) {
	if ((py.misc.lev+1) > c_list[m_list[monptr].mptr].level) {
	  a_type = 99;
	  adesc = MAX_ATTACK_DESC;
	}
      }
    }
    
    flag = monster_hits(a_type, monptr);
    
    if (flag) {
      if (adesc != 19) {
	msg_print2(cdesc, attack_desc[adesc]);
      } else {
	/*{Eddie attacks}*/
	if (py.flags.see_inv) {
	  i7 = 11;
	} else {
	  i7 = 7;
	}
	switch (randint(i7)) {
	case  1: msg_print2(cdesc,"insults you.");             break;
	case  2: msg_print2(cdesc,"insults your mother.");     break;
	case  3: msg_print2(cdesc,"wets on your leg.");        break;
	case  4: msg_print2(cdesc,"defiles you.");             break;
	case  5: msg_print2(cdesc,"humiliates you.");          break;
	case  6: msg_print2(cdesc,"laughs at you.");           break;
	case  7: msg_print2(cdesc,"curses you!");              break;
	case  8: msg_print2(cdesc,"moons you!");               break;
	case  9: msg_print2(cdesc,"gives you the finger.");    break;
	case 10: msg_print2(cdesc,"makes obscene gestures.");  break;
	case 11: msg_print2(cdesc,"dances around you.");       break;
	}
      }
      
      did_move |= monster_hit_effects(a_type,monptr,dam,cdesc,ddesc,damstr);
      
    } else {
      switch (adesc) {
      case 1: case 2: case 3: case 6:
	msg_print2(cdesc, "misses you.");
	break;
	    default:
	      break;
      }
    }
  }
  
  return did_move;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean make_move(integer monptr, mm_type mm)
{
/*{ Make the move if possible, five choices }*/

    integer   i1,i2,newy,newx;
    unsigned  movebits;
    boolean   flag,tflag;
    boolean   return_value = false;
    vtype     outval;

   i1   = 1;
   flag = false;
   movebits  = c_list[m_list[monptr].mptr].cmove;

   do {
     /*{ Get new positon }*/
      newy = m_list[monptr].fy;
      newx = m_list[monptr].fx;
      move_dir(mm[i1],&newy,&newx);
      //with cave[newy][newx]. do;

      if (cave[newy][newx].fval != 15) {
	  
	  tflag = false;

	  /*{ Floor is open? }*/
	  if (cave[newy][newx].fopen) {
	      tflag = true;

	      /*{ Creature moves through walls? }*/
	  } else if (uand(movebits,0x40000) != 0) {
	      tflag = true;

	      /*{ Creature can open doors? }*/
	  } else if (cave[newy][newx].tptr > 0) {
	      //with t_list[cave[newy][newx].tptr]. do;
	      //with m_list[monptr] do;
	      if (uand(movebits,0x20000) != 0) {
                     
		  /*{ Creature can open doors. }*/
		  switch (t_list[cave[newy][newx].tptr].tval) {
		  case 105                   :
		      /*{ Closed doors. }*/      
		      if (t_list[cave[newy][newx].tptr].p1 == 0) {
			  tflag = true;
			  if (cave[newy][newx].fm) {
			      if (los(char_row,char_col,newy,newx)) {
				  t_list[cave[newy][newx].tptr] = door_list[1];
				  cave[newy][newx].fopen = true;
				  lite_spot(newy,newx);
				  tflag = false;
			      }
			  }
			  
			  /*{ Locked door  }*/           
		      } else if (t_list[cave[newy][newx].tptr].p1 > 0) {
			if (randint(100-c_list[m_list[monptr].mptr].level) < 5) {
			      t_list[cave[newy][newx].tptr].p1 = 0;
			  }

			  /*{ Stuck doors }*/            
		      } else if (t_list[cave[newy][newx].tptr].p1 < 0) {
			  if (randint(m_list[monptr].hp) > (10+abs(t_list[cave[newy][newx].tptr].p1))) {
			      t_list[cave[newy][newx].tptr].p1 = 0;
			  }
		      }
		      break;
		      
		      /*{ Secret doors..}*/ 
		  case 109 : 
		      tflag               = true;
		      if (cave[newy][newx].fm) {
			  if (los(char_row,char_col,newy,newx)) {
			      t_list[cave[newy][newx].tptr] = door_list[1];
			      cave[newy][newx].fopen = true;
			      lite_spot(newy,newx);
			      tflag        = false;
			  }
		      }
		      break;
		      
		  default:
		      break;
		  }
		  
	      } else {     
		  /*{ Creature can not open doors, must bash them }*/
		  switch (t_list[cave[newy][newx].tptr].tval) {
		  case 105 : 
		      i2 = abs(t_list[cave[newy][newx].tptr].p1) + 20;
		      if (randint(m_list[monptr].hp) > i2) {
			  tflag = true;
			  if (cave[newy][newx].fm) {
			      if (los(char_row,char_col,newy,newx)) {
				  
				  t_list[cave[newy][newx].tptr] = door_list[1];
				  t_list[cave[newy][newx].tptr].p1 = randint(2) - 1;
				  cave[newy][newx].fopen = true;
				  lite_spot(newy,newx);
				  tflag = false;
			      }
			  }
		      }
		      break;
		  case 109 :
		      break;
		  default:
		      break;
		  }
	      }
	  }


	  /*{ Glyph of warding present?  Scare Monster trap}*/ 
	  if (tflag) {
	      if (cave[newy][newx].tptr > 0) {
		  if (t_list[cave[newy][newx].tptr].tval == 102) {
                      if (t_list[cave[newy][newx].tptr].subval == 99) {
                         tflag = false;
		      }
		  }
	      }
	  }


	  if (tflag) {

	      /*{ Creature has attempted to move on player?  }*/
	      if (cave[newy][newx].cptr == 1) {
               
                  if (! (m_list[monptr].ml)) {
		      update_mon(monptr);
		  }
                  if (find_flag) {
                     find_flag = false;
                     move_char(5);
		  }
                  
		  make_attack(monptr);

                  /*{ Player has read a Confuse Monster. 
		    Monster gets a saving throw... }*/
                  if (py.flags.confuse_monster) {
		      //with m_list[monptr] do;
		      //with c_list[mptr] do;
		      msg_print("Your hands stop glowing.");
		      py.flags.confuse_monster = false;
		      if ((randint(MAX_MONS_LEVEL) < c_list[m_list[monptr].mptr].level) ||
			  (uand(0x1000,c_list[m_list[monptr].mptr].cdefense) != 0)) {
			sprintf(outval, "The %s is unaffected.", c_list[m_list[monptr].mptr].name);
			  msg_print(outval);
		      } else {
			sprintf(outval, "The %s appears confused.", c_list[m_list[monptr].mptr].name);
			  msg_print(outval);
			  m_list[monptr].confused = true;
		      }
		  }
                  tflag = false;
                  flag  = true;
		      
		  /*{ Creature is attempting to move on other creature? }*/
	      } else if ((cave[newy][newx].cptr > 1) &&
			 ((newy != m_list[monptr].fy) ||
			  (newx != m_list[monptr].fx))) {

                  /*{ Creature eats other creatures? }*/
                  if (uand(movebits,0x80000) != 0) {
		      delete_monster(cave[newy][newx].cptr);
                  } else {
		      tflag = false;
		  }
	      }
	  }

	  /*{ Creature has been allowed move }*/
	  if (tflag) {
	    //with m_list[monptr]. do;
               
	      /*{ Pick up or eat an object }*/
	      if (uand(movebits,0x100000) != 0) {
		  //with cave[newy][newx]. do;
		  if (cave[newy][newx].tptr > 0) {
		      if (t_list[cave[newy][newx].tptr].tval < 100) {
			  delete_object(newy,newx);
		      }
		  }
	      }

	      /*{ Move creature record }*/
	      move_rec(m_list[monptr].fy,m_list[monptr].fx,newy,newx);
	      m_list[monptr].fy = newy;
	      m_list[monptr].fx = newx;
	      flag = true;
	      return_value = true;
	  }
	  
      } /* if fval != 15 */

      i1++;

      /*{ Up to 5 attempts at moving, then give up }*/
   } while (!flag && (i1 <= 5));

   return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean mon_move(integer monptr)
{
    /*{ Move the critters about the dungeon }*/


    integer   i1,i2,i3;
    mm_type   mm;
    boolean   move_test;
    boolean   return_value = false;
 
    /*{ Main procedure for monster movement (MON_MOVE) }*/

    return_value = false;
    //with c_list[m_list[monptr].mptr]. do;

    /*{ Does the critter multiply? }*/
    if (m_list[monptr].cur_reprod > 0) {        
        if (MAX_MON_MULT >= mon_tot_mult) {     
            if ((py.flags.rest % MON_MULT_ADJ) == 0) {
                //with m_list[monptr]. do;
                i3 = 0;
                for (i1 = m_list[monptr].fy-1; i1 <= m_list[monptr].fy+1; i1++) {
                    for (i2 = m_list[monptr].fx-1; i2 <= m_list[monptr].fx+1; i2++) {
                        if (in_bounds(i1,i2)) {
                            if (cave[i1][i2].cptr > 1) {
                                i3++;
                            }
                        }
                    }
                }

                if (i3 < 4) {
		  if (randint(i3*MON_MULT_ADJ) == 1) {
		    m_list[monptr].cur_reprod--;
		    multiply_monster(m_list[monptr].fy,
				     m_list[monptr].fx,
				     m_list[monptr].mptr,
				     randint(m_list[monptr].cur_reprod),false);
		  }
                }
            }
        }
    }


    move_test = false;
    
    /*{ Creature is confused?  Chance it becomes un-confused  }*/
    if (m_list[monptr].confused) {
        mm[1] = randint(9);
        mm[2] = randint(9);
        mm[3] = randint(9);
        mm[4] = randint(9);
        mm[5] = randint(9);
        return_value = make_move(monptr,mm);
        if (randint(8) == 1) {
            m_list[monptr].confused = false;
        }
        move_test = true;
            
    } else if (c_list[m_list[monptr].mptr].spells > 0) {
      /*{ Creature may cast a spell }*/
      return_value = cast_spell(monptr, &move_test);
    }
    
    if (!move_test) {

	/*{ 75% random movement }*/
        if ((randint(100) < 75) &&
            (uand(c_list[m_list[monptr].mptr].cmove,0x00000020) != 0)) {
            mm[1] = randint(9);
            mm[2] = randint(9);
            mm[3] = randint(9);
            mm[4] = randint(9);
            mm[5] = randint(9);
            return_value = make_move(monptr,mm);
                          
	    /*{ 40% random movement }*/
        } else if ((randint(100) < 40) &&
                   (uand(c_list[m_list[monptr].mptr].cmove,0x00000010) != 0))  {
            mm[1] = randint(9);
            mm[2] = randint(9);
            mm[3] = randint(9);
            mm[4] = randint(9);
            mm[5] = randint(9);
            return_value = make_move(monptr,mm);

	    /*{ 20% random movement }*/
        } else if ((randint(100) < 20) &&
                   (uand(c_list[m_list[monptr].mptr].cmove,0x00000008) != 0))  {
            mm[1] = randint(9);
            mm[2] = randint(9);
            mm[3] = randint(9);
            mm[4] = randint(9);
            mm[5] = randint(9);
            return_value = make_move(monptr,mm);

	    /*{ Normal movement }*/
        } else if (uand(c_list[m_list[monptr].mptr].cmove,0x00000002) != 0) {
            if (randint(200) == 1) {
                mm[1] = randint(9);
		mm[2] = randint(9);
                mm[3] = randint(9);
                mm[4] = randint(9);
                mm[5] = randint(9);
            } else {
                get_moves(monptr,mm);
            }
            return_value = make_move(monptr,mm);

	    /*{ Attacks, but does not move }*/
        } else if (uand(c_list[m_list[monptr].mptr].cmove,0x00000001) != 0) {
            if (m_list[monptr].cdis < 2) {
                get_moves(monptr,mm);
                return_value = make_move(monptr,mm);
            }
        }
    }

    return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void creatures(boolean attack)
{
  /*{ Main procedure for creatures }*/
  
  integer    i1,i2,i3,moldy,moldx;
  integer    rate;
  
  if (muptr > 0) {
    
    /*{ Process the monsters  }*/
    i1 = muptr;
    
    do {
      //with m_list[i1]. do;
      m_list[i1].cdis = distance(char_row,char_col,
				 m_list[i1].fy,m_list[i1].fx);
      if (attack) {  /*{ Attack is argument passed to CREATURE}*/
	i3 = movement_rate(m_list[i1].cspeed);
	if (i3 > 0) {
	  rate = movement_rate(m_list[i1].cspeed);
	  for (i2 = 1; i2 <= rate; i2++) {
	    if ((m_list[i1].cdis <= c_list[m_list[i1].mptr].aaf) || 
		(m_list[i1].ml)) {
	      if (m_list[i1].csleep > 0) {
		if (py.flags.aggravate) {
		  m_list[i1].csleep = 0;
		} else if (py.flags.rest < 1) {
		  if (randint(10) > py.misc.stl) {
		    m_list[i1].csleep -= trunc(75.0/m_list[i1].cdis);
		  }
		}
		if (m_list[i1].stuned > 0) {
		  m_list[i1].stuned--;
		}
	      }
	      if ((m_list[i1].csleep <= 0) && (m_list[i1].stuned <= 0)) {
		moldy = m_list[i1].fy;
		moldx = m_list[i1].fx;
		if (mon_move(i1)) {
		  if (m_list[i1].ml) {
		    m_list[i1].ml = false;
		    if (test_light(moldy,moldx)) {
		      lite_spot(moldy,moldx);
		    } else {
		      unlite_spot(moldy,moldx);
		    }
		  }
		}
	      }
	    }
	    update_mon(i1);
	  }
	} else {
	  update_mon(i1);
	}
      } else {
	update_mon(i1);
      }
      
      i1 = m_list[i1].nptr;
    } while ((i1 != 0) && (!moria_flag));
    /*{ End processing monsters }*/
    
    }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


/* END FILE creature.c */
