/* death.c */
/*
  { Handles the gravestone and the top fifty routines, and
  also the 100-day time limit routine. }
*/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer total_points()
{
  /*	{ Calculates the total number of points earned		-JWT-	}*/
  /*	{ The formula was changed to reflect the difficulty of low exp.  */
  /*      modifier classes like warriors			-Cap'n- }*/
  integer  return_value;

  if (PM.expfact == 0) {
    return_value = PM.max_exp + 100*PM.max_lev;
  } else {
    return_value = trunc(PM.max_exp / PM.expfact) + 100*PM.max_lev;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void top_twenty(integer points, integer this_many)
{
  /*{ Enters a players name on the top twenty list		-JWT-	}*/

  string    list[MAX_HIGH_SCORES+2];
  integer   players_line = 0;
  integer   i1,i2,i3,i4;
  int       n1;
  vtype     o1,s1;
  FILE     *f1;
  boolean   flag;
  char      ch;

//  if (py.misc.cheated) {
//    exit_game();
//  }
  clear_screen();

  if (!read_top_scores(&f1, BOSS_TOP, list, MAX_HIGH_SCORES, &n1, s1)) {
    prt(s1,2,1);
    prt("",3,1);
  } else {

    i3   = points;
    flag = false;
    
    if (i3 == 0) {
      i1 = n1;
    } else {
      for (i1=1; (i1 <= n1) && !flag ; ) {   /* XXXX check for corruption */
	sscanf(&(list[i1][13]),"%ld",&i4);
	if (i4 < i3) {
	  flag = true;
	} else {
	  i1++;
	}
      }
    }

    if ((i3 > 0) && ((flag) || (n1 == 0) || (n1 < MAX_HIGH_SCORES))) {

      for (i2 = MAX_HIGH_SCORES-1; i2 >= i1 ; i2--) {
	strcpy(list[i2+1], list[i2]);
      }
      
      user_name(o1);
      
      format_top_score(list[i1], o1, i3, 3 /*PM.diffic*/, PM.name,
		       PM.lev, PM.race, PM.tclass);
      
      if (n1 < MAX_HIGH_SCORES) {
	n1++;
      }

      max_score    = n1;
      players_line = i1;
      flag         = false;

      write_top_scores(&f1, list, n1);

    } else { 
      /* did not get a high score */
      max_score = 20;
    }      
    
    if (!close_top_scores(&f1)) {
      prt("Error unlocking score file.",2,1);
      prt("",3,1);
    }
    
    put_buffer("Username     Points   Character name          Level Quality      Class",1,1);
    put_buffer("____________ ________ _______________________ _____ ____________ __________",2,1);
    
    i2 = 3;
    if (max_score > n1) {
      max_score = n1;
    }
    
    if (this_many > 0) {
      if (this_many > MAX_HIGH_SCORES) {
	max_score = MAX_HIGH_SCORES;
      } else {
	max_score = this_many;
      }
    }

    for (i1 = 1; i1 <= max_score; i1++) {
      /*insert_str(list[i1],chr(7),''); XXXX  why? */
      if (i1 == players_line) {
	put_buffer_attr(list[i1],i2,1, A_REVERSE);
      } else {
	put_buffer(list[i1],i2,1);
      }
      if ((i1 != 1) && ((i1 % 20) == 0) && (i1 != max_score)) {
	prt("[Press any key to continue, or <Control>-Z to exit]",
	    24,1);
	ch = inkey();
	switch (ch) {
	case 3: case 25: case 26:
	  erase_line(24,1);
	  put_buffer(" ",23,13);
	  exit_game();
	  break;
	}
	clear_rc(3,1);
	i2 = 2;
      }
      i2++;
    } /* end for */
    
    erase_line(23,1);
    put_qio();
    
  } /* end if read_top_scores */
};
//////////////////////////////////////////////////////////////////////
void sc(char *out_str, char *in_str)
{
  strcpy(out_str, in_str);
}
//////////////////////////////////////////////////////////////////////
void si(char *out_str, char *part1, char *part2, char *part3)
{
  sprintf(out_str, "%s%s%s", part1, part2, part3);
}
//////////////////////////////////////////////////////////////////////
static void date(day)
char *day;
{
  register char *tmp;
  long clockvar;

  clockvar = time((long *) 0);
  tmp = (char *)ctime(&clockvar);
  tmp[10] = '\0';
  (void) strcpy(day, tmp);
}
//////////////////////////////////////////////////////////////////////
char* fill_str(char *centered_str, char *in_str, int width)
{
  /*{ Centers a string within a <width> character string	-JWT-	}*/

  register int i, j;

  i = strlen(in_str);
  j = width/2 - i/2;
  (void) sprintf (centered_str, "%*s%s%*s", j, "", in_str, width - i - j, "");
  return centered_str;

};
//////////////////////////////////////////////////////////////////////
static void dprint(vtype str, integer row)
{
/*{ Prints a line to the screen efficiently		-RAK-	}*/

  integer   i1,i2,nblanks,xpos,slen;
  vtype     prt_str;

  prt_str[0]  = 0;
  nblanks     = 0;
  xpos        = 0;

  slen = strlen(str);
  for (i1 = 0; i1 < slen; i1++) {
//printf("\tdo a char: %d >%c<\n",i1,str[i1]); fflush(stdout);
    if (str[i1] == ' ') {
      if (xpos > 0) {
	nblanks++;
	if (nblanks > 5) {
	  nblanks = 0;
	  put_buffer(prt_str,row,xpos);
	  prt_str[0] = 0;
	  xpos = 0;
	}
      }
    } else {
      if (xpos == 0) {
	xpos = i1;
      }
      if (nblanks > 0) {
	for (i2 = 0; i2 < nblanks; i2++) {
	  strcat(prt_str, " ");
	}
	nblanks = 0;
      }
      strncat(prt_str, &(str[i1]), 1);
    }
  } /* end for */

  if (xpos > 0) {
//    printf("doing final put_buffer >%s<\n",prt_str); fflush(stdout);
    put_buffer(prt_str,row,xpos);
  }
}
//////////////////////////////////////////////////////////////////////
static void print_tomb()
{
  /*{ Prints the gravestone of the character }*/

  vtype   str1,str2,str3,str4,str5,str6,str7,str8;
  vtype   dd[20];
  vtype   fnam;
  char    command;
  FILE   *f1;
  integer i1;
  vtype   deathdate;
  vtype   temp, out_str;
  boolean flag;

  date(deathdate);

  fill_str(str1, py.misc.name, 31);
  fill_str(str2, py.misc.title, 31);
  fill_str(str3, py.misc.tclass, 31);
  sprintf(temp,"Level : %d", py.misc.lev);
  fill_str(str4, temp, 31);
  sprintf(temp,"%ld Exp", py.misc.exp);
  fill_str(str5, temp, 31);
  sprintf(temp,"%ld Dollars", py.misc.au);
  fill_str(str6, temp, 31);
  sprintf(temp,"Died near %s", townlist[town_num].town_name);
  fill_str(str7, temp, 31);
  fill_str(str8, died_from, 31);
sc(dd[ 0]," ");
sc(dd[ 1],"               _______________________");
sc(dd[ 2],"              /                       \\         ___");
sc(dd[ 3],"             /                         \\ ___   /   \\      ___");
sc(dd[ 4],"            /            RIP            \\   \\  |   |     /   \\");
sc(dd[ 5],"           /                             \\  | _|___|_    |   |");
si(dd[ 6],"          /",str1,                       "\\_|_          _|___|_");
sc(dd[ 7],"         |               the               |   ___");
si(dd[ 8],"         | ",str2,                       " |  /   \\");
sc(dd[ 9],"         |                                 |  |   |");
si(dd[10],"         | ",str3,                       " | _|___|_   ____");
si(dd[11],"         | ",str4,                       " |          /    \\");
si(dd[12],"         | ",str5,                       " |          |    |");
si(dd[13],"         | ",str6,                       " |          |    |");
si(dd[14],"         | ",str7,                       " |         _|____|_");
sc(dd[15],"         |            killed by            |");
si(dd[16],"         | ",str8,                       " |");
si(dd[17],"         |           ",deathdate,"            |");
sc(dd[18],"        *|   *     *     *    *   *     *  | *");
sc(dd[19],"_______)/\\\\_)_/___(\\/___(//_\\)/_\\//__\\\\(/_|_)_______");

 clear_from(1);
 for (i1 = 0; i1 <= 19; i1++) {
   dprint(dd[i1],i1+1);
 }
 flush();

 if (get_com("Print to file? (Y/N)",&command)) {
   switch (command) {
   case 'y': case 'Y':
     prt("Enter Filename:",1,1);
     flag = false;

     do {
       if (get_string(fnam,1,17,60)) {
	 if (strlen(fnam) == 0) {
	   strcpy(fnam, "BOSSCHR.DIE");
	 }

	 f1 = (FILE *)fopen(fnam, "w");
	 if (f1 == NULL) {
	   sprintf(out_str, "Error creating> %s",fnam);
	   prt(out_str,2,1);
	 } else {
	   flag = true;
	   for (i1 = 0; i1 < 20; i1++) {
	     fprintf(f1,"%s\n",dd[i1]);
	   }
	   fclose(f1);
	 }
       } else {
	 flag = true;
       }
     } while (!flag);
     break;

   default:
     break;
   }
 }

 flush();
   
 if (get_com("Print character sheet to file? (Y/N)",&command)) {
   switch (command) {
   case 'y': case 'Y' :  
     character_print();
     break;
   default:
     break;
   }
 }
   
};
//////////////////////////////////////////////////////////////////////
static void kingly()
{
/*{ Change the player into a King! }*/

/*{ Change the character attributes.}*/
  dun_level = 0;
  strcpy(died_from,"Ripe Old Age");

//with py.misc. do;

  if (PM.lev <= MAX_PLAYER_LEVEL) {
    PM.lev += MAX_PLAYER_LEVEL;
  }
  PM.max_exp = 1000000*total_winner_num + randint(1000);
  PM.exp     = PM.max_exp;

  /*{ Let the player know that he did good.}*/
  clear_from(1);
  dprint("                                  #",2);
  dprint("                                #####",3);
  dprint("                                  #",4);
  dprint("                            ,,,  $$$  ,,,",5);
  dprint("                        ,,=$   \"$$$$$\"   $=,,",6);
  dprint("                      ,$$        $$$        $$,",7);
  dprint("                      *>         <*>         <*",8);
  dprint("                      $$         $$$         $$",9);
  dprint("                      \"$$        $$$        $$\"",10); 
  dprint("                       \"$$       $$$       $$\"",11);
  dprint("                        *#########*#########*",12);
  dprint("                        *#########*#########*",13);
  dprint("                          Veni, Vidi, Vici!",16);
  dprint("                      You have slain the BOSS!",17);
  dprint("                        And saved the world!",18);
  flush();
  pause_game(24);
};
//////////////////////////////////////////////////////////////////////
void upon_death()
{
  /*{ What happens upon dying...}*/
  integer   points;

  //with py.misc. do;
  points = ( trunc(PM.max_exp/PM.expfact) +
	     100*(PM.max_lev + townlist[town_num].lev_plus) -
	     principal);

  if (total_winner_num > 0) {
    kingly();
    PM.lev += MAX_PLAYER_LEVEL;
    points += 1000000*total_winner_num + 1000*(100-day);
    PM.exp  = PM.max_exp;
  }

  print_tomb();
  top_twenty(points, 50);
  exit(0);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void time_out()
{
  clear_from(1);
  prt("Midnight, the bewitching hour.  It has been 100 days since you",1,3);
  prt("started your quest.  You have been busy, and so has the Boss.",2,3);
  prt("Sadly for you and the world you were supposed to save, the Boss",3,3);
  prt("has amassed enough power to take over the world.  He has seized",4,3);
  prt("control of all major world governments and the world economy.",5,3);
  prt("A simple pack of chewing gum now costs over 400 dollars, and",6,3);
  prt("there is only one brand on the market.  All over the world,",7,3);
  prt("people cry out in vain for freedom and brand name choices.",8,3);
  prt("You were their last hope, and you have let them down.  The Boss",9,3);
  prt("has vacated the Earth and now resides in an ultra-secure satel-",10,3);
  prt("lite orbiting in geosynchronous orbit over Sumatra.  You lose,",11,3);
  prt("although you may explore the Boss' demense to your heart's",12,3);
  prt("content.  But it will do absolutely no good at all.",13,3);
  pause_game(24);
  out_of_time = true;
  draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////


/* END FILE death.c */
