/* desc.c */
/**/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void r__randdesloop(atype str_array[], int count)
{
  integer   i1,i2;
  vtype     tmp;

  for (i1 = 0; i1 < count; i1++) {
	  i2 = randint(count)-1;
	  if (i1 != i2) {
#if DO_DEBUG && 0
	    fprintf(debug_file,"%2ld:%2ld \"%s\" swapped with \"%s\"\n",
		    i1,i2,str_array[i1],str_array[i2]);
#endif
	    strcpy(tmp, str_array[i1]);
	    strcpy(str_array[i1], str_array[i2]);
	    strcpy(str_array[i2], tmp);
	  }
  }
  
};

//////////////////////////////////////////////////////////////////////

void randes()
{
  /*{ Randomize colors, woods, and metals				}*/

  r__randdesloop( colors,    MAX_COLORS);
  r__randdesloop( woods,     MAX_WOODS);
  r__randdesloop( metals,    MAX_METALS);
  r__randdesloop( rocks,     MAX_ROCKS);
  r__randdesloop( amulets,   MAX_AMULETS);
  r__randdesloop( mushrooms, MAX_MUSH);

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void rantitle(char *title)
{
  /*{ Return random title						}*/
  /* title buffer must be at least 11 + (4 * 10) = 51 chars long */

  integer i3;

  i3 = (MAX_SYLLABLES div 4);
  sprintf(title, "Labeled \"%s to %s %s %s\"",
	  syllables[ (i3*0) + randint(i3) - 1 ],
	  syllables[ (i3*1) + randint(i3) - 1 ],
	  syllables[ (i3*2) + randint(i3) - 1 ],
	  syllables[ (i3*3) + randint(i3) - 1 ]  );
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void magic_init(unsigned long random_seed)
{
  //{ Initialize all Potions, wands, staves, scrolls, ect..}

  integer    i1,tmpv;
  vtype      tmps;

  set_seed(random_seed);

  randes();

  for (i1 = 1; i1 <= max_objects; i1++) {
    tmpv = (int)(uand(0xFF,object_list[i1].subval));
    
    switch (object_list[i1].tval) {
    case 3: case 75: case 76:
      if (tmpv <= MAX_COLORS) {
	insert_str(object_list[i1].name,"%C",colors[tmpv-1]);
      }
      break;
      
    case 70: case 71:
      rantitle(tmps);
      insert_str(object_list[i1].name,"%T",tmps);
      break;
      
    case 45 : 
      if (tmpv <= MAX_COLORS) {
	insert_str(object_list[i1].name,"%R",rocks[tmpv-1]);
      }
      break;
      
    case 40 : 
      if (tmpv <= MAX_ROCKS) {
	insert_str(object_list[i1].name,"%A",amulets[tmpv-1]);
      }
      break;
      
    case 65 :
      if (tmpv <= MAX_AMULETS) {
	insert_str(object_list[i1].name,"%M",metals[tmpv-1]);
      }
      break;
      
    case 55 : 
      if (tmpv <= MAX_WOODS) {
	insert_str(object_list[i1].name,"%W",woods[tmpv-1]);
      }
      break;
      
    case 80 : 
      if (tmpv <= MAX_MUSH) {
	insert_str(object_list[i1].name,"%M",mushrooms[tmpv-1]);
      }
      break;
/*
    case 60 : 
    if (tmpv <= MAX_RODS) {
      insert_str(object_list[i1].name,"%D",rods[tmpv-1]);
    }
*/    
    default:
      break;
    }
  }
};

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
char *objdes(char *out_val, integer ptr, boolean pref, char which_list)
{
  char           *cpos;
  vtype           tmp_val;
  treasure_type   obj_describe;
        
  if (which_list == 'e') {
    obj_describe = equipment[ptr];
  } else if (which_list == 't') {
    obj_describe = temporary_slot;
  } else {
    obj_describe = inventory[ptr];
  }

  //with obj_describe. do;
  strcpy(tmp_val, obj_describe.name);
  cpos = strchr(tmp_val,'|');
  if (cpos != NULL) {
    *cpos = 0;
  }

  cpos = strchr(tmp_val,'^');
  if (cpos != NULL) {
    *cpos = 0;
  }

  if (!(pref)) {
    cpos = strstr(tmp_val," (");
    if (cpos != NULL) {
      *cpos = 0;
    }
  }

  insert_num(tmp_val,"%P1",obj_describe.p1,true);
  insert_num(tmp_val,"%P2",obj_describe.tohit,true);
  insert_num(tmp_val,"%P3",obj_describe.todam,true);
  insert_num(tmp_val,"%P4",obj_describe.toac,true);
  insert_num(tmp_val,"%P5",obj_describe.p1,false);
  insert_num(tmp_val,"%P6",obj_describe.ac,false);

  if (obj_describe.number != 1) {
    insert_str(tmp_val,"ch~","ches");
    insert_str(tmp_val,"fe~","ves");
    insert_str(tmp_val,"~","s");
  } else {
    insert_str(tmp_val,"~","");
  }

  if (pref) {
    if (strchr(tmp_val,'&') != NULL) {
      insert_str(tmp_val,"&","");

      if (obj_describe.number > 1) {
	sprintf(out_val,"%d%s",obj_describe.number,tmp_val);
      } else if (obj_describe.number < 1) {
	sprintf(out_val,"no more%s",tmp_val);
      } else if (is_vowel(tmp_val[1])) {
	sprintf(out_val,"an%s",tmp_val);
      } else {
	sprintf(out_val,"a%s",tmp_val);
      }
    } else {
      strcpy(out_val, tmp_val);
    }
    strcat(out_val,".");

  } else {
    insert_str(tmp_val,"& ","");
    strcpy(out_val, tmp_val);
  }

  return out_val;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void known1(char *object_str)
{
  /*{ Remove 'Secret' symbol for identity of object			}*/

  insert_str(object_str, "|", "");

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void known2(char *object_str)
{
  /*{ Remove 'Secret' symbol for identity of pluses			}*/

  insert_str(object_str, "^", "");
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void unquote(char *object_str)
{
  /*	{ Return string without quoted portion				}*/

  integer   pos0,pos1,pos2,olen;
  vtype     str1,str2;

  pos0 = pindex(object_str,'"');
  if (pos0 > 0) {
    pos1 = pindex(object_str,'~');
    pos2 = pindex(object_str,'|');
    olen = strlen(object_str);
    strncpy(str1,object_str,pos1); str1[pos1] = 0;
    strncpy(str2,&(object_str[pos2]),olen-pos2); str2[olen-pos2] = 0;
    sprintf(object_str,"%s%s",str1,str2);
  }

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void identify(treasure_type *item)
{
  /*{ Somethings been identified }*/

  integer   i1,x1,x2;

  x1 = item->tval;
  x2 = item->subval;

  if (strchr(item->name,'|') != NULL) {
    for (i1 = 1; i1 <= MAX_TALLOC; i1++) {
      //with t_list[i1]. do;
      if ((t_list[i1].tval == x1) && (t_list[i1].subval == x2)) {
	unquote(t_list[i1].name);
	known1(t_list[i1].name);
      }
    }

    for (i1 = 1; i1 <= INVEN_MAX; i1++) {
      //with inventory[i1]. do;
      if ((inventory[i1].tval == x1) && (inventory[i1].subval == x2)) {
	unquote(inventory[i1].name);
	known1(inventory[i1].name);
      }
    }
    
    i1 = 0;

    do {
      i1++;
      //with object_list[i1]. do;
      if ((object_list[i1].tval == x1) && (object_list[i1].subval == x2)) {

	if (strstr(object_list[i1].name,"%T") != NULL) {
	  insert_str(object_list[i1].name," %T|","");
	  object_ident[i1] = true;
	} else {
	  unquote(object_list[i1].name);
	  known1(object_list[i1].name);
	  object_ident[i1] = true;
	}
      }
    } while (i1 != max_objects);
   }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE desc.c */
