/* device.c */
/*{ Use an alien device... }*/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void device_effects(integer effect, boolean *ident)
{
  integer i3,y,x;

  switch (effect) {
  case 1  :  *ident = light_area(char_row,char_col);
    break;

  case 2  :  *ident = detect_sdoor();
    break;

  case 3  :  *ident = detect_trap();
    break;

  case 4  :  *ident = detect_treasure();
    break;

  case 5  :  *ident = detect_object();
    break;

  case 6  : 
    teleport(100);
    *ident = true;
    break;

  case 7  :  *ident = earthquake();
    break;

  case 8  : 
    for (i3 = 1; i3 <= randint(4); i3++) {
      y = char_row;
      x = char_col;
      summon_monster(&y,&x,false);
    }
    *ident = true;
    break;

  case 9  :  *ident = genocide();
    break;

  case 10 :  *ident = destroy_area(char_row,char_col);
    break;

  case 11 :  *ident = starlite(char_row,char_col);
    break;

  case 12 :  *ident = speed_monsters(+1);
    break;

  case 13 :  *ident = speed_monsters(-1);
    break;

  case 14 :  *ident = sleep_monsters2_3(char_row,char_col,20);
    break;

  case 15 :  *ident = hp_player(randint(8),"a staff.");
    break;

  case 16 :  *ident = detect_invisible();
    break;

  case 17 :  
    py.flags.fast = py.flags.fast + randint(30) + 15;
    *ident = true;
    break;

  case 18 :  
    py.flags.slow = py.flags.slow + randint(30) + 15;
    *ident = true;
    break;

  case 19 :  *ident = mass_poly();
    break;
    
  case 20 : 
    if (remove_curse) {
      msg_print("The staff glows blue for a moment...");
      *ident = true;
    }
    break;
    
  case 21 :  *ident = detect_evil();
    break;
    
  case 22 :  
    if ((cure_blindness()) || (cure_poison()) || (cure_confusion())) {
      *ident = true;
    }
    break;
    
  case 23 :  *ident = dispell_creature(0x0004,60);
    break;
    
  case 24 :  *ident = mass_genocide();
    break;
    
  case 25 :  *ident = unlight_area(char_row,char_col);
    break;
    
  default:
    break;
  }
};
//////////////////////////////////////////////////////////////////////
void use()
{
  unsigned   i1;
  integer    i2,i3,item_val,chance;
  boolean    redraw,ident;
  obj_set    how_odd = {55};

  reset_flag = true;

  if (inven_ctr > 0) {
    if (find_range(how_odd,&i2,&i3)) {
      redraw = false;
      if (get_item(&item_val,"Use which weird device?",&redraw,i2,i3)) {
	//with inventory[item_val]. do;
	if (redraw) { draw_cave(); }
	reset_flag = false;
	//with py.misc do;
	chance = PM.wierd + PM.lev + int_adj() - inventory[item_val].level;
	if (py.flags.confused > 0) {
	  chance /= 2;
	}
	if (chance < 0) { chance = 0; }
	if (randint(chance) < USE_DEVICE) {
	  msg_print("You failed to use the device properly.");
	} else if (inventory[item_val].p1 > 0) {
	  i1 = inventory[item_val].flags;
	  ident = false;
	  inventory[item_val].p1--;
	  for (;i1 > 0;) {
	    i2 = bit_pos(&i1) + 1;
	    device_effects(i2, &ident);
	  }
	  if (ident) {
	    identify(&inventory[item_val]);
	  }
	  if (inventory[item_val].flags != 0) {
	    //with py.misc do;
	    PM.exp += (real)inventory[item_val].level/(real)PM.lev + .5;
	    prt_experience();
	  }
	  desc_charges(item_val);
	}
      } else {
	if (redraw) { draw_cave(); }
      }
    } else {
      msg_print("You are not carrying any wierd devices.");
    }
  } else {
    msg_print("But you are not carrying anything.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE device.c */
