/* eat.c */
/* { Eat some food.} */

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void food_effects(integer effect, boolean *ident, integer item_val)
{
  //with inventory[item_val]. do;

  switch (effect) {
  case 1  :  
    //with py.flags do
    PF.poisoned += randint(10) + inventory[item_val].level;
    Opusii_vomit(35);
    *ident = true;
    break;
    
  case 2  : 
    //with py.flags do
    PF.blind += randint(250) + 10*inventory[item_val].level + 100;
    draw_cave();
    msg_print("A veil of darkness surrounds you.");
    *ident = true;
    break;
    
  case 3  :  
    //with py.flags do
    PF.afraid += randint(10) + inventory[item_val].level;
    msg_print("You feel terrified!");
    *ident = true;
    break;
    
  case 4  :  
    //with py.flags do
    PF.confused += randint(10) + inventory[item_val].level;
    msg_print("You feel drugged.");
    break;
    
  case 5  :  
    //with py.flags do
    PF.image += randint(200) + 25*inventory[item_val].level + 200;
    break;
    
  case 6  :  
    *ident = cure_poison();
    break;
    
  case 7  :  
    *ident = cure_blindness();
    break;
    
  case 8  :  
    //with py.flags do
    if (PF.afraid > 1) {
      PF.afraid = 1;
      *ident = true;
    }
    break;
    
  case 9  :
    *ident = cure_confusion();
    break;
    
  case 10 : 
    *ident = lose_str();
    break;
    
  case 11 :
    *ident = lose_con();
    break;
    
  case 12 :
    *ident = lose_int();
    break;
    
  case 13 :
    *ident = lose_wis();
    break;
    
  case 14 : 
    *ident = lose_dex();
    break;
    
  case 15 : 
    *ident = lose_chr();
    break;
    
  case 16 :  
    //with py.stat do
    if (PS.str > PS.cstr) {
      PS.cstr = PS.str;
      msg_print("You feel your strength returning.");
      prt_strength();
      *ident = true;
    }
    break;
    
  case 17 :
    //with py.stat do
    if (PS.con > PS.ccon) {
      PS.ccon = PS.con;
      msg_print("You feel your health returning.");
      prt_constitution();
      *ident = true;
    }
    break;
    
  case 18 :  
    //with py.stat do
    if (PS.int_ > PS.cint) {
      PS.cint = PS.int_;
      msg_print("Your head spins a moment.");
      prt_intelligence();
      *ident = true;
    }
    break;
    
  case 19 :  
    //with py.stat do
    if (PS.wis > PS.cwis) {
      PS.cwis = PS.wis;
      msg_print("You feel your wisdom returning.");
      prt_wisdom();
      *ident = true;
    }
    break;
    
  case 20 :  
    //with py.stat do
    if (PS.dex > PS.cdex) {
      PS.cdex = PS.dex;
      msg_print("You feel more dextrous.");
      prt_dexterity();
      *ident = true;
    }
    break;
    
  case 21 : 
    //with py.stat do
    if (PS.chr > PS.cchr) {
      PS.cchr = PS.chr;
      msg_print("Your skins starts itching.");
      prt_charisma();
      *ident = true;
    }
    break;
    
  case 22 : 
    *ident = hp_player(randint(3),"food.");
    break;

  case 23 : 
    *ident = hp_player(randint(6),"food.");
    break;
    
  case 24 :  
    *ident = hp_player(randint(12),"food.");
    break;
    
  case 25 : 
    *ident = hp_player(damroll("3d6"),"food.");
    break;
    
  case 26 :  
    *ident = hp_player(damroll("3d12"),"food.");
    break;
    
  case 27 : 
    *ident = hp_player(-randint(4),"poisonous food.");
    break;
    
  case 28 : 
    *ident = hp_player(-randint(8),"poisonous food.");
    break;
    
  case 29 : 
    *ident = hp_player(-damroll("2d8"),"poisonous food.");
    break;
    
  case 30 :
    *ident = hp_player(-damroll("3d8"),"poisonous food.");
    break;
    
  case 31 :  
    //with py.misc do
    PM.mhp = PM.mhp - 1;
    if (PM.mhp < PM.chp) {
      PM.chp = PM.mhp;
    }
    take_hit(1,"poisonous food.");
    prt_mhp();
    prt_chp();
    *ident = true;
    break;
    
  default:
    break;
  }
};
//////////////////////////////////////////////////////////////////////
void eat()
{
  unsigned  i1;
  integer   i2,i3,item_val;
  boolean   redraw,ident;
  obj_set   bite_me = {80};

  reset_flag = true;
  if (inven_ctr > 0) {
    if (find_range(bite_me,&i2,&i3)) {
      redraw = false;
      if (get_item(&item_val,"Eat which food?",&redraw,i2,i3)) {
	//with inventory[item_val]. do
	if (redraw) { draw_cave(); }
	reset_flag = false;
	i1 = inventory[item_val].flags;
	ident = false;
	while (i1 > 0) {
	  i2 = bit_pos(&i1) + 1;
	  food_effects(i2, &ident, item_val);
	}
	if (ident) {
	  identify(&inventory[item_val]);
	}
	if (inventory[item_val].flags != 0) {
	  //with py.misc do
	  PM.exp += (real)inventory[item_val].level/(real)PM.lev + .5;
	  prt_experience();
	}
	add_food(inventory[item_val].p1);
	py.flags.status &= 0xFFFFFFFC;
	prt_hunger();
	prt_cur_weight();
	desc_remain(item_val);
	inven_destroy(item_val);
      } else {
	if (redraw) { draw_cave(); }
      }              
    } else {
      msg_print("You are not carrying any food.");
    }
  } else {
    msg_print("But you are not carrying anything.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE eat.c */
