/* floppy.c */
/* 
   { Running Disk Programs              -RAK- (RLG)  } 
   { Player Must have a computer (tval=29) wielded   }
*/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void floppy_effect(integer effect, boolean *first, boolean *ident,
		   integer item_val)
{
  integer x,y,i3,i9;

  switch (effect) {
  case 1  :  *ident = enchant_weapon("tohit");
    break;
  case 2  :  *ident = enchant_weapon("todam");
    break;
  case 3  :  *ident = enchant_armor("up");
    break;

  case 4  :  
    identify(&inventory[item_val]);
    msg_print("This is an identify program");
    msg_print(" ");
    if (ident_spell()) { *first = false; }
    break;

  case 5  :  
    if (remove_curse()) {
      msg_print("You feel as if someone is watching over you.");
      *ident = true;
    }
    break;

  case 6  :  *ident = light_area(char_row,char_col);
    break;

  case 7  :  
    i9 = randint(3);
    for (i3 = 1; i3 <= i9; i3++) {
      y = char_row;
      x = char_col;
      summon_monster(&y,&x,false);
    }
    *ident = true;
    break;

  case 8  :  
    teleport(10);
    *ident = true;
    break;

  case 9  :  
    teleport(100);
    *ident = true;                          
    break;

  case 10 :  
    msg_print("That disk appeared to be blank.");
    *ident = true;
    break;

  case 11 :  
    msg_print("Your hands begin to glow.");
    py.flags.confuse_monster = true;
    *ident = true;
    break;

  case 12 :  *ident = map_area();
    break;
  case 13 :  *ident = sleep_monsters2_3(char_row,char_col,1);
    break;
  case 14 :  *ident = warding_glyph(char_row, char_col);
    break;
  case 15 :  *ident = detect_treasure();
    break;
  case 16 :  *ident = detect_object();
    break;
  case 17 :  *ident = detect_trap();
    break;
  case 18 :  *ident = detect_sdoor();
    break;

  case 19 :  
    msg_print("This is a mass genocide program.");
    msg_print(" ");
    *ident = mass_genocide();
    break;

  case 20 :  *ident = detect_invisible();
    break;

  case 21 :  
    *ident = aggravate_monster(20);
    msg_print("There is a high pitched humming noise");
    break;

  case 22 :  *ident = trap_creation();
    break;
  case 23 :  *ident = td_destroy();
    break;
  case 24 :  *ident = door_creation();
    break;

  case 25 :  
    identify(&inventory[item_val]);
    msg_print("This is a Recharge program.");
    msg_print(" ");
    if (recharge(60)) { *first = false; }
    break;

  case 26 :  
    msg_print("This is a genocide program.");
    msg_print(" ");
    *ident = genocide();
    break;

  case 27 :  *ident = unlight_area(char_row,char_col);
    break;
  case 28 :  *ident = protect_evil();
    break;
  case 29 :  *ident = create_food();
    break;
  case 30 :  *ident = dispell_creature(0x0008,60);
    break;

  case 31 :  
    msg_print("That disk appeared to be blank.");
    *ident = true;
    break;

  case 32 : /*{Cursed bit- do nothing}*/
    break;

  case 33 :
    for (i3 = 1; i3 <= randint(2); i3++) {
      *ident = enchant_weapon("both");
    }
    break;

  case 34 :  *ident = enchant_weapon("curse");
    break;

  case 35 :  
    for (i3 = 1; i3 <= randint(2); i3++) {
      *ident = enchant_armor("up");
    }
    break;

  case 36 :  *ident = enchant_armor("curse");
    break;

  case 37 :  
    i9 = randint(3);
    for (i3 = 1; i3 <= i9; i3++) {
      y = char_row;
      x = char_col;
      summon_undead(&y,&x);
    }
    *ident = true;
    break;

  case 38 :  *ident = bless(randint(12)+6);
    break;
  case 39 :  *ident = bless(randint(24)+12);
    break;
  case 40 :  *ident = bless(randint(48)+24);
    break;

  case 41 :  
    *ident = true;
    py.flags.word_recall = 25 + randint(30);
    msg_print("The air about you becomes charged...");
    break;

  case 42 :  *ident = destroy_area(char_row,char_col);
    break;

  case 43 :  
    *ident = true;
    random_wierdness(0,true);
    break;

  case 44 :
    i9 = randint(3);
    for (i3 = 1; i3 <= i9; i3++) {
      y = char_row;
      x = char_col;
      summon_monster(&y,&x,false);
    }
    *ident = true;
    break;

  case 45 : 
    //with py.flags do;
    *ident = true;
    PF.ring_blast = 9; /*{odd}*/
    msg_print("You are surrounded by a strange ring of fire!");
    break;

  case 46 :  
    //with py.flags do;
    *ident = true;
    PF.ring_blast = 10; /*{even}*/
    msg_print("A strange ring of frost encircles you!");
    break;

  default:
    msg_print("bogus disk.  send bug report to max::raoul");
    break;
  }
  
};
//////////////////////////////////////////////////////////////////////
void read_floppy()
{
  unsigned   i1;
  integer    i2,i3,item_val,failure_rate;
  boolean    redraw,ident,first;
  obj_set    is_it_hard = {70,71};

  first  = true;
  reset_flag = true;
  
  if (inven_ctr > 0) {
    if (equipment[35].tval == 29) {
      if (find_range(is_it_hard,&i2,&i3)) {
	if (py.flags.blind > 0) {
	  msg_print("Help me, I'm blind!");
	} else if (no_light()) {
	  msg_print("You have no light to see by.");
	} else if (py.flags.confused > 0) {
	  msg_print("The text seems to swim about the screen!");
	  msg_print("You are too confused to type...");
	} else {
	  redraw = false;
	  if (get_item(&item_val,"Run which floppy disk?",&redraw,i2,i3)) {
	    //with inventory[item_val]. do;
	    if (redraw) { draw_cave(); }
	    failure_rate = (equipment[35].subval - 300);
	    reset_flag = false;
	    i1 = inventory[item_val].flags;
	    ident = false;
	    if ((failure_rate > 90) && (randint(3)==3)) {
	      ident = false;
	      first = false;
	      msg_print("Sparks fly from the computer!");
	    } else {
	      for (;i1 > 0;) {
		i2 = bit_pos(&i1) + 1;
		if (inventory[item_val].tval == 71) { i2 = i2 + 32; }
		if (first) {
		  if (!(i2 == 4 || i2 == 25)) {
		    first = false;
		  }
		}
		floppy_effect(i2, &ident, &first, item_val);
	      }
	      
	      if (!reset_flag) {
		if (ident) {
		  identify(&inventory[item_val]);
		}
		if (!first) {
		  /*{Disk Eaten?}*/
		  if (i2 == 4) {
		    failure_rate = failure_rate div 2;
		  }
		  if (randint(100) < failure_rate) {
		    msg_print("Your computer eats the disk.");
		    desc_remain(item_val);
		    inven_destroy(item_val);
		  }
		}
		if (inventory[item_val].flags != 0) {
		  //with py.misc do;
		  PM.exp += (real)inventory[item_val].level/(real)PM.lev + .5;
		  prt_experience();
		}
	      }
	    }
	  } else {
	    if (redraw) { draw_cave(); }
	  }
	}
      } else { 
	msg_print("You are not carrying any disks.");
      }
    } else {
      msg_print("But, you are not wielding a computer!");
    }
  } else {
    msg_print("But you are not carrying anything.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/* END FILE floppy.c */
