/* help.c */
/**/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void moria_help(char *help_level)
{
  msg_print("Pretend I'm helping you with...");
  msg_print(help_level);
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void help()
{
  /*        { Help for available commands}*/

  integer i1 = 1;
  vtype   cmd_str;
  extern boolean cmd_md;
  clear_from(1);

prt("B <Dir> Bash (object/creature)|  q        Quaff a potion.",i1++,1);
prt("C       Display character.    |  r        Run a disk program.",i1++,1);
prt("D <Dir> Disarm a trap/chest.  |  s        Search for hidden doors.",i1++,1);
prt("E       Eat some food.        |  t        Take off an item.",i1++,1);
sprintf(cmd_str,"F       Put D-cell in lantern.|  %c        Use an alien device.",(cmd_md) ? '7' : 'u');
prt(cmd_str,i1++,1);
prt("L       Current location.     |  V        Version and credits.",i1++,1);
prt("P       Print map.            |  w        Wear/Wield an item.",i1++,1);
prt("R       Rest for a period.    |  x        Exchange weapon.",i1++,1);
prt("S       Search Mode.          |  /        Identify a character.",i1++,1);
prt("T <Dir> Tunnel.               |  ?        Display this panel.",i1++,1);
sprintf(cmd_str,"a       Aim & fire a ray gun. |  %c        Display the Kill list.",(cmd_md) ? '8' : 'k');
prt(cmd_str,i1++,1);
sprintf(cmd_str,"%c       Browse a book.        |  H        Get Help on a subject.",(cmd_md) ? '4' : 'b');
prt(cmd_str,i1++,1);
prt("c <Dir> Close a door.         |  ^M       Repeat the last message.",i1++,1);
prt("d       Drop an item.         |  ^R       Redraw the screen.",i1++,1);
prt("e       Equipment list.       |  ^C       Quit the game.",i1++,1);
prt("f       Fire a gun.           |  ^Y       Save character and quit.",i1++,1);
sprintf(cmd_str,"%c       Hurl an item.         |",(cmd_md) ? '6' : 'h');
prt(cmd_str,i1++,1);
prt("i       Inventory list.       |  < Go up an up-staircase.",i1++,1);
sprintf(cmd_str,"%c <Dir> Jam a door with spike.|  > Go down a down-staircase.",(cmd_md) ? '7' : 'j');
prt(cmd_str,i1++,1);
sprintf(cmd_str,"%c <Dir> Look given direction. |  %c <Dir>  Move in direction.",(cmd_md) ? '9' : 'l',(cmd_md) ? 'g' : '.');
prt(cmd_str,i1++,1);
sprintf(cmd_str,"m       Do skill from manual. |  Movement: %c  %c  %c",(cmd_md)?'y':'7',(cmd_md)?'k':'8',(cmd_md)?'u':'9');
prt(cmd_str,i1++,1);
sprintf(cmd_str,"o <Dir> Open a door/chest.    |            %c     %c    5 = Rest",(cmd_md)?'h':'4',(cmd_md)?'l':'6');
prt(cmd_str,i1++,1);
sprintf(cmd_str,"p       Read a prayer.        |            %c  %c  %c",(cmd_md)?'b':'1',(cmd_md)?'j':'2',(cmd_md)?'n':'3');
prt(cmd_str,i1++,1);
      pause_game(24);
      draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void wizard_help()
{
  /*{Help for available wizard commands}*/

  integer i1 = 1;
  clear_from(1);

  prt("^A - Remove Curse and Cure all maladies.",i1++,1);
  prt("^B - Print random objects sample.",i1++,1);
  /* ^C taken (quit game) */
  prt("^D - Down/Up n levels. Or n*100 to go to town #n",i1++,1);
  prt("^E - Change character.",i1++,1);
  prt("^F - Delete monsters.",i1++,1);
  prt("^G - Allocate treasures.",i1++,1);
  prt("^H - Wizard Help.",i1++,1);
  prt("^I - Identify.",i1++,1);
  prt("^J - Gain experience.",i1++,1);
  prt("^K - Summon monster.",i1++,1);
  prt("^L - Wizard light.",i1++,1);
  /* ^M taken (old messages) */
  prt("^N - Print monster dictionary.",i1++,1);
  prt("^O - Make Wierdness Occur.",i1++,1);
  prt("^P - Wizard password on/off.",i1++,1);
  prt("^Q - Make nice character.",i1++,1);
  /* ^R taken (redraw) */

  prt("^T - Teleport player.",i1++,1);       
  prt("^U - Examine character values. (debugging).",i1++,1);
  prt("^V - Restore lost character.",i1++,1);
  prt("^W - Create any object *CAN CAUSE FATAL ERROR*",i1++,1);
  prt("^X - Examine an inventory item in detail.",i1++,1);
  /* ^Y (save game) */
  /* ^Z (suspend) */
  pause_game(24);
  draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void ident_char()
{
  char  command;

  if (get_com("Enter character to be identified :", &command)) {
    switch (command) {
    case ' ' : prt("  - An open pit.",1,1);break;
    case '!' : prt("! - A potion.",1,1);break;
    case '"' : prt("\" - An amulet, periapt, or necklace.",1,1);break;
    case '#' : prt("# - A stone wall, or box.",1,1);break;
    case '$' : prt("$ - Treasure.",1,1);break;
    case '%' : prt("% - Computer.",1,1);break;
    case '&' : prt("& - Treasure chest.",1,1);break;
    case '\'': prt("' - An open door.",1,1);break;
    case '(' : prt("( - Soft armor.",1,1);break;
    case ')' : prt(") - A shield.",1,1);break;
    case '*' : prt("* - Grenade,or Treasure.",1,1); break;
    case '+' : prt("+ - A closed door.",1,1);break;
    case ',' : prt(", - Food.",1,1);break;
    case '-' : prt("- - A ray gun",1,1);break;
    case '.' : prt(". - Floor.",1,1);break;
    case '/' : prt("/ - Sports Equipment.",1,1);break;
    case ':' : prt(": - Rubble.",1,1);break;
    case ';' : prt("; - A loose rock.",1,1);break;
    case '<' : prt("< - An up staircase.",1,1);break;
    case '=' : prt("= - A ring.",1,1);break;
    case '>' : prt("> - A down staircase.",1,1);break;
    case '?' : prt("? - A floppy disk.",1,1);break;
    case '0' : prt("0 - ???.",1,1);break;
    case '@' : prt(py.misc.name,1,1);break;
    case 'A' : prt("A - Alien Daysians.",1,1);break;
    case 'B' : prt("B - The Boss.",1,1);break;
    case 'C' : prt("C - Acidic Cubes.",1,1);break;
    case 'D' : prt("D - Droids.",1,1);break;
    case 'E' : prt("E - Evil Things.",1,1);break;
    case 'F' : prt("F - Flayers.",1,1);break;
    case 'G' : prt("G - Guards.",1,1);break;
    case 'H' : prt("H - Hounds or Horses.",1,1);break;
    case 'I' : prt("I - Insane Lads.",1,1);break;
    case 'J' : prt("J - Jarwangian Molds.",1,1);break;
      /*{'K' : prt("K - ???.",1,1);}*/
    case 'L' : prt("L - ???.",1,1);break;
    case 'M' : prt("M - Mutants.",1,1);break;
      /*{'N' : prt("N - Negative Beings.",1,1);}*/
    case 'O' : prt("O - Oozes.",1,1);break;
    case 'P' : prt("P - Giant/Powerful humanoids.",1,1);break;
      /*{'Q' : prt("Q - ???.",1,1);}*/
    case 'R' : prt("R - Robots.",1,1);break;
    case 'S' : prt("S - ???.",1,1);break;
    case 'T' : prt("T - ???.",1,1);break;
    case 'U' : prt("U - ???.",1,1);break;
    case 'V' : prt("V - Vortexes.",1,1);break;
    case 'W' : prt("W - Warbots.",1,1);break;
    case 'X' : prt("X - ???.",1,1);break;
    case 'Y' : prt("Y - ???.",1,1);break;
    case 'Z' : prt("Z - Zarg!!.",1,1);break;
    case '[' : prt("[ - Hard armor.",1,1);break;
    case ']' : prt("] - Misc. armor.",1,1);break;
    case '^' : prt("^ - A trap.",1,1);break;
    case '_' : prt("_ - An alien device.",1,1);break;
      /*{'`' : prt("` - Not used.",1,1);}*/
    case 'a' : prt("a - Animals.",1,1);break;
    case 'b' : prt("b - Bats.",1,1);break;
    case 'c' : prt("c - cloister.",1,1);break;
    case 'd' : prt("d - Droids.",1,1);break;
    case 'e' : prt("e - Ectoplasms.",1,1);break;
    case 'f' : prt("f - Walking Fungi.",1,1);break;
    case 'g' : prt("g - Gang Members.",1,1);break;
    case 'h' : prt("h - Hackers.",1,1);break;
    case 'i' : prt("i - Insect (swarms).",1,1);break;
    case 'j' : prt("j - ???.",1,1);break;
    case 'k' : prt("k - Kitchen Utensils.",1,1);break;
    case 'l' : prt("l - Lasers.",1,1);break;
    case 'm' : prt("m - Machinery.",1,1);break;
    case 'n' : prt("n - ???.",1,1);break;
    case 'o' : prt("o - Orbs.",1,1);break;
    case 'p' : prt("p - Person (Humanoid).",1,1);break;
    case 'q' : prt("q - ???.",1,1);break;
    case 'r' : prt("r - Rodents.",1,1);break;
    case 's' : prt("s - Snakes.",1,1);break;
    case 't' : prt("t - Ticks.",1,1);break;
    case 'u' : prt("u - ???.",1,1);break;
    case 'v' : prt("v - Vogons.",1,1);break;
    case 'w' : prt("w - Worms.",1,1);break;
    case 'x' : prt("x - Spiders.",1,1);break;
    case 'y' : prt("y - ???.",1,1);break;
    case 'z' : prt("z - Zippy.",1,1);break;
    case '{' : prt("{ - Ammo.",1,1);break;
    case '|' : prt("| - A sword or dagger.",1,1);break;
    case '}' : prt("} - Gun.",1,1);break;
    case '~' : prt("~ - Miscellaneous item.",1,1);break;
    default  : prt("Not Used.",1,1); break;
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void do_all_mons()
{
  /*{Displays the list of all the monsters -NBT}*/

  clear_from(1);
prt(" Note: A \"*\" in front of the symbol denotes that more than one",3,1);
prt("       type of creature uses that symbol.",4,1);
prt("*$ Coins                   *a Animals                  *b Bats",6,1);
prt(" c Cloister                *d Droids                   *e Ectoplasms ",7,1);
prt("*f Walking Fungi           *g Gangs                    *h Hackers",8,1);
prt("*i Insects (swarm)          j Jackal                   *k Kitchen Utensils",9,1);
prt("*l Lasers                  *m Machinery                 n ???",10,1);
prt("*o Orbs                    *p Humanoid                  q ???",11,1);
prt("*r Rodent                  *s Snakes                   *t Tick",12,1);
prt("*v Vortexes                *w Worm(s)                   y ???",13,1);
prt("*z Zippy                   *| Evil Sword               *A Aliens",14,1);
prt(" B The Boss                 C Acidic Cube              *D Droids",15,1);
prt("*E Evil Things              F Mind Flayer              *G Guards",16,1);
prt("*H Hound, Horse             I A Lad Insane             *J Jelly",17,1);
prt(" L ???                     *M Mutants",18,1);
prt("*O Ooze                    *P Giant Humanoid           *R Robots",19,1);
prt(" S ???                      T ???                       U ???",20,1);
prt("*V Vortexes                *W Warbots                   X ???",21,1);
prt(" Y ???                      Z Zarg!!",22,1);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/* END FILE help.c */
