/* misc.c */
/**/

#include "boss.h"
#include "main.h"
#include <sys/time.h>

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer lesser(integer a, integer b)
{
  //{ An often needed function.  Returns the Lesser of two integers }

  return (a > b) ? b : a;
};

//////////////////////////////////////////////////////////////////////
integer greater(integer a, integer b)
{
  //{ Returns the Greater of two integers. }

  return (a > b) ? a : b;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer bit_pos(unsigned *test) {
/* Returns position of first set bit			-RAK-	*/
/*     and clears that bit */

  register int i;
  register unsigned mask = 0x1;

  for (i = 0; i < sizeof(*test)*8; i++) {
    if (*test & mask) {
      *test &= ~mask;
      return(i);
    }
    mask <<= 1;
  }

  /* no one bits found */
  return(-1);
};

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void insert_str(char *object_str, char *mtc_str, char *insert_str)
{
  char * s1;
  char ending[80];

  s1 = strstr(object_str, mtc_str);
  if (s1 != NULL) {
    strcpy(ending, s1+strlen(mtc_str));
    strcpy(s1, insert_str);
    strcat(s1, ending);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void insert_num(char *object_str,char *mtc_str, 
		integer number, boolean show_sign)
{
  vtype     numstr;

  sprintf(numstr, "%s%ld", (((number>0) && show_sign) ? "+" : ""), number);
//  strcat(object_str, " ");
  
  insert_str(object_str, mtc_str, numstr);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void zero_pyflag()
{
  /*{Decrease py.flags after mass turn increment - RLG}*/
     
  //with py.flags do;
  if ( PF.blind       > 0 )   { PF.blind       = 1; }
  if ( PF.paralysis   > 0 )   { PF.paralysis   = 1; }
  if ( PF.confused    > 0 )   { PF.confused    = 1; }
  if ( PF.protection  > 0 )   { PF.protection  = 1; }
  if ( PF.fast        > 0 )   { PF.fast        = 1; }
  if ( PF.slow        > 0 )   { PF.slow        = 1; }
  if ( PF.afraid      > 0 )   { PF.afraid      = 1; }
  if ( PF.poisoned    > 0 )   { PF.poisoned    = 1; }
  if ( PF.image       > 0 )   { PF.image       = 1; }
  if ( PF.protevil    > 0 )   { PF.protevil    = 1; }
  if ( PF.invuln      > 0 )   { PF.invuln      = 1; }
  if ( PF.hero        > 0 )   { PF.hero        = 1; }
  if ( PF.shero       > 0 )   { PF.shero       = 1; }
  if ( PF.blessed     > 0 )   { PF.blessed     = 1; }
  if ( PF.resist_heat > 0 )   { PF.resist_heat = 1; }
  if ( PF.resist_cold > 0 )   { PF.resist_cold = 1; }
  if ( PF.detect_inv  > 0 )   { PF.detect_inv  = 1; }
  if ( PF.tim_infra   > 0 )   { PF.tim_infra   = 1; }

  PF.word_recall = 0;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer todis_adj()
{
  /*{ returns a character's adjustment to disarm    }*/

  integer adj;

  if      (PS.cdex <   4) { adj =  -8; }
  else if (PS.cdex <   6) { adj =  -6; }
  else if (PS.cdex <   9) { adj =  -4; }
  else if (PS.cdex <  13) { adj =  -2; }
  else if (PS.cdex <  16) { adj =   0; }
  else if (PS.cdex <  18) { adj =   1; }
  else if (PS.cdex <  20) { adj =   2; }
  else if (PS.cdex <  25) { adj =   3; }
  else if (PS.cdex <  30) { adj =   4; }
  else if (PS.cdex <  35) { adj =   5; }
  else if (PS.cdex <  40) { adj =   6; }
  else if (PS.cdex <  45) { adj =   7; }
  else if (PS.cdex <  50) { adj =   8; }
  else                    { adj =   9; }

  return adj;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer wis_adj()
{
  //{ adjustment for wisdom }

  integer adj;

  if      (py.stat.cwis > 49) {        adj = 10; }
  else if (py.stat.cwis > 44) {        adj =  9; }
  else if (py.stat.cwis > 39) {        adj =  8; }
  else if (py.stat.cwis > 34) {        adj =  7; }
  else if (py.stat.cwis > 29) {        adj =  6; }
  else if (py.stat.cwis > 24) {        adj =  5; }
  else if (py.stat.cwis > 19) {        adj =  4; }
  else if (py.stat.cwis > 17) {        adj =  3; }
  else if (py.stat.cwis > 14) {        adj =  2; }
  else if (py.stat.cwis > 7)  {        adj =  1; }
  else                        {        adj =  0; }

  return adj;
};
 
//////////////////////////////////////////////////////////////////////
 
integer int_adj()
{
  //{ adjustment for intellegence   }

  integer adj;

  if      (py.stat.cint > 49) {        adj = 10; }
  else if (py.stat.cint > 44) {        adj =  9; }
  else if (py.stat.cint > 39) {        adj =  8; }
  else if (py.stat.cint > 34) {        adj =  7; }
  else if (py.stat.cint > 29) {        adj =  6; }
  else if (py.stat.cint > 24) {        adj =  5; }
  else if (py.stat.cint > 19) {        adj =  4; }
  else if (py.stat.cint > 17) {        adj =  3; }
  else if (py.stat.cint > 14) {        adj =  2; }
  else if (py.stat.cint >  7) {        adj =  1; }
  else                        {        adj =  0; }

  return adj;
};
 
//////////////////////////////////////////////////////////////////////
 
integer chr_adj()
{
  //{ adjustment for charisma }

  integer adj;

  if      (py.stat.cchr > 49) {        adj = 10; }
  else if (py.stat.cchr > 44) {        adj =  9; }
  else if (py.stat.cchr > 39) {        adj =  8; }
  else if (py.stat.cchr > 34) {        adj =  7; }
  else if (py.stat.cchr > 29) {        adj =  6; }
  else if (py.stat.cchr > 24) {        adj =  5; }
  else if (py.stat.cchr > 19) {        adj =  4; }
  else if (py.stat.cchr > 17) {        adj =  3; }
  else if (py.stat.cchr > 14) {        adj =  2; }
  else if (py.stat.cchr > 7 ) {        adj =  1; }
  else                        {        adj =  0; }

  return adj;
};
//////////////////////////////////////////////////////////////////////
real chr_padj()
{
  //{ charisma adjustment for buy/sell prices  -rlg }                      

  real adj;

  if      (py.stat.cchr > 49) {         adj = -0.20; }
  else if (py.stat.cchr > 44) {         adj = -0.18; }
  else if (py.stat.cchr > 39) {         adj = -0.16; }
  else if (py.stat.cchr > 34) {         adj = -0.14; }
  else if (py.stat.cchr > 29) {         adj = -0.12; }
  else if (py.stat.cchr > 24) {         adj = -0.10; }
  else if (py.stat.cchr > 19) {         adj = -0.08; }
  else if (py.stat.cchr > 17) {         adj = -0.04; }
  else if (py.stat.cchr > 15) {         adj = -0.02; }
  else if (py.stat.cchr > 12) {         adj =  0.05; }
  else if (py.stat.cchr >  9) {         adj =  0.10; }
  else if (py.stat.cchr >  6) {         adj =  0.20; }
  else if (py.stat.cchr >  3) {         adj =  0.25; }
  else                        {         adj =  0.30; }
  
  return adj;
};
//////////////////////////////////////////////////////////////////////
integer con_adj()
{
  //{ returns a characters adjustment to hit points    }

  integer adj;

  //with py.stat do;
  if      (py.stat.ccon <   4) { adj =  -3; }
  else if (py.stat.ccon <   6) { adj =  -2; }
  else if (py.stat.ccon <   9) { adj =  -1; }
  else if (py.stat.ccon <  13) { adj =   0; }
  else if (py.stat.ccon <  16) { adj =   1; }
  else if (py.stat.ccon <  18) { adj =   2; }
  else if (py.stat.ccon <  20) { adj =   3; }
  else if (py.stat.ccon <  25) { adj =   4; }
  else if (py.stat.ccon <  30) { adj =   5; }
  else if (py.stat.ccon <  35) { adj =   6; }
  else if (py.stat.ccon <  40) { adj =   7; }
  else if (py.stat.ccon <  45) { adj =   8; }
  else if (py.stat.ccon <  50) { adj =   9; }
  else                         { adj =  10; }

 return adj;
};

//////////////////////////////////////////////////////////////////////
integer todam_adj()
{
  /*{ returns a character's adjustment to damage    }*/

  integer adj = 0;

  //with py.stat do;
  if      (PS.cstr <   4) { adj = -2; }
  else if (PS.cstr <   6) { adj = -1; }
  else if (PS.cstr <   9) { adj =  0; }
  else if (PS.cstr <  13) { adj =  1; }
  else if (PS.cstr <  16) { adj =  2; }
  else if (PS.cstr <  18) { adj =  3; }
  else if (PS.cstr <  20) { adj =  4; }
  else if (PS.cstr <  25) { adj =  5; }
  else if (PS.cstr <  30) { adj =  6; }
  else if (PS.cstr <  35) { adj =  7; }
  else if (PS.cstr <  40) { adj =  8; }
  else if (PS.cstr <  50) { adj =  9; }
  else                    { adj = 10; }

  return adj;
};
//////////////////////////////////////////////////////////////////////
integer tohit_adj()
{
  /*{ returns a character's adjustment to hit.  }*/

  integer total;

  //with py.stat do;
  if      (PS.cdex <   4) { total = -3; }
  else if (PS.cdex <   6) { total = -2; }
  else if (PS.cdex <   8) { total = -1; }
  else if (PS.cdex <  16) { total =  0; }
  else if (PS.cdex <  17) { total =  1; }
  else if (PS.cdex <  18) { total =  2; }
  else if (PS.cdex <  20) { total =  3; }
  else if (PS.cdex <  30) { total =  4; }
  else if (PS.cdex <  40) { total =  5; }
  else if (PS.cdex <  50) { total =  6; }
  else                    { total =  7; }

  if      (PS.cstr <   4) { total = total - 3; }
  else if (PS.cstr <   5) { total = total - 2; }
  else if (PS.cstr <   7) { total = total - 1; }
  else if (PS.cstr <  18) { total = total + 0; }
  else if (PS.cstr <  25) { total = total + 1; }
  else if (PS.cstr <  30) { total = total + 2; }
  else if (PS.cstr <  40) { total = total + 3; }
  else if (PS.cstr <  50) { total = total + 4; }
  else                    { total = total + 5; }

  return total;
};
//////////////////////////////////////////////////////////////////////
integer toac_adj()
{
  /* { returns a character's adjustment to armor class   } */

  integer adj;

  //with py.stat do;
  if      (PS.cdex <   4) { adj =  -4; }
  else if (PS.cdex <   6) { adj =  -3; }
  else if (PS.cdex <   9) { adj =  -2; }
  else if (PS.cdex <  13) { adj =  -1; }
  else if (PS.cdex <  16) { adj =   0; }
  else if (PS.cdex <  18) { adj =   1; }
  else if (PS.cdex <  20) { adj =   2; }
  else if (PS.cdex <  25) { adj =   3; }
  else if (PS.cdex <  30) { adj =   4; }
  else if (PS.cdex <  35) { adj =   5; }
  else if (PS.cdex <  40) { adj =   6; }
  else if (PS.cdex <  50) { adj =   7; }
  else                    { adj =   8; }

  return adj;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void gain_mana(integer amount)
{
  //{ gain some resources if you know at least one skill    }

  integer  i1,new_mana;
  boolean  knows_spell;

  knows_spell = false;
  for (i1 = 1; (i1 <= MAX_SKILLS) && !knows_spell; i1++) {
    if (skill_list[i1].learned) {
      knows_spell = true;
    }
  }

  if (knows_spell) {
    if ((PM.lev & 1) == 1) {
      switch (amount) {
      case  0 : new_mana = 0; break;
      case  1 : new_mana = 1; break;
      case  2 : new_mana = 1; break;
      case  3 : new_mana = 1; break;
      case  4 : new_mana = 2; break;
      case  5 : new_mana = 2; break;
      case  6 : new_mana = 3; break;
      case  7 : new_mana = 4; break;
      case  8 : new_mana = 5; break;
      case  9 : new_mana = 5; break;
      case 10 : new_mana = 6; break;
      default : new_mana = 0; break;
      }
    } else {
      switch (amount) {
      case  0 : new_mana = 0; break;
      case  1 : new_mana = 1; break;
      case  2 : new_mana = 1; break;
      case  3 : new_mana = 2; break;
      case  4 : new_mana = 2; break;
      case  5 : new_mana = 3; break;
      case  6 : new_mana = 3; break;
      case  7 : new_mana = 4; break;
      case  8 : new_mana = 5; break;
      case  9 : new_mana = 6; break;
      case 10 : new_mana = 6; break;
      default : new_mana = 0; break;
      }
    }
    py.misc.mana  += new_mana;
    py.misc.cmana += new_mana;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/*{ it's about time someone added this code!  the skill system is a complete
  mess and it's needed to be fixed since i got a hold of the code.  -rlg}*/

integer xbth()
{
  return lesser(200, 
		PM.bth + PM.lev*BTH_LEV_ADJ + PM.ptohit*BTH_PLUS_ADJ);
};
//////////////////////////////////////////////////////////////////////
integer xbthb()
{
  return lesser(200,
		PM.bthb + PM.lev*BTH_LEV_ADJ + PM.ptohit*BTH_PLUS_ADJ);
};
//////////////////////////////////////////////////////////////////////
integer xperc()
{
  return lesser(200,
		PM.perc + (PM.lev div 2) + int_adj());
};
//////////////////////////////////////////////////////////////////////
integer xsrh()
{
  return lesser(100,
		PM.srh + (PM.lev div 2) + int_adj());
};
//////////////////////////////////////////////////////////////////////
integer xstl()
{
  return lesser(10,
		PM.stl + (PM.lev div 8));
};
//////////////////////////////////////////////////////////////////////
integer xdis()
{
  return lesser(100,
		PM.disarm + (PM.lev div 2) + 2*todis_adj());
};
//////////////////////////////////////////////////////////////////////
integer xsave()
{
  return lesser(100,
		PM.save + (PM.lev div 2) + wis_adj());
};
//////////////////////////////////////////////////////////////////////
integer xdev()
{
  return lesser(100,
		PM.wierd + (PM.lev div 2) + int_adj());
};
//////////////////////////////////////////////////////////////////////
char *xinfra(vtype out_val)
{
  if (PF.see_infra == 0) {
    strcpy(out_val, "None");
  } else if (PF.see_infra == 1) {
    strcpy(out_val, "1 Meter");
  } else {
    sprintf(out_val, "%ld Meters", PF.see_infra);
  }

  return out_val;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_field(vtype info, integer row, integer column)
{
  /*{ print character info in given row, column		-rak-	}*/
  vtype   out_val1;

  sprintf(out_val1, "%-14s", info);
  put_buffer(out_val1,row,column);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
char get_loc_symbol(integer y, integer x)
{
  /* check lights and stuff before calling loc_symbol */

  char     tmp_char = ' ';

  if (test_light(y,x)) {
    tmp_char = loc_symbol(y,x);
  } else if ((cave[y][x].cptr == 1) && (!find_flag)) {
    tmp_char = '@';
  } else if (cave[y][x].cptr > 1) {
    if (m_list[cave[y][x].cptr].ml) {
      tmp_char = loc_symbol(y,x);
    } else {
      tmp_char = ' ';
    }
  } else {
    tmp_char = ' ';
  }

  return tmp_char;
};
//////////////////////////////////////////////////////////////////////
char loc_symbol(integer y,integer x)
{
  char     sym;
  byteint  cptr, tptr, fval;
  
  wordint  mptr;
  
  cptr = cave[y][x].cptr;
  fval = cave[y][x].fval;
  tptr = cave[y][x].tptr;
  
  //with cave[y,x] do;
  if ((cptr == 1) && (!find_flag)) {
    sym = '@';
  } else if (py.flags.blind > 0) {
    sym = ' ';
  } else {
    
    
    if (cptr > 1) {
      
      //with m_list[cptr] do;
      mptr = m_list[cptr].mptr;
      if ((m_list[cptr].ml) &&
	  ((uand(c_list[mptr].cmove,0x00010000) == 0) || (py.flags.see_inv))) {
	sym = c_list[mptr].cchar;
      } else if (tptr > 0) {
	sym = t_list[tptr].tchar;
      } else if (is_in(fval,earth_set)) { /* 0, 3, 8 and 9 were here too */
	sym = '.';
      } else if (is_in(fval,pwall_set)) {
	sym = '#';
      } else {
	/* unknown terrain type */
	sym = '.' + 0x80;
      }      

    } else if (tptr > 0) {
      sym = t_list[tptr].tchar;
    } else if (is_in(fval,earth_set)) { /* 0, 3, 8 and 9 were here too */
      sym = '.';
    } else if (is_in(fval,pwall_set)) {
      sym = '#';
    } else {
      /* unknown terrain type */
      sym = '.' + 0x80;
    }      
  }
  
#if DO_DEBUG
  if ((((int)sym & 0x7f) < 32) || (((int)sym & 0x7f) > 126)) {
    fprintf(debug_file,": error in loc_sym: (%ld, %ld) = %ld   cptr=%ld tptr=%ld fval=%ld\n",
	    x,y,(integer)sym,(integer)cptr,(integer)tptr,(integer)fval);
    fflush(debug_file);
  }
#endif

  return sym;
};

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean test_light(integer y,integer x)
{
/*{ tests a spot for light or field mark status		-rak-	}*/
  return ((cave[y][x].pl) || (cave[y][x].fm) || (cave[y][x].tl));
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_map()
{
  /* xxxx taken from imoria witout checking... */

  /*	{ prints the map of the dungeon				-rak-	}*/

  integer    i1,i2,i3,i4,i5;
  integer    ypos,xpos=0,isp;
  vtype      floor_str;
  char       tmp_char;
  boolean    flag;
  
  redraw = false;		/*{ screen has been redrawn	   }*/
  i3 = 1;			/*{ used for erasing dirty lines   }*/
  i4 = 14;			/*{ erasure starts in this column  }*/
  for (i1 = panel_row_min; i1 <= panel_row_max; i1++) {	
    i3++;			/*{ increment dirty line ctr	}*/
    if (used_line[i3]) {	/*{ if line is dirty...		}*/
      erase_line(i3,i4);	/*{ erase it.			}*/
      used_line[i3] = false;	/*{ now it's a clean line	}*/
    }
    floor_str[0] = 0;	        /*{ floor_str is string to be printed}*/
    ypos = i1;		        /*{ save row			}*/
    flag = false;		/*{ false until floor_str <> ''	}*/
    isp = 0;		        /*{ number of blanks encountered}*/
    for (i2 = panel_col_min; i2 <= panel_col_max; i2++) {
      //printf ("\n\t>>(row, col) = (%d, %d)", i1,i2);  fflush(stdout);
      //with cave[i1,i2] do;
      
      /*{ get character for location	}*/
      if (test_light(i1,i2)) {
	tmp_char = loc_symbol(i1,i2);
      } else if ((cave[i1][i2].cptr == 1) && (!find_flag)) {
	tmp_char = '@';
      } else if (cave[i1][i2].cptr > 1) {
	if (m_list[cave[i1][i2].cptr].ml) {
	  tmp_char = loc_symbol(i1,i2);
	} else {
	  tmp_char = ' ';
	}
      } else {
	tmp_char = ' ';
      }
      
      
      if (tmp_char == ' ') {
	
	if (flag) {
	  isp++;
	  if (isp > 3) {
	    print_str(floor_str,ypos,xpos);
	    flag = false;
	    isp  = 0;
	  }
	}
	
      } else {
	
	if (flag) {
	  if (isp > 0) {
	    for (i5 = 0; i5 < isp; i5++) {
	      strcat(floor_str," ");
	    }
	    isp = 0;
	  }
	  floor_str[strlen(floor_str)+1] = 0;
	  floor_str[strlen(floor_str)] = tmp_char;
	} else {
	  xpos = i2;	
	  flag = true;	
	  floor_str[1] = 0;
	  floor_str[0] = tmp_char;
	}
	
      }
    }
    if (flag) {
      print_str(floor_str,ypos,xpos);
    }
  }
  
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_max_weight()
{
  /*{ Prints weight capacity }*/
 max_weight = weight_limit();
 prt_num( "",max_weight,22,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_depth()
{
  //{ prints depth in stat area }

  vtype    depths;

  if (dun_level == 0) {
    sprintf(depths,"%s",townlist[town_num].town_name);
  } else if (dun_level < 0) {
    sprintf(depths,"Office Building");
  } else {
    sprintf(depths,"Depth: %ld (meters)",dun_level*50);
  }

  prt(depths,24,60);
};
//////////////////////////////////////////////////////////////////////
void draw_cave()
{
  //{ draws entire screen   }
  clear_screen();
  prt_stat_block();
  prt_map();
  prt_depth();
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_cur_weight()
{
  /*{ Prints current weight   }*/
  prt_num( "",inven_weight,21,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_gold()
{
  /*{ Prints current gold   }*/

  prt_num( "",py.misc.au,20,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_experience()
{
  /*{ Prints experience }*/

  //with py.misc do;

  if (PM.exp > player_max_exp) { PM.exp = player_max_exp; }
  if (PM.lev < MAX_PLAYER_LEVEL) {
    while (trunc(player_exp[PM.lev]*PM.expfact) <= PM.exp) {
      gain_level();
    }
    if (PM.exp > PM.max_exp) {
      PM.max_exp = PM.exp;
    }
  }

    prt_num("",py.misc.exp,15,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_time()
{
  /*{ prints game time in stat block. --jeb}*/

  integer   hours;
  integer   minutes;
  char     *weekday;
  vtype     out_val;
  
  switch (day % 7) {
  case 0: weekday = "SUN"; break;
  case 1: weekday = "MON"; break;
  case 2: weekday = "TUE"; break;
  case 3: weekday = "WED"; break;
  case 4: weekday = "THU"; break;
  case 5: weekday = "FRI"; break;
  case 6: weekday = "SAT"; break;
  }

  minutes = (turn % 720) div 12;
  hours = turn div 720;

  sprintf(out_val, "%s %02ld:%02ld", weekday, hours, minutes);
  put_buffer(out_val,23,1);
};
//////////////////////////////////////////////////////////////////////
void prt_strength()
{
  /*{ Prints strength   }*/

  prt_stat("",py.stat.cstr,7,stat_column+6);

};
//////////////////////////////////////////////////////////////////////
void prt_dexterity()
{
  /*{ Prints dexterity  }*/

  prt_stat("",py.stat.cdex,10,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
void prt_constitution()
{
  /*{ Prints constitution   }*/

  prt_stat("",py.stat.ccon,11,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
void prt_intelligence()
{
  /*{ Prints intelligence   }*/

      prt_stat("",py.stat.cint,8,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
void prt_wisdom()
{
  /*{ Prints wisdom }*/
      prt_stat("",py.stat.cwis,9,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
void prt_charisma()
{
  /*{ Prints charisma   }*/
      prt_stat("",py.stat.cchr,12,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
void prt_pac()
{
  /*{ prints current AC }*/
      prt_num( "",py.misc.dis_ac,19,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
void prt_mhp()
{
  /*{ Prints Max hit points }*/
      prt_num( "",py.misc.mhp,17,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
void prt_title()
{
  /*{ Prints title of character }*/
      prt_field(py.misc.title,5,stat_column);
};
//////////////////////////////////////////////////////////////////////
void prt_level()
{
  /*{ Prints level  }*/
      prt_num( "",py.misc.lev,14,stat_column+6);
};
//////////////////////////////////////////////////////////////////////
void prt_hunger()
{
  /*{ Prints status of hunger   }*/

  if (uand(0x000002,py.flags.status) != 0) {
    put_buffer("Weak    ",24,1);
  } else if (uand(0x000001,py.flags.status) != 0) {
    put_buffer("Hungry  ",24,1);
  } else {
    put_buffer("        ",24,1);
  }
};
//////////////////////////////////////////////////////////////////////
void prt_blind()
{
  /*{ Prints Blind status   }*/

  if (uand(0x000004,py.flags.status) != 0) {
    put_buffer("Blind  ",24,9);
  } else {
    put_buffer("       ",24,9);
  }
};
//////////////////////////////////////////////////////////////////////
void prt_confused()
{
  /*{ Prints Confusion status   }*/

  if (uand(0x000008,py.flags.status) != 0) {
    put_buffer("Confused  ",24,16);
  } else {
    put_buffer("          ",24,16);
  }
};
//////////////////////////////////////////////////////////////////////
void prt_afraid()
{
  /*{ Prints Fear status    }*/

  if (uand(0x000010,py.flags.status) != 0) {
    put_buffer("Afraid  ",24,26);
  } else {
    put_buffer("        ",24,26);
  }
};
//////////////////////////////////////////////////////////////////////
void prt_poisoned()
{
  /*{ Prints Poisoned status }*/

  if (uand(0x000020,py.flags.status) != 0) {
    put_buffer("Poisoned  ",24,34);
  } else { 
    put_buffer("          ",24,34);
  }
};
//////////////////////////////////////////////////////////////////////
void prt_chp()
{
  /*{ Prints players current hit points (a real number...)  }*/

  prt_num( "",trunc(py.misc.chp),16,stat_column+6);

};
//////////////////////////////////////////////////////////////////////
void prt_mana()
{
  /*{ Prints players current (a real number...) and max mana points }*/

  real     mwkdiv;
  integer  indx;
  
  mwkdiv = py.misc.cmana/10;
  if (mwkdiv < 1) {
    indx = 2;
  } else {
    if (mwkdiv < 10) {
      indx = 3;
    } else {
      indx = 4;
    }
  }
  prt_num( "",trunc(py.misc.cmana),18,stat_column+6);
  prt_num( "/",py.misc.mana,18,stat_column+5+indx);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
unsigned long get_seed()
{
//	{ use date and time to produce a random seed	-rak-	}
  struct timeval tv;
  unsigned long the_seed;

  ENTER("get_seed","");

  gettimeofday(&tv, NULL);

  the_seed  = tv.tv_usec ^ tv.tv_sec;
  the_seed |= 1; // odd number

  //  the_seed = 883993667;

  RETURN("get_seed","",'u',"rand seed",&the_seed);
  return the_seed;
}; /* end get_seed */
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void set_seed(unsigned long the_seed)
{
  /* use the_seed to seed the generator */

#if DO_DEBUG
  if (debug_file != NULL) {
    fprintf(debug_file,"set_seed: s= %ld\n",the_seed);
    fflush(debug_file);
  }
#endif	  

#if use_mtwist
  seedmt(the_seed);
#else
  srand(the_seed);
#endif
}; /* end get_seed */

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer randnor(integer mean,integer stand)
{
/*{ generates a random integer number of normal distribution -rak-}*/

  return (integer)(sqrt(-2.0*log(randint(9999999)/10000000.0))*
		   cos(6.283*(randint(9999999)/10000000.0))*stand) + mean;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer rand_rep(integer num, integer die)
{
  integer i1, sum=0;

  for (i1 = 0; i1 < num; i1++) {
    sum += randint(die);
  }

  return sum;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void sort_objects()
{
//	{ order the treasure list by level			-rak-	}
  integer        i1, i2, i3, gap;
  treasure_type  tmp;

  gap = max_objects / 2;
  while (gap > 0) {
    for (i1=gap+1; i1<=max_objects; i1++) {
      i2 = i1 - gap;
      while (i2 > 0) {
	i3 = i2 + gap;
	if (object_list[i2].level > object_list[i3].level) {
	  tmp = object_list[i2];
	  object_list[i2] = object_list[i3];
	  object_list[i3] = tmp;
	} else {
	  i2 = 0;
	}
	i2 = i2 - gap;
      } /* end while i2 */
    } /* end for i1 */
    gap = gap / 2;
  } /* end while gap */

//  verify that the sort worked
//    i2 = 0;
//    for (i1=1; i1<=max_objects; i1++) {
//      if (i2 > object_list[i1].level) {
//	printf("error: sort_objects failed\n");
//	exit_game();
//      }
//      i2 = object_list[i1].level;
//    }
}; /* end sort_objects */
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void init_m_level()
{
  //	{ initializes m_level array for use with place_monster	-rak-	}
  int   i1 = 1; //{main counter, goes by step through c_list}
  int   i2 = 0; //        {counter for level}
  int   i3 = max_creatures - EXTRA_MONSTERS; // {max value for main counter}

  do {
    m_level[i2] = 0;
    while ((i1 <= i3) && (c_list[i1].level == i2)) {
      m_level[i2]++;
      i1++;
    }
    i2++;
  } while (i2 <= MAX_MONS_LEVEL);

  for (i1 = 2; i1 <= MAX_MONS_LEVEL; i1++) {
    m_level[i1] += m_level[i1-1];
  }
  
//  for (i1 = 0; i1 < MAX_MONS_LEVEL+1; i1++) {
//    printf ("\n m_level[%d] : %d",i1,m_level[i1]);  fflush(stdout);
//  }

}; /* end init_m_level */ 

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void init_t_level()
{
//	{ initializes t_level array for use with place_object	-rak-	}
  int   i1 = 1;
  int   i2 = 0;

  do {
    while ((i1 <= MAX_OBJECTS) && (object_list[i1].level == i2)) {
      t_level[i2] = t_level[i2] + 1;  // number of treasures with this level
      i1++;
    }
    i2++;
  } while (!((i2 > MAX_OBJ_LEVEL) || (i1 > MAX_OBJECTS)));

  for (i1 = 1; i1 <= MAX_OBJ_LEVEL; i1++) {
    t_level[i1] += t_level[i1-1];
  }

}; /* end init_t_level */ 

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void price_adjust()
{
  integer  i1;
  for (i1=1; i1<= MAX_OBJECTS; i1++) {
    object_list[i1].cost = trunc(object_list[i1].cost*COST_ADJ + 0.99);
  }

  for (i1=1; i1<= inven_init_max; i1++) {
    inventory_init[i1].cost = trunc(inventory_init[i1].cost*COST_ADJ + 0.99);
  }
}; /* end cost_adj */


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

integer randint(integer maxval)
{
/* generates a random integer x where 1<=x<=maxval	-rak-	*/

  integer r = 0;
  
  if (maxval) {
#if use_mtwist
    r = ((randommt() % maxval) + 1);
#else
    r = ((rand() % maxval) + 1);
#endif
  }

  /*
#if DO_DEBUG
   fprintf(debug_file, "   rand:  %ld\t(%ld)\n", r, maxval);
   fflush(debug_file);
#endif	  
*/

  return r;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_stat(	vtype 	stat_name,
		byteint	stat,
		integer row,
		integer column)
{
  /* { print character stat in given row, column		-rak-	}*/

  prt_num(stat_name,stat,row,column);

  /* the old way...
  stat_s_type out_val1;
  vtype       out_val2;

  cnv_stat(stat, out_val1);
  sprintf(out_val2, "%s%s", stat_name, out_val1);
  put_buffer(out_val2,row,column);
  */
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

boolean already_playing()
{
 /* xxxx check already playing */
  return false;
}; /* end already_playing */

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

boolean check_time()
{
  /*{ check the day-time strings to see if open             -rak-   }*/

  /* the file hours.dat is where days gets filled in from     */
  /* default hours are defined in values.h, in the days array */

  struct tm  now;
  integer    cur_time;
  integer    day, hour;
  boolean    return_value = false;

  /*{ returns the day number; 1=sunday...7=saturday         -rak-   }*/
  /*{ returns the hour number; 0=midnight...23=11 pm        -rak-   }*/

  cur_time = time(NULL);
  now      = *localtime(&cur_time);
  day      = now.tm_wday;
  hour     = now.tm_hour;

  if ((days[day][hour+4] == 'X') || (days[day][hour+4] == 'x')) {
    return_value = true;
  }

  return return_value;
}; /* end check_time */
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void put_character()
{
  //{ prints the following information on the screen.   }
  clear_screen();

  prt2("Name  : ", PM.name,3,3);
  prt2("Qual  : ", PM.race,4,3);
  prt2("Sex   : ", PM.sex,5,3);
  prt2("Class : ", PM.tclass,6,3);

};
//////////////////////////////////////////////////////////////////////

void put_misc1()
{
  //{ prints age, height, weight, and sc };

  prt_num("Age          : ", PM.age,4,27);
  prt_num("Height/Weight: ", PM.ht ,5,27);
  prt_num("/"              , PM.wt ,5,44);
  prt_num("Social Class : ", PM.sc ,6,27);

};
//////////////////////////////////////////////////////////////////////
 
void put_misc2()
{
  //{ prints the following information on the screen. }

  vtype out_val;
  
  prt_num("Level          : ", PM.lev,10,27);
  prt_num("Cash           : ", PM.au,11,27);
  prt_num("Savings Account: ", act_bal,12,27);
  prt_num("Bank Loan      : ", principal,13,27);
          
  prt_num("Experience : ",PM.exp,10,54);
  prt_num("Needed Exp : ",trunc(player_exp[PM.lev]*PM.expfact),11,54);
  sprintf(out_val,"Hit Points : %d/%d",(int)(PM.chp),(int)(PM.mhp));
  prt(out_val,12,54);
  sprintf(out_val,"Resources  : %d/%d",(int)(PM.cmana),(int)(PM.mana));
  prt(out_val,13,54);
};

//////////////////////////////////////////////////////////////////////

void put_stats()
{
  //{ prints the following information on the screen. }

  //with py. do;

  prt("Cur",2,62);
  prt("Max",2,71);
  prt_stat("STR : ",PS.cstr,3,56);
  prt_stat("| ",PS.str,3,69);
  prt_stat("INT : ",PS.cint,4,56);
  prt_stat("| ",PS.int_,4,69);
  prt_stat("WIS : ",PS.cwis,5,56);
  prt_stat("| ",PS.wis,5,69);
  prt_stat("DEX : ",PS.cdex,6,56);
  prt_stat("| ",PS.dex,6,69);
  prt_stat("CON : ",PS.ccon,7,56);
  prt_stat("| ",PS.con,7,69);
  prt_stat("CHR : ",PS.cchr,8,56);
  prt_stat("| ",PS.chr,8,69);
  prt_num("+ To Hit : ",PM.dis_th,10,4);
  prt_num("+ To Dam : ",PM.dis_td,11,4);
  prt_num("+ To AC  : ",PM.dis_tac,12,4);
  prt_num("Total AC : ",PM.dis_ac,13,4);
};
//////////////////////////////////////////////////////////////////////
char *likert(integer x,integer y,integer i1)
{
  //{ Returns a rating of x depending on y }
  
  char *ert = NULL;

  switch( i1 ) {
  case 1:
    switch( (int)(x/y) ) {
    case -1: case  0: case  1: ert = "VERY BAD";  break;
    case  2: case  3:          ert = "Bad";       break;
    case  4:                   ert = "Poor";      break;
    case  5: case  6:          ert = "Average";   break;
    case  7:                   ert = "Good";      break;
    case  8:                   ert = "Very Good"; break;
    case  9:                   ert = "Superb";    break;
    default:                   ert = "EXCELLENT"; break;
    }
    break;

  case 2:
    switch( (int)(x/y) ) {
    case -1: case  0: case  1: ert = "Repugnant"; break;
    case  2:                   ert = "Mediocre";  break;
    case  3:                   ert = "Sub-Par";   break;
    case  4: case  5:          ert = "Average";   break;
    case  6:                   ert = "Notable";   break;
    case  7:                   ert = "Honorable"; break;
    case  8:                   ert = "Remarkable";break;
    case  9:                   ert = "Exemplary"; break;
    default:                   ert = "PERFECTION";break;
    }
    break;

  case 3:
    switch( (int)(x/y) ) {
    case -1: case  0: case  1: ert = "Bogus";     break;
    case  2:                   ert = "Awful";     break;
    case  3:                   ert = "Cool Minus";break;
    case  4: case  5:          ert = "Dude";      break;
    case  6:                   ert = "Cool";      break;
    case  7:                   ert = "Mass Cool"; break;
    case  8: case  9:          ert = "Awesome";   break;
    default:                   ert = "EXCELLENT"; break;
    }
    break;

  case 4:
    switch( (int)(x/y) ) {
    case -1: case  0: case  1: ert = "very bad";  break;
    case  2:                   ert = "bad";       break;
    case  3:                   ert = "not bad";   break;
    case  4: case  5: case  6: ert = "okay";      break;
    case  7: case  8: case  9: ert = "good";      break;
    default:                   ert = "very good"; break;
    }
    break;

  default:
    switch( (int)(x/y) ) {
    case -1: case  0: case  1: ert = "  :6    ";  break;
    case  2:                   ert = "  :0    ";  break;
    case  3:                   ert = "  :(    ";  break;
    case  4: case  5:          ert = "  :}    ";  break;
    case  6:                   ert = "  :)    ";  break;
    case  7:                   ert = "  :]    ";  break;
    case  8: case  9:          ert = "  :>    ";  break;
    default:                   ert = "  :D    ";  break;
    }
    break;
  }

  return ert;
};
//////////////////////////////////////////////////////////////////////
void put_misc3()
{
  //{ Prints ratings on certain abilities }

  integer    i1;
  vtype      out_val;

  clear_rc(16,1);
  i1 = randint(5);   //{random variation for likert tables}

  prt("(Miscellaneous Abilities)",16,24);
  prt2("Melee Fights: ", likert(xbth(),  20, i1) ,17,  2);
  prt2("Guns/Grenade: ", likert(xbthb(), 20, i1) ,18,  2);
  prt2("Saving Throw: ", likert(xsave(), 10, i1) ,19,  2);
  prt2("Stealth     : ", likert(xstl(),   1, i1) ,17, 27);
  prt2("Disarming   : ", likert(xdis(),  10, i1) ,18, 27);
  prt2("Weird Device: ", likert(xdev(),  10, i1) ,19, 27);
  prt2("Perception  : ", likert(xperc(), 10, i1) ,17, 52);
  prt2("Searching   : ", likert(xsrh(),  10, i1) ,18, 52);
  prt2("Infra-Vision: ", xinfra(out_val),         19, 52);

};
//////////////////////////////////////////////////////////////////////
void display_char()
{
  //{ used to display the character on the screen. }

  put_character();
  put_misc1();
  put_stats();
  put_misc2();
  put_misc3();
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prt_num(vtype header, integer num,integer row,integer column)
{
  /*	{ print number with header at given row, column		-rak-	}*/

  vtype out_val;

  sprintf(out_val,"%s%ld  ",header,num);
  put_buffer(out_val,row,column);

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer weight_limit()
{
  //{ computes current weight limit }

  return lesser(3000,
		py.stat.cstr*PLAYER_WEIGHT_CAP + py.misc.wt);
};
//////////////////////////////////////////////////////////////////////
void prt_search()
{
  //{ Prints Searching status   }
  if (uand(0x000100,py.flags.status) != 0) {
    put_buffer("Searching  ",24,44);
  } else {
    put_buffer("           ",24,44);
  }
};
//////////////////////////////////////////////////////////////////////
void prt_rest()
{
  //{ Prints Resting status }
  if (uand(0x000200,py.flags.status) != 0) {
    put_buffer("Resting    ",24,44);
  } else {
    put_buffer("           ",24,44);
  }
};
//////////////////////////////////////////////////////////////////////
void prt_winner()
{
  //{ Prints winner status on display   }
  put_buffer("*Winner*",23,1);
};
//////////////////////////////////////////////////////////////////////
void prt_stat_block()
{
  //{ Prints character-screen info  }
  
  integer   indx;
  real      mwkdiv;

  prt_field(py.misc.race,                 3,stat_column);
  prt_field(py.misc.tclass,               4,stat_column);
  prt_field(py.misc.title,                5,stat_column);
  prt_stat("STR : ",py.stat.cstr,         7,stat_column);
  prt_stat("INT : ",py.stat.cint,         8,stat_column);
  prt_stat("WIS : ",py.stat.cwis,         9,stat_column);
  prt_stat("DEX : ",py.stat.cdex,        10,stat_column);
  prt_stat("CON : ",py.stat.ccon,        11,stat_column);
  prt_stat("CHR : ",py.stat.cchr,        12,stat_column);
  prt_num( "LEV : ",py.misc.lev,         14,stat_column);
  prt_num( "EXP : ",py.misc.exp,         15,stat_column);
  prt_num( "CHP : ",trunc(py.misc.chp),  16,stat_column);
  prt_num( "MHP : ",py.misc.mhp,         17,stat_column);

  if ((strcmp(py.misc.tclass, "Ninja")    != 0) &&
      (strcmp(py.misc.tclass, "Wrestler") != 0)) {
    mwkdiv = py.misc.cmana/10;
    if (mwkdiv < 1) {
        indx=2;
    } else {
      if (mwkdiv < 10) {
	indx=3;
      } else {
	indx=4;
      }
    }
    prt_num( "RSRC: ",(int)(py.misc.cmana),18,stat_column);
    prt_num( "/",py.misc.mana,18,stat_column+5+indx);
  }

  prt_num( "AC  : ",py.misc.dis_ac,      19,stat_column);
  prt_num( "CASH: ",py.misc.au,          20,stat_column);
  prt_num( "WGHT: ",inven_weight,        21,stat_column);
  max_weight = weight_limit();
  prt_num( "MXWT: ",max_weight,          22,stat_column);

  prt_time();
  if (total_winner_num > 0) { prt_winner(); }

  if (uand(0x000003,py.flags.status) != 0) {  prt_hunger();   }
  if (uand(0x000004,py.flags.status) != 0) {  prt_blind();    }
  if (uand(0x000008,py.flags.status) != 0) {  prt_confused(); }
  if (uand(0x000010,py.flags.status) != 0) {  prt_afraid();   }
  if (uand(0x000020,py.flags.status) != 0) {  prt_poisoned(); }
  if (uand(0x000100,py.flags.status) != 0) {  prt_search();   }
  if (uand(0x000200,py.flags.status) != 0) {  prt_rest();     }

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void char_inven_init()
{
  //{ Init players with some belongings, and also clear the kill_list record. }

  integer    i1,i2,dummy;

  for (i1 = 0;  i1 < MAX_CHAR_INVEN_INIT ; i1++) {
    i2 = player_init[py.misc.pclass][i1];
    temporary_slot = inventory_init[i2];
    magic_treasure(&temporary_slot,777);
    inven_carry(&dummy);
  }

  for (i1 = 23; i1 <= EQUIP_MAX; i1++) {
    equipment[i1] = blank_treasure;
  }

  for (i1 = 1; i1 <= max_creatures; i1++) {
    kill_list[i1] = 0;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean learn_spell(boolean *redraw)
{
  //{  Learn some magic spells (Scientist)    }
  
  unsigned         i2;
  integer          i1,i3,sn,sc;
  integer          new_spells;
  unsigned         spell_flag;
  spl_type         spell;
  boolean          return_value = false;
  
  new_spells = how_many_skills(int_adj());
  i1 = 0;
  spell_flag = 0;
  
  do {
    i1++;
    if (inventory[i1].tval == 90) {
      spell_flag |= inventory[i1].flags;
    }
  } while (!(i1 >= inven_ctr));
  
  while ((new_spells > 0) && (spell_flag > 0)) {
    i1 = 0;
    i2 = spell_flag;
    
    do {
      i3 = bit_pos(&i2) + 1;
      //with skill_list[i3]. do;
      if (skill_list[i3].slevel <= py.misc.lev) {
	if (!skill_list[i3].learned) {
	  i1++;
	  spell[i1].splnum = i3;
	}
      }
    } while (i2 != 0);
    
    if (i1 > 0) {
      print_new_skills(spell,i1,redraw);
      if (get_skill(spell,i1,&sn,&sc,"Learn which skill?",redraw)) {
	skill_list[sn].learned = true;
	return_value = true;
	if (py.misc.mana == 0) {
	  py.misc.mana  = 1;
	  py.misc.cmana = 1;
	} else {
	  new_spells = 0;
	}
      } else {
	new_spells = 0;
      }
    }
    new_spells--;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean learn_extra(boolean *redraw)
{
  //{ Learn some extra spells (Con-Artist)    }

  unsigned      i2;
  integer       i1,i3,sn,sc;
  integer       new_spells;
  unsigned      spell_flag;
  spl_type      spell;

  boolean       return_value = false;

  new_spells = how_many_skills(chr_adj());
  i1 = 0;
  spell_flag = 0;

  do {
    i1++;
    if (inventory[i1].tval == 92) {
      spell_flag |= inventory[i1].flags;
    }
  } while (!(i1 >= inven_ctr));

  while ((new_spells > 0) && (spell_flag > 0)) {

    i1 = 0;
    i2 = spell_flag;
    
    do {
      i3 = bit_pos(&i2) + 1;
      //with skill_list[i3]. do;
      if (skill_list[i3].slevel <= py.misc.lev) {
	if (!skill_list[i3].learned) {
	  i1++;
	  spell[i1].splnum = i3;
	}
      }
    } while (i2 != 0);
      
    if (i1 > 0) {
      print_new_skills(spell,i1,redraw);
      if (get_skill(spell,i1,&sn,&sc,"Learn which trick?",redraw)) {
	skill_list[sn].learned = true;
	return_value = true;
	if (py.misc.mana == 0) {
	  py.misc.mana  = 1;
	  py.misc.cmana = 1;
	}
      } else {
	new_spells = 0;
      }
    } else {
      new_spells = 0;
    }

    new_spells--;
  }

  return return_value;
}; 
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean learn_prayer()
{ 
  //{ Learn some prayers (Guru)   }

  integer   i1,i2,i3,i4,new_spell;
  integer   test_array[33]; // : array [1..32] of integer;
  unsigned  spell_flag;
  boolean   return_value = false;

  i1 = 0;
  spell_flag = 0;

  do {
    i1++;
    if (inventory[i1].tval == 91) {
      spell_flag |= inventory[i1].flags;
    }
  } while (!(i1 >= inven_ctr));

  i1 = 0;
  while (spell_flag > 0) {
    i2 = bit_pos(&spell_flag) + 1;
    //with skill_list[i2]. do;
    if (skill_list[i2].slevel <= py.misc.lev) {
      if (!skill_list[i2].learned) {
	i1++;
	test_array[i1] = i2;
      }
    }
  }

  i2 = how_many_skills(wis_adj());
  new_spell = 0;

  while ((i1 > 0) && (i2 > 0)) {
    i3 = randint(i1);
    skill_list[test_array[i3]].learned = true;
    new_spell++;
    for (i4 = i3; i4 <= i1-1; i4++) {
      test_array[i4] = test_array[i4+1];
    }
    i1--;      /*{ One less spell avalible to learn   }*/
  }

  if (new_spell > 0) {
    if (new_spell > 1) {
      msg_print("You learned new prayers!");
    } else {
      msg_print("You learned a new prayer!");
    }
    if (py.misc.exp == 0) {
      msg_print(" ");
    }

    if (py.misc.mana == 0) {
      py.misc.mana  = 1;
      py.misc.cmana = 1;
    }
    return_value = true;
  } else {
    return_value = false;
  }

  return return_value;
};

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/*{ Based on adjustment, determines how many new skills are learned. -RLG}*/
integer how_many_skills(integer adjustment)
{
  integer   num;

  switch (adjustment) {
  case 0 :                   num = 0;             break;
  case 1 : case 2 : case 3 : num = 1;             break;
  case 4 :                   num = randint(2);    break;
  case 5 :                   num = 2;             break;
  case 6 :                   num = randint(3);    break;
  case 7 :                   num = randint(2)+1;  break;
  case 8 :                   num = randint(3)+1;  break;
  case 9 :                   num = randint(2)+2;  break;
  case 10 :                  num = randint(5);    break;
  default:                   num = 0;             break;
  }

  return num;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/*{ Returns spell pointer }*/
boolean get_skill( spl_type spell, integer num, integer *sn, integer *sc,
		   vtype prompt, boolean *redraw)
{
  boolean     flag = true;
  char        choice;
  vtype       out_val;

  *sn = 0;

  sprintf(out_val,"(Skills a-%c, space=list, <ESC>=exit) %s",
	  (int)num+96,prompt);

  while (((*sn < 1) || (*sn > num)) && (flag)) {
    prt(out_val,1,1);
    choice = inkey();
    *sn = choice;

    switch (*sn) {
    case 0: case 3: case 25: case 26: case 27: 
      flag = false;
      reset_flag = true;
      break;
      
    case 32 : 
      print_new_skills(spell,num,redraw);
      break;
      
    default:
      *sn -= 96;
      break;
    }
  }

  msg_flag = false;

  if (flag) {
    skill_chance(&spell[*sn]);
    *sc = spell[*sn].splchn;
    *sn = spell[*sn].splnum;
  }

   return flag;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/*{ Returns spell chance of failure for spell }*/
void skill_chance(spl_rec *spell)
{
  integer    adjust;

  switch (py.misc.pclass) {
  case 1: case 2: case 7:   adjust = int_adj();
  case 3: case 4:           adjust = wis_adj();
  case 5: case 6:           adjust = chr_adj();
  }

  //with skill_list[spell->splnum]. do;
  //with spell-> do;

  spell->splchn = ( skill_list[spell->splnum].sfail - 
		    3*(py.misc.lev - skill_list[spell->splnum].slevel) - 
		    3*(adjust-1) );

  if (skill_list[spell->splnum].smana > py.misc.cmana) {
    spell->splchn += 5*trunc(skill_list[spell->splnum].smana - py.misc.cmana);
  }

  if (spell->splchn > 95) {
    spell->splchn = 95;
  } else if (spell->splchn < 5) {
    spell->splchn = 5;
  }
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void print_new_skills(spl_type spell, integer num, boolean *redraw)
{

  integer    i1;
  vtype      out_val;

  *redraw = true;

  clear_from(1);
  prt("   Name                          Level  Rsrc  %Failure",2,1);

  for (i1 = 1; i1 <= num; i1++) {
    //with skill_list[spell[i1].splnum]. do;
    skill_chance(&spell[i1]);
    sprintf(out_val,"%c) %-30s %3d    %3d      %2ld",
	    96+(int)i1,
	    skill_list[spell[i1].splnum].sname,
	    skill_list[spell[i1].splnum].slevel,
	    skill_list[spell[i1].splnum].smana,
	    spell[i1].splchn);
    prt(out_val,2+i1,1);
  }
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void draw_the_bus()
{
  /*{ Routine that draws the bus.  See also 'take_bus' in train.inc }*/

  vtype     str, str2;
  FILE     *f1;
  integer   i1;

  f1 = priv_fopen( BUS_PIC, "r");

  if (f1 == NULL) {
    sprintf(str,"You endure a long bus ride and arrive in %s",
	    townlist[town_num].town_name);
    msg_print(str);
  } else {

    clear_from(1);
    for (i1 = 1; i1 <= 24; i1++) {
      fgets(str, sizeof(str), f1);
      prt(str,i1,1);
    }

    fill_str(str, townlist[town_num].town_name, 21);
    sprintf(str2, "%s|", str);
    prt( str2,18,52);
    pause_game(24);

    fclose(f1);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
byteint de_statp(byteint stat)
{
  /*{ Decreases a stat by one randomized level  }*/
  
  if (stat > 34) {
    stat--;
    if (randint(5)==1) {   /* {Hose the sucker...!} */
      stat--;
    }
  } else if (stat > 3) {
    stat--;
  }

  return stat;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
byteint in_statp(byteint stat)
{
  /*{ Increases a stat by one randomized level  }*/

  if (stat < 35) {
    stat++;
  } else if (stat < 50) {
    stat += randint(2) - 1;
  }

  return stat;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
byteint in_statt(byteint stat)
{
  /*{ Increases a stat by one true level    }*/

  if (stat < 50) {
    stat++;
  }

  return stat;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
byteint de_statt(byteint stat)
{
  /*{ Decreases a stat by true level    }*/

  if (stat > 3) {
    stat--;
  }

  return stat;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
static void ic__insert(integer pos, integer wgt)
{
  /*{ Insert TEMPORARY_SLOT at given location }*/

  integer i1;

  for (i1 = inven_ctr; i1 >= pos; i1--) {
    inventory[i1+1] = inventory[i1];
  }
  
  inventory[pos] = temporary_slot;
  inven_ctr++;
  inven_weight  += wgt;
};
//////////////////////////////////////////////////////////////////////
void inven_carry(integer *item_val)
{
  /*{ Add the item in TEMPORARY_SLOT to players inventory.  Return the
    item position for a description if needed...  }*/

  integer   item_num,wgt,typ,subt;
  boolean   flag = false;
  
  *item_val = 0;

  /*{ Check to see if player can carry object  }*/

  //with temporary_slot do;
  item_num = temporary_slot.number;
  typ      = temporary_slot.tval;
  subt     = temporary_slot.subval;
  wgt      = temporary_slot.number * temporary_slot.weight;

  do {
    (*item_val)++;
    //with inventory[*item_val]. do;

    if (typ == inventory[*item_val].tval) {
      if (subt == inventory[*item_val].subval) { /*{ Adds to other item }*/
	if (subt > 255) {
	  inventory[*item_val].number += item_num;
	  inven_weight += wgt;
	  flag = true;
	}
      }
    } else if (typ > inventory[*item_val].tval) {
      /* { Insert into list  } */
      ic__insert(*item_val,wgt);
      flag = true;
    }

    } while (!((*item_val >= inven_ctr) || (flag)));


  if (!flag) {     /*{ Becomes last item in list }*/
    ic__insert(inven_ctr+1,wgt);
    *item_val = inven_ctr;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
char *cnv_stat (byteint stat, char *out_val)
{
  /*{ Converts stat num into string }*/

  vtype   tmp_str;
  integer part1,part2;

  if (stat > 18) {
    part1 = 18;
    part2 = stat - 18;
    sprintf(tmp_str,"18/%ld",part2);
  } else {
    sprintf(tmp_str,"%d",stat);
  }

  sprintf(out_val, "%6s", tmp_str);

  return out_val;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void alloc_monster(obj_set alloc_set, integer num, integer dis, boolean slp)
{
  /*{ Allocates a random monster }*/
  integer y,x,i1,i2,i3;
  
  for (i1 = 1; i1 <= num; i1++) {
    do {
      y = randint(cur_height-2)+1;
      x = randint(cur_width-2)+1;
    } while (!(is_in(cave[y][x].fval, alloc_set)  &&
	       (cave[y][x].cptr == 0)             &&
	       (cave[y][x].fopen)                 &&
	       (distance(y,x,char_row,char_col) > dis)));
    
    if (dun_level <= 0) {
      i2 = randint(m_level[0]);
    } else {
      
      if (dun_power > MAX_MONS_LEVEL) {
	i2 = randint(m_level[MAX_MONS_LEVEL]) + m_level[0];
      } else {
	if (randint(MON_NASTY) == 1) {
	  i2 = dun_power + abs(randnor(0,4)) + 1;
	  if (i2 > MAX_MONS_LEVEL) { i2 = MAX_MONS_LEVEL; }
	  i3 = m_level[i2] - m_level[i2-1];
	  i2 = randint(i3) + m_level[i2-1];
	} else {
	  i2 = randint(m_level[dun_power]) + m_level[0];
	}
      }
    }
    place_monster(y,x,i2,slp);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean summon_monster(integer *y, integer *x, boolean slp)
{
/*{ Places creature adjacent to given location }*/

  integer i1,i2,i3,i4,i5;
  boolean return_value = false;

  obj_set   one_two_four_five = {1,2,4,5};

  i1 = 0;
  i5 = dun_power - MON_SUMMON_ADJ;
  
  if (i5 < 1) {
    i4 = 1;
  } else if (i5 > MAX_MONS_LEVEL) {
    i4 = MAX_MONS_LEVEL;
  } else {
    i4 = i5;
  }

  if (dun_level <= 0) {
    i4 = randint(m_level[0]);
  } else {
    i4 = randint(m_level[i4]) + m_level[0];
  }

  do {
    i2 = *y - 2 + randint(3);
    i3 = *x - 2 + randint(3);
    if (in_bounds(i2,i3)) {
      //with cave[i2][i3]. do;
      if (is_in(cave[i2][i3].fval,one_two_four_five)) {
	if (cave[i2][i3].cptr == 0) {
	  if (cave[i2][i3].fopen) {
	    place_monster(i2,i3,i4,slp);
	    return_value = true;
	    i1 = 9;
	    *y = i2;
	    *x = i3;
	  }
	}
      }
    }
    i1 = i1 + 1;
  } while (i1 <= 9);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean summon_undead(integer *y, integer *x)
{
  /*{ Places undead adjacent to given location }*/
  
  integer   i1,i2,i3,i4,i5,ctr;
  obj_set   one_two_four_five = {1,2,4,5};
  boolean   return_value = false;

  i1 = 0;
  i4 = m_level[MAX_MONS_LEVEL];

  do {
    i5 = randint(i4) + m_level[0];
    ctr = 0;

    do {
      if (uand(c_list[i5].cdefense,0x0008) != 0) {
	ctr = 20;
	i4  = 0;
      } else {
	i5 = i5 + 1;
	if (i5 > i4) {
	  ctr = 20;
	} else {
	  ctr = ctr + 1;
	}
      }
    } while (ctr <= 19);

  } while (i4 != 0);


  do {
    i2 = *y - 2 + randint(3);
    i3 = *x - 2 + randint(3);
    
    if (in_bounds(i2,i3)) {
      //with cave[i2][i3]. do;
      if (is_in(cave[i2][i3].fval, one_two_four_five)) {
	if ((cave[i2][i3].cptr == 0) && (cave[i2][i3].fopen)) {
	  place_monster(i2,i3,i5,false);
	  return_value = true;
	  i1 = 9;
	  *y = i2;
	  *x = i3;
	}
      }
    }
    
    i1 = i1 + 1;
  } while (i1 <= 9);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void alloc_object(obj_set alloc_set, integer typ, integer num)
{
  /*{ Allocates an object for tunnels and rooms }*/

  integer   i1,i2,i3;

  for (i3 = 1; i3 <= num; i3++) {
    do {
      i1 = randint(cur_height);
      i2 = randint(cur_width);
    } while (! (is_in(cave[i1][i2].fval, alloc_set) &&
		(cave[i1][i2].tptr == 0)));

    switch (typ) {
    case 1 : place_trap(i1,i2,1,randint(MAX_TRAPA)); break;
    case 2 : place_trap(i1,i2,2,randint(MAX_TRAPB)); break;
    case 3 : place_rubble(i1,i2);                    break;
    case 4 : place_gold(i1,i2);                      break;
    case 5 : place_object(i1,i2);                    break;
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void random_object(integer y, integer x, integer num)
{
  /*{ Creates objects nearby the coordinates given  }*/

  integer  i1,i2,i3;

  do {
    i1 = 0;
    
    do {
      i2 = y - 3 + randint(5);
      i3 = x - 4 + randint(7);
      //with cave[i2][i3]. do;
      if (is_in(cave[i2][i3].fval, floor_set)) {
	if (cave[i2][i3].tptr == 0) {
	  if (randint(100) < 75) {
	    place_object(i2,i3);
	  } else {
	    place_gold(i2,i3);
	    i1 = 9;
	  }
	}
      }
      
      i1 = i1 + 1;
      
    } while (i1 <= 10);
    num = num - 1;
    
  } while (num != 0);

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void blank_cave()
{
  /*{ Blanks out entire cave }*/

  integer  i1,i2;

  for (i1 = 1; i1 <= MAX_HEIGHT; i1++) {
    for (i2 = 1; i2 <= MAX_WIDTH; i2++) {
      cave[i1][i2] = blank_floor;
      cave[i1][i2].fopen = true;
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_boundry()
{
  /*{ Places indestructable rock around edges of dungeon }*/

  integer  i1;
  
  for (i1 = 1; i1 <= cur_height; i1++) {
    cave[i1][1].fval    = boundry_wall.ftval;
    cave[i1][1].fopen   = boundry_wall.ftopen;
    cave[i1][cur_width].fval  = boundry_wall.ftval;
    cave[i1][cur_width].fopen = boundry_wall.ftopen;
  }
  
  for (i1 = 1; i1 <= cur_width; i1++) {
    cave[1][i1].fval     = boundry_wall.ftval;
    cave[1][i1].fopen    = boundry_wall.ftopen;
    cave[cur_height][i1].fval  = boundry_wall.ftval;
    cave[cur_height][i1].fopen = boundry_wall.ftopen;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean in_bounds(integer y, integer x)
{
  /*{ Checks a co-ordinate for in bounds status }*/
  boolean  return_value = false;


  if ((y > 1) && (y < cur_height) &&
      (x > 1) && (x < cur_width)) {
    return_value = true;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void mlink()
{
  /*{ Link all free space in monster list together }*/

  integer  i1;

  for (i1 = 1; i1 <= MAX_MALLOC; i1++) {
    m_list[i1] = blank_monster;
    m_list[i1].nptr = i1 - 1;
  }

  m_list[2].nptr = 0;
  muptr = 0;
  mfptr = MAX_MALLOC;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void tlink()
{
  /*{ Link all free space in treasure list together }*/

  integer i1;

  for (i1 = 1; i1 <= MAX_TALLOC; i1++) {
    t_list[i1] = blank_treasure;
    t_list[i1].p1 = i1 - 1;
  }

  tcptr = MAX_TALLOC;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer next_to8 (integer y, integer x, obj_set group_set)
{
  /*{ Checks all adjacent spots for elements }*/

  integer  i1,i2,i3;
  
  i1 = 0;
  for (i2 = (y - 1); i2 <= (y + 1); i2++) {
    for (i3 = (x - 1); i3 <= (x + 1); i3++) {
      if (in_bounds(i2,i3)) {
	if (is_in(cave[i2][i3].fval, group_set)) {
	  i1 = i1 + 1;
	}
      }
    }
  }
  
  return i1;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer next_to4 (integer y, integer x, obj_set group_set)
{
  /*{ Checks points north, south, east, and west for a type }*/

  integer  i1;

  i1 = 0;
  if (y > 1) {
    if (is_in(cave[y-1][x].fval, group_set)) {
      i1 = i1 + 1;
    }
  }
  
  if (y < cur_height) {
    if (is_in(cave[y+1][x].fval, group_set)) {
      i1 = i1 + 1;
    }
  }
  
  if (x > 1) {
    if (is_in(cave[y][x-1].fval, group_set)) {
      i1 = i1 + 1;
    }
  }

  if (x < cur_width) {
    if (is_in(cave[y][x+1].fval, group_set)) {
      i1 = i1 + 1;
    }
  }

  return i1;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_badguy_monster(integer monster)
{
  /*{ Places badguy at random location. -RLG}*/

  integer  cur_pos,y,x,z;

  /*{ Finds exact spot of badguy in creature list}*/
  get_random_location(&y, &x);
  z = m_level[0] + m_level[MAX_MONS_LEVEL] + NUM_OF_POLICE + monster;
  popm(&cur_pos);
  bungi(y,x,z,cur_pos);

  //with m_list[cur_pos]. do;
  m_list[cur_pos].cur_reprod = c_list[z].reprod;
  m_list[cur_pos].csleep = 10;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_the_boss()
{
  /*{ Places the Boss at random location }*/

  integer   cur_pos,y,x,z;

  get_random_location(&y,&x);
  z = max_creatures;
  popm(&cur_pos);
  bungi(y,x,z,cur_pos);

  //with m_list[cur_pos]. do;
  m_list[cur_pos].cur_reprod = c_list[z].reprod;
  m_list[cur_pos].csleep = 0;

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer popt(integer *x)
{
  /*{ Gives pointer to next free space  }*/

  if (tcptr < 1) {
    compact_objects();
  }

  *x = tcptr;
  tcptr = t_list[*x].p1;

  return *x;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void pusht(integer x)
{
  /*{ Pushs a record back onto free space list  }*/

  t_list[x] = blank_treasure;
  t_list[x].p1 = tcptr;
  tcptr = x;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_closed_door(integer y, integer x)
{
  integer  cur_pos;

  popt(&cur_pos);

  //with cave[y][x]. do;
  cave[y][x].tptr = cur_pos;
  t_list[cur_pos] = door_list[2];
  cave[y][x].fval  = corr_floor3.ftval;
  cave[y][x].fopen = false;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_locked_door(integer y, integer x)
{
  integer   cur_pos;

  popt(&cur_pos);

  //with cave[y][x]. do;
  cave[y][x].tptr = cur_pos;
  t_list[cur_pos] = door_list[2];
  cave[y][x].fval  = corr_floor3.ftval;
  cave[y][x].fopen = false;
  t_list[cur_pos].p1 = randint(10) + 10;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_stuck_door(integer y, integer x)
{
  integer   cur_pos;

  popt(&cur_pos);

  //with cave[y][x]. do;
  cave[y][x].tptr = cur_pos;
  t_list[cur_pos] = door_list[2];
  cave[y][x].fval  = corr_floor3.ftval;
  cave[y][x].fopen = false;
  t_list[cur_pos].p1 = -randint(10) - 10;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_secret_door(integer y, integer x)
{
  integer  cur_pos;

  popt(&cur_pos);

  //with cave[y][x]. do;
  cave[y][x].tptr = cur_pos;
  t_list[cur_pos] = door_list[3];
  cave[y][x].fval  = corr_floor4.ftval;
  cave[y][x].fopen = false;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_broken_door(integer y, integer x)
{
  integer   cur_pos;

    popt(&cur_pos);

    //with cave[y][x]. do;
    cave[y][x].tptr = cur_pos;
    t_list[cur_pos] = door_list[1];
    cave[y][x].fval  = corr_floor3.ftval;
    cave[y][x].fopen = true;
    t_list[cur_pos].p1 = 1;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_open_door(integer y, integer x)
{
  integer   cur_pos;

  popt(&cur_pos);

  //with cave[y][x]. do;
  cave[y][x].tptr = cur_pos;
  t_list[cur_pos] = door_list[1];
  cave[y][x].fval = corr_floor3.ftval;
  cave[y][x].fopen = true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_door(integer y, integer x)
{

  switch (randint(3)) {
  case 1 : 
    switch (randint(4)) {
    case 1 :  place_broken_door(y,x); break;
    default:  place_open_door(y,x);   break;
    }
    break;

  case 2 : 
    switch (randint(12)) {
    case 1: case 2  : place_locked_door(y,x); break;
    case 3:           place_stuck_door(y,x);  break;
    default:          place_closed_door(y,x); break;
    }
    break;
    
  case 3 :
    place_secret_door(y,x);
    break;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_up_stairs(integer y, integer x)
{
  /*{ Place an up staircase at given y,x    }*/

  integer   cur_pos,i3;

  //with cave[y][x]. do;
  if (cave[y][x].tptr != 0) {
    pusht(cave[y][x].tptr);
    cave[y][x].tptr = 0;
    cave[y][x].fopen = true;
  }

  popt(&cur_pos);
  cave[y][x].tptr = cur_pos;

  switch (randint(10)) {
  case 1: case 2: case 3: case 4: case 5: i3 = 1; break;
  case 6: case 7: case 8:                 i3 = 2; break;
  case 9: case 10:                        i3 = 3; break;
  }

  t_list[cur_pos] = up_stair[i3];
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_down_stairs(integer y, integer x)
{
  /*{ Place a down staircase at given y,x   }*/

  integer   cur_pos,i3;

  //with cave[y][x]. do;
  if (cave[y][x].tptr != 0) {
    pusht(cave[y][x].tptr);
    cave[y][x].tptr = 0;
    cave[y][x].fopen = true;
  }

  popt(&cur_pos);
  cave[y][x].tptr = cur_pos;

  switch (randint(10)) {
  case 1: case 2: case 3: case 4: case 5: i3 = 1; break;
  case 6: case 7: case 8:                 i3 = 2; break;
  case 9: case 10:                        i3 = 3; break;
  }

  t_list[cur_pos] = down_stair[i3];
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_stairs(integer typ, integer num, integer walls)
{ 
  /*{ Places a staircase 1=up, 2=down   }*/

  integer   i1,i2,y1,x1,y2,x2;
  boolean   flag;
  obj_set   one_two_four = {1,2,4};

  for (i1 = 1; i1 <= num; i1++) {
    flag = false;

    do {
      i2 = 0;

      do {
	y1 = randint(cur_height - 12);
	x1 = randint(cur_width  - 12);
	y2 = y1 + 12;
	x2 = x1 + 12;
	
	do {
	  
	  do {
	    //with cave[y1][x1]. do;
	    if (is_in(cave[y1][x1].fval, one_two_four)) {
	      if (cave[y1][x1].tptr == 0) {
		if (next_to4(y1,x1,wall_set) >= walls) {
		  flag = true;
		  switch (typ) {
		  case 1 : place_up_stairs(y1,x1);   break;
		  case 2 : place_down_stairs(y1,x1); break;
		  }
		}
	      }
	    }
	    
	    x1 = x1 + 1;
	    
	  } while (! ((x1 == x2) || (flag)) );
	  
	  x1 = x2 - 12;
	  y1 = y1 + 1;
	  
	} while (! ((y1 == y2) || (flag)) );

	i2 = i2 + 1;
	
      } while (! ((flag) || (i2 > 30)) );
      
      walls = walls - 1;
      
    } while (!flag);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_gold(integer y, integer x)
{
  /*{ Places a treasure (Gold or Gems) at given row, column }*/

  integer   cur_pos,i1;

  popt(&cur_pos);
  i1 = trunc((randint(dun_power+2)+2)/2.0);

  if (randint(OBJ_GREAT) == 1) {
    i1 = i1 + randint(dun_power);
  }

  if (i1 > MAX_GOLD) {
    i1 = randint(MAX_GOLD-8)+8;
  }

  cave[y][x].tptr = cur_pos;
  t_list[cur_pos] = gold_list[i1];

  //with t_list[cur_pos]. do;
  t_list[cur_pos].cost = (randint(6*t_list[cur_pos].cost) + 
			  t_list[cur_pos].cost);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_trap(integer y,integer x,integer typ,integer subval)
{
  /*{places a trap at a given location}*/

  integer        cur_pos;
  treasure_type  cur_trap;

  if (typ == 1) {
    cur_trap = trap_lista[subval];
  } else {
    if (typ == 2) {
      cur_trap = trap_listb[subval];
    } else {
      cur_trap = blk_mkt_trap; /*{typ=3, one per level - mwk}*/
    }
  }

  popt(&cur_pos);
  cave[y][x].tptr  = cur_pos;
  t_list[cur_pos] = cur_trap;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_rubble(integer y, integer x)
{
  /*{ Places rubble at location y,x }*/

  integer   cur_pos;

  popt(&cur_pos);

  //with cave[y][x]. do;
  cave[y][x].tptr = cur_pos;
  cave[y][x].fopen = false;

  t_list[cur_pos] = rubble;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_object(integer y, integer x)
{
  /*{ Places an object at given row, column co-ordinate }*/

  integer   cur_pos;

  popt(&cur_pos);
  cave[y][x].tptr = cur_pos;
  t_list[cur_pos] = object_list[get_obj_num(dun_power)];
  magic_treasure(&t_list[cur_pos],dun_power);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean move_dir(integer dir, integer *y, integer *x)
{
  /*{ Given direction 'dir', returns new row, column location   }*/

  integer   new_row,new_col;
  boolean   return_value = false;

  switch (dir) {
  case 1 : 
    new_row = *y + 1;
    new_col = *x - 1;
    break;

  case 2 : 
    new_row = *y + 1;
    new_col = *x;
    break;

  case 3 : 
    new_row = *y + 1;
    new_col = *x + 1;
    break;

  case 4 : 
    new_row = *y;
    new_col = *x - 1;
    break;

  case 5 : 
    new_row = *y;
    new_col = *x;
    break;

  case 6 : 
    new_row = *y;
    new_col = *x + 1;
    break;

  case 7 : 
    new_row = *y - 1;
    new_col = *x - 1;
    break;

  case 8 : 
    new_row = *y - 1;
    new_col = *x;
    break;

  case 9 : 
    new_row = *y - 1;
    new_col = *x + 1;
    break;
  };

  if ((new_row >= 1) && (new_row <= cur_height)) {
    if ((new_col >= 1) && (new_col <= cur_width)) {
      *y = new_row;
      *x = new_col;
      return_value = true;
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer distance(integer y1,integer x1,integer y2,integer x2)
{
  register int dy, dx;

/*
	;	Distance returned is only an approximation based on :
	;
	;	dy = abs(y1-y2)
	;	dx = abs(x1-x2)
	;
	;	distance =  2*(dy+dx) - MIN(dy,dx)
	;		    ----------------------
	;			      2
*/
  dy = y1 - y2;
  if (dy < 0)
    dy = -dy;
  dx = x1 - x2;
  if (dx < 0)
    dx = -dx;

  return ((((dy + dx) << 1) - (dy > dx ? dx : dy)) >> 1);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_monster(integer y, integer x, integer z, boolean slp)
{
  /*{ Places a monster at given location }*/

  integer  cur_pos;

  popm(&cur_pos);
  bungi(y,x,z,cur_pos);

  //with m_list[cur_pos]. do;
  m_list[cur_pos].cur_reprod = c_list[z].reprod;
  if (slp) {
    m_list[cur_pos].csleep = (trunc(c_list[z].sleep/5.0) + 
			      randint(c_list[z].sleep));
  } else {
    m_list[cur_pos].csleep = 0;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_policeman(integer y1,integer x1,integer cop_num)
{
  /*{ Places a policeman on town level. }*/

  integer   y,x,z,cur_pos;
  obj_set   one_two_four = {1,2,4};

  do {
    y = y1 + randint(7)-4;
    x = x1 + randint(7)-4;
  } while (! ((in_bounds(y,x)) && is_in(cave[y][x].fval, one_two_four) &&
	      (cave[y][x].cptr == 0)));

  z = m_level[0] + m_level[MAX_MONS_LEVEL] + cop_num;
  popm(&cur_pos);
  bungi(y,x,z,cur_pos);

  //with m_list[cur_pos]. do;
  m_list[cur_pos].cur_reprod = c_list[z].reprod;
  m_list[cur_pos].csleep = 0;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void place_mult_monster(integer y, integer x, integer z, integer repro,
			boolean slp)
{
  /*{ Places multiplying/reproducing monster at given location. -RLG}*/

  integer  cur_pos;

  popm(&cur_pos);
  bungi(y,x,z,cur_pos);

  //with m_list[cur_pos]. do;
  m_list[cur_pos].cur_reprod = repro;
  if (slp) {
    m_list[cur_pos].csleep = (trunc(c_list[z].sleep/5.0) + 
			      randint(c_list[z].sleep));
  } else {
    m_list[cur_pos].csleep = 0;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void get_random_location(integer *y, integer *x)
{
  obj_set   one_two_four = {1,2,4};

  do {
    *y = randint(cur_height-2)+1;
    *x = randint(cur_width-2)+1;
  } while (! (is_in(cave[*y][*x].fval, one_two_four)  &&
	      (cave[*y][*x].cptr == 0)        &&
	      (cave[*y][*x].tptr == 0)        &&
	      (distance(*y,*x,char_row,char_col) > MAX_SIGHT)));
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void bungi(integer y, integer x, integer z, integer cur_pos)
{
  /*{ Put varying monster info from creature list into monster list.}*/
  /*{ The procedure is called bungi because he was there......  -RLG}*/

  //with m_list[cur_pos]. do;
  m_list[cur_pos].fy    = y;
  m_list[cur_pos].fx    = x;
  m_list[cur_pos].mptr  = z;
  m_list[cur_pos].nptr  = muptr;
  muptr = cur_pos;

  if (uand(c_list[z].cdefense,0x4000) != 0) {
    m_list[cur_pos].hp = max_hp(c_list[z].hd);
  } else {
    m_list[cur_pos].hp = damroll(c_list[z].hd);
  }

  m_list[cur_pos].cspeed = c_list[z].speed + py.flags.speed;
  m_list[cur_pos].stuned = 0;
  m_list[cur_pos].cdis   = distance(char_row,char_col,y,x);

  cave[y][x].cptr = cur_pos;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer popm(integer *x)
{
  /*{ Returns a pointer to next free space }*/
  if (mfptr < 1) {
    compact_monsters();
  }
  *x = mfptr;
  mfptr = m_list[*x].nptr;

  return *x;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void pushm(integer x)
{
  /*{ Pushs a record back onto free space list }*/
  m_list[x] = blank_monster;
  m_list[x].nptr = mfptr;
  mfptr = x;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer get_obj_num(integer level)
{
  /*{ Returns the array number of a random object   }*/

  integer  i1;

  if (level > MAX_OBJ_LEVEL)   { level = MAX_OBJ_LEVEL; }
  if (randint(OBJ_GREAT) == 1) { level = MAX_OBJ_LEVEL; }

  if (level == 0) {
    i1 = randint(t_level[0]);
  } else {
    i1 = randint(t_level[level]);
  }

  return i1;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void compact_objects()
{
  /*{ If too many objects on floor level, delete some of them   }*/

  integer   i1,i2,ctr,cur_dis;
  boolean   flag;
  obj_set   one_six_nine = {1,6,9};

  ctr = 0;
  cur_dis = 66;

  do {
    for (i1 = 1; i1 <= cur_height; i1++) {
      for (i2 = 1; i2 <= cur_width; i2++) {
	//with cave[i1][i2]. do;
	if (cave[i1][i2].tptr > 0) {
	  if (distance(i1,i2,char_row,char_col) > cur_dis) {
	    flag = false;

	    //with t_list[cave[i1][i2].tptr]. do;
	    switch (t_list[cave[i1][i2].tptr].tval) {
	    case 102     : 
	      if (is_in(t_list[cave[i1][i2].tptr].subval, one_six_nine)) {
		flag = true;
	      } else if (randint(4) == 1) {
		flag = true;
	      }
	      break;

	    case 103     :
	      flag = true;
	      break;

	    case 104: case 105 : 
	      if (randint(4) == 1) {
		flag = true;
	      }
	      break;

	    case 107: case 108 :
	      break;

	    default:
	      if (randint(8) == 1) {
		flag = true; 
	      }
	      break;
	    }

	    if (flag) {
	      cave[i1][i2].fopen = true;
	      t_list[cave[i1][i2].tptr] = blank_treasure;
	      t_list[cave[i1][i2].tptr].p1 = tcptr;
	      tcptr = cave[i1][i2].tptr;
	      cave[i1][i2].tptr = 0;
	      ctr = ctr + 1;
	    }
	  }
	}
      }
    }

    if (ctr == 0) { 
      cur_dis = cur_dis - 6;
    }
  } while (ctr <= 0);

  if (cur_dis < 66) { 
    draw_cave();
  };
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void compact_monsters()
{
  /*{ Compact monsters }*/

  integer  i1,i2,i3,ctr,cur_dis;
  boolean  delete_1,delete_any;

  cur_dis = 66;
  delete_any = false;

  do {
    i1 = muptr;
    i2 = 0;

    do {
      delete_1 = false;
      i3 = m_list[i1].nptr;

      //with m_list[i1]. do;
      if (cur_dis > m_list[i1].cdis) {
	if (randint(3) == 1) {
	  
	  if (i2 == 0) {
	    muptr = i3;
	  } else {
	    m_list[i2].nptr = i3;
	  }
	  
	  cave[m_list[i1].fy][m_list[i1].fx].cptr = 0;
	  m_list[i1] = blank_monster;
	  m_list[i1].nptr = mfptr;
	  mfptr = i1;
	  ctr = ctr + 1;
	  delete_1 = true;
	  delete_any = true;
	}
      }
      
      if (!delete_1) { i2 = i1; }
      i1 = i3;
      
    } while (i1 != 0);
    
    if (!(delete_any)) {
      cur_dis = cur_dis - 6;
    }
    
  } while (!delete_any);

  if (cur_dis < 66) {
    draw_cave();
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer max_hp(dtype hp_str)
{
  /*{ Gives Max hit points					-RAK-	}*/

  integer   i1,num=0,die=0;
  dtype     hp_copy;
  integer   return_value;

  strcpy(hp_copy, hp_str);

  for (i1 = 0; i1 < strlen(hp_copy); i1++) {
    if (hp_copy[i1] == 'd') {
	  hp_copy[i1] = ' ';
    }
  }

  sscanf(hp_copy,"%ld %ld",&num,&die);
  return_value = num*die;

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer damroll(dtype dice)
{
  /*{ Converts input string into a dice roll		-RAK-	}*/
  /*{	Normal input string will look like '2d6', '3d8'... etc. }*/

  integer   i1;
  dtype     dice_copy;
  integer   num = 0, sides = 0;
  integer   return_value = 0;

  ENTER("damroll", "m")

  strcpy(dice_copy, dice);

  for (i1 = 0; i1 < strlen(dice_copy); i1++) {
    if (dice_copy[i1] == 'd') {
	  dice_copy[i1] = ' ';
    }
  }

  sscanf(dice_copy,"%ld %ld",&num,&sides);
  return_value = rand_rep(num,sides);
  
  RETURN("damroll", "m", 'd',"damage",&return_value)
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean los(integer y1, integer x1,integer y2,integer x2)
{
  /*{ Returns true if no obstructions between two given points -RAK-}*/

  integer    ty,tx,stepy,stepx,p1,p2;
  real       slp,tmp;
  boolean    flag = true;

//  ENTER("los", "m")
//  fprintf(debug_file,"los: (%d, %d) to (%d, %d)\n",x1,y1,x2,y2);

  ty = (y1 - y2);
  tx = (x1 - x2);

//  fprintf(debug_file,"los: ty = %d   tx = %d\n",ty,tx);
  
  if ((ty != 0) || (tx != 0)) {
    if (ty < 0) {
      stepy = -1;
    } else {
      stepy = 1;
    }
    if (tx < 0) {
      stepx = -1;
    } else {
      stepx = 1;
    }
    if (ty == 0) {

//      fprintf(debug_file,"los: ty==0  stepx = %d\n",stepx);
      do {
	x2 += stepx;
//	fprintf(debug_file,"los: checking y=[%d]  x=[%d]  %d\n",
//		y2,x2,cave[y2][x2].fopen);
	flag = cave[y2][x2].fopen;
      } while (!((x1 == x2) || !flag));

    } else if (tx == 0) {

//      fprintf(debug_file,"los: tx==0  stepy = %d\n",stepy);
      do {
	y2 += stepy;
//	fprintf(debug_file,"los: checking y=[%d]  x=[%d]  %d\n",
//		y2,x2,cave[y2][x2].fopen);
	flag = cave[y2][x2].fopen;
      } while (!((y1 == y2) || !flag));

    } else if (abs(ty) > abs(tx)) {

//      fprintf(debug_file,"los: ty>tx  stepy = %d\n",stepy);
      slp = ((real)abs(tx)/(real)abs(ty))*stepx;
      tmp = x2;
      do {
	y2  += stepy;
	tmp += slp;
	p1 = tmp - 0.1 + .5;
	p2 = tmp + 0.1 + .5;
//	fprintf(debug_file,"los: checking y=[%d]  x=[%d]  x=[%d]  %d : %d\n",
//		y2,p1,p2,cave[y2][p1].fopen,cave[y2][p2].fopen);
	if (! ((cave[y2][p1].fopen) || (cave[y2][p2].fopen))) {
//	  fprintf(debug_file,"los: setting ty>tx false\n");
	  flag = false;
	}
      } while (!((y1 == y2) || !flag));

    } else {

//      fprintf(debug_file,"los: tx>ty  stepx = %d\n",stepx);
      slp = ((real)abs(ty)/(real)abs(tx))*stepy;
      tmp = y2;
      do {
	x2  += stepx;
	tmp += slp;
	p1 = tmp - 0.1 + .5;
	p2 = tmp + 0.1 + .5;
//	fprintf(debug_file,"los: checking y=[%d]  y=[%d]  x=[%d]  %d : %d\n",
//		p1,p2,x2,cave[p1][x2].fopen,cave[p2][x2].fopen);
	if (! ((cave[p1][x2].fopen) || (cave[p2][x2].fopen))) {
//	  fprintf(debug_file,"los: setting tx>ty false\n");
	  flag = false;
	}
      } while (!((x1 == x2) || !flag));

    }
  }
  
//  RETURN("los", "m", 'b', "have los: ",&flag);
  return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer inven_damage(obj_set typ, integer perc)
{
  /*{ Destroys a type of item on a given percent chance }*/

  integer i1,i2;

  i2 = 0;
  for (i1 = 1; i1 <= inven_ctr; i1++) {
    //with inventory[i1]. do;
    if (is_in(inventory[i1].tval, typ)) {
      if (randint(100) < perc) {
	inven_destroy(i1);
	i2++;
	
      }
    }
  }

  return i2;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void inven_destroy(integer item_val)
{
  /*{ Destroy an item in the inventory }*/

  integer i2;

  temporary_slot = inventory[item_val];

  //with inventory[item_val]. do;
  if ((inventory[item_val].number > 1) && (inventory[item_val].subval < 512)) {
    inventory[item_val].number--;
    inven_weight -= inventory[item_val].weight;
    temporary_slot.number = 1;
  } else {
    inven_weight -= inventory[item_val].weight * inventory[item_val].number;
    for (i2 = item_val; i2 <= inven_ctr-1; i2++) {
      inventory[i2] = inventory[i2+1];
    }
    inventory[inven_ctr] = blank_treasure;
    inven_ctr--;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
#define max(xx,yy) (((xx)>(yy)) ? (xx) : (yy))
#define min(xx,yy) (((xx)<(yy)) ? (xx) : (yy))

integer maxmin(integer x, integer y, integer z)
{
  /* return max( min(x,y) - 1, z ) */
  integer  i1;
  
  i1 = min(x,y) - 1;
  return max(i1, z);
};

integer minmax(integer x, integer y, integer z)
{
  /* return min( max(x,y) + 1, z ) */
  integer  i1;

  i1 = max(x,y) + 1;
  return min(i1, z);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void mess_with_mind()
{
  /*{  -jeb}*/

  if (!strcmp(username, "cloister")) {
    strcpy(py.misc.name, "Cloister Bell");
  } else if (!strcmp(username, "three")) {
    strcpy(py.misc.name, "Three");
    strcpy(py.misc.race, "LPMud Wizard");
  } else {
    /*
      strcpy(py.misc.name, "We're onto you, dude.");
      strcpy(py.misc.race, "Thumbs Down");   
    */
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void area_affect(integer dir, integer y, integer x)
{
  /*        { Turns off Find_flag if something interesting appears  -RAK-   }*/
  /*        { BUG: Does not handle corridor/room corners, but I didn't want }*/
  /*        {      to add a lot of checking for such a minor detail         }*/

  integer    z[4];        /*: array [1..3] of integer;*/
  integer    i1,row,col;
  obj_set    corridors = {4, 5, 6, 0};
  //obj_set    some_hidden_stuff = {Unseen_trap,Secret_door, 0};
  obj_set    some_hidden_stuff = {101,109, 0};

  if (cave[y][x].fval == corr_floor1.ftval) {
    i1 = 0;
    if (next_to4(y,x,corridors) > 2) {
      find_flag = false;
    }
  }

  if ((find_flag) && (py.flags.blind < 1)) {

    switch (dir) {
    case 1: case 3: case 7: case 9:
      z[1] = rotate_dir(dir,-1);
      z[2] = dir;
      z[3] = rotate_dir(dir,1);
      break;
      
    case 2: case 4: case 6: case 8:
      z[1] = rotate_dir(dir,-2);
      z[2] = dir;
      z[3] = rotate_dir(dir,2);
      break;
    }
    
    for (i1 = 1; i1 <= 3; i1++) {
      row = y;
      col = x;
      if (move_dir(z[i1],&row,&col)) {

	//with cave[row,col] do;

	/* { Empty doorways        }*/
	if (cave[row][col].fval == corr_floor2.ftval) {
	  find_flag = false;
	}

	/*  { Objects player can see}*/
	/*  { Including doors       }*/
	if (find_flag) {
	  if (player_light) {
	    if (cave[row][col].tptr > 0) {
	      if (!(is_in(t_list[cave[row][col].tptr].tval, 
			  some_hidden_stuff))) {
		find_flag = false;
	      }
	    }
	  } else if ((cave[row][col].tl) ||
		     (cave[row][col].pl) ||
		     (cave[row][col].fm)) {
	    if (cave[row][col].tptr > 0) {
	      if (!(is_in(t_list[cave[row][col].tptr].tval, 
			  some_hidden_stuff))) {
		find_flag = false;
	      }
	    }
	  }
	}
	
	/*{ Creatures             }*/
	if (find_flag) {
	  if ((cave[row][col].tl) || (cave[row][col].pl) || (player_light)) {
	    if (cave[row][col].cptr > 1) {
	      //with m_list[cave[row][col].cptr] do;
	      if (m_list[cave[row][col].cptr].ml) {
		find_flag = false;
	      }
	    }
	  }
	}

      } /* end if move_char */
    } /* end for */
  } /* end if find and not blind */
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean pick_dir(integer dir)
{
  /*{ Picks new direction when in find mode                 -RAK-   }*/

  integer  z[3];     /*   : array [1..2] of integer;*/
  integer  i1,y,x;
  boolean  return_value;

  if ((find_flag) && (next_to4(char_row,char_col,corr_set) == 2)) {

    switch (dir) {
    case 1: case 3: case 7: case 9: 
      z[1] = rotate_dir(dir,-1);
      z[2] = rotate_dir(dir,1);
      break;
      
    case 2: case 4: case 6: case 8: 
      z[1] = rotate_dir(dir,-2);
      z[2] = rotate_dir(dir,2);
      break;
    }

    return_value = false;

    for (i1 = 1; i1 <= 2; i1++) {
      y = char_row;
      x = char_col;
      if (move_dir(z[i1],&y,&x)) {
	if (cave[y][x].fopen) {
	  return_value = true;
	  com_val = z[i1] + 48;
	}
      }
    }
  } else {
    return_value = false;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer rotate_dir(integer dir,integer rot)
{
  integer return_value;

//  ENTER("rotate_dir", "m")
  if (dir == 5) {
    return_value = 5;
  } else {
    for ( ; rot < 0 ; rot += 8); /* make sure the mod is a positive number */
    return_value = key_of[(oct_of[dir] + rot) % 8];
  }

//  RETURN("rotate_dir", "m", 'd',"dir",&return_value)
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer get_hitdie()
{
  integer  i1;
  i1 = randint(py.misc.hitdie) + con_adj();
  return i1;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void carry(integer y,integer x)
{
  /*
    { Player is on an object.  Many things can happen BASED
    on the TVAL of the object.  Traps are set off, money and most
    objects are picked up.  Some objects, such as open doors, just
    sit there.}
  */

  integer   item_val;
  vtype     out_val, out_val2;

  find_flag = false;
  
  //with cave[y][x]. do;
  temporary_slot = t_list[cave[y][x].tptr];
  
  if (t_list[cave[y][x].tptr].tval == 100) {
    /*{ There's GOLD in them thar hills! }*/
    pusht(cave[y][x].tptr);
    cave[y][x].tptr = 0;
    //with temporary_slot. do;
    py.misc.au += temporary_slot.cost;
    sprintf(out_val,"You have found $%ld worth of %s. ",
	    temporary_slot.cost,temporary_slot.name);
    prt_gold();
    msg_print(out_val);
  } else { 
    if (is_in(t_list[cave[y][x].tptr].tval, trap_set)) {
      /*{ OOPS! }*/
      hit_trap(&y,&x);
    } else {
      /*{Attempt to pick up an object}*/
      if (t_list[cave[y][x].tptr].tval < 100) {
	if (inven_check_weight()) {  /*{ Wgt lim check }*/   
	  if (inven_check_num()) {   /*{ Too many objects? }*/ 
	    /*{ Okay, pick it up }*/    
	    pusht(cave[y][x].tptr);
	    cave[y][x].tptr = 0;
	    inven_carry(&item_val);
	    objdes(out_val2,item_val,true,'i');
	    sprintf(out_val, "You have %s (%c%c", 
		    out_val2, raoul_label(item_val), cur_char1(item_val));
	    prt_cur_weight();
	    msg_print(out_val);
	  } else {
	    msg_print("You can't carry that many items.");
	  }
	} else {
	  msg_print("You can't carry that much weight.");
	}
      }
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean inven_check_weight()
{
  /*{ Check inventory for too much weight   }*/

  integer item_wgt;
  boolean return_value = false;

  max_weight = weight_limit();

  //with temporary_slot do;
  item_wgt = temporary_slot.number * temporary_slot.weight;

  /*{ Now, check to see if player can carry object  }*/
  if ((inven_weight + item_wgt) <= max_weight) {
    /*{ Can carry weight  }*/
    return_value = true;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean inven_check_num()
{
  /*{ Check to see if he will be carrying too many objects  }*/

  integer  i1;
  boolean  return_value = false;

  if (inven_ctr < INVEN_MAX) {
    return_value = true;
  } else if (temporary_slot.subval > 255) {
    for (i1 = 1; i1 <= inven_ctr; i1++) {
      //with inventory[i1]. do;
      if (inventory[i1].tval == temporary_slot.tval) {
	if (inventory[i1].subval == temporary_slot.subval) {
	  return_value = true;
	}
      }
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void Opusii_vomit(integer percentage)
{
  if (randint(100) < percentage) {
    //with py.flags do;
    PF.food -= 500;  /* XXXX does not check for negative food, is that ok? */
    PF.paralysis = randint(4);
    msg_print("You yak all over the tunnel floor!");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer attack_blows(integer weight, integer *wtohit)
{
  /*{ Weapon weight VS strength and dexterity   }*/

  integer adj_weight,blows;

  blows   = 1;
  *wtohit = 0;

  //with py.stat do;
  if ((PS.cstr*15) < weight) {
    *wtohit = -weight; /* harsh! full penalty no matter how close str is! */
  } else {

    if      (PS.cdex < 10) { blows = 1; }
    else if (PS.cdex < 20) { blows = 2; }
    else if (PS.cdex < 25) { blows = 3; }
    else if (PS.cdex < 30) { blows = 4; }
    else if (PS.cdex < 40) { blows = 5; }
    else if (PS.cdex < 50) { blows = 6; }
    else                   { blows = 7; }
    
    adj_weight = trunc((PS.cstr*10)/weight);
    
    if      (adj_weight < 2) { blows = 1; }
    else if (adj_weight < 3) { blows = trunc(blows/3.0);  }
    else if (adj_weight < 4) { blows = trunc(blows/2.5);  }
    else if (adj_weight < 5) { blows = trunc(blows/2.25); }
    else if (adj_weight < 7) { blows = trunc(blows/2.00); }
    else if (adj_weight < 9) { blows = trunc(blows/1.75); }
    else if (adj_weight <11) { blows = trunc(blows/1.50); }
    else if (adj_weight <14) { blows = blows;             }
    else                     { blows = blows + 1;         }
  }

  return  blows;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer critical_blow(integer weight, integer plus, integer dam)
{
  /*{ Critical hits, Nasty way to die...    }*/

  integer return_value = dam;

  /*
    { Weight of weapon, pluses to hit, and character level all
    contribute to the chance of a critical    }
  */

  if (!strcmp(py.misc.tclass, "Ninja")) { weight *= 8; }
  
  if (randint(5000) <= (weight + 5*plus + 3*py.misc.lev)) {

    if (!strcmp(py.misc.tclass, "Ninja")) { weight /= 7; }
    weight += randint(650);

    if        (weight < 400) {
      return_value = 2*dam + 5;
      msg_print("It was a good hit! (x2 damage)");
    } else if (weight < 700) {
      return_value = 3*dam + 10;
      msg_print("It was an excellent hit! (x3 damage)");
    } else if (weight < 900) {
      return_value = 4*dam + 15;
      msg_print("It was a superb hit! (x4 damage)");
    } else {
      return_value = 5*dam + 20;
      msg_print("It was a *GREAT* hit! (x5 damage)");
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean find_range(obj_set item_val, integer *i2, integer *i3)
{
  /*{ Finds range of item in inventory list }*/

  integer  i1;
  boolean  flag = false;

  i1  = 0;
  *i2 = 0;
  *i3 = 0;

  while(i1 < inven_ctr) {
    i1++;

    if (is_in(inventory[i1].tval, item_val) && !flag) {
      flag = true;
      *i2   = i1;
    }

    if (!is_in(inventory[i1].tval, item_val) && flag && (*i3 == 0)) {
      *i3 = i1 - 1;
    }
  }

  if ((flag) && (*i3 == 0)) {
    *i3 = inven_ctr;
  }

  return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean player_saves(integer adjust)
{
  /*{ Saving throws for player character... }*/
  boolean flag = false;

  if (randint(120) <= (py.misc.save + adjust)) {
    flag = true;
  }

  return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE misc.c */
 
