/* prayer.c */
/*        { Prayers ...                                     -RAK-   }*/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void prayer_effects(integer effect, integer y, integer x)
{
  integer   i1, dir, dumy, y_dumy, x_dumy;

  y_dumy = y;
  x_dumy = x;

  switch (effect) {
  case 1  :  
    detect_evil();
    break;

  case 2  :  
    hp_player(damroll("4d4")+1,"a prayer.");
    break;

  case 3  : 
    bless(randint(30)+12);
    break;

  case 4  :
    remove_fear();
    break;

  case 5  :  
    light_area(char_row,char_col);
    break;

  case 6  :
    detect_trap();
    break;

  case 7  : 
    detect_sdoor();
    break;

  case 8  :  
    slow_poison();
    break;

  case 9  : 
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      confuse_monster(dir,y,x);
    }
    break;

  case 10 : 
    teleport(py.misc.lev*3);
    break;

  case 11 :
    hp_player(damroll("8d4"),"a prayer.");
    break;

  case 12 :  
    bless(randint(60)+24);
    break;

  case 13 :  
    sleep_monsters2_3(char_row,char_col,2);
    break;

  case 14 :  
    create_food();
    break;

  case 15 :  
    for (i1 = 1; i1 <= inven_ctr; i1++) {
      //with inventory[i1]. do;
      inventory[i1].flags &= 0x7FFFFFFF;
    }
    for (i1 = 23; i1 <= EQUIP_MAX; i1++) {
      //with equipment[i1]. do;
      equipment[i1].flags &= 0x7FFFFFFF;
    }
    break;

  case 16 :
    //with py.flags do
    PF.resist_heat += randint(40) + 10;
    PF.resist_cold += randint(40) + 10;
    break;

  case 17 : 
    cure_poison();
    break;

  case 18 :  
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_ball(6,dir,y,x,
		damroll("3d10")+py.misc.lev,3,false,"Black Sphere");
    }
    break;

  case 19 :  
    hp_player(damroll("12d4"),"a prayer.");
    break;

  case 20 :  
    detect_inv2(randint(60)+24);
    break;

  case 21 :  
    protect_evil();
    break;

  case 22 :  
    earthquake();
    break;

  case 23 :  
    map_area();
    break;

  case 24 :  
    hp_player(damroll("16d4"),"a prayer.");
    break;

  case 25 :  
    turn_undead();
    break;

  case 26 : 
    bless(randint(100)+48);
    break;

  case 27 :  
    dispell_creature(0x0008,3*py.misc.lev);
    break;

  case 28 :  
    cure_disease();
    break;

  case 29 :  
    hp_player(200,"a prayer.");
    break;

  case 30 : 
    dispell_creature(0x0004,3*py.misc.lev);
    break;

  case 31 :  
    warding_glyph(y,x);
    break;

  case 32 :  
    dispell_creature(0x0004,4*py.misc.lev);
    cure_confusion();
    remove_fear();
    cure_poison();
    cure_blindness();
    hp_player(1000,"a prayer.");
    break;

  default:
    break;
  }
};
//////////////////////////////////////////////////////////////////////
void pray()
{
  integer   i1,i2,item_val;
  integer   choice,chance;
  integer   y_dumy,x_dumy;
  boolean   redraw;
  obj_set   prayer_books = {91};

  reset_flag = true;

  if (py.flags.blind > 0) {
    msg_print("You can't see to read your prayer!");
  } else if (no_light()) {
    msg_print("You have no light to read by.");
  } else if (py.flags.confused > 0) {
    msg_print("You are too confused...");
  } else if (py.misc.pskill == 3 || py.misc.pskill == 4) {
    if (inven_ctr > 0) {
      if (find_range(prayer_books,&i1,&i2)) {
	redraw = false;
	if (get_item(&item_val,"Use which holy book?",
		     &redraw,i1,i2)) {
	  if (use_skill("Recite which prayer?",item_val,
			&choice,&chance,&redraw)) {
	    if (redraw) { draw_cave(); }
	    //with skill_list[choice]. do;
	    reset_flag = false;
	    
	    if (randint(100) < chance) {
	      msg_print("You lost your concentration!");
	    } else {
	      y_dumy = char_row;
	      x_dumy = char_col;
	      prayer_effects(choice, y_dumy, x_dumy);
	      if (!reset_flag) {
		//with py.misc do;
		PM.exp += skill_list[choice].sexp;
		prt_experience();
		skill_list[choice].sexp = 0;
	      }
	    }
	    
	    //with py.misc do;
	    if (!reset_flag) {
	      if (skill_list[choice].smana > PM.cmana) {
		msg_print("You faint from fatigue!");
		PF.paralysis =
		  randint(5*trunc(skill_list[choice].smana-PM.cmana));
		PM.cmana = 0;
		if (randint(3) == 1) {
		  msg_print("You have damaged your health!");
		  py.stat.ccon = de_statp(py.stat.ccon);
		  prt_constitution();
		}
	      } else {
		PM.cmana -= skill_list[choice].smana;
	      }
	      prt_mana();
	    }
	    
	    if (randint(10)==1) {
	      reset_flag = true;  /* this is kinda handy! */
	    }
	  }
	} else {
	  if (redraw) { draw_cave(); }
	}
      } else {
	msg_print("But you are not carrying any Holy Books!");
      }
    } else {
      msg_print("But you are not carrying any Holy Books!");
    }
  } else {
    msg_print("Pray hard enough and your prayers may be answered.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE prayer.c */

