/* raygun.c */
/* { Wands for the aiming...}*/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void raygun_effects(integer effect, boolean *ident, integer dir, 
		    integer y, integer x)
{
  switch (effect) {
  case 1  :  
    msg_print("A line of blue shimmering light appears.");
    light_line(dir,char_row,char_col,damroll("2d8"),false);
    *ident = true;
    break;
    
  case 2  :  
    fire_bolt(1,dir,y,x,damroll("3d8"),"Lightning Bolt");
    *ident = true;
    break;
    
  case 3  :  
    fire_bolt(4,dir,y,x,damroll("4d8"),"Frost Bolt");
    *ident = true;
    break;

  case 4  :  
    fire_bolt(5,dir,y,x,damroll("6d8"),"Fire Bolt");
    *ident = true;
    break;

  case 5  :
    *ident = wall_to_mud(dir,y,x);
    break;

  case 6  : 
    *ident = poly_monster(dir,y,x);
    break;

  case 7  :
    *ident = hp_monster(dir,y,x,-damroll("4d6"));
    break;

  case 8  : 
    *ident = speed_monster(dir,y,x,1);
    break;

  case 9  :
    *ident = speed_monster(dir,y,x,-1);
    break;

  case 10 :
    *ident = confuse_monster(dir,y,x);
    break;

  case 11 :
    *ident = sleep_monster(dir,y,x);
    break;

  case 12 : 
    *ident = drain_life(dir,y,x);
    break;

  case 13 :
    *ident = td_destroy2(dir,y,x);
    break;

  case 14 :  
    fire_bolt(0,dir,y,x,damroll("2d6"),"Energy Bolt");
    *ident = true;
    break;

  case 15 :
    *ident = build_wall(dir,y,x);
    break;
    
  case 16 : 
    *ident = clone_monster(dir,y,x);
    break;

  case 17 :  
    *ident = teleport_monster(dir,y,x);
    break;

  case 18 :
    *ident = disarm_all(dir,y,x);
    break;

  case 19 :  
    fire_ball(1,dir,y,x,24,2,false,"Lightning Ball");
    *ident = true;
    break;

  case 20 :  
    fire_ball(4,dir,y,x,32,2,false,"Cold Ball");
    *ident = true;
    break;

  case 21 :  
    fire_ball(5,dir,y,x,48,2,false,"Fire Ball");
    *ident = true;
    break;

  case 22 :  
    fire_ball(2,dir,y,x,8,2,false,"Poison Gas");
    *ident = true;
    break;

  case 23 :  
    fire_ball(3,dir,y,x,40,2,false,"Acid Ball");
    *ident = true;
    break;

  case 24 :
    raygun_effects(randint(24), ident, dir, y, x);
    *ident = false;
    break;

  default:
    msg_print ("Unimplemented Beam");
    break;
  }
};
//////////////////////////////////////////////////////////////////////
void aim()
{
  unsigned   i1;
  integer    i2,i3,i4,chance;
  integer    dir,item_val;
  integer    dumy,y_dumy,x_dumy;
  boolean    redraw,ident;
  obj_set    zappo = {65};

  redraw = false;
  reset_flag = true;

  if (inven_ctr > 0) {
    if (find_range(zappo,&i2,&i3)) {
      if (get_item(&item_val,"Aim which ray gun?",&redraw,i2,i3)) {
	//with inventory[item_val]. do;
	if (redraw) { draw_cave(); }
	reset_flag = false;
	redraw = false;
	y_dumy = char_row;
	x_dumy = char_col;

	if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
	  if (py.flags.confused > 0) {
	    msg_print("You are confused...");
	    do {
	      dir = randint(9);
	    } while (dir == 5);
	  }

	  i1 = inventory[item_val].flags;
	  ident = false;
	  //with py.misc do;
	  chance = PM.wierd+5+PM.lev + int_adj() - inventory[item_val].level;
	  if (py.flags.confused > 0) {
	    chance /= 2;
	  }
	  if (chance < 0) { chance = 0; }
	  if (randint(chance) < USE_DEVICE) {
	    msg_print("You failed to use the ray gun.");
	  } else if (inventory[item_val].p1 > 0) {
	    inventory[item_val].p1--;
	    for (;i1 > 0;) {
	      i2 = bit_pos(&i1) + 1;
	      i3 = char_row;
	      i4 = char_col;
	      raygun_effects(i2, &ident, dir, i3, i4);
	    }
	    if (ident) {
	      identify(&inventory[item_val]);
	    }
	    if (inventory[item_val].flags != 0) {
	      //with py.misc do;
	      PM.exp += (real)inventory[item_val].level/(real)PM.lev + .5;
	      prt_experience();
	    }
	    desc_charges(item_val);
	  }
	}
      }
    } else {
      msg_print("You are not carrying any ray guns.");
    }
  } else {
    msg_print("But you are not carrying anything.");
  }

  if (redraw) { draw_cave(); }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE raygun.c */
