/* save.c */
/* code for saving and loading characters */

#include "boss.h"
#include "master.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void sc__open_save_file(FILE **f1, vtype fnam, boolean quick, boolean *flag)
{
  vtype    out_val;

  if (death || quick) {
    *flag = true;
    *f1   = (FILE *)fopen(finam,"w");
  } else {
    prt("Enter Filename:",1,1);
    *flag = false;

    /*{ Open the user's save file                          -JWT-   }*/
    if (get_string(fnam,1,17,60)) {
      if (strlen(fnam) == 0) {
/*	strcpy(fnam, finam); */
	strcpy(fnam, "BOSSCHR.SAV");
      }

      *f1 = (FILE *)fopen(fnam,"w");
  
      if (*f1 == NULL) {
	sprintf(out_val, "Error creating> %s", fnam);
	msg_print(out_val);
      } else {
	*flag = true;
      }
    } else {
      erase_line(1,1);
    }/* endif else get_string */
  } /*endif dead or quick*/

};
//////////////////////////////////////////////////////////////////////
void sc__open_master(FILE *f1, GDBM_FILE *f2, boolean *flag)
{
  /*{ Make an attempt to open the MASTER file               -JWT-   }*/

  if (!master_file_open(f2)) {
    msg_print("Error saving character (open MASTER), contact BOSS Wizard.");
    *flag = true;
  }
  
};
//////////////////////////////////////////////////////////////////////
void sc__write_master(GDBM_FILE f2, boolean *flag)
{
  /*{ Write key to MASTER		-KRC-	}*/

  int           i2;
  master_key    mkey;
  master_entry  mentry;
  boolean       result;

  mkey.creation_time = PM.creation_time;
  mentry.save_count  = PM.save_count + 1;
  //mentry.deaths      = PM.deaths;

  if (PM.save_count == 0) {
    result = master_file_write_new(f2, &mkey, &mentry);
    PM.creation_time = mkey.creation_time;
    PM.save_count++;
  } else {
    i2 = master_file_verify(f2, &mkey);
    if (i2 == MF_CHAR_MISMATCH) {
      result = false;
    } else {
      result = master_file_write(f2, &mkey, &mentry);
      PM.save_count++;
    }
  }

  if (!result) {
    msg_print("Error in writing to MASTER.");
  }

  *flag = result;
};
//////////////////////////////////////////////////////////////////////
void sc__display_status(boolean quick, vtype fnam,ntype out_rec)
{
    /*{ Message to player on what is happening}*/
    if (!death) {
      clear_from(1);
      if (!quick) {
	put_qio();
      } else {
	strcpy(fnam, finam);
      }
      sprintf(out_rec, "Saving character in %s...",fnam);
      prt(out_rec,1,1);
    }
};
//////////////////////////////////////////////////////////////////////
void sc__write_seeds(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
  /* creation_time, save_count and deaths are in the master file, be sure
     to fix up char_restore if you move more onto this line               */
  
  unsigned long  save_seed;

  save_seed  = get_seed();
  save_seed ^= randint(9999999);
  sprintf(out_rec,"%lu %ld %ld %d",save_seed,py.misc.creation_time,
	  py.misc.save_count,0/*py.misc.deaths*/);
  //sprintf(title2,"%lu %s",save_seed,py.misc.ssn); 
  set_seed(ENCRYPT_SEED2);
  encrypt_write(f1, cf_state, out_rec);
  set_seed(save_seed);
};
//////////////////////////////////////////////////////////////////////
void sc__write_version(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
    /*{ Version number of Boss               }*/
    sprintf(out_rec,"%3.2f",CUR_VERSION);
    encrypt_write(f1, cf_state, out_rec);
};
//////////////////////////////////////////////////////////////////////
void sc__write_player_record(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
  /*{ Write out the player record.	}*/

  integer i1;

  //with py.misc do;
  sprintf(out_rec,"%s",py.misc.name);
  encrypt_write(f1, cf_state, out_rec);

  sprintf(out_rec,"%s",py.misc.race);
  encrypt_write(f1, cf_state, out_rec);
      
  sprintf(out_rec,"%s",py.misc.sex);
  encrypt_write(f1, cf_state, out_rec);

  sprintf(out_rec,"%s",py.misc.tclass);
  encrypt_write(f1, cf_state, out_rec);
	
  sprintf(out_rec,"%s",py.misc.title);
  encrypt_write(f1, cf_state, out_rec);

  for (i1 = 0; i1 < 5; i1++) {
    strcpy(out_rec,py.misc.history[i1]);
    encrypt_write(f1, cf_state, out_rec);
  }

  sprintf(out_rec,
	  "%ld %ld %d %d %d "
	  "%d %d %d %d %ld "
	  "%ld %d %d %f",
	  char_row, char_col, PM.pclass,    PM.prace,   PM.pskill,
	  PM.age,   PM.ht,    PM.wt,        PM.sc,      PM.max_exp,
	  PM.exp,   PM.lev,   PM.max_lev,   PM.expfact);
  encrypt_write(f1, cf_state, out_rec);

  sprintf(out_rec,
	  "%d %d %d %d "
	  "%d %d %f %d "
	  "%f %ld %d %d "
	  "%d %d %d %d "
	  "%d %d %d "
	  "%d %d %d",
	  PM.srh,    PM.perc,    PM.stl,     PM.bth,
	  PM.bthb,   PM.mana,    PM.cmana,   PM.mhp,
	  PM.chp,    PM.au,      PM.ptohit,  PM.ptodam,
	  PM.pac,    PM.ptoac,   PM.dis_th,  PM.dis_td,
	  PM.dis_ac, PM.dis_tac, PM.disarm,
	  PM.wierd,  PM.save,    PM.hitdie);
  encrypt_write(f1, cf_state, out_rec);

  sprintf(out_rec,
	  "%ld %ld %ld %ld "
	  "%ld %ld %ld %ld "
	  "%ld %d %d",
	  inven_ctr,  inven_weight,    equip_ctr,   dun_level,
	  missle_ctr, mon_tot_mult,    turn,        day,
	  town_num,   defeated_badguy, randes_seed);
  encrypt_write(f1, cf_state, out_rec);
};
//////////////////////////////////////////////////////////////////////
void sc__write_kill_list(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
  integer i1;

  /*{ Write out the kill list.	}*/
  for (i1 = 1; i1 <= 400; i1++) {
    sprintf(out_rec, "%ld", kill_list[i1]);
    encrypt_write(f1, cf_state, out_rec);
  }
};
//////////////////////////////////////////////////////////////////////
void sc__write_bank_records(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
    /*{ Write out the bank records.	}*/
  sprintf(out_rec, 
	  "%ld %ld %ld "
	  "%f %f %f",
	  act_bal, principal, payment_count,
	  iod_val, iol_val,   danny_cut);
  encrypt_write(f1, cf_state, out_rec);
};
//////////////////////////////////////////////////////////////////////
void sc__write_inventory(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
  integer i1;

  /*{ Write out the inventory records.	}*/
  for (i1 = 1; i1 <= inven_ctr; i1++) {
    sprintf(out_rec,"%c %s", inventory[i1].tchar,inventory[i1].name);
    encrypt_write(f1, cf_state, out_rec);
 
    sprintf(out_rec,"%s",inventory[i1].damage);
    encrypt_write(f1, cf_state, out_rec);
 
    //with inventory[i1]. do;
    sprintf(out_rec,
	    "%d %ld %d "
	    "%d %d %d "
	    "%d %d %ld "
	    "%d %d %ld",
	    inventory[i1].tval,   inventory[i1].subval, inventory[i1].weight,
	    inventory[i1].number, inventory[i1].tohit,  inventory[i1].todam,
	    inventory[i1].ac,     inventory[i1].toac,   inventory[i1].p1,
	    inventory[i1].flags,  inventory[i1].level,  inventory[i1].cost);
    encrypt_write(f1, cf_state, out_rec);
  }
};
//////////////////////////////////////////////////////////////////////
void sc__write_equipment(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
  integer i1;

  for (i1 = 23; i1 <= EQUIP_MAX; i1++) {
    sprintf(out_rec,"%c %s", equipment[i1].tchar,equipment[i1].name);
    encrypt_write(f1, cf_state, out_rec);
    
    sprintf(out_rec,"%s",equipment[i1].damage);
    encrypt_write(f1, cf_state, out_rec);

    //with equipment[i1]. do;
    sprintf(out_rec,
	    "%d %ld %d "
	    "%d %d %d "
	    "%d %d %ld "
	    "%d %d %ld",
	    equipment[i1].tval,   equipment[i1].subval, equipment[i1].weight,
	    equipment[i1].number, equipment[i1].tohit,  equipment[i1].todam,
	    equipment[i1].ac,     equipment[i1].toac,   equipment[i1].p1,
	    equipment[i1].flags,  equipment[i1].level,  equipment[i1].cost);
    encrypt_write(f1, cf_state, out_rec);
  }
};
//////////////////////////////////////////////////////////////////////
void sc__write_stats_and_flags(FILE *f1, encrypt_state *cf_state,ntype out_rec)
{
  //with py.stat do;
  sprintf(out_rec,
	  "%d %d %d %d "
	  "%d %d %d %d "
	  "%d %d %d %d",
	  PS.str, PS.cstr, PS.dex,  PS.cdex,
	  PS.con, PS.ccon, PS.int_, PS.cint,
	  PS.wis, PS.cwis, PS.chr,  PS.cchr);
  encrypt_write(f1, cf_state, out_rec);
 
  //with py.flags do;
  sprintf(out_rec,
	  "%d %ld %ld "
	  "%ld %ld %ld "
	  "%ld %ld "
	  "%ld %d",
	  PF.status,PF.blind,PF.confused,
	  PF.food,PF.food_digested,PF.protection,
	  PF.speed,PF.afraid,
	  PF.poisoned,PF.see_inv);
  encrypt_write(f1, cf_state, out_rec);
  
  sprintf(out_rec,
	  "%ld %ld %ld "
	  "%d %d %d",
	  PF.fast,PF.slow,PF.protevil,
	  PF.teleport,PF.free_act,PF.slow_digest);
  encrypt_write(f1, cf_state, out_rec);
  
  sprintf(out_rec,
	  "%d %d "
	  "%d %d %d "
	  "%d %d",
	  PF.aggravate,PF.sustain_str,
	  PF.sustain_int,PF.sustain_wis,PF.sustain_con,
	  PF.sustain_dex,PF.sustain_chr);
  encrypt_write(f1, cf_state, out_rec);
  
  sprintf(out_rec,
	  "%d %d "
	  "%d %d %d "
	  "%d %d",
	  PF.fire_resist,PF.cold_resist,
	  PF.acid_resist,PF.regenerate,PF.lght_resist,
	  PF.ffall,PF.confuse_monster);
  encrypt_write(f1, cf_state, out_rec);
  
  sprintf(out_rec,
	  "%ld %ld %ld "
	  "%ld %ld %ld "
	  "%ld %ld %ld "
	  "%ld %ld %ld "
	  "%ld %ld %ld",
	  PF.image,PF.invuln,PF.hero,
	  PF.shero,PF.blessed,PF.resist_heat,
	  PF.resist_cold,PF.ring_blast,PF.special,
	  PF.petrified,PF.diseased,PF.detect_inv,
	  PF.word_recall,PF.see_infra,PF.tim_infra);
  encrypt_write(f1, cf_state, out_rec);
  
};
//////////////////////////////////////////////////////////////////////
void sc__write_magic(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
  integer i1;

  for (i1 = 1; i1 <= MAX_SKILLS; i1++) {
    //with skill_list[i1]. do;
    sprintf(out_rec,"%s", skill_list[i1].sname);
    encrypt_write(f1, cf_state, out_rec);

    sprintf(out_rec,
	    "%d %d "
	    "%d %d "
	    "%d",
	    skill_list[i1].slevel,  skill_list[i1].smana,
	    skill_list[i1].sexp,    skill_list[i1].sfail,
	    skill_list[i1].learned);
    encrypt_write(f1, cf_state, out_rec);
  }
};
//////////////////////////////////////////////////////////////////////
void sc__write_dungeon(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
    /*{ Write the important dungeon info and floor	-RAK-	}*/

  integer        i1, i2, tot_treasure, tptr, count = 0;
  unsigned long  xfloor, prevFloor = 999999;

  sprintf(out_rec,
	  "%ld %ld "
	  "%ld %ld",
	  cur_height,cur_width,
	  max_panel_rows,max_panel_cols);
  encrypt_write(f1, cf_state, out_rec);
 
  /* { Save the floor        }*/
  tot_treasure = 0;
  for (i1 = 1; i1 <= cur_height; i1++) {
    for (i2 = 1; i2 <= cur_width; i2++) {
      //with cave[i1][i2]. do;
      xfloor = cave[i1][i2].fval;
      if (cave[i1][i2].fopen) {
	xfloor |= 0x20;
      }
      if (cave[i1][i2].pl) {
	xfloor |= 0x40;
      }
      if (cave[i1][i2].fm) {
	xfloor |= 0x80;
      }
      if (cave[i1][i2].tptr > 0) {
	tot_treasure++;
      }
      
      /* run length encoding the floor cuts about 30k from the save file */
      if (xfloor == prevFloor) {
	count++;
      } else {
	if (count != 0) {
	  if (count == 1) {
	    sprintf(out_rec, "%ld", prevFloor);
	  } else {
	    sprintf(out_rec, "%ld %ld", prevFloor, count);
	  }      
	  encrypt_write(f1, cf_state, out_rec);
	}
	prevFloor = xfloor;
	count = 1;
      }

    } /* end for i2 */
  } /* end for i1 */

  if (count == 1) {
    sprintf(out_rec, "%ld", prevFloor);
  } else {
    sprintf(out_rec, "%ld %ld", prevFloor, count);
  }      
  encrypt_write(f1, cf_state, out_rec);

  /*{ Save the Treasure List		}*/
  sprintf(out_rec,"%ld",tot_treasure);
  encrypt_write(f1, cf_state, out_rec);

  for (i1 = 1; i1 <= cur_height; i1++) {
    for (i2 = 1; i2 <= cur_width; i2++) {
      if (cave[i1][i2].tptr > 0) {
	tptr = cave[i1][i2].tptr;
	//with t_list[tptr]. do;
	sprintf(out_rec,"%ld %ld",i1,i2);
	encrypt_write(f1, cf_state, out_rec);
 
	sprintf(out_rec,"%c %s",t_list[tptr].tchar,t_list[tptr].name);
	encrypt_write(f1, cf_state, out_rec);
	
	sprintf(out_rec,"%s",t_list[tptr].damage);
	encrypt_write(f1, cf_state, out_rec);
 
	sprintf(out_rec,
		"%d %ld %d "
		"%d %d %d "
		"%d %d %ld "
		"%d %d %ld",
		t_list[tptr].tval,   t_list[tptr].subval, t_list[tptr].weight,
		t_list[tptr].number, t_list[tptr].tohit,  t_list[tptr].todam,
		t_list[tptr].ac,     t_list[tptr].toac,   t_list[tptr].p1,
		t_list[tptr].flags,  t_list[tptr].level,  t_list[tptr].cost);
	encrypt_write(f1, cf_state, out_rec);
      }
    }
  }
};
//////////////////////////////////////////////////////////////////////
void sc__write_identified(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
  integer i1;

  /*{ Save identified list			}*/
  for (i1 = 1; i1 <= MAX_OBJECTS; i1++) {
    if (object_ident[i1]) {
      out_rec[i1-1] = 'T';
    } else {
      out_rec[i1-1] = 'F';
    }
  }

  out_rec[MAX_OBJECTS] = 0;
  encrypt_write(f1, cf_state, out_rec);
};
//////////////////////////////////////////////////////////////////////
void sc__write_monsters(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
  /*{ Save the Monster List 		}*/

  integer    i1, tot_monsters;

  for (i1=muptr,tot_monsters = 0; i1 > 0; i1 = m_list[i1].nptr) {
    tot_monsters++;
  }
  
  sprintf(out_rec,"%ld",tot_monsters);
  encrypt_write(f1, cf_state, out_rec);
  
  for (i1 = muptr; i1 > 0; i1 = m_list[i1].nptr) {
    // with m_list[i1] do;
    sprintf(out_rec,
	    "%d %d %d %d "
	    "%d %d %d %d "
	    "%d %d",
	    m_list[i1].fy,m_list[i1].fx,m_list[i1].mptr,m_list[i1].hp,
	    m_list[i1].cspeed,m_list[i1].csleep,m_list[i1].cdis,m_list[i1].ml,
	    m_list[i1].confused,m_list[i1].cur_reprod);
    encrypt_write(f1, cf_state, out_rec);
  }
};
//////////////////////////////////////////////////////////////////////
void sc__write_town(FILE *f1, encrypt_state *cf_state, ntype out_rec)
{
  /*{ Save the town level stores		}*/
  integer          i1,i2;

  sprintf(out_rec,"%d", town_seed);
  encrypt_write(f1, cf_state, out_rec);

  for (i1 = 0; i1 < MAX_STORES; i1++) {
    //with stores[i1]. do;
    /*{ Save items...                 }*/
    sprintf(out_rec,"%d",stores[i1].store_ctr);
    encrypt_write(f1, cf_state, out_rec);

    for (i2 = 1; i2 <= stores[i1].store_ctr; i2++) {
      //with stores[i1].store_inven[i2].sitem do;
      sprintf(out_rec,"%ld",stores[i1].store_inven[i2].scost);
      encrypt_write(f1, cf_state, out_rec);
      
      sprintf(out_rec,"%c %s",
	      stores[i1].store_inven[i2].sitem.tchar,
	      stores[i1].store_inven[i2].sitem.name);
      encrypt_write(f1, cf_state, out_rec);
      
      sprintf(out_rec,"%s",stores[i1].store_inven[i2].sitem.damage);
      encrypt_write(f1, cf_state, out_rec);

      sprintf(out_rec,"%d %ld %d %d %d %d %d %d %ld %d %d %ld",
	      stores[i1].store_inven[i2].sitem.tval,
	      stores[i1].store_inven[i2].sitem.subval,
	      stores[i1].store_inven[i2].sitem.weight,
	      stores[i1].store_inven[i2].sitem.number,
	      stores[i1].store_inven[i2].sitem.tohit,
	      stores[i1].store_inven[i2].sitem.todam,
	      stores[i1].store_inven[i2].sitem.ac,
	      stores[i1].store_inven[i2].sitem.toac,
	      stores[i1].store_inven[i2].sitem.p1,
	      stores[i1].store_inven[i2].sitem.flags,
	      stores[i1].store_inven[i2].sitem.level,
	      stores[i1].store_inven[i2].sitem.cost);
      encrypt_write(f1, cf_state, out_rec);
      //end with store inven;
    } //end for i2;

    //with store_open do;
    sprintf(out_rec,"%d %d %d",
	    stores[i1].owner, stores[i1].insult_cur, stores[i1].store_open);
      encrypt_write(f1, cf_state, out_rec);
  } //end for i1;
};
//////////////////////////////////////////////////////////////////////
boolean save_char(boolean quick)
{
  vtype          fnam;
  boolean        flag;
  ntype          out_rec;
  FILE          *f1 = NULL;  //: text;
  encrypt_state  cf_state;
  GDBM_FILE      f2;

  sc__open_save_file(&f1, fnam, quick, &flag);
  encrypt_init(&cf_state, saveFileKey, saveFilesAreEncrypted);
  
  //unlink(fnam); /* I don't think this is needed... */

//  if (flag) {
    sc__open_master(f1, &f2, &flag);
//  }
//  if (flag) {
    sc__write_master(f2, &flag);
    master_file_close(&f2);
//  }
  
  /*{ If ID was written to MASTER, continue saving          -RAK-   }*/
  if (flag) {
    sc__write_seeds(f1, &cf_state, out_rec);
    sc__display_status(quick, fnam, out_rec);
    
    sc__write_version         (f1, &cf_state, out_rec);
    sc__write_player_record   (f1, &cf_state, out_rec);
    sc__write_kill_list       (f1, &cf_state, out_rec);
    sc__write_bank_records    (f1, &cf_state, out_rec);
    sc__write_inventory       (f1, &cf_state, out_rec);
    sc__write_equipment       (f1, &cf_state, out_rec);
    sc__write_stats_and_flags (f1, &cf_state, out_rec);
    sc__write_magic           (f1, &cf_state, out_rec);
    sc__write_dungeon         (f1, &cf_state, out_rec);
    sc__write_identified      (f1, &cf_state, out_rec);
    sc__write_monsters        (f1, &cf_state, out_rec);
    sc__write_town            (f1, &cf_state, out_rec);
    
    sprintf(out_rec, "%ld", PM.creation_time);
    encrypt_write(f1, &cf_state, out_rec);
    
    encrypt_flush(f1, &cf_state);
    fclose(f1);
    
  } /* endif flag */
  
  if (flag && !death) {
    sprintf(out_rec,"Character saved. [Boss Version %3.2f]\n",CUR_VERSION);
    prt(out_rec,2,1);
    exit_game();
  }

  set_seed(get_seed());

  return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void data_exception()
{

/*   Data Corruption means character is dead, or save file was -RAK-
     screwed with.  Keep them guessing as to what is actually wrong.*/

  clear_from(1);
  prt("Data Corruption Error.",1,1);
  prt(" ",2,1);
  exit_game();
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer  new_stat(integer statnum)
{
  /*
    {Stat conversion from 18(200) system to integer system. -RLG}
    {Kinda like converting Farenheit to Celsius}
  */
  integer return_value;

  if (statnum < 19) {
    return_value = statnum;
  } else if (statnum < 68) {
    return_value = 19;
  } else if (statnum < 93) {
    return_value = (statnum+32) div 5;
  } else if (statnum < 108) {
    return_value = (statnum-18) div 3;
  } else if (statnum < 118) {
    return_value = (statnum-48) div 2;
  } else if (statnum < 218) {
    return_value = (statnum+127) div 7;
  } else {
    return_value = 50;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
void gc__open_save_file(FILE **f1, vtype fnam, boolean *paniced)
{
  vtype   out_str;

  *f1 = (FILE *)fopen(fnam,"r");
  if (*f1 == NULL) {
    sprintf(out_str, "Error Opening> %s", fnam);
    prt(out_str,1,1);
    prt("",2,1);
    *paniced = true;
  } else {
    rewind(*f1);
  }
};
//////////////////////////////////////////////////////////////////////
void gc__open_master(FILE *f1, GDBM_FILE *f2, boolean *paniced)
{
  if (!master_file_open(f2)) {
    prt("ERROR opening file MASTER.",1,1);
    *paniced = true;
  }
};
//////////////////////////////////////////////////////////////////////
void gc__read_master(GDBM_FILE f2, boolean *paniced)
{
  int           result;
  master_key    mkey;

  mkey.creation_time = PM.creation_time;

  result = master_file_verify(f2, &mkey);

  if (result != MF_CHAR_OK) {
    printf("\n\r--------------------------------------------------------\n\r");
    printf(    "| There was a data corruption error with the character |\n\r");
    printf(    "| Terminating IMORIA now.                              |\n\r");
    printf(    "--------------------------------------------------------\n\r");
//    exit_game();

    *paniced = true;
  }
};
//////////////////////////////////////////////////////////////////////
void gc__read_seeds(FILE *f1, encrypt_state *cf_state, ntype in_rec,
		    boolean *paniced)
{
  /* creation_time, save_count and deaths are in the master file, be sure
     to fix up char_restore if you move more onto this line               */

  unsigned long  save_seed;
  integer        deaths;

  set_seed(ENCRYPT_SEED2);
  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,"%lu %ld %ld %ld",&save_seed, &py.misc.creation_time,
	     &py.misc.save_count, &deaths/*&py.misc.deaths*/) != 4) {
    *paniced = true;
  }

  set_seed(save_seed);
};
//////////////////////////////////////////////////////////////////////
void gc__display_status(vtype fnam, ntype in_rec)
{
  prt("Restoring Character...",1,1);
  put_qio();
};
//////////////////////////////////////////////////////////////////////
void gc__read_version(FILE *f1, encrypt_state *cf_state,ntype in_rec,
		      boolean *paniced,real *save_version)
{
  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,"%f",save_version) != 1) {
    *paniced = true;
  }

  if ( (int)(*save_version*100.0) != (int)(CUR_VERSION*100.0)) {
    prt("Save file is incompatible with this version.",2,1);
    sprintf(in_rec,"  [Save file version %3.2f]",*save_version);
    prt(in_rec,3,1);
    sprintf(in_rec,"  [Boss version     %3.2f]",CUR_VERSION);
    prt(in_rec,4,1);

    exit_game();

    prt("Updating character for newer version...",5,1);
    pause_game(24);
  }

};
//////////////////////////////////////////////////////////////////////
void gc__read_player_record(FILE *f1, encrypt_state *cf_state, ntype in_rec,
			    boolean *paniced, boolean prop, boolean *was_dead)
{
  integer i1;
  integer x1,x2,x3,x4,x5,x6,x7,x8,x9,x10;
  integer x11,x12,x13,x14,x15,x16,x17,x18,x19,x20;

  read_decrypt(f1, cf_state, in_rec, paniced);
  strncpy(py.misc.name, in_rec, sizeof(PM.name));

  read_decrypt(f1, cf_state, in_rec, paniced);
  strncpy(py.misc.race, in_rec, sizeof(PM.race));

  read_decrypt(f1, cf_state, in_rec, paniced);      
  strncpy(py.misc.sex, in_rec, sizeof(PM.sex));

  read_decrypt(f1, cf_state, in_rec, paniced);
  strncpy(py.misc.tclass, in_rec, sizeof(PM.tclass));

  read_decrypt(f1, cf_state, in_rec, paniced);	
  strncpy(py.misc.title, in_rec, sizeof(PM.title));

  for (i1 = 0; i1 < 5; i1++) {
    read_decrypt(f1, cf_state, in_rec, paniced);
    strncpy(py.misc.history[i1], in_rec, sizeof(vtype));
  }

  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld %ld %ld %ld "
	     "%ld %ld %ld %ld %ld "
	     "%ld %ld %ld %f",
	     &char_row, &char_col, &x1, &x2,   &x3,
	     &x4,       &x5,       &x6, &x7,   &PM.max_exp,
	     &PM.exp,   &x8,       &x9, &PM.expfact) != 14) {
    *paniced = true;
  }
  PM.pclass  = x1;
  PM.prace   = x2;
  PM.pskill  = x3;
  PM.age     = x4;
  PM.ht      = x5; 
  PM.wt      = x6;
  PM.sc      = x7;
  PM.lev     = x8;
  PM.max_lev = x9;

  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld %ld %ld "
	     "%ld %ld %f %ld "
	     "%f %ld %ld %ld "
	     "%ld %ld %ld %ld "
	     "%ld %ld %ld "
	     "%ld %ld %ld",
	     &x1, &x2, &x3, &x4,
	     &x5, &x6, &PM.cmana, &x7,
	     &PM.chp, &x8, &x9, &x10,
	     &x11, &x12, &x13, &x14,
	     &x15, &x16, &x17,
	     &x18, &x19, &x20) != 22) {
    *paniced = true;
  }
  PM.srh     = x1;
  PM.perc    = x2;
  PM.stl     = x3;
  PM.bth     = x4;
  PM.bthb    = x5;
  PM.mana    = x6;
  PM.mhp     = x7;
  PM.au      = x8;
  PM.ptohit  = x9;
  PM.ptodam  = x10;
  PM.pac     = x11;
  PM.ptoac   = x12;
  PM.dis_th  = x13;
  PM.dis_td  = x14;
  PM.dis_ac  = x15;
  PM.dis_tac = x16;
  PM.disarm  = x17;
  PM.wierd   = x18;
  PM.save    = x19;
  PM.hitdie  = x20;

  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld %ld %ld "
	     "%ld %ld %ld %ld "
	     "%ld %ld %d",
	     &inven_ctr,  &inven_weight,    &equip_ctr,   &dun_level,
	     &missle_ctr, &mon_tot_mult,    &turn,        &day,
	     &town_num,   &x1,              &randes_seed) != 11) {
    *paniced = true;
  }
  defeated_badguy = x1;
};
//////////////////////////////////////////////////////////////////////
void gc__kill_list(FILE *f1, encrypt_state *cf_state, ntype in_rec,
		   boolean *paniced, boolean *was_dead)
{
  integer i1;

  for (i1 = 1; i1 <= 400; i1++) {
    read_decrypt(f1, cf_state, in_rec, paniced);
    if (sscanf(in_rec,"%ld", &(kill_list[i1])) != 1) {
      *paniced = true;
    }
  }
};
//////////////////////////////////////////////////////////////////////
void gc__bank_records(FILE *f1, encrypt_state *cf_state, ntype in_rec,
		      boolean *paniced, boolean *was_dead)
{
  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld %ld "
	     "%f %f %f",
	     &act_bal, &principal, &payment_count,
	     &iod_val, &iol_val,   &danny_cut) != 6) {
    *paniced = true;
  }
};
//////////////////////////////////////////////////////////////////////
void gc__read_inventory(FILE *f1, encrypt_state *cf_state, ntype in_rec,
			boolean *paniced, boolean *was_dead)
{
  integer i1;
  integer x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12;

  /* { Read in the inventory records.	}*/
  for (i1 = 1; i1 <= inven_ctr; i1++) {
    read_decrypt(f1, cf_state, in_rec, paniced);
    inventory[i1].tchar = in_rec[0];
    strncpy(inventory[i1].name, &in_rec[2], sizeof(inventory[i1].name));

    read_decrypt(f1, cf_state, in_rec, paniced);
    strncpy(inventory[i1].damage, in_rec, sizeof(inventory[i1].damage));
 
    //with inventory[i1]. do;
    read_decrypt(f1, cf_state, in_rec, paniced);
    if (sscanf(in_rec,
	       "%ld %ld %ld "
	       "%ld %ld %ld "
	       "%ld %ld %ld "
	       "%ld %ld %ld",
	       &x1, &x2, &x3,
	       &x4, &x5, &x6,
	       &x7, &x8, &x9,
	       &x10, &x11, &x12) != 12) {
      *paniced = true;
    }
    inventory[i1].tval   = x1;
    inventory[i1].subval = x2;
    inventory[i1].weight = x3;
    inventory[i1].number = x4;
    inventory[i1].tohit  = x5;
    inventory[i1].todam  = x6;
    inventory[i1].ac     = x7;
    inventory[i1].toac   = x8;
    inventory[i1].p1     = x9;
    inventory[i1].flags  = x10;
    inventory[i1].level  = x11;
    inventory[i1].cost   = x12;
  }
};
//////////////////////////////////////////////////////////////////////
void gc__read_equipment(FILE *f1, encrypt_state *cf_state, ntype in_rec,
			boolean *paniced, boolean *was_dead)
{
  /*{ Read in the equipment records.	}*/
  integer i1;
  integer x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12;

  for (i1 = 23; i1 <= EQUIP_MAX; i1++) {
    read_decrypt(f1, cf_state, in_rec, paniced);
    equipment[i1].tchar = in_rec[0];
    strncpy(equipment[i1].name, &in_rec[2], sizeof(equipment[i1].name));
    
    read_decrypt(f1, cf_state, in_rec, paniced);
    strncpy(equipment[i1].damage, in_rec, sizeof(equipment[i1].damage));

    //with equipment[i1]. do;
    read_decrypt(f1, cf_state, in_rec, paniced);
    if (sscanf(in_rec,
	       "%ld %ld %ld "
	       "%ld %ld %ld "
	       "%ld %ld %ld "
	       "%ld %ld %ld",
	       &x1, &x2, &x3,
	       &x4, &x5, &x6,
	       &x7, &x8, &x9,
	       &x10, &x11, &x12) != 12) {
      *paniced = true;
    }
    equipment[i1].tval   = x1;
    equipment[i1].subval = x2;
    equipment[i1].weight = x3;
    equipment[i1].number = x4;
    equipment[i1].tohit  = x5;
    equipment[i1].todam  = x6;
    equipment[i1].ac     = x7;
    equipment[i1].toac   = x8;
    equipment[i1].p1     = x9;
    equipment[i1].flags  = x10;
    equipment[i1].level  = x11;
    equipment[i1].cost   = x12;
  }
};
//////////////////////////////////////////////////////////////////////
void gc__read_stats_and_flags(FILE *f1, encrypt_state *cf_state, ntype in_rec,
			      boolean *paniced)
{
  integer x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12;

  //with py.stat do;
  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld %ld %ld "
	     "%ld %ld %ld %ld "
	     "%ld %ld %ld %ld",
	     &x1, &x2, &x3, &x4,
	     &x5, &x6, &x7, &x8,
	     &x9, &x10, &x11, &x12) != 12) {
    *paniced = true;
  }
  PS.str   = x1;
  PS.cstr  = x2;
  PS.dex   = x3;
  PS.cdex  = x4;
  PS.con   = x5;
  PS.ccon  = x6;
  PS.int_  = x7;
  PS.cint  = x8;
  PS.wis   = x9;
  PS.cwis  = x10;
  PS.chr   = x11;
  PS.cchr  = x12;

 
  //with py.flags do;
  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%d %ld %ld "
	     "%ld %ld %ld "
	     "%ld %ld "
	     "%ld %ld",
	     &PF.status,   &PF.blind,         &PF.confused,
	     &PF.food,     &PF.food_digested, &PF.protection,
	     &PF.speed,    &PF.afraid,
	     &PF.poisoned, &x1) != 10) {
    *paniced = true;
  }
  PF.see_inv = x1;

  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld %ld "
	     "%ld %ld %ld",
	     &PF.fast,      &PF.slow,     &PF.protevil,
	     &x1,  &x2, &x3) != 6) {
    *paniced = true;
  }
  PF.teleport    = x1;
  PF.free_act    = x2;
  PF.slow_digest = x3;

  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld "
	     "%ld %ld %ld "
	     "%ld %ld",
	     &x1, &x2,
	     &x3, &x4, &x5,
	     &x6, &x7) != 7) {
    *paniced = true;
  }
  PF.aggravate   = x1;
  PF.sustain_str = x2;
  PF.sustain_int = x3;
  PF.sustain_wis = x4;
  PF.sustain_con = x5;
  PF.sustain_dex = x6;
  PF.sustain_chr = x7;

  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld "
	     "%ld %ld %ld "
	     "%ld %ld",
	     &x1, &x2,
	     &x3, &x4, &x5,
	     &x6, &x7) != 7) {
    *paniced = true;
  }
  PF.fire_resist     = x1;
  PF.cold_resist     = x2;
  PF.acid_resist     = x3;
  PF.regenerate      = x4;
  PF.lght_resist     = x5;
  PF.ffall           = x6;
  PF.confuse_monster = x7;

  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld %ld "
	     "%ld %ld %ld "
	     "%ld %ld %ld "
	     "%ld %ld %ld "
	     "%ld %ld %ld",
	     &PF.image,       &PF.invuln,     &PF.hero,
	     &PF.shero,       &PF.blessed,    &PF.resist_heat,
	     &PF.resist_cold, &PF.ring_blast, &PF.special,
	     &PF.petrified,   &PF.diseased,   &PF.detect_inv,
	     &PF.word_recall, &PF.see_infra,  &PF.tim_infra) != 15) {
    *paniced = true;
  }

};
//////////////////////////////////////////////////////////////////////
void gc__read_magic(FILE *f1, encrypt_state *cf_state, ntype in_rec,
		    boolean *paniced)
{
  integer i1;
  integer x1,x2,x3,x4,x5;

  for (i1 = 1; i1 <= MAX_SKILLS; i1++) {
    //with skill_list[i1]. do;
    read_decrypt(f1, cf_state, in_rec, paniced);
    strncpy(skill_list[i1].sname, in_rec, sizeof(skill_list[i1].sname));

    read_decrypt(f1, cf_state, in_rec, paniced);
    if (sscanf(in_rec,
	       "%ld %ld "
	       "%ld %ld "
	       "%ld",
	       &x1, &x2,
	       &x3, &x4,
	       &x5) != 5) {
      *paniced = true;
    }
    skill_list[i1].slevel  = x1;
    skill_list[i1].smana   = x2;
    skill_list[i1].sexp    = x3; 
    skill_list[i1].sfail   = x4;
    skill_list[i1].learned = x5;
  }
};
//////////////////////////////////////////////////////////////////////
void gc__read_dungeon(FILE *f1, encrypt_state *cf_state, ntype in_rec,
		      boolean *paniced)
{
  integer        i1, i2, i3, i4, tot_treasure, count = 0;
  unsigned long  xfloor;
  integer        x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x12,x13;

  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,
	     "%ld %ld "
	     "%ld %ld",
	     &cur_height,     &cur_width,
	     &max_panel_rows, &max_panel_cols) != 4) {
    *paniced = true;
  }

  if (cur_height > MAX_HEIGHT) { 
    *paniced   = true;
  } else if (cur_width > MAX_WIDTH) { 
    *paniced   = true;
  }

  /*{ Read the floor	}*/
  
  if (!(*paniced)) {
    for (i1 = 1; i1 <= cur_height; i1++) {
      //read_decrypt(f1, cf_state, in_rec, paniced);
      for (i2 = 1; i2 <= cur_width; i2++) {

	if (count == 0) {
	  read_decrypt(f1, cf_state, in_rec, paniced);
	  if (sscanf(in_rec, "%ld %ld", &xfloor, &count) == 1) {	  
	    count = 1;
	  }
	}
	count--;
	
	//with cave[i1][i2]. do;
	cave[i1][i2].fval = (xfloor & 0x1f);
	if (xfloor & 0x20) {
	  cave[i1][i2].fopen = true;
	}
	if (xfloor & 0x40) {
	  cave[i1][i2].pl = true;
	}
	if (xfloor & 0x80) {
	  cave[i1][i2].fm = true;
	}
	cave[i1][i2].tl   = false;
	cave[i1][i2].tptr = 0;
	cave[i1][i2].cptr = 0;
	
      } /* end for i2 */
    } /* end for i1 */
  }  

  /*{ Read the Treasure List		}*/
  tlink();
  if (!(*paniced)) {
    read_decrypt(f1, cf_state, in_rec, paniced);
    if (sscanf(in_rec,"%ld",&tot_treasure) != 1) {
      *paniced = true;
    }
  
    for (i1 = 1; i1 <= tot_treasure; i1++) {
      popt(&i2);
      //with t_list[i2] do;
      
      read_decrypt(f1, cf_state, in_rec, paniced);
      if (sscanf(in_rec,"%ld %ld",&i3,&i4) != 2) {
	*paniced = true;
      }
      cave[i3][i4].tptr = i2;
      
      read_decrypt(f1, cf_state, in_rec, paniced);
      t_list[i2].tchar = in_rec[0];
      strcpy(t_list[i2].name, &in_rec[2]);
      
      read_decrypt(f1, cf_state, in_rec, paniced);
      strcpy(t_list[i2].damage, in_rec);
      
      read_decrypt(f1, cf_state, in_rec, paniced);
      if (sscanf(in_rec,"%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld",
		 &x1, &x2, &x3, &x4, &x5, &x6, &x7, &x8, &x9, 
		 &x10, &x12, &x13) != 12) {
	*paniced = true;
      }
      
      t_list[i2].tval    = x1;
      t_list[i2].subval  = x2;
      t_list[i2].weight  = x3;
      t_list[i2].number  = x4;
      t_list[i2].tohit   = x5;
      t_list[i2].todam   = x6;
      t_list[i2].ac      = x7;
      t_list[i2].toac    = x8;
      t_list[i2].p1      = x9;
      t_list[i2].flags   = x10;
      t_list[i2].level   = x12;
      t_list[i2].cost    = x13;
    }
  }

};
//////////////////////////////////////////////////////////////////////
void gc__read_identified(FILE *f1, encrypt_state *cf_state, ntype in_rec,
			 boolean *paniced)
{
  integer i1;

  read_decrypt(f1, cf_state, in_rec, paniced);
  for (i1 = 1; i1 <= MAX_OBJECTS; i1++) {
    if (in_rec[i1-1] == 'T') {
      identify(&(object_list[i1]));
    } else if (in_rec[i1-1] == 'F') {
      object_ident[i1] = false;
    } else {
      *paniced = true;
    }
  } 
};
//////////////////////////////////////////////////////////////////////
void gc__read_monsters(FILE *f1, encrypt_state *cf_state, ntype in_rec,
		       boolean *paniced)
{
  integer    i1, i2, i3, tot_monsters;
  integer    x1,x2,x3,x4,x5,x6,x7,x8,x9,x10;

  muptr = 0;
  mlink();

  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec,"%ld",&tot_monsters) != 1) {
    *paniced = true;
  }
  
  i3 = 0;
  for (i1 = 1 ; i1 <= tot_monsters ; i1++) {
    read_decrypt(f1, cf_state, in_rec, paniced);
    popm(&i2);

    // with m_list[i1] do;
    if (sscanf(in_rec,
	       "%ld %ld %ld %ld "
	       "%ld %ld %ld %ld "
	       "%ld %ld",
	       &x1, &x2, &x3, &x4,
	       &x5, &x6, &x7, &x8,
	       &x9, &x10) != 10) {
      *paniced = true;
    }
    m_list[i1].fy         = x1;
    m_list[i1].fx         = x2;
    m_list[i1].mptr       = x3;
    m_list[i1].hp         = x4;
    m_list[i1].cspeed     = x5;
    m_list[i1].csleep     = x6;
    m_list[i1].cdis       = x7; 
    m_list[i1].ml         = x8;
    m_list[i1].confused   = x9;
    m_list[i1].cur_reprod = x10; 

  }
};
//////////////////////////////////////////////////////////////////////
void gc__read_town(FILE *f1, encrypt_state *cf_state, ntype in_rec,
		   boolean *paniced)
{
  integer          i1,i2;
  integer          x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11,x12;

  /*{ Restore the town level stores 	}*/
  read_decrypt(f1, cf_state, in_rec, paniced);
  if (sscanf(in_rec, "%d", &town_seed) != 1) {
    *paniced = true;
  }

  for (i1 = 0; i1 < MAX_STORES; i1++) {
    //with stores[i1]. do;
    read_decrypt(f1, cf_state, in_rec, paniced);
    if (sscanf(in_rec,"%ld",&x1) != 1) {
      *paniced = true;
    }
    stores[i1].store_ctr = x1;

    for (i2 = 1; i2 <= stores[i1].store_ctr; i2++) {
      //with stores[i1].store_inven[i2].sitem do;
      read_decrypt(f1, cf_state, in_rec, paniced);
      if (sscanf(in_rec,"%ld",&stores[i1].store_inven[i2].scost) != 1) {
	*paniced = true;
      }

      read_decrypt(f1, cf_state, in_rec, paniced);
      stores[i1].store_inven[i2].sitem.tchar = in_rec[0];
      strcpy(stores[i1].store_inven[i2].sitem.name, &in_rec[2]);
      
      read_decrypt(f1, cf_state, in_rec, paniced);
      strcpy(stores[i1].store_inven[i2].sitem.damage, in_rec);

      read_decrypt(f1, cf_state, in_rec, paniced);
      if (sscanf(in_rec,"%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld",
		 &x1, &x2, &x3, &x4,
		 &x5, &x6, &x7, &x8,
		 &x9, &x10, &x11, &x12) != 12) {
	*paniced = true;
      }
      stores[i1].store_inven[i2].sitem.tval    = x1;
      stores[i1].store_inven[i2].sitem.subval  = x2;
      stores[i1].store_inven[i2].sitem.weight  = x3;
      stores[i1].store_inven[i2].sitem.number  = x4;
      stores[i1].store_inven[i2].sitem.tohit   = x5;
      stores[i1].store_inven[i2].sitem.todam   = x6;
      stores[i1].store_inven[i2].sitem.ac      = x7;
      stores[i1].store_inven[i2].sitem.toac    = x8;
      stores[i1].store_inven[i2].sitem.p1      = x9;
      stores[i1].store_inven[i2].sitem.flags   = x10;
      stores[i1].store_inven[i2].sitem.level   = x11;
      stores[i1].store_inven[i2].sitem.cost    = x12;

      //end with store inven;
    } //end for i2;

    //with store_open do;
    read_decrypt(f1, cf_state, in_rec, paniced);
    if (sscanf(in_rec,"%ld %ld %ld",
	       &x1, &x2, &x3) != 3) {
      *paniced = true;
    }
    stores[i1].owner      = x1;
    stores[i1].insult_cur = x2;
    stores[i1].store_open = x3;
  } //end for i1;
};
//////////////////////////////////////////////////////////////////////
boolean get_char(vtype fnam, boolean prop)
{
  /*{ Restore a saved game                          -RAK- & -JWT-   }*/

  real           save_version;
  ntype          in_rec;
  FILE          *f1 = NULL;
  GDBM_FILE      f2 = NULL;
  boolean        dun_flag;
  boolean        was_dead,paniced;
  encrypt_state  cf_state;
  integer        check_time;
  
  dun_flag = false;
  paniced = false;
// clear_from(1);

#define DP if (!paniced)

  gc__open_save_file(&f1, fnam, &paniced);
  encrypt_init(&cf_state, saveFileKey, saveFilesAreEncrypted);

  if (paniced) {
    exit_game();
  } else {
    DP { gc__read_seeds(f1, &cf_state, in_rec, &paniced); }
    DP { gc__display_status(fnam, in_rec); }
    DP { gc__read_version(f1, &cf_state, in_rec, &paniced, &save_version); }
    DP { gc__read_player_record(f1,&cf_state,in_rec,&paniced,prop,&was_dead); }
    DP { gc__kill_list(f1, &cf_state, in_rec, &paniced, &was_dead); }
    DP { gc__bank_records(f1, &cf_state, in_rec, &paniced, &was_dead); }
    DP { gc__read_inventory(f1, &cf_state, in_rec, &paniced, &was_dead); }
    DP { gc__read_equipment(f1, &cf_state, in_rec, &paniced, &was_dead); }
    DP { gc__read_stats_and_flags(f1, &cf_state, in_rec, &paniced); }
    DP { gc__read_magic(f1, &cf_state, in_rec, &paniced); }
    DP { gc__read_dungeon(f1, &cf_state, in_rec, &paniced); }
    DP { gc__read_identified(f1, &cf_state, in_rec, &paniced); }
    DP { gc__read_monsters(f1, &cf_state, in_rec, &paniced); }
    DP { gc__read_town(f1, &cf_state, in_rec, &paniced); }
  
    /* odds are we would have paniced by this time if an 
       encrypted file has been tampered with, but just in case... */
    DP {
      read_decrypt(f1, &cf_state, in_rec, &paniced);
      sscanf(in_rec, "%ld", &check_time);
      if (PM.creation_time != check_time) {
	paniced = true;
      }
    }

    fclose(f1);
    
  } /* endif !paniced */
  
  DP { seed = get_seed(); }

  /*{ See if character is should be allowed to load }*/

  DP { gc__open_master(f1, &f2, &paniced); }
  DP {
    gc__read_master(f2, &paniced);
    master_file_close(&f2);
  }

  if (paniced) { 
    data_exception();
    //exit_game();
  }

  if (dun_flag) {
    store_init();
    store_maint();
  }

  if (day >= DAY_LIMIT) {
    out_of_time = true;
  }

  return dun_flag;
} /* end get_char */
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE save.c */
