/* skills.c */
/**/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void explosion(integer typ, integer y, integer x, integer dam_hp,
	       integer radius, boolean painful, char *descrip)
{
  /*{Blow up a certain (y,x) Painful is true when it hurts the player.}*/

  integer   i1,i2,i3,dam,thit,tkill;
  integer   weapon_type,harm_type;
  obj_set   *destroy;
  vtype     out_val;

  thit   = 0;
  tkill  = 0;
  get_flags(typ,&weapon_type,&harm_type,&destroy);

  for (i1 = y-radius; i1 <= y+radius; i1++) {
    for (i2 = x-radius; i2 <= x+radius; i2++) {
      if (in_bounds(i1,i2)) {
        if (distance(y,x,i1,i2) <= radius) {
          if (los(y,x,i1,i2)) {               /*{ FIXED BUG V4.5        }*/
            //with cave[i1,i2] do;
	    if (cave[i1][i2].tptr > 0) {
	      if (is_in(t_list[cave[i1][i2].tptr].tval, *destroy)) {
		delete_object(i1,i2);
	      }
	    }
	    if (cave[i1][i2].fopen) {
	      if (panel_contains(i1,i2)) {
		print('*',i1,i2);
		put_qio();
		usleep(DRAW_BALL_DELAY);
	      }

	      if ((painful) && (cave[i1][i2].cptr == 1)) {
		dam = trunc(dam_hp/(distance(i1,i2,y,x)+1));
		switch (typ) {
		case 0 : take_hit(dam,descrip);
		case 1 : light_dam(dam,descrip);
		case 2 : poison_gas(dam,descrip);
		case 3 : acid_dam(dam,descrip);
		case 4 : cold_dam(dam,descrip);
		case 5 : fire_dam(dam,descrip);
		}
	      }

	      if (cave[i1][i2].cptr > 1) {
		//with m_list[cave[i1][i2].cptr] do;
		//with c_list[m_list[cave[i1][i2].cptr].mptr] do;
		dam = dam_hp;
		thit++;

		if ((harm_type & 
		     c_list[m_list[cave[i1][i2].cptr].mptr].cdefense) != 0) {
		  dam *= 2;
		} else if ((weapon_type & 
		     c_list[m_list[cave[i1][i2].cptr].mptr].spells) != 0) {
		  dam /= 2;
		}

		dam = (integer)(dam/(distance(i1,i2,y,x)+1));
		i3 = mon_take_hit(cave[i1][i2].cptr,dam);

		if (i3 > 0) {
		  tkill++;
		} else {
		  if (panel_contains(i1,i2)) {
		    print(c_list[m_list[cave[i1][i2].cptr].mptr].cchar,i1,i2);
		    m_list[cave[i1][i2].cptr].ml = true;
		  }
		}

	      }
	    }
	  }
	}
      }
    }
  }

  for (i1 = y-radius; i1 <= y+radius; i1++) {
    for (i2 = x-radius; i2 <= x+radius; i2++) {
      if (in_bounds(i1,i2)) {
        if (panel_contains(i1,i2)) {
	  
          if (distance(y,x,i1,i2) <= radius) {
            //with cave[i1,i2] do;
	    if (test_light(i1,i2)) {
	      lite_spot(i1,i2);
	    } else if (cave[i1][i2].cptr == 1) {
	      lite_spot(i1,i2);

	    } else if (cave[i1][i2].cptr > 1) {
	      if (m_list[cave[i1][i2].cptr].ml) {
		lite_spot(i1,i2);
	      } else {
		unlite_spot(i1,i2);
	      }
	    } else {
	      unlite_spot(i1,i2);
	    }
	  }
	}
      }
    }
  }

  if (thit == 1) {
    sprintf(out_val, "The %s envelopes a creature!",descrip);
    msg_print(out_val);
  } else if (thit > 1) {
    sprintf(out_val, "The %s envelopes several creatures!",descrip);
    msg_print(out_val);
  }
  if (tkill == 1) {
    sprintf(out_val, "The %s kills a creature!",descrip);
    msg_print(out_val);
  } else if (tkill > 1) {
    msg_print("Several monsters expire in the attack!");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void get_flags ( integer typ, integer *weapon_type, integer *harm_type,
		 obj_set **destroy)
{
  /*{ Return flags for given type area affect }*/

  switch (typ) {
  case 1  :  /*{ Lightning }*/
    *weapon_type = 0x00080000;
    *harm_type   = 0x0100;
    *destroy     = &destroyed_by_lightning;
    break;
    
  case 2  :  /*{ Gas }*/
    *weapon_type = 0x00100000;
    *harm_type   = 0x0040;
    *destroy     = &null_obj_set;
    break;
    
  case 3  :  /*{ Acid }*/
    *weapon_type = 0x00200000;
    *harm_type   = 0x0080;
    *destroy     = &destroyed_by_acid;
    break;
    
  case 4  :  /*{ Frost }*/
    *weapon_type = 0x00400000;
    *harm_type   = 0x0010;
    *destroy     = &destroyed_by_cold;
    break;
    
  case 5  :  /*{ Fire }*/
    *weapon_type = 0x00800000;
    *harm_type   = 0x0020;
    *destroy     = &destroyed_by_fire;
    break;
    
  case 6  :  /*{ Anti-Mut }*/
    *weapon_type = 0x00000000;
    *harm_type   = 0x0004;
    *destroy     = &null_obj_set;
    break;
    
  default:
    *weapon_type = 0x00000000;
    *harm_type   = 0x0000;
    *destroy     = &null_obj_set;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void make_light(integer y, integer x, integer r, boolean light)
{
  /*{ lights/darkens a circular area around the [y,x] of radius r.  --jeb}*/

  real     d,ty,tx;  /* {d = distance squared, ty,tx=temp real x,y} */
  integer  i1,i2;    /* {i1,i2 = cave co-ordinates}         */
  integer   row,col;
  char     sym_char;
  dtype    temp_char;
          
  ty = 1.0 * y;
  tx = 1.0 * x;

  for (i1 = y-r; i1 <= y+r; i1++) {
    for (i2 = x-2*r; i2 <= x+2*r; i2++) {
      if (in_bounds(i1,i2)) {

	d = (i1-ty)*(i1-ty) + (0.7*(i2-tx))*(0.7*(i2-tx));  

	if ((d <= r*r) &&
	    (is_in(cave[i1][i2].fval, pwall_set) ||
	     is_in(cave[i1][i2].fval, floor_set))) {

	  cave[i1][i2].pl = light;
	  row = i1 - panel_row_prt; /*{convert [i1,i2] to screen pos}*/
	  col = i2 - panel_col_prt;

	  if ((row >= 2 && row <= 23) && (col >= 15 && col <= 80)) {
	    if (light) {
	      sym_char = loc_symbol(i1,i2);
	    } else {
	      sym_char = ' ';
	    }
	    used_line[row] = true;
	    temp_char[0] = sym_char; 
	    temp_char[1] = 0;
	    put_buffer(temp_char,row,col);
	  }
	  
	}
      }
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean teleport_away(integer monptr, integer dis)
{
  /*{ Move the creature record to a new location }*/

  integer   yn,xn,ctr;

  //with m_list[monptr]. do;
  ctr = 0;
  do {
    do {
      yn = m_list[monptr].fy + (randint(2*dis+1) - (dis + 1));
      xn = m_list[monptr].fx + (randint(2*dis+1) - (dis + 1));
    } while (!in_bounds(yn,xn));
    ctr++;
    if (ctr > 9) {
      ctr  = 0;
      dis += 5;
    }
  } while (! ((cave[yn][xn].fopen) && (cave[yn][xn].cptr == 0)));
  
  move_rec(m_list[monptr].fy,m_list[monptr].fx,yn,xn);
  if (test_light(m_list[monptr].fy,m_list[monptr].fx)) {
    lite_spot(m_list[monptr].fy,m_list[monptr].fx);
  }
  m_list[monptr].fy = yn;
  m_list[monptr].fx = xn;
  m_list[monptr].ml = false;
  
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean teleport_to(integer ny, integer nx)
{
  /*{ Teleport player to spell casting creature }*/

  integer   dis,ctr,y,x,i1,i2;

  dis = 1;
  ctr = 0;
  do {
    y = ny + (randint(2*dis+1) - (dis + 1));
    x = nx + (randint(2*dis+1) - (dis + 1));
    ctr++;
    if (ctr > 9) {
      ctr = 0;
      dis++;
    }
  } while (! ((cave[y][x].fopen) && (cave[y][x].cptr < 2)) );

  move_rec(char_row,char_col,y,x);

  for (i1 = char_row-1; i1 <= char_row+1; i1++) {
    for (i2 = char_col-1; i2 <= char_col+1; i2++) {
      //with cave[i1][i2] do;
      cave[i1][i2].tl = false;
      if (!test_light(i1,i2)) {
	unlite_spot(i1,i2);
      }
    }
  }

  if (test_light(char_row,char_col)) {
    lite_spot(char_row,char_col);
  }

  char_row = y;
  char_col = x;
  move_char(5);
  creatures(false);

  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean teleport_monster(integer dir, integer y, integer x)
{
  /*{ Teleport all creatures in a given direction away }*/

  boolean  flag = false;
  boolean  return_value = false;

  do {
    move_dir(dir,&y,&x);
    //with cave[y][x]. do;
    if (cave[y][x].cptr > 1) {
      teleport_away(cave[y][x].cptr,MAX_SIGHT);
      return_value = true;
    }
  } while (! ((!(cave[y][x].fopen)) || (flag)));

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void lose_exp(integer amount)
{
  /*{ Lose experience }*/

  integer  i1,i2,av_hp,lose_hp,av_mn,lose_mn;
  boolean  flag;

  if (py.misc.lev > 40) {
    msg_print("But the feeling is only temporary!");
  } else {
    //with py.misc do;

    if (amount > PM.exp) {
      PM.exp  = 0;
    } else {
      PM.exp -= amount;
    }

    i1 = 1;
    for ( ; trunc(player_exp[i1]*PM.expfact) <= PM.exp ; ) {
      i1++;
    }

    i2 = PM.lev - i1;

    for (; i2 > 0 ;) {
      av_hp = trunc(PM.mhp/PM.lev);
      av_mn = trunc(PM.mana/PM.lev);
      PM.lev--;
      i2--;
      lose_hp  = randint(av_hp*2-1);
      lose_mn  = randint(av_mn*2-1);
      PM.mhp  -= lose_hp;
      PM.mana -= lose_mn;
      if (PM.mhp  < 1) { PM.mhp  = 1; }
      if (PM.mana < 0) { PM.mana = 0; }

      if (PM.pskill != 0) {
	i1 = MAX_SKILLS;
	flag = false;

	do {
	  i1 = i1 - 1;                 
	  flag = skill_list[i1].learned;
	} while (!flag && (i1 >= 2));
	
	if (flag) {
	  skill_list[i1].learned = false;
	  switch (PM.pskill) {
	  case 1: case 2: case 7:
	    msg_print("You have forgotten a tech skill!"); break;
	  case 3: case 4:
	    msg_print("You have forgotten a prayer!");     break;
	  case 5: case 6:
	    msg_print("You have forgotten a trick");       break;
	  }
	}
      }
    }

    if (PM.chp   > PM.mhp)  { PM.chp   = PM.mhp; }
    if (PM.cmana > PM.mana) { PM.cmana = PM.mana; }
    strcpy(PM.title, player_title[PM.pclass][PM.lev]);
    prt_experience();
    prt_mhp();
    prt_chp();
    prt_mana();
    prt_level();
    prt_title();
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean aggravate_monster(integer dis_affect)
{
  /*{ Get all the monsters on the level pissed off. }*/

  integer i1;

  i1 = muptr;
  do {
    //with m_list[i1]. do;
    m_list[i1].csleep = 0;
    if (m_list[i1].cdis <= dis_affect) {
      if (m_list[i1].cspeed < 2) {
	m_list[i1].cspeed++;
      }
    }
    i1 = m_list[i1].nptr;
  } while (i1 != 0);

  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean remove_fear()
{
  /*{ Cure the players fear }*/
  boolean return_value = false;

  //with py.flags do;
  if (PF.afraid > 1) {
    PF.afraid = 1;
    return_value = true;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean remove_curse()
{
  /*{ Removes curses from items in equipment}*/

  integer i1;
  boolean return_value = false;

  for (i1 = 23; i1 <= 34; i1++) {
    //with equipment[i1]. do;
    if (uand(0x80000000,equipment[i1].flags) != 0) {
      equipment[i1].flags &= 0x7FFFFFFF;
      py_bonuses(&blank_treasure,0);
      return_value = true;
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean cure_blindness()
{
  /*{ Cure players blindness }*/

  boolean return_value = false;

  //with py.flags do;
  if (PF.blind > 1) {
    PF.blind = 1;
    return_value = true;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean cure_poison()
{
  /*{ Cure poisoning }*/

  boolean return_value = false;

  //with py.flags do;
  if (PF.poisoned > 1) {
    PF.poisoned = 1;
    return_value = true;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean cure_disease()
{
  /*{ Cure disease. - RLG}*/

  boolean return_value = false;

  //with py.flags do;
  if (PF.diseased > 1) {
    PF.diseased = 1;
    return_value = true;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean cure_confusion()
{
  /*{ Cure players confusion }*/

  boolean return_value = false;

  //with py.flags do;
  if (PF.confused > 1) {
    PF.confused = 1;
    return_value = true;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean mass_genocide()
{
  /*{ Delete all creatures within MAX_SIGHT distance }*/

  integer i1,i2;
  boolean return_value = false;

  for ( i1 = muptr; i1 != 0; i1 = i2 ) {
    //with m_list[i1], c_list[m_list[i1].mptr]. do;
    i2 = m_list[i1].nptr;
    if (m_list[i1].cdis <= MAX_SIGHT) {
      if (uand(c_list[m_list[i1].mptr].cdefense,0x80000000) == 0) {
	delete_monster(i1);
	return_value = true;
      }
    }
  }
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean fire_ball (integer typ, integer dir, integer y, integer x,
		   integer dam_hp, integer radius, boolean painful,
		   char *descrip)
{
  /*{ Shoot a ball in a given direction.  
    Note that balls have an area affect. }*/

  integer   oldy,oldx,dist;
  boolean   flag;

  flag = false;
  oldy = y;
  oldx = x;
  dist = 0;

  do {
    move_dir(dir,&y,&x);
    dist++;
    if (test_light(oldy,oldx)) {
      lite_spot(oldy,oldx);
    } else {
      unlite_spot(oldy,oldx);
    }
    if (dist > OBJ_BOLT_RANGE) {
      flag = true;
    } else {
      //with cave[y][x]. do;
      if (!cave[y][x].fopen || (cave[y][x].cptr > 1)) {
	flag = true;
	if (!cave[y][x].fopen) {
	  y = oldy;
	  x = oldx;
	}
	explosion(typ,y,x,dam_hp,2,painful,descrip);
      } else if (panel_contains(y,x)) {
	print('*',y,x);
      }
      oldy = y;
      oldx = x;
    }
  } while (!flag);
    
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean light_line(integer dir, integer y, integer x, integer dmg,
		   boolean laser)
{
  /*{ Leave a line of light in given dir, 
    blue light can sometimes hurt creatures.}*/

  vtype    out_val;
  integer  i1;

  for ( ; cave[y][x].fopen ; ) {
    //with cave[y][x]. do;
    if (panel_contains(y,x)) {
      if (!(cave[y][x].tl || cave[y][x].pl)) {
	lite_spot(y,x);
      }
      if (cave[y][x].cptr > 1) {
	//with m_list[cave[y][x].cptr]. do;
	//with c_list[m_list[cave[y][x].cptr].mptr]. do;
	if (uand(0x0100,c_list[m_list[cave[y][x].cptr].mptr].cdefense) != 0) {
	  sprintf(out_val, "The %s wails out in pain!",
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	  i1 = mon_take_hit(cave[y][x].cptr,dmg);
	  if (i1 > 0) {
	    sprintf(out_val, "The %s buys the proverbial farm.",
		    c_list[m_list[cave[y][x].cptr].mptr].name);
	    msg_print(out_val);
	  }
	} else if (laser) {
	  sprintf(out_val,"The %s is zapped by the laser!",
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	  i1 = mon_take_hit(cave[y][x].cptr,dmg);
	  if (i1 > 0) {
	    sprintf(out_val, "The %s sizzles and melts away.",
		    c_list[m_list[cave[y][x].cptr].mptr].name);
	    msg_print(out_val);
	  }
	}
      }
    }
    cave[y][x].pl = true;
    
    move_dir(dir,&y,&x);
  }
  
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean starlite(integer y, integer x)
{
  /*{ Light line in all directions }*/

  integer i1;

  msg_print("The end of the device bursts into a blue shimmering light.");
  for (i1 = 1; i1 <= 9; i1++) {
    if (i1 != 5) {
      light_line(i1,y,x,damroll("2d8"),false);
    }
  }

  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean slow_poison()
{
  /*{ Slow Poison }*/

  boolean   return_value = false;

  //with py.flags do;
  if (PF.poisoned > 0) {
    PF.poisoned /= 2;
    if (PF.poisoned < 1) { PF.poisoned = 1; }
    return_value = true;
    msg_print("The effects of the poison has been reduced.");
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean bless(integer amount)
{
  PF.blessed += amount;
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean detect_inv2(integer amount)
{
  /*{ Detect Invisible for period of time }*/
  PF.detect_inv += amount;
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean detect_invisible()
{
  /*{ Locates and displays all invisible creatures on current panel }*/

  integer  i1;
  boolean  flag = false;

  for (i1 = muptr; i1 != 0; i1 = m_list[i1].nptr) {
    //with m_list[i1]. do;
    if (panel_contains(m_list[i1].fy,m_list[i1].fx)) {
      if (uand(0x10000,c_list[m_list[i1].mptr].cmove) != 0) {
	m_list[i1].ml = true;
	print(c_list[m_list[i1].mptr].cchar,m_list[i1].fy,m_list[i1].fx);
	flag = true;
      }
    }
  }

  if (flag) {
    msg_print("You sense the presence of invisible creatures!");
    msg_print(" " );
    msg_flag = false;
  }

   return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean build_wall(integer dir, integer y, integer x)
{
  /*{ Create a wall. }*/

  integer  i1 = 0;
  boolean  return_value = false;

  move_dir(dir,&y,&x);
  for (; ((cave[y][x].fopen) && (i1 < 10)) ;) {
    //with cave[y][x]. do;
    if (cave[y][x].tptr > 0) {
      delete_object(y,x);
    }
    if (cave[y][x].cptr > 1) {
      mon_take_hit(cave[y][x].cptr,damroll("2d8"));
    }
    cave[y][x].fval  = rock_wall2.ftval;
    cave[y][x].fopen = rock_wall2.ftopen;
    cave[y][x].fm = false;
    if (test_light(y,x)) {
      lite_spot(y,x);
    }
    i1++;
    return_value = true;
    move_dir(dir,&y,&x);
  }            

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean clone_monster(integer dir, integer y, integer x)
{
  /*{ Replicate a creature }*/

  boolean   flag = false;
  boolean   return_value = false;

  do {
    move_dir(dir,&y,&x);
    //with cave[y][x]. do;
    if (cave[y][x].cptr > 1) {
      //with m_list[cave[y][x].cptr]. do;
      multiply_monster(y,x,m_list[cave[y][x].cptr].mptr,
		       m_list[cave[y][x].cptr].cur_reprod,false);
      if (panel_contains(y,x)) {
	if (m_list[cave[y][x].cptr].ml) {
	  return_value = true;
	}
      }
      flag = true;
    }
  } while (! ((!(cave[y][x].fopen)) || (flag)));

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean lose_str()
{
  /*{ Lose a strength point. }*/
  
  if (!(py.flags.sustain_str)) {
    //with py.stat do;
    PS.cstr = de_statp(PS.cstr);
    msg_print("You feel rather sick.");
    prt_strength();
  } else {
    msg_print("You feel sick for a moment, then it passes.");
  }
  
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean lose_int() 
{
  /*{ Lose an intelligence point. }*/

  if (!(py.flags.sustain_int)) {
    //with py.stat do;
    PS.cint = de_statp(PS.cint);
    msg_print("You become very dizzy.");
    prt_intelligence();
  } else {
    msg_print("You become dizzy for a moment, then it passes.");
  }
  
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean lose_wis()
{
/*{ Lose a wisdom point. }*/
  
  if (!(py.flags.sustain_wis)) {
    //with py.stat do;
    PS.cwis = de_statp(PS.cwis);
    msg_print("You feel more naive.");
    prt_wisdom();
  } else {
    msg_print("You feel senseless for a moment, then it passes.");
  }
  
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean lose_dex() 
{
  /*{ Lose a dexterity point.}*/
  
  if (!(py.flags.sustain_dex)) {
    //with py.stat do;
    PS.cdex = de_statp(PS.cdex);
    msg_print("You feel like a klutz.");
    prt_dexterity();
  } else {
    msg_print("You feel like a klutz for a moment, then it passes.");
  }
  
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean lose_con()
{
  /*{ Lose a constitution point.}*/
  
  if (!(py.flags.sustain_con)) {
    //with py.stat do;
    PS.ccon = de_statp(PS.ccon);
    msg_print("You feel very sick.");
    prt_constitution();
  } else {
    msg_print("You feel sick for a moment, then it passes.");
  }
  
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean lose_chr() 
{
  /*{ Lose a charisma point.}*/
  
  if (!py.flags.sustain_chr) {
    //with py.stat do;
    PS.cchr = de_statp(PS.cchr);
    msg_print("You get a bad case of acne.");
    prt_charisma();
  } else {
    msg_print("Your skin starts to itch, but feels better now.");
  }
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean hp_player(integer num, char *kind)
{
  /*{ Change players hit points in some manner }*/

  boolean return_value = false;

  //with py.misc do
  if (num < 0) {
    take_hit(abs(num),kind);
    if (PM.chp < 0) {
      msg_print("You feel your life slipping away!");
    }
    return_value = true;
  } else if (PM.chp < PM.mhp) {
    PM.chp += num;
    if (PM.chp > PM.mhp) {
      PM.chp = PM.mhp;
    }
    prt_chp();
    switch (trunc(num/5)) {
    case 0:                      msg_print("You feel a little better."); break;
    case 1: case 2:                  msg_print("You feel better."); break;
    case 3: case 4: case 5: case 6:  msg_print("You feel much better."); break;
    default:                         msg_print("You feel very good."); break;
    }
    return_value = true;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean confuse_monster(integer dir, integer y, integer x)
{
    /*{ Confuse a creature }*/

    boolean flag = false;
    vtype   out_val;
    boolean return_value = false;

    do {
	move_dir(dir,&y,&x);
	//with cave[y][x]. do;
	if (cave[y][x].fopen) {
	    if (cave[y][x].cptr > 1) {
		//with m_list[cave[y][x].cptr]. do ;
		//with c_list[m_list[cave[y][x].cptr].mptr]. do;
		return_value = true;
		flag = true;
		if ((randint(MAX_MONS_LEVEL) < c_list[m_list[cave[y][x].cptr].mptr].level) ||
		    (uand(0x1000,c_list[m_list[cave[y][x].cptr].mptr].cdefense) != 0)) {
		    sprintf(out_val, "The %s is unaffected.", 
			    c_list[m_list[cave[y][x].cptr].mptr].name);
		    msg_print(out_val);
		} else {
		    m_list[cave[y][x].cptr].confused = true;
		    m_list[cave[y][x].cptr].csleep = 0;
		    sprintf(out_val, "The %s appears confused.", 
			    c_list[m_list[cave[y][x].cptr].mptr].name);
		    msg_print(out_val);
		}
	    }
	} else {
	    flag = true;
	}
    } while (!flag);
	
    return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean sleep_monster(integer dir, integer y, integer x)
{
    /*{ Sleep a creature. }*/


    boolean flag = false;
    vtype   out_val;
    boolean return_value = false;

    do {
	move_dir(dir,&y,&x);
	//with cave[y][x]. do;
	if (cave[y][x].fopen) {
	    if (cave[y][x].cptr > 1) {
		//with m_list[cave[y][x].cptr]. do ;
		//with c_list[m_list[cave[y][x].cptr].mptr]. do;
		return_value = true;
		flag = true;
		if ((randint(MAX_MONS_LEVEL) < c_list[m_list[cave[y][x].cptr].mptr].level) ||
		    (uand(0x1000,c_list[m_list[cave[y][x].cptr].mptr].cdefense) != 0)) {
		    sprintf(out_val, "The %s is unaffected.", 
			    c_list[m_list[cave[y][x].cptr].mptr].name);
		    msg_print(out_val);
		} else {
		    m_list[cave[y][x].cptr].csleep = 500;
		    sprintf(out_val, "The %s snores blissfuly...", 
			    c_list[m_list[cave[y][x].cptr].mptr].name);
		    msg_print(out_val);
		}
	    }
	} else {
	    flag = true;
	}
    } while (!flag);
	
    return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
static void replace_spot(integer y, integer x, integer typ)
{
    //with cave[y][x]. do;
    switch (typ) {
    case 1: case 2: case 3:
	cave[y][x].fval  = corr_floor1.ftval;
	cave[y][x].fopen = corr_floor1.ftopen;
	break;
    case 4: case 7: case 10 :
	cave[y][x].fval  = rock_wall1.ftval;
	cave[y][x].fopen = rock_wall1.ftopen;
	break;
    case 5: case 8: case 11 :  
	cave[y][x].fval  = rock_wall2.ftval;
	cave[y][x].fopen = rock_wall2.ftopen;
	break;
    case 6: case 9: case 12 :  
	cave[y][x].fval  = rock_wall3.ftval;
	cave[y][x].fopen = rock_wall3.ftopen;
	break;
    }

    cave[y][x].pl = false;
    cave[y][x].fm = false;

    if (cave[y][x].tptr > 0) {
	delete_object(y,x);
    }
    if (cave[y][x].cptr > 1) {
	delete_monster(cave[y][x].cptr);
    }
};
//////////////////////////////////////////////////////////////////////
boolean destroy_area(integer y, integer x)
{
    /*{ The spell of destruction.}*/
    
    integer  i1,i2,i3;
 
    if (dun_level > 0) {
	for (i1 = (y-15); i1 <= (y+15); i1++) {
            for (i2 = (x-15); i2 <= (x+15); i2++) {
		if (in_bounds(i1,i2)) {
		    if (cave[i1][i2].fval != 15) {
			i3 = distance(i1,i2,y,x);
			if (i3 < 13) {
			    replace_spot(i1,i2,randint(6));
			} else if (i3 < 16) {
			    replace_spot(i1,i2,randint(9));
			}
		    }
		}
	    }
	}
    }
    msg_print("There is a searing blast of light!");
    py.flags.blind += 10 + randint(10);

    return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean warding_glyph(integer y, integer x)
{
    /*{ Leave a glyph of warding... Creatures will not pass over!}*/

    integer  i1;

    //with cave[y][x]. do;
    if (cave[y][x].tptr == 0) {
	popt(&i1);
	cave[y][x].tptr = i1;
	t_list[i1] = scare_monster;
    }

    return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean wall_to_mud(integer dir, integer y, integer x)
{
  /*{ Turn stone to mud, delete wall. }*/

  integer  i1; 
  vtype    out_val, out_val2;
  boolean  flag = false;
  boolean  return_value = false;

  do {
    move_dir(dir,&y,&x);
    //with cave[y][x]. do;
    if (in_bounds(y,x)) {
      if (is_in(cave[y][x].fval, wall_set)) {
	flag = true;
	twall(y,x,1,0);
	if (test_light(y,x)) {
	  msg_print("The wall erodes away");
	  return_value = true;
	}
      } else if ((cave[y][x].tptr > 0) && (!cave[y][x].fopen)) {
	flag = true;
	if (panel_contains(y,x)) {
	  if (test_light(y,x)) {
	    temporary_slot = t_list[cave[y][x].tptr];
	    objdes(out_val,1,false,'t');
	    sprintf(out_val2, "The %s erodes away", out_val);
	    msg_print(out_val2);
	    return_value = true;
	  }
	}
	delete_object(y,x);
      }

      if (cave[y][x].cptr > 1) {
	//with m_list[cave[y][x].cptr]. do; 
	//with c_list[m_list[cave[y][x].cptr].mptr]. do;
	if (uand(0x0200,c_list[m_list[cave[y][x].cptr].mptr].cdefense) != 0) {
	  i1 = mon_take_hit(m_list[cave[y][x].cptr].mptr,100);
	  flag = true;
	  if (m_list[cave[y][x].cptr].ml) {
	    if (i1 > 0) {
	      sprintf(out_val, "The %s flops once, and dies.",
		      c_list[m_list[cave[y][x].cptr].mptr].name);
	      msg_print(out_val);
	    } else {
	      sprintf(out_val, "The %s melts away.",
		      c_list[m_list[cave[y][x].cptr].mptr].name);
	      msg_print(out_val);
	    }
	  }
	}
      }
    } else {
      flag = true;
    }
  } while (!flag);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean create_food()
{
  /*{ Create some high quality mush for the player. }*/

  //with cave[char_row][char_col]. do;
  if (cave[char_row][char_col].tptr > 0) {
    delete_object(char_row,char_col);  /* you can nuke traps? */
  }
  place_object(char_row,char_col);
  t_list[cave[char_row][char_col].tptr] = mush;

  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean detect_evil()
{
  /*{ Display evil creatures on current panel }*/

  integer   i1;
  boolean   flag = false;

  i1 = muptr;

  for (i1 = muptr; i1 != 0; i1 = m_list[i1].nptr) {
    //with m_list[i1]. do;
    if (panel_contains(m_list[i1].fy,m_list[i1].fx)) {
      if (uand(0x0004,c_list[m_list[i1].mptr].cdefense) != 0) {
	m_list[i1].ml = true;
	print(c_list[m_list[i1].mptr].cchar,m_list[i1].fy,m_list[i1].fx);
	flag = true;
      }
    }
    i1 = m_list[i1].nptr;
  }

  if (flag) {
    msg_print("You detect scum nearby!");
    msg_print(" ");
    msg_flag = false;
  }

  return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean detect_monsters()
{
  /*{ Display all creatures on the current panel }*/

  integer   i1;
  boolean   flag = false;

  i1 = muptr;

  for (i1 = muptr; i1 != 0; i1 = m_list[i1].nptr) {
    //with m_list[i1]. do;
    if (panel_contains(m_list[i1].fy,m_list[i1].fx)) {
      if (uand(0x10000,c_list[m_list[i1].mptr].cmove) == 0) {
	m_list[i1].ml = true;
	print(c_list[m_list[i1].mptr].cchar,m_list[i1].fy,m_list[i1].fx);
	flag = true;
      }
    }
    i1 = m_list[i1].nptr;
  }

  if (flag) {
    msg_print("You detect life forms nearby...");
    msg_print(" ");
    msg_flag = false;
  }

  return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean detect_object()
{
  /*{ Detect all objects on the current panel }*/

  integer  i1,i2;
  boolean  return_value = false;

  for (i1 = panel_row_min; i1 <= panel_row_max; i1++) {
    for (i2 = panel_col_min; i2 <= panel_col_max; i2++) {
      //with cave[i1][i2]. do;
      if (cave[i1][i2].tptr > 0) {
	if (t_list[cave[i1][i2].tptr].tval < 100) {
	  if (! (test_light(i1,i2))) {
	    lite_spot(i1,i2);
	    cave[i1][i2].tl = true;
	    return_value = true;
	  }
	}
      }
    }
  }
  
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean detect_trap()
{
  /*{ Locates and displays traps on current panel }*/

  integer  i1,i2;
  boolean  return_value = false;

  for (i1 = panel_row_min; i1 <= panel_row_max; i1++) {
    for (i2 = panel_col_min; i2 <= panel_col_max; i2++) {
      //with cave[i1][i2]. do;
      if (cave[i1][i2].tptr > 0) {
	if (t_list[cave[i1][i2].tptr].tval == 101) {
	  change_trap(i1,i2);
	  cave[i1][i2].fm = true;
	  return_value = true;
	} else if (t_list[cave[i1][i2].tptr].tval == 2) {  /* chests? */
	  //with t_list[cave[i1][i2].tptr]. do;
	  known2(t_list[cave[i1][i2].tptr].name);
	}
      }
    }
  }
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean detect_sdoor()
{ 
  /*{ Locates and displays all secret doors on current panel }*/

  integer  i1,i2;
  boolean  return_value = false;

  for (i1 = panel_row_min; i1 <= panel_row_max; i1++) {
    for (i2 = panel_col_min; i2 <= panel_col_max; i2++) {
      //with cave[i1][i2]. do;
      if (cave[i1][i2].tptr > 0) {
	if (t_list[cave[i1][i2].tptr].tval == 109) {
	  /*{ Secret doors }*/
	  cave[i1][i2].fval = corr_floor3.ftval;
	  change_trap(i1,i2);
	  cave[i1][i2].fm = true;
	  return_value = true;
	} else if (t_list[cave[i1][i2].tptr].tval == 107 ||
		   t_list[cave[i1][i2].tptr].tval == 108) {
	  /*{ staircases }*/
	  if (!cave[i1][i2].fm) {
	    cave[i1][i2].fm = true;
	    lite_spot(i1,i2);
	    return_value = true;
	  }
	}
      }
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean detect_treasure()
{
  /*{ Detect any treasures on the current panel }*/

  integer  i1,i2;
  boolean  return_value = false;

  for (i1 = panel_row_min; i1 <= panel_row_max; i1++) {
    for (i2 = panel_col_min; i2 <= panel_col_max; i2++) {
      //with cave[i1][i2]. do;
      if (cave[i1][i2].tptr > 0) {
	if (t_list[cave[i1][i2].tptr].tval == 100) {
	  if (! (test_light(i1,i2))) {
	    lite_spot(i1,i2);
	    cave[i1][i2].tl = true;
	    return_value = true;
	  }
	}
      }
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean disarm_all(integer dir, integer y, integer x)
{
  /*{ Disarms all traps/chests in a given direction }*/
  
  char    *a_char;
  integer  oldy,oldx;
  boolean  return_value = false;
  
  do {
    //with cave[y][x]. do;
    
    if (cave[y][x].tptr > 0) {
      //with t_list[cave[y][x].tptr]. do;
      
      if (t_list[cave[y][x].tptr].tval == 101 ||
	  t_list[cave[y][x].tptr].tval == 102) {
	if (delete_object(y,x)) {
	  return_value = true;
	}
      } else if (t_list[cave[y][x].tptr].tval == 105) {
	t_list[cave[y][x].tptr].p1 = 0;
      } else if (t_list[cave[y][x].tptr].tval == 109) {
	cave[y][x].fval = corr_floor3.ftval;
	change_trap(y,x);
	cave[y][x].fm = true;
	return_value = true;
      } else if (t_list[cave[y][x].tptr].tval == 2) {
	if (t_list[cave[y][x].tptr].flags > 0) {
	  msg_print("Click!");
	  t_list[cave[y][x].tptr].flags &= 0xFFFFFE0F; /* detrap */
	  t_list[cave[y][x].tptr].flags &= 0xFFFFFFFE; /* unlock */
	  a_char = strstr(t_list[cave[y][x].tptr].name," (");
	  if (a_char != NULL) {
	    *a_char = 0;
	  }
	  strcat(t_list[cave[y][x].tptr].name, " (Unlocked)");
	  known2(t_list[cave[y][x].tptr].name);
	  return_value = true;
	}
      }
      
    }

    oldy = y;
    oldx = x;
    move_dir(dir,&y,&x);
  } while (cave[oldy][oldx].fopen);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean dispell_creature(integer cflag, integer damage)
{
  /*{ Attempts to destroy a type of creature.  Success depends on
    the creatures level VS. the player's level}*/

  integer  i1,m_next;
  vtype    out_val;
  boolean  return_value = false;

  for (i1 = muptr; i1 != 0; i1 = m_next) {
    m_next = m_list[i1].nptr;
    //with m_list[i1]. do;
    if (m_list[i1].ml) {
      if (uand(cflag,c_list[m_list[i1].mptr].cdefense) != 0) {
	m_list[i1].hp -= randint(damage);
	m_list[i1].csleep = 0;
	if (m_list[i1].hp < 0) {
	  sprintf(out_val, "The %s dissolves!", c_list[m_list[i1].mptr].name);
	  msg_print(out_val);
	  monster_death(m_list[i1].fy,m_list[i1].fx,
			c_list[m_list[i1].mptr].cmove);
	  //with c_list[m_list[i1].mptr]. do;
	  //with py.misc do;
	  PM.exp += .5 + c_list[m_list[i1].mptr].mexp *
	    ((real)c_list[m_list[i1].mptr].level/(real)PM.lev);
	  delete_monster(i1);
	} else {
	  sprintf(out_val, "The %s shudders.", c_list[m_list[i1].mptr].name);
	  msg_print(out_val);
	}
	return_value = true;
      }
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean turn_undead()
{ 
  /*{ Attempt to turn (confuse) undead creatures.}*/

  integer  i1;
  vtype    out_val;
  boolean  return_value = false;

  for (i1 = muptr; i1 != 0; i1 = m_list[i1].nptr) {
    //with m_list[i1]. do;
    if (panel_contains(m_list[i1].fy,m_list[i1].fx)) {
      if (m_list[i1].ml) {
	if (uand(0x0008,c_list[m_list[i1].mptr].cdefense) != 0) {
	  if (((py.misc.lev+1) > c_list[m_list[i1].mptr].level) ||
	      (randint(5) == 1)) {
	    sprintf(out_val, "The %s runs frantically!",
		    c_list[m_list[i1].mptr].name);
	    msg_print(out_val);
	    m_list[i1].confused = true;
	  } else {
	    sprintf(out_val, "The %s is unaffected.",
		    c_list[m_list[i1].mptr].name);
	    msg_print(out_val);
	  }
	  return_value = true;
        }
      }
    }
  }
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean trap_creation()
{
  /*{ Surround the fool with traps (chuckle) }*/

  integer   i1,i2;

  for (i1 = char_row-1; i1 <= char_row+1; i1++) {
    for (i2 = char_col-1; i2 <= char_col+1; i2++) {
      //with cave[i1][i2]. do;
      if (is_in(cave[i1][i2].fval, floor_set)) {
	if (cave[i1][i2].tptr > 0) {
	  delete_object(i1,i2); /* this deletes doors and rubble! */
	}
	place_trap(i1,i2,1,randint(MAX_TRAPA));
      }
    }
  }

  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean door_creation()
{
  /*{ Surround the player with doors. }*/

  integer  i1,i2,i3;

  for (i1 = char_row-1; i1 <= char_row+1; i1++) {
    for (i2 = char_col-1; i2 <= char_col+1; i2++) {
      if ((i1 != char_row) || (i2 != char_col)) {
	//with cave[i1][i2]. do;
	if (is_in(cave[i1][i2].fval, floor_set)) {
	  popt(&i3);
	  if (cave[i1][i2].tptr > 0) {
	    delete_object(i1,i2);
	  }
	  cave[i1][i2].fopen = false;
	  cave[i1][i2].tptr = i3;
	  t_list[i3] = door_list[2];
	  if (test_light(i1,i2)) {
	    lite_spot(i1,i2);
	  }
	}
      }
    }
  }
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean td_destroy()
{
  /*{ Destroys any adjacent door(s)/trap(s) }*/

  integer  i1,i2;
  obj_set  poofka = {101,102,104,105,109};
  boolean  return_value = false;
  
  for (i1 = char_row-1; i1 <= char_row+1; i1++) {
    for (i2 = char_col-1; i2 <= char_col+1; i2++) {
      //with cave[i1][i2]. do;
      if (cave[i1][i2].tptr > 0) {
	if (is_in(t_list[cave[i1][i2].tptr].tval, poofka)) {
	  if (delete_object(i1,i2)) {
	    return_value = true;
	  }
	}
      }
    }
  }
  
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean td_destroy2(integer dir, integer y, integer x)
{
  /*{ Destroy all traps and doors in a given direction }*/

  obj_set  poofka = {2,101,102,105,109};
  boolean  return_value = false;

  do {
    move_dir(dir,&y,&x);
    //with cave[y][x]. do;
    if (cave[y][x].tptr > 0) {
      //with t_list[cave[y][x].tptr] do;
      if (is_in(t_list[cave[y][x].tptr].tval, poofka)) {
	if (delete_object(y,x)) {
	  msg_print("There is a bright flash of light!");
	  cave[y][x].fopen = true;
	  return_value = true;
	}
      }
    }
  } while (cave[y][x].fopen);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean speed_monster(integer dir, integer y, integer x, integer spd)
{
  /*{ Increase or decrease a creatures speed }*/

  boolean  flag = false;
  vtype    out_val;
  boolean  return_value = false;

  do {
    move_dir(dir,&y,&x);
    //with cave[y][x]. do;
    if (cave[y][x].fopen) {
      if (cave[y][x].cptr > 1) {
	flag = true;
	//with m_list[cave[y][x].cptr]. do;
	//c_list[m_list[cave[y][x].cptr].mptr]. do;
	if (spd > 0) {
	  m_list[cave[y][x].cptr].cspeed += spd;
	  m_list[cave[y][x].cptr].csleep  = 0;
	} else if (randint(MAX_MONS_LEVEL) > 
		   c_list[m_list[cave[y][x].cptr].mptr].level) {
	  m_list[cave[y][x].cptr].cspeed += spd;
	  m_list[cave[y][x].cptr].csleep  = 0;
	  sprintf(out_val, "The %s looks blurry.",
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	} else {
	  sprintf(out_val, "The %s is unaffected.",
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	}
	return_value = true;
      }
    } else {
      flag = true;
    }
  } while (!flag);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean speed_monsters(integer spd)
{
  /*{ Change speed of any creature player can see. }*/

  integer  i1,i2;
  vtype    out_val;
  boolean  return_value = false;

  for (i1 = muptr; i1 != 0; i1 = i2) {
    //with m_list[i1]. do;
    i2 = m_list[i1].nptr;
    if (m_list[i1].ml) {
      //with c_list[m_list[i1].mptr]. do;
      if (spd > 0) {
	m_list[i1].cspeed += spd;
	m_list[i1].csleep  = 0;
	return_value = true;
      } else if (randint(MAX_MONS_LEVEL) > c_list[m_list[i1].mptr].level) {
	m_list[i1].cspeed += spd;
	m_list[i1].csleep  = 0;
	return_value = true;
      } else {
	sprintf(out_val, "The %s changes speed...", 
		c_list[m_list[i1].mptr].name);  /* huh? */
	msg_print(out_val);
      }
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean restore_level()
{
  /*{ Restores any drained experience }*/

  boolean  return_value = false;

  //with py.misc do;
  if (PM.max_exp > PM.exp) {
    return_value = true;
    msg_print("You feel your life energies returning...");
    for (;PM.exp < PM.max_exp;) {
      PM.exp = PM.max_exp;
      prt_experience();
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean hp_monster(integer dir, integer y, integer x, integer dam)
{
  /*{ Increase or decrease a creatures hit points }*/

  integer  i1;
  vtype    out_val;
  boolean  flag = false;
  boolean  return_value = false;

  do {
    move_dir(dir,&y,&x);
    //with cave[y][x]. do;
    if (cave[y][x].fopen) {
      if (cave[y][x].cptr > 1) {
	flag = true;
	//with m_list[cave[y][x].cptr]. do; 
	//with c_list[m_list[cave[y][x].cptr].mptr]. do;
	return_value = true;
	i1 = mon_take_hit(cave[y][x].cptr,dam);
	if (i1 > 0) {
	  sprintf(out_val, "The %s suffers from a major coronary.",
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	} else {
	  sprintf(out_val,"The %s says \"thanks, buddy!\"",
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	}
      }
    } else {
      flag = true;
    }            
  } while (!flag);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean light_area(integer y, integer x)
{
  /*
   * { Light an area: 1.  If corridor then light immediate area
   * 2.  If room then light entire room. }
   */
  
  integer  i1,i2;
  integer  radius;
  vtype    out_val;
  obj_set  one_two = {1,2};  

  sprintf(out_val, "You are surrounded by a %s light.",
	  colors[randint(MAX_COLORS)]);
  msg_print(out_val);
  
  if (is_in(cave[y][x].fval, one_two) && (dun_level > 0)) {
    radius = trunc((1.0*py.misc.lev) / 3.0);
    if (radius < 3) { radius = 3; }
    if (is_in((dun_level % 10), open_cave_set)) {
      make_light(y,x,radius,true);
    } else {
      light_room(y,x);
    }
    creatures(false);
  } else {
    for (i1 = y-1; i1 <= y+1; i1++) {
      for (i2 = x-1; i2 <= x+1; i2++) {
	if (in_bounds(i1,i2)) {
	  if (! (test_light(i1,i2))) {
	    lite_spot(i1,i2);
	  }
	  cave[i1][i2].pl = true;
	}
      }
    }
  }
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean unlight_area(integer y, integer x)
{
  /*{ Darken an area, opposite of light area }*/

  integer  i1,i2,i3,tmp1,tmp2,start_row,start_col,END_row,END_col;
  boolean  flag = false;
  obj_set  four_five_six = {4,5,6};
  obj_set  one_two = {1,2};
  vtype    out_val;
  boolean  return_value = false;

  if (is_in(cave[y][x].fval, one_two) && (dun_level > 0)) {
    tmp1 = trunc(SCREEN_HEIGHT/2);
    tmp2 = trunc(SCREEN_WIDTH /2);
    start_row = trunc(y/tmp1)*tmp1 + 1;
    start_col = trunc(x/tmp2)*tmp2 + 1;
    END_row = start_row + tmp1 - 1;
    END_col = start_col + tmp2 - 1;

    for (i1 = start_row; i1 <= END_row; i1++) {
      out_val[0] = 0;
      i3 = 0;
      for (i2 = start_col; i2 <= END_col; i2++) {
	//with cave[i1][i2]. do;
	if (is_in(cave[i1][i2].fval, one_two)) {
	  cave[i1][i2].pl = false;
	  cave[i1][i2].fval = 1;
	  if (!(test_light(i1,i2))) {
	    if (i3 == 0) {
	      i3 = i2;
	    }
	    strcat(out_val, " ");
	  } else if (i3 > 0) {
	    flag = true;
	    print_str(out_val,i1,i3);
	    out_val[0] = 0;
	    i3 = 0;
	  } else if (i3 > 0) {
	    flag = true;
	    print_str(out_val,i1,i3);
	    out_val[0] = 0;
	    i3 = 0;
	  }
	
	  if (i3 > 0) {
	    flag = true;
	    print_str(out_val,i1,i3);
	  }
	}
      }
    }

  } else {

    for (i1 = y-1; i1 <= y+1; i1++) {
      for (i2 = x-1; i2 <= x+1; i2++) {
	if (in_bounds(i1,i2)) {
	  //with cave[i1][i2]. do;
	  if (is_in(cave[i1][i2].fval, four_five_six)) {
	    if (cave[i1][i2].pl) {
	      cave[i1][i2].pl = false;
	      flag = true;
	    }
	  }
	}
      }
    }
  }

  if (flag) {
    msg_print("Darkness pervades the area around you...");
    return_value = true;
  } else {
    return_value = false;
  }
  
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean map_area()
{     
  /*{ Map the current area plus some }*/

  integer   i1,i2,i3,i4,i5,i6,i7,i8;

  i1 = panel_row_min - randint(10);
  i2 = panel_row_max + randint(10);
  i3 = panel_col_min - randint(20);
  i4 = panel_col_max + randint(20);

  for (i5 = i1; i5 <= i2; i5++) {
    for (i6 = i3; i6 <= i4; i6++) {
      if (in_bounds(i5,i6)) {
	if (is_in(cave[i5][i6].fval, floor_set)) {
	  for (i7 = i5-1; i7 <= i5+1; i7++) {
	    for (i8 = i6-1; i8 <= i6+1; i8++) {
	      //with cave[i7][i8]. do;
	      if (is_in(cave[i7][i8].fval, pwall_set)) {
		cave[i7][i8].pl = true;
	      } else if (cave[i7][i8].tptr > 0) {
		if (is_in(t_list[cave[i7][i8].tptr].tval, light_set)) {
		  cave[i7][i8].fm = true;
		}
	      }
	    }
	  }
	}
      }
    }
  }

  draw_cave();

  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean protect_evil()
{
  /*{ Evil creatures do not like this.}*/

  //with py.flags do
  PF.protevil += randint(25) + 3*py.misc.lev;

  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean sleep_monsters2_3(integer y, integer x, integer rad)
{
  /* 
   *  Sleep creatures within radius from player,
   * combining sleep II and sleep III spells - mwk,opusii 6/28/87
   */

  integer  i1,i2,mk1,mk2,mk3,mk4;
  vtype    out_val;
  boolean  return_value = false;

  mk1 = y-rad;  mk2 = y+rad;  mk3 = x-rad;  mk4 = x+rad;

  /*  {stay inbounds} */
  if (mk1 < 1)           { mk1 = 1; }
  if (mk2 > MAX_HEIGHT)  { mk2 = MAX_HEIGHT; }
  if (mk3 < 1)           { mk3 = 1; }
  if (mk4 > MAX_WIDTH)   { mk4 = MAX_WIDTH; }
  
  for (i1 = mk1; i1 <= mk2; i1++) {
    for (i2 = mk3; i2 <= mk4; i2++) {
      //with cave[i1][i2]. do;
      if (cave[i1][i2].cptr > 1) {
	//with m_list[cave[i1][i2].cptr]. do;
	//with c_list[m_list[cave[i1][i2].cptr].mptr]. do;
	if (m_list[cave[i1][i2].cptr].ml) {   /*{visible}*/

	  if ((0x1000 & c_list[m_list[cave[i1][i2].cptr].mptr].cdefense) == 0){

	    /*{can(will) be slept}*/
	    if ( rad > 5 ) {
	      move_cursor(1,1); /*{let them guess for sleep III}*/
	    } else {
	      sprintf(out_val, "The %s snoozes for a while.",
		      c_list[m_list[cave[i1][i2].cptr].mptr].name);
	      msg_print(out_val);
	    }
	    return_value = true;
	    m_list[cave[i1][i2].cptr].csleep = 500;

	  } else {

	    /*{can not (quite) sleep}*/
	    if ( randint(20) > 18 ) { /*{give small chance}*/
	      if ( rad > 5 ) {
		move_cursor(1,1); /*{let them guess for sleep III}*/
	      } else {
		sprintf(out_val, "The %s goes into dreamland.",
			c_list[m_list[cave[i1][i2].cptr].mptr].name);
		msg_print(out_val);
	      }
	      return_value = true;
	      /*{better than none!}*/
	      m_list[cave[i1][i2].cptr].csleep = 13 + randint(7);
	    } else {
	      if ( rad > 5 ) {
		move_cursor(1,1);
	      } else {
		sprintf(out_val, "The %s is unaffected.",
			c_list[m_list[cave[i1][i2].cptr].mptr].name);
		msg_print(out_val);
	      }
	    }

	  }
	}
      }
    }
  }    

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean earthquake()
{
  /*
    { This is a fun one.  In a given block, pick some walls and
    turn them into open spots.  Pick some open spots and turn
    them into walls.  An "Earthquake" effect.}
  */
  
  integer  i1,i2;
  obj_set  one_two = {1,2};
  
  for (i1 = char_row-8; i1 <= char_row+8; i1++) {
    for (i2 = char_col-8; i2 <= char_col+8; i2++) {
      if ((i1 != char_row) || (i2 != char_col)) {
	if (in_bounds(i1,i2)) {
	  if (randint(8) == 1) {
	    //with cave[i1][i2]. do;
	    if (cave[i1][i2].tptr > 0) {
	      delete_object(i1,i2);
	    }
	    if (cave[i1][i2].cptr > 1) {
	      mon_take_hit(cave[i1][i2].cptr,damroll("2d8"));
	    }
	    
	    if (is_in(cave[i1][i2].fval, wall_set)) {
	      if (next_to4(i1,i2,one_two) > 0) {
		cave[i1][i2].fval  = corr_floor2.ftval;
		cave[i1][i2].fopen = corr_floor2.ftopen;
	      } else {
		cave[i1][i2].fval  = corr_floor1.ftval;
		cave[i1][i2].fopen = corr_floor1.ftopen;
	      }
	      if (test_light(i1,i2)) { unlite_spot(i1,i2); }
	      cave[i1][i2].pl = false;
	      cave[i1][i2].fm = false;
	      if (cave[i1][i2].tl) { lite_spot(i1,i2); }
	    } else if (is_in(cave[i1][i2].fval, floor_set)) {
	      switch (randint(10)) {
	      case 1: case 2: case 3: case 4: case 5: 
		cave[i1][i2].fval  = rock_wall3.ftval;
		cave[i1][i2].fopen = rock_wall3.ftopen;
		break;
	      case 6: case 7: case 8: 
		cave[i1][i2].fval  = rock_wall2.ftval;
		cave[i1][i2].fopen = rock_wall2.ftopen;
		break;
	      case 9: case 10: 
		cave[i1][i2].fval  = rock_wall1.ftval;
		cave[i1][i2].fopen = rock_wall1.ftopen;
		break;
	      }
	      cave[i1][i2].fm = false;
	    }
	    
	    if (test_light(i1,i2)) {
	      lite_spot(i1,i2);
	    }

	  }
	}
      }
    }
  }
	  
  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean genocide()
{
  /*{ Delete all creatures of a given type from level. }*/

  integer  i1,i2;
  vtype    out_val;
  char     typ;

  if (get_com("Which type of creature do wish exterminated?",&typ)) {
    for (i1 = muptr; i1 != 0; i1 = i2) {
      //with m_list[i1]., c_list[m_list[i1].mptr]. do
      i2 = m_list[i1].nptr;
      if (typ == c_list[m_list[i1].mptr].cchar) {
	if (uand(c_list[m_list[i1].mptr].cdefense,0x80000000) == 0) {
	  delete_monster(i1);
	} else {
	  sprintf(out_val, "The %s is unaffected.",
		  c_list[m_list[i1].mptr].name);
	  msg_print(out_val);
	}
      }
    }
  }

  return true;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean mass_poly()
{
  /*{ Polymorph any creature that player can see. }*/

  integer  i1,i2,y,x;
  boolean  return_value = false;

  for (i1 = muptr; i1 != 0; i1 = i2) {
    //with m_list[i1]. do;
    i2 = m_list[i1].nptr;
    if (m_list[i1].cdis < MAX_SIGHT) {
      //with c_list[m_list[i1].mptr]. do;
      if (uand(c_list[m_list[i1].mptr].cdefense,0x80000000) == 0) {
	y = m_list[i1].fy;
	x = m_list[i1].fx;
	delete_monster(i1);
	place_monster(y,x,randint(m_level[MAX_MONS_LEVEL]) + m_level[0],false);
	return_value = true;
      }
    }
  }
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean poly_monster(integer dir, integer y, integer x)
{
  /*{ Polymorph a monster }*/

  integer  dist = 0;
  boolean  flag = false;
  vtype    out_val;
  boolean  return_value = false;

  do {
    move_dir(dir,&y,&x);
    dist++;
    if (dist < OBJ_BOLT_RANGE) {
      //with cave[y][x]. do;
      if (cave[y][x].fopen) {
	if (cave[y][x].cptr > 1) {
	  //with c_list[m_list[cave[y][x].cptr].mptr]. do;
	  if (randint(MAX_MONS_LEVEL) > 
	      c_list[m_list[cave[y][x].cptr].mptr].level) {
	    flag = true;
	    delete_monster(cave[y][x].cptr);
	    place_monster(y,x,
			  randint(m_level[MAX_MONS_LEVEL])+ m_level[0],false);
	    if (panel_contains(y,x)) {
	      if (test_light(y,x)) {
		return_value = true;
	      }
	    }
	  } else {
	    sprintf(out_val,"The %s is unaffected.",
		    c_list[m_list[cave[y][x].cptr].mptr].name);
	    msg_print(out_val);
	  }
	}
	
      } else {
	flag = true;
      }
    } else {
      flag = true;
    }
  } while (!flag);
  
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean fire_bolt (integer typ, integer dir, integer y, integer x,
		   integer dam, char *bolt_typ)
{
  /*{ Shoot a bolt in a given direction }*/

  integer  i1,oldy,oldx,dist,weapon_type,harm_type;
  char     mwkchar;
  obj_set *dummy;
  vtype    out_val;
  char    *diestr; 
  boolean  flag = false;
    
  get_flags(typ,&weapon_type,&harm_type,&dummy);
  oldy = y;
  oldx = x;
  dist = 0;
  
  do {
    move_dir(dir,&y,&x);
    if (test_light(oldy,oldx)) {
      lite_spot(oldy,oldx);
    } else {
      unlite_spot(oldy,oldx);
    }
    
    dist++;
    
    if (dist > OBJ_BOLT_RANGE ) {
      flag = true;
    } else {
      //with cave[y][x]. do;
      if (cave[y][x].fopen) {
	if (cave[y][x].cptr > 1) {
	  flag = true;
	  //with m_list[cave[y][x].cptr]. do;
	  //with c_list[m_list[cave[y][x].cptr].mptr]. do;
	  
	  sprintf(out_val, "The %s strikes the %s", bolt_typ, 
		  c_list[m_list[cave[y][x].cptr].mptr].name);
	  msg_print(out_val);
	  
	  if (uand(harm_type,c_list[m_list[cave[y][x].cptr].mptr].cdefense) != 0) {
	    dam *= 2;
	  } else if (uand(weapon_type,c_list[m_list[cave[y][x].cptr].mptr].spells) != 0) {
	    dam /= 4;
	  }
	  i1 = mon_take_hit(cave[y][x].cptr,dam);
	  if (i1 > 0) {
	    switch (randint(5)) {
	    case 1 : diestr = "ceases to live.";      break;
	    case 2 : diestr = "is no longer.";        break;
	    case 3 : diestr = "dies agonizingly.";    break;
	    case 4 : diestr = "expires with a sigh."; break;
	    case 5 : diestr = "collapses in a heap."; break;
	    }
	    sprintf(out_val, "The %s %s", c_list[i1].name, diestr);
	    msg_print(out_val);
	  } else {
	    if (panel_contains(y,x)) {
	      print(c_list[m_list[cave[y][x].cptr].mptr].cchar,y,x);
	      m_list[cave[y][x].cptr].ml = true;
	    }
	  }
	  
	} else if (panel_contains(y,x)) {
	  switch (dir) {
	  case 1: case 9: mwkchar ='/';  break;
	  case 2: case 8: mwkchar ='|';  break;
	  case 3: case 7: mwkchar ='\\'; break;
	  case 4: case 6: mwkchar ='-';  break;
	  }
	  print(mwkchar,y,x);
	  put_qio();
	  usleep(DRAW_BOLT_DELAY);
	}
	
      } else {
        flag = true;
      }         
      oldy = y;
      oldx = x;
    }
  } while (!flag);

  return true;
};                     
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean recharge(integer num)
{
  /*{ Recharge a wand, staff, or rod.  Sometimes the item breaks. }*/

  integer  item_val;
  boolean  redraw = false;
  boolean  return_value = false;
  obj_set  feed_me = {55,60,65};
  
  if (get_item(&item_val,"Recharge which item?",&redraw,1,inven_ctr)) {
    //with inventory[item_val]. do;
    if (is_in(inventory[item_val].tval, feed_me)) {
      if (randint(8) == 1) {
	return_value = true;
	msg_print("The item melts in your hand...");
	inven_destroy(item_val);
      } else {
	return_value = true;
	num = trunc(num/(inventory[item_val].level+2));
	inventory[item_val].p1 += 2 + randint(num);

	/* this looks like a nop to me... */
	if (strchr(inventory[item_val].name,'^') == NULL) {
	  /*{obj already identified}*/
	  insert_str(inventory[item_val].name," (%P1"," (%P1");
	} else {
	  /*{obj not ident'd}*/
	  insert_str(inventory[item_val].name,"^ (%P1","^ (%P1");
	}
      }
    }
  }      

  if (redraw) {
    msg_print(" ");
    draw_cave();
  }
      
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean ident_spell()
{
  /*{ Identify an object }*/

  integer   item_val;
  vtype     out_val, out_val2;
  boolean   redraw = false;
  boolean   return_value = false;

  if (get_item(&item_val,"Identify which item?",&redraw,1,inven_ctr)) {
    //with inventory[item_val]. do;
    return_value = true;
    identify(&inventory[item_val]);
    known2(inventory[item_val].name);
    objdes(out_val,item_val,true,'i');
    sprintf(out_val2, "%c%c %s", (char)(item_val+96), cur_char2(item_val),
	    out_val);
    msg_print(out_val2);
  }
  if (redraw) {
    msg_print(" ");
    draw_cave();
  }

  return return_value;
};    
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean drain_life(integer dir, integer y, integer x)
{
  /*{ Drains life }*/

  integer  i1;
  vtype    out_val;
  boolean  flag = false;
  boolean  return_value = false;
  
  do {
    move_dir(dir,&y,&x);
    //with cave[y][x]. do;
    if (cave[y][x].fopen) {
      if (cave[y][x].cptr > 1) {
	flag = true;
	//with m_list[cave[y][x].cptr]. do;
	//with c_list[m_list[cave[y][x].cptr].mptr]. do;
	if (uand(c_list[m_list[cave[y][x].cptr].mptr].cdefense,0x0008) == 0) {
	  return_value = true;
	  i1 = mon_take_hit(cave[y][x].cptr,50);
	  if (i1 > 0) {
	    sprintf(out_val, "The %s dies smiling.",c_list[i1].name);
	    msg_print(out_val);
	  } else {
	    sprintf(out_val, "The %s gets a boo-boo too big for a band-aid.",
		    c_list[i1].name);
	    msg_print(out_val);
	  }
	}
      }
    } else {
      flag = true;
    }
    
  } while (!flag);
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
static boolean enchant(worlint *pluses)
{
  /*{ Enchants a plus onto an item.}*/

  integer  chance = 0;
  boolean  return_value = false;

  if (*pluses > 0) {
    switch (*pluses) {
    case 1  :  chance = 040; break;
    case 2  :  chance = 100; break;
    case 3  :  chance = 200; break;
    case 4  :  chance = 400; break;
    case 5  :  chance = 600; break;
    case 6  :  chance = 700; break;
    case 7  :  chance = 800; break;
    case 8  :  chance = 900; break;
    case 9  :  chance = 950; break;
    default :  chance = 995; break;
    }
  }

  if (randint(1000) > chance) {
    (*pluses)++;
    return_value = true;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean enchant_weapon(char *how)
{
  /*{Complex routine to handle modifications on a player's wielded weapon}*/

  vtype    out_val, out_val2;
  boolean  failure = true;      
  boolean  return_value = true;

  //with equipment[23]. do;
  if (equipment[23].tval > 0) {
    if (!strcmp(how, "curse")) {
      temporary_slot = equipment[23];
      objdes(out_val,23,false,'e');
      sprintf(out_val2, "Your %s glows black, then fades.", out_val);
      msg_print(out_val2);
      
      if (equipment[23].tohit > 0) {
	equipment[23].tohit = 0;
      } else {
	equipment[23].tohit--;
      }
      if (equipment[23].todam > 0) {
	equipment[23].todam = 0;
      } else {
	equipment[23].todam--;
      }
      py_bonuses(&temporary_slot,-1);
    } else {
      objdes(out_val,23,false,'e');
      sprintf(out_val2, "Your %s glows faintly!", out_val);
      msg_print(out_val2);
      
      if (!strcmp(how, "tohit") || !strcmp(how, "both")) {
	if (enchant(&equipment[23].tohit)) {
	  equipment[23].flags &= 0x7FFFFFFF;
	  py_bonuses(&blank_treasure,0);
	  failure = false; 
	}
      }
      
      if (!strcmp(how, "todam") || !strcmp(how, "both")) {
	if (enchant(&equipment[23].todam)) {
	  equipment[23].flags &= 0x7FFFFFFF;
	  py_bonuses(&blank_treasure,0);
	  failure = false;
	}
      }
      
      if (failure) {
	msg_print("It appears to be unaffected...");
      }
    }
  }
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean enchant_armor(char *how)
{
  integer  tmp[6+1];    //    : array [1..6] of integer;
  integer  i3,i4;
  vtype    out_val, out_val2;
  boolean  return_value = true;

  i3 = 0;
  i4 = 0;

  if (equipment[26].tval > 0) {
    i3 = i3 + 1;
    tmp[i3] = 26;
  }
  
  if (equipment[27].tval > 0) {
    i3 = i3 + 1;
    tmp[i3] = 27;
  }
  
  if (equipment[31].tval > 0) {
    i3 = i3 + 1;
    tmp[i3] = 31;
  }
  
  if (equipment[32].tval > 0) {
    i3 = i3 + 1;
    tmp[i3] = 32;
  }
  
  if (equipment[28].tval > 0) {
    i3 = i3 + 1;
    tmp[i3] = 28;
  }
  
  if (equipment[24].tval > 0) {
    i3 = i3 + 1;
    tmp[i3] = 24;
  }
  
  if (i3 > 0) { i4 = tmp[randint(i3)]; }

  if (strcmp(how, "curse")) {
    if        (uand(0x80000000,equipment[26].flags) != 0) {
      i4 = 26;
    } else if (uand(0x80000000,equipment[27].flags) != 0) {
      i4 = 27;
    } else if (uand(0x80000000,equipment[31].flags) != 0) {
      i4 = 31;
    } else if (uand(0x80000000,equipment[32].flags) != 0) {
      i4 = 32;
    } else if (uand(0x80000000,equipment[24].flags) != 0) {
      i4 = 24;
    } else if (uand(0x80000000,equipment[28].flags) != 0) {
      i4 = 28;
    }
  }

  if (i4 > 0) {
    //with equipment[i4]. do;
    if (!strcmp(how, "curse")) {
      temporary_slot = equipment[i3];
      objdes(out_val,i3,false,'e');
      sprintf(out_val2, "Your %s glows black, then fades.", out_val);
      msg_print(out_val2);
      equipment[i4].flags = 0x80000000;
      equipment[i4].toac = -randint(5) - randint(5);
      py_bonuses(&temporary_slot,-1);
    } else {
      objdes(out_val,i4,false,'e');
      sprintf(out_val2, "Your %s glows faintly!", out_val);
      msg_print(out_val2);
      if (enchant(&equipment[i4].toac)) {
	equipment[i4].flags &= 0x7FFFFFFF;
	py_bonuses(&blank_treasure,0);
      } else {
	msg_print("It appears unaffected...");
      }
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/* END FILE skills.c */
