/* store1.c */
/**/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void store_init()
{
  //{ Initializes the town stores with inventory }

  int  i2, i3;

  for (i2 = 1; i2 <= MAX_STORES ; i2++) {
    //with stores[i2]. do;
    stores[i2].owner      = 0;      //{owner is now a dummy value};
    stores[i2].insult_cur = 0;
    stores[i2].store_open = 0;
    stores[i2].store_ctr  = 0;

    for (i3=0; i3 <= STORE_INVEN_MAX; i3++) {
      stores[i2].store_inven[i3].sitem = blank_treasure;
      stores[i2].store_inven[i3].scost = 0;
    }
  }

} /* end store_init */


//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
static void sc__insert(integer store_num, integer pos, integer icost)
{
  /*{ Insert TEMPORARY_SLOT at given location }*/

  integer  i1;

  //with stores[store_num]. do;
  for (i1 = stores[store_num].store_ctr; i1 >= pos; i1--) {
    stores[store_num].store_inven[i1+1] = stores[store_num].store_inven[i1];
  }

  stores[store_num].store_inven[pos].sitem = temporary_slot;
  stores[store_num].store_inven[pos].scost = -icost;
  stores[store_num].store_ctr = stores[store_num].store_ctr + 1;
};
//////////////////////////////////////////////////////////////////////
void store_carry( integer store_num, integer *ipos)
{
  /*{ Add the item in TEMPORARY_SLOT to store's inventory. }*/

  integer  item_num,item_val,typ,subt,icost;
  boolean  flag;
                                        
  *ipos = 0;
  identify(&temporary_slot);
  unquote(temporary_slot.name);
  known1(temporary_slot.name);
  known2(temporary_slot.name);
  icost = sell_price(store_num, &temporary_slot);

  if (icost > 0) {

    //with temporary_slot. do;
    //with stores[store_num]. do;
    
    item_val = 0;
    flag = false;
    item_num = temporary_slot.number;
    typ      = temporary_slot.tval;
    subt     = temporary_slot.subval;
    
    do {
      item_val++;
      
      //with stores[store_num].store_inven[item_val].sitem. do;
      if (typ == stores[store_num].store_inven[item_val].sitem.tval) {
	
	if (subt == stores[store_num].store_inven[item_val].sitem.subval) { 
	  /*{ Adds to other item   }*/
	  if (subt > 255) {
	    if (stores[store_num].store_inven[item_val].sitem.number < 24) {
	      stores[store_num].store_inven[item_val].sitem.number += item_num;
	    }
	    flag = true;
	  }
	}
      } else if (typ > stores[store_num].store_inven[item_val].sitem.tval) {
	/*{ Insert into list }*/
	sc__insert(store_num,item_val,icost);
	flag = true;
	*ipos = item_val;
      }
    } while (! ((item_val >= stores[store_num].store_ctr) || (flag)));
    
    
    if (!flag) {
      /*{ Becomes last item in list }*/
      sc__insert(store_num,stores[store_num].store_ctr+1,icost);
      *ipos = stores[store_num].store_ctr;
    }
  }
};                    
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void do_black_market()
{
  /*{Add Black Market items to the inventory}*/

  integer indx,iptr,inven_num;

  inven_num = 0;
  stores[7].store_ctr = 0;

  while (inven_num < STORE_INVEN_MAX) {
    inven_num = 5 + randint(STORE_INVEN_MAX);
  }

  if (inven_num > STORE_INVEN_MAX) {
    inven_num = STORE_INVEN_MAX;
  }

  for (indx = 1; indx <= inven_num; indx++) {
    //with stores[7].store_inven[indx]. do;
    do {
      iptr = randint(inven_init_max);
      temporary_slot = inventory_init[iptr];
      magic_treasure(&temporary_slot,999); /*{special black magic}*/
    } while (temporary_slot.cost <= 500);
    store_carry(7,&iptr);
  }
  
  for (indx = inven_num; indx <= STORE_INVEN_MAX; indx++) {
    //with stores[7].store_inven[indx]. do;
    stores[7].store_inven[indx].sitem = blank_treasure;
  }

  stores[7].store_ctr = stores[7].store_ctr - 1;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer iv__search_list(integer x1, integer x2)
{
  integer i1,i2;

  i1 = 0;
  i2 = 0;

  do {
    i1 = i1 + 1;
    //with object_list[i1]. do;
    if ((object_list[i1].tval == x1) && (object_list[i1].subval == x2)) {
      i2 = object_list[i1].cost;
    }
  } while (! ((i1 == max_objects) || (i2 > 0)));

  return i2;
};
//////////////////////////////////////////////////////////////////////
integer item_value(treasure_type *item)
{
  /*{ Returns the value for any given object }*/
 
  integer return_value = 0;

  obj_set weapons_and_armor = {19,20,21,23,30,31,32,33,34,35,36};
  obj_set weapons_1         = {20,21,22,23};
  obj_set weapons_2         = {21,22,23};
  obj_set ammo_and_stuff    = {9,10,11,12,13,82,84};
  obj_set read_and_drink    = {70,71,75,76,80};
  obj_set ring_ring         = {40,45};
  obj_set wands_and_stuff   = {55,60,65};
 
  //with item-> do;
  return_value = item->cost;

  if (is_in(item->tval, weapons_and_armor)) {
    /*{ Weapons and armor }*/
    if (strchr(item->name,'^') != NULL) {
      return_value = iv__search_list(item->tval,item->subval)*item->number;
    } else if (is_in(item->tval, weapons_1)) {
      if (is_in(item->tval, weapons_2)) {
	return_value = (item->cost+(item->tohit+item->todam+item->toac)*100)*
	  item->number;
      } else {
	/*{armors}*/
	return_value = (item->cost+(item->tohit+item->toac)*100)*item->number;
      }
    } else {
      return_value = (item->cost+item->toac*100)*item->number;
    }
    
  } else if (is_in(item->tval, ammo_and_stuff)) {

    /*{ Ammo, Spikes, Thrown and Grenades }*/
    if (strchr(item->name,'^') != NULL) {
      return_value = iv__search_list(item->tval,1)*item->number;
    } else {
      return_value = (item->cost+(item->tohit+item->todam+item->toac)*10)*
	item->number;
    }

  } else if (is_in(item->tval, read_and_drink)) {

    /*{ Potions, Scrolls, and Food }*/
    if (strchr(item->name,'|') != NULL) {
      switch (item->tval) {
      case 70: case 71 : return_value =  20; break;
      case 75: case 76 : return_value =  20; break;
      case 80:           return_value =   1; break;
      default:                             break;
      }      
    }

  } else if (is_in(item->tval, ring_ring)) {

    /*{ Rings and amulets }*/
    if (strchr(item->name,'|') != NULL) {
      switch (item->tval) {
      case 40 : return_value = 45; break;
      case 45 : return_value = 45; break;
      default :                  break;

      }
    } else if (strchr(item->name,'^') != NULL) {
      return_value = abs(item->cost);
    }

  } else if (is_in(item->tval, wands_and_stuff)) {

    /*{ Wands rods, and staves}*/
    if (strchr(item->name,'|') != NULL) {
      switch (item->tval) {
      case 55 : return_value = 70; break;
      case 60 : return_value = 60; break;
      case 65 : return_value = 50; break;
      default :                   break;
      }
    } else if (strchr(item->name,'^') == NULL) {
      return_value = item->cost + trunc(item->cost/20.0)*item->p1;
    }
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
integer sell_price (integer snum, treasure_type *item)
{
  /*{ Asking price for an item }*/

  integer i1;
  integer return_value = 0;

  //with stores[snum]. do;
  i1 = item_value(item);

  if (item->cost > 0) {
    //with owners[snum][town_num]. do;
    i1 = i1 + trunc(i1*rgold_adj[owners[snum][town_num].owner_class][py.misc.pclass]);
    i1 = i1 + trunc(i1*(owners[snum][town_num].buy_inflate));
    if (i1 < 1) {
      i1 = 1;
    }
    return_value = i1;

  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean store_check_num(integer store_num)
{
  /*{ Check to see if he will be carrying too many objects }*/

  integer   i1;
  boolean   return_value = false;

  //with stores[store_num]. do;
  if (stores[store_num].store_ctr < STORE_INVEN_MAX) {
    return_value = true;
  } else {
    if ((temporary_slot.subval > 255) &&
	(temporary_slot.subval < 512)) {
      for (i1 = 1; i1 <= stores[store_num].store_ctr; i1++) {
	//with stores[store_num].store_inven[i1].sitem. do;
	if (stores[store_num].store_inven[i1].sitem.tval == 
	    temporary_slot.tval) {
	  if (stores[store_num].store_inven[i1].sitem.subval == 
	      temporary_slot.subval) {
	    return_value = true;
	  }
	}
      }
    }
  }
  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void store_create(integer store_num)
{
  /*{ Creates an item and inserts it into store's inven }*/

  integer  i1,tries,dummy;

  tries = 0;
  //with stores[store_num]. do;

  do {
    i1 = store_choice[store_num][randint(STORE_CHOICES)];
    temporary_slot = inventory_init[i1];
    magic_treasure(&temporary_slot,OBJ_TOWN_LEVEL);
    if (store_check_num(store_num)) {
      //with temporary_slot do;
      if (temporary_slot.cost > 0) {    /*{ Item must be good }*/
	store_carry(store_num, &dummy);
	tries = 10;
      }
    }
    tries++;
  } while (tries <= 3);
};                    
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void store_destroy(integer store_num, integer item_val, boolean one_of)
{
  /*
    { Destroy an item in the store's inventory.
    Note that if 'one_of' is false, an entire slot is destroyed }
  */

  integer   i2, store_ctr;

  //with stores[store_num] do;
  temporary_slot = stores[store_num].store_inven[item_val].sitem;
  //with stores[store_num].store_inven[item_val].sitem do;
  if ((stores[store_num].store_inven[item_val].sitem.number > 1) && 
      (stores[store_num].store_inven[item_val].sitem.subval < 512) &&
      (one_of)) {
    temporary_slot.number = 1;
    stores[store_num].store_inven[item_val].sitem.number--;
  } else {
    store_ctr = stores[store_num].store_ctr;
    for (i2 = item_val; i2 < store_ctr; i2++) {
      stores[store_num].store_inven[i2] = stores[store_num].store_inven[i2+1];
    }
    stores[store_num].store_inven[store_ctr].sitem = blank_treasure;
    stores[store_num].store_inven[store_ctr].scost = 0;
    stores[store_num].store_ctr--;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void store_maint()
{
  /*
    { Rotate stock, create sales, and up-keep the store's inventory. }
    { Remember Doofus, that this procedure only works when there's a }
    { dungeon floor in existance.}
  */
  
  integer  i1,i2,i3,i4,cnt,store_ctr;

  do_black_market();

  for (i1 = 1; i1 <= MAX_STORES; i1++) {
    if (i1 != 7) {
      //with stores[i1]. do;

      /*{ On Sale! }*/
      store_ctr = stores[i1].store_ctr;
      for (i3 = 1; i3 <= store_ctr; i3++) {
	if (randint(10) == 1) {
	  //with stores[i1].store_inven[i3]. do;
	  i4 = abs(trunc(stores[i1].store_inven[i3].scost*SALE_VAL));
	  if (i4 < 1) { i4 = 1; }
	  stores[i1].store_inven[i3].scost = i4; 
	  stores[i1].store_inven[i3].sitem.cost = i4;
	}
      }
      
      /*{ Maint. }*/
      stores[i1].insult_cur = 0;
      store_ctr = stores[i1].store_ctr;
      if (store_ctr > STORE_MAX_INVEN) {
	/* too much stuff */
	for (i2=0 , cnt=(store_ctr-STORE_MAX_INVEN+2); i2 < cnt; i2++) {
	  store_destroy(i1,randint(stores[i1].store_ctr),false);
	}
      } else if (store_ctr < STORE_MIN_INVEN) {
	/* make new stuff */
	for (i2=0 , cnt=(STORE_MIN_INVEN-store_ctr+2); i2 < cnt; i2++) {
	  store_create(i1);
	}
      } else {
	/* make some, ruin some */
	for (i2=0 , cnt=(1+randint(STORE_TURN_AROUND)); i2 < cnt; i2++) {
	  store_destroy(i1,randint(stores[i1].store_ctr),true);
	}
	for (i2=0 , cnt=(1+randint(STORE_TURN_AROUND)); i2 < cnt; i2++) {
	  store_create(i1);
	}
      }	     	     
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE store1.c */
