/* tech.c */
/*{ Throw a magic spell }*/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void tech_effects(integer effect, integer y, integer x)
{
  integer dir, dumy, y_dumy, x_dumy;

  y_dumy = y;
  x_dumy = x;

  switch (effect) {
  case 1  :  
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_bolt(0,dir,char_row,char_col,damroll("2d6")+1,"Energy Bolt");
    }
    break;
    
  case 2  :  detect_monsters();
    break;
    
  case 3  :  teleport(10);
    break;
    
  case 4  :  light_area(char_row,char_col);
    break;
    
  case 5  :  hp_player(damroll("4d4"),"a magic spell.");
    break;
    
  case 6  :
    detect_sdoor();
    detect_trap();
    break;
    
  case 7  :  
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_ball(2,dir,char_row,char_col,9,2,false,"Poison Gas");
    }
    break;

  case 8  : 
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      confuse_monster(dir,char_row,char_col);
    }
    break;

    case 9 : 
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_bolt(1,dir,char_row,char_col,damroll("3d8")+1,"Electric Shock");
    }
    break;

    case 10 :  td_destroy();
    break;

   case 11 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      sleep_monster(dir,char_row,char_col);
    }
    break;

    case 12 :  cure_poison();
    break;

    case 13 :  teleport(py.misc.lev*5);
    break;

    case 14 :  remove_curse();
    break;

    case 15 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_bolt(4,dir,char_row,char_col,damroll("4d8")+1,"Killer Snowball");
    }
    break;

    case 16 :  
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      wall_to_mud(dir,char_row,char_col);
    }
    break;

    case 17 :  ident_spell();
    break;

    case 18 :  recharge(20);
    break;

    case 19 :  sleep_monsters2_3(char_row,char_col,1);
    break;

    case 20 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      poly_monster(dir,char_row,char_col);
    }
    break;

    case 21 :  create_food();
    break;

    case 22 :  sleep_monsters2_3(char_row,char_col,20);
    break;

    case 23 :
      if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
	fire_bolt(5,dir,char_row,char_col,damroll("6d8")+1,"Flame-Thrower");
      }
    break;

    case 24 :
      if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
	speed_monster(dir,char_row,char_col,-1);
      }
    break;

    case 25 :  py.flags.ring_blast = 10; /*{Ring of Frost}*/
    break;

    case 26 :
      if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
	fire_ball(4,dir,char_row,char_col,
		  damroll("6d6")+1,2,false,"Frost Ball");
      }
    break;

  case 27 :  recharge(50);
    break;

  case 28 :
      if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
	teleport_monster(dir,char_row,char_col);
      }
    break;

  case 29 :
    //with py.flags do
    PF.fast += randint(20) + py.misc.lev;
    break;

  case 30 :  py.flags.ring_blast = 9; /*{Ring of Fire}*/
    break;

  case 31 :
      if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
	fire_ball(5,dir,char_row,char_col,
		  damroll("7d7")+1,2,false,"Fire Ball");
      }
    break;

    case 32 :  destroy_area(char_row,char_col);
    break;

    case 33 :  genocide();
    break;

  default:
    break;
  }
};
//////////////////////////////////////////////////////////////////////
void use_tech_skills()
{
  integer   i1,i2,item_val;
  integer   choice,chance;
  integer   y_dumy,x_dumy;
  boolean   redraw;
  obj_set   techies = {1,2,7};
  obj_set   manuals = {90};

  reset_flag = true;  /* have not actually cast anything yet */

  if (py.flags.blind > 0) {
    msg_print("You can't see to read your tech manual!");
  } else if (no_light()) {
    msg_print("You have no light to read by.");
  } else if (py.flags.confused > 0) {
    msg_print("You are too confused...");
  } else if (is_in(py.misc.pskill, techies)) {
    if (inven_ctr > 0) {
      if (find_range(manuals,&i1,&i2)) {
        redraw = false;
        if (get_item(&item_val,"Use which tech manual?",
                     &redraw,i1,i2)) {
          if (use_skill("Do which skill?",item_val,
                        &choice,&chance,&redraw)) {
	    if (redraw) { draw_cave(); redraw = false; }
            //with skill_list[choice]. do;
            reset_flag = false;
            if (randint(100) < chance) {
              msg_print("You failed to perform the skill!");
            } else {
              y_dumy = char_row;
              x_dumy = char_col;
              tech_effects(choice, y_dumy, x_dumy);
              if (!reset_flag) {
                //with py.misc do;
                PM.exp += skill_list[choice].sexp;
                prt_experience();
                skill_list[choice].sexp = 0;
              }
            }
            //with py.misc do;
            if (!reset_flag) {
              if (skill_list[choice].smana > PM.cmana) {
                msg_print("You faint from the effort!");
                py.flags.paralysis = 
                  randint(5*trunc(skill_list[choice].smana-PM.cmana));
                PM.cmana = 0;
                if (randint(3) == 1) {
                  msg_print("You have damaged your health!");
                  py.stat.ccon = de_statp(py.stat.ccon);
                  prt_constitution();
                }
              } else {
                PM.cmana -= skill_list[choice].smana;
              }
              prt_mana();
            }

            if (randint(10) == 1) {
              reset_flag = true;
            }
	  }
	}
	if (redraw) { draw_cave(); }
      } else {
        msg_print("But you are not carrying any tech manuals!");
      }
    } else {
      msg_print("But you are not carrying any tech manuals!");
    }
  } else {
    msg_print("Invalid Command.");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE tech.c */
