/* train.c */
/* Special training within stores. Or get a job! */

#include "boss.h"
#include "main.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
char get_training_option()
{
  char     option, command;
  boolean  exit_flag;
       
  prt_num("Dollars Remaining : ",py.misc.au,19,23);
  prt("You may:",21,6);
  prt("  p) Pay for Option.               space) Browse options.",22,6);
  prt(" ^Z) Exit.                            ^R) Redraw the screen.",23,6);

  do {
    if (get_com("!",&command)) {
      msg_flag = false;
      switch (command) {
      case 18  :
	break;
	
      case 32  :
	prt("All options are shown.",1,1);
	break;
	
      case 112  :
	prt("What would you like?",1,1);
	exit_flag = get_com("!",&option);
	break;
	
      default:
	prt("Invalid Command.",1,1);
	break;
      }
    } else {
      exit_flag = true;      
    }
  } while (!exit_flag);
  
  return option;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void ltrain()
{
  integer  oa,ob,oc;
  char    *too_poor;       
  
  /*{set prices}*/
  oa = py.misc.stl*100;
  ob = (py.misc.perc)*10;
  oc = 20*py.stat.ccon*py.stat.ccon;
  
  too_poor = "You cannot afford such professional services.";
  prt("Welcome to the Survivalist Union",3,20);
  prt(" How can we assist you?",5,1);        prt("   Your Price:",5,61);
  prt(" a) Increase Stealth Skill",7,1);     prt_num("",oa,7,66);
  prt(" b) Increase Perception Skill",8,1);  prt_num("",ob,8,66);
  prt(" c) Increase Constitution",9,1);      prt_num("",oc,9,66);
  
  switch (get_training_option()) { /*{97-99}*/
  case 97: 
    if (py.misc.au < oa) {
      msg_print(too_poor);
    } else {
      msg_print("You suffer hours of intensive games of hide and seek.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oa;
      py.flags.food = py.flags.food - 3000;          
      py.misc.stl = py.misc.stl + 1;
    }
    break;
    
  case 98: 
    if (py.misc.au < ob) {
      msg_print(too_poor);
    } else {
      msg_print("You spend hours doing intensive word search puzzles.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - ob;
      py.flags.food = py.flags.food - 3000;          
      py.misc.perc = py.misc.perc + 5 + randint(5);
    }
    break;
    
  case 99: 
    if (py.misc.au < oc) {
      msg_print(too_poor);
    } else {
      msg_print("You do aerobic exercises and practice swallowing poisons.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oc;
      py.flags.food = py.flags.food - 3000;          
      py.stat.ccon = in_statt(py.stat.ccon);
      if (py.stat.ccon > py.stat.con) {
	py.stat.con = py.stat.ccon;
      }
    }
    break;
    
  default:
    turn = turn + 12;
    break;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void wtrain()
{
  integer  oa,ob,oc;
  char    *too_poor;       
  
  /*{set prices}*/
  oa = py.misc.bth*10;
  ob = py.misc.bthb*10;
  oc = 20*py.stat.cstr*py.stat.cstr;
  
  too_poor = "You cannot afford our physical training.";
  prt("Welcome to the Soldier of Fortune Outpost",3,15);
  prt(" How can we assist you?",5,1);    prt("   Your Price:",5,61);
  prt(" a) Increase Melee Skill",7,1);   prt_num("",oa,7,66);
  prt(" b) Increase Gun Skill",8,1);     prt_num("",ob,8,66);
  prt(" c) Increase Strength",9,1);      prt_num("",oc,9,66);
  
  switch (get_training_option()) { /*{97-99}*/
  case 97: 
    if (py.misc.au < oa) {
      msg_print(too_poor);
    } else {
      msg_print("You endure hours of hand to hand training.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oa;
      py.flags.food = py.flags.food - 3000;          
      py.misc.bth = py.misc.bth + 5 + randint(5);
    }
    break;
    
  case 98: 
    if (py.misc.au < ob) {
      msg_print(too_poor);
    } else {
      msg_print("You endure hours of ranged weapon training.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - ob;
      py.flags.food = py.flags.food - 3000;          
      py.misc.bthb = py.misc.bthb + 5 + randint(5);
    }
    break;
    
  case 99: 
    if (py.misc.au < oc) {
      msg_print(too_poor);
    } else {
      msg_print("You lift weights under skilled supervision.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oc;
      py.flags.food = py.flags.food - 3000;          
      py.stat.cstr = in_statt(py.stat.cstr);
      if (py.stat.cstr > py.stat.str) {
	py.stat.str = py.stat.cstr;
      }
    }
    break;
    
  default:
    turn = turn + 12;
    break;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void ttrain()
{
  integer  oa,ob,oc;
  char    *too_poor;       
  
  /*{set prices}*/
  oa = py.misc.save*10;
  if (py.misc.pclass == 2 || py.misc.pclass == 5) {
    ob = py.misc.lev*600;
  } else {
    ob = py.misc.lev*1000;
  }
  oc = 20*py.stat.cwis*py.stat.cwis;
  
  too_poor = "Sorry, but you must donate more money than you are carrying.";
  prt("Welcome to the Illustrious All-Knowing Club",3,15);
  prt(" How may we aid you?",5,1);    prt("   Your Price:",5,61);
  prt(" a) Increase Saving Throw",7,1);  prt_num("",oa,7,66);
  prt(" b) Increase Resources",8,1);     prt_num("",ob,8,66);
  prt(" c) Increase Wisdom",9,1);        prt_num("",oc,9,66);
  
  switch (get_training_option()) { /*{97-99}*/
  case 97: 
    if (py.misc.au < oa) {
      msg_print(too_poor);
    } else {
      msg_print("You study the mystical arts of avoiding pain.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oa;
      py.flags.food = py.flags.food - 3000;          
      py.misc.save = py.misc.save + 5 + randint(5);
    }
    break;
    
  case 98: 
    if (py.misc.au < ob) {
      msg_print(too_poor);
    } else if (py.misc.pclass == 0 || py.misc.pclass == 3) {
      msg_print("You don't use resources!  How unresourceful.");
    } else {
      
      msg_print("You learn a few ways to conserve your resources.");
      turn = turn + 720;
      py.misc.au = py.misc.au - ob;
      py.flags.food = py.flags.food - 700;           
      py.misc.mana = py.misc.mana + 1 + wis_adj();
    }
    break;
    
  case 99: 
    if (py.misc.au < oc) {
      msg_print(too_poor);
    } else {
      msg_print("You spend hours studying all sorts of theology books.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oc;
      py.flags.food = py.flags.food - 3000;          
      py.stat.cwis = in_statt(py.stat.cwis);
      if (py.stat.cwis > py.stat.wis) {
	py.stat.wis = py.stat.cwis;
      }
    }
    break;
    
  default:
    turn = turn + 12;
    break;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void dtrain()
{
  integer  i3,oa,ob,oc,od;
  char    *too_poor;
  
  /*{set price on options}*/
  oa = trunc(1000*(py.misc.mhp/py.misc.hitdie));
  ob = (py.flags.see_infra + 1)*100;
  oc = 20*py.stat.cchr*py.stat.cchr;
  od = 500;
  
  too_poor = "You cannot afford our chemical talents.";
  prt("Welcome to the Secret Society of Chemists",3,15);
  prt(" How can we help you?",5,1);   prt("   Your Price:",5,61);
  prt(" a) Increase Hit Points",7,1);    prt_num("",oa,7,66);
  prt(" b) Increase Infra-Vision",8,1);  prt_num("",ob,8,66);
  prt(" c) Increase Charisma",9,1);      prt_num("",oc,9,66);
  prt(" d) Sex Change",10,1);            prt_num("",od,10,66);
  
  switch (get_training_option()) {  /*{97-100}*/
  case 97: 
    if (py.misc.au < oa) {
      msg_print(too_poor);
    } else {
      msg_print("You are bathed in a juicy mixture.");
      msg_print("");
      turn = turn + 360;
      //with py.misc do;
      PM.au -= oa;
      i3 = get_hitdie();
      PM.chp += i3;       PM.mhp += i3;
    }
    break;
    
  case 98: 
    if (py.misc.au < ob) {
      msg_print(too_poor);
    } else {
      msg_print("Strange chemicals are squirted into your eyes.");
      msg_print("");
      turn = turn + 120;
      py.misc.au = py.misc.au - ob;
      py.flags.see_infra = py.flags.see_infra + 1;            
    }
    break;
    
  case 99: 
    if (py.misc.au < oc) {
      msg_print(too_poor);
    } else {
      msg_print("You are given several skin treatments and");
      msg_print("taught a few social graces.");
      msg_print("");
      turn = turn + 2160;
      py.misc.au = py.misc.au - oc;
      py.flags.food = py.flags.food - 3000;
      py.stat.cchr = in_statt(py.stat.cchr);               
      if (py.stat.cchr > py.stat.chr) {
	py.stat.chr = py.stat.cchr;
      }
    }
    break;
    
  case 100: 
    if (py.misc.au < od) {
      msg_print(too_poor);
    } else if (strcmp(PM.sex, "Male") && strcmp(PM.sex, "Female")) {
      msg_print("Ummm, there is nothing they can do for you.  Sorry.");
    } else {
      msg_print("The Chemists lock you in a dark closet for hours...");
      msg_print("");
      turn = turn + 2880;
      py.flags.food = py.flags.food - 2880;
      //with py.misc do;
      if (randint(10) == 10) {
	strcpy(PM.sex, "Neuter");
	msg_print("A horrible thing has happened!  The Chemists refund your money.");
	msg_print("");
      } else {
	PM.au -= od;
	if (!strcmp(PM.sex, "Male")) {
	  strcpy(PM.sex, "Female");
	} else {
	  strcpy(PM.sex, "Male");
	}
      }
    }
    break;
    
  default:
    turn = turn + 12;
    break;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void atrain()
{
  integer  oa,ob,oc;
  char    *too_poor;       
  
  oa = py.misc.wierd*10;
  if (py.misc.pclass == 1 || py.misc.pclass == 4) {
    ob = py.misc.lev*600;
  } else {
    ob = py.misc.lev*1000;
  }
  oc = 20*py.stat.cint*py.stat.cint;
  
  too_poor = "You are too poor for us to help you.  Where is your money?";
  prt("Welcome to the Academy of Unknown Sciences",3,15);
  prt(" Shall we assist you?",5,1);      prt("   Your Price:",5,61);
  prt(" a) Increase Wierd Device",7,1);  prt_num("",oa,7,66);
  prt(" b) Increase Resources",8,1);     prt_num("",ob,8,66);
  prt(" c) Increase Intellegence",9,1);  prt_num("",oc,9,66);
  
  switch (get_training_option()) { /*{97-99}*/
  case 97: 
    if (py.misc.au < oa) {
      msg_print(too_poor);
    } else {
      msg_print("You play around with a few strange thingies.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oa;
      py.flags.food = py.flags.food - 3000;          
      py.misc.wierd = py.misc.wierd + 5 + randint(5);
    }
    break;
    
  case 98: 
    if (py.misc.au < ob) {
      msg_print(too_poor);
    } else if (py.misc.pclass == 0 || py.misc.pclass == 3) {
      msg_print("You don't use resources!  How unresourceful.");
    } else {
      msg_print("You learn a few ways to conserve your resources.");
      turn = turn + 720;
      py.misc.au = py.misc.au - ob;
      py.flags.food = py.flags.food - 700;           
      py.misc.mana = py.misc.mana + 1 + int_adj();
    }
    break;
    
  case 99: 
    if (py.misc.au < oc) {
      msg_print(too_poor);
    } else {
      msg_print("You study your brains out and learn more about llamas.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oc;
      py.flags.food = py.flags.food - 3000;          
      py.stat.cint = in_statt(py.stat.cint);
      if (py.stat.cint > py.stat.int_) {
	py.stat.int_ = py.stat.cint;
      }
    }
    break;
    
  default:
    turn = turn + 12;
    break;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void gtrain()
{
  integer  oa,ob,oc;
  char    *too_poor;       
  
  /*{set prices}*/
  oa = py.misc.disarm*10;
  if (py.misc.pclass == 6 || py.misc.pclass == 7) {
    ob = py.misc.lev*600;
  } else {
    ob = py.misc.lev*1000;
  }
  oc = 20*py.stat.cdex*py.stat.cdex;
  
  too_poor = "We can't afford to help charity cases like you.";
  prt("Welcome to the Guild of Honest Citizens",3,15);
  prt(" What can we do for you?",5,1);    prt("   Your Price:",5,61);
  prt(" a) Increase Disarming Skill",7,1);  prt_num("",oa,7,66);
  prt(" b) Increase Resources",8,1);     prt_num("",ob,8,66);
  prt(" c) Increase Dexterity",9,1);     prt_num("",oc,9,66);
  
  switch (get_training_option()) { /*{97-99}*/
  case 97: 
    if (py.misc.au < oa) {
      msg_print(too_poor);
    } else {
      msg_print("You carefully experiment with dangerous mousetraps.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oa;
      py.flags.food = py.flags.food - 3000;          
      py.misc.disarm = py.misc.disarm + 5 + randint(5);
    }
    break;
    
  case 98: 
    if (py.misc.au < ob) {
      msg_print(too_poor);
    } else if (py.misc.pclass == 0 || py.misc.pclass == 3) {
      msg_print("You don't use resources!  How unresourceful.");
    } else {
      msg_print("You learn a few ways to conserve your resources.");
      turn = turn + 720;
      py.misc.au = py.misc.au - ob;
      py.flags.food = py.flags.food - 700;           
      py.misc.mana = py.misc.mana + 1 + chr_adj();
    }
    break;
    
  case 99: 
    if (py.misc.au < oc) {
      msg_print(too_poor);
    } else {
      msg_print("You spend a few hours juggling and throwing darts.");
      turn = turn + 2880;
      py.misc.au = py.misc.au - oc;
      py.flags.food = py.flags.food - 3000;          
      py.stat.cdex = in_statt(py.stat.cdex);
      if (py.stat.cdex > py.stat.dex) {
	py.stat.dex = py.stat.cdex;
      }
    }
    break;
    
  default:
    turn = turn + 12;
    break;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void training(integer store_num)
{
  integer   i5;

  i5 = turn;
  clear_from(1);
  switch (store_num) {
  case 2:   ltrain(); break;
  case 3:   wtrain(); break;
  case 4:   ttrain(); break;
  case 5:   dtrain(); break;
  case 6:   atrain(); break;
  case 11:  gtrain(); break;
  default:  
    msg_print("You find no trainers here.  Try a different store."); break;
  }

  if (py.flags.food < 650) { py.flags.food = 650; }

  if ((i5 <  4320) && (turn >  4320)) { moria_flag = true; }
  if ((i5 < 12960) && (turn > 12960)) { moria_flag = true; }
  if (turn > 17280) {
    midnight();
  }
  msg_print("");
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean get_job_option(char *option)
{
  char     command;
  boolean  exit_flag    = false;
  boolean  return_value = false;
       
  prt_num("Dollars Remaining : ",py.misc.au,19,23);
  prt("You may:",21,1);
  prt("  p) Pick a part time job.         space) Browse options.",22,6);
  prt(" ^Z) Exit.                            ^R) Redraw the screen.",23,6);

  do {
    if (get_com("!",&command)) {
      msg_flag = false;
      switch (com_val) {
      case 18  :
	break;
	
      case 32  :
	prt("All jobs are shown.",1,1);
	break;
	
      case 112  :
	prt("Which would you like?",1,1);
	exit_flag = get_com("!",option);
	if ((*option < 49) || (*option > 57)) {
	  exit_flag = false;
	} else {
	  return_value = true;
	}
	break;

      default:
	prt("Invalid Command.",1,1);
	break;
      }
    } else {
      exit_flag = true;      
    }

  } while (!exit_flag);

  return return_value;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void get_job()
{
  char     option;
  integer  qualified;
  integer  i1,i3,i4;

  qualified = (py.misc.lev div 4) + 2;
  clear_from(1);
  prt("Blue Fish Temporary Hiring Services, Inc.",3,16);
  prt(" List of Jobs Available:",5,1);    prt("   Hourly Wage:",5,61);
  
  for (i1 = 1; i1 <= 9; i1++) {
    prt_num("  ",i1,i1+6,1);
    prt(")",i1+6,4);
    prt(joblist[i1],i1+6,5);
    prt_num("$",jobwage[i1],i1+6,66);
  }

  if (get_job_option(&option)) {
    i3 = option - 48; /*{1-9}*/
  }

  if (i3 > qualified) {
    msg_print("You are not qualified for that job.");
  } else {
    msg_print("You endure several hours of work");
    turn += 5760;

    i4 = randint(100);

    switch (i3) {
    case 1: 
      if (i4 > 95) {
	msg_print("You lose a finger in the disposal machine");
	py.stat.cdex = de_statt(py.stat.cdex);
      } else if (i4 > 80) {
	msg_print("You find a missing earring and are rewarded!"); 
	py.misc.au += 20;
      }
      break;

    case 2: 
      if (i4 > 90) {
	msg_print("You are steamed badly and your health declines.");
	py.stat.ccon = de_statt(py.stat.ccon);
      } else if (i4 > 80) {
	msg_print("Your determination earns you a pay bonus!"); 
	py.misc.au += 30;
      }
      break;

    case 3: 
      if (i4 > 95) {
	msg_print("You take the wrong elevator out!");
	dun_level = 2;
      } else if (i4 > 90) {
	msg_print("A wealty couple gives you a *big* tip!");
	py.misc.au += 50;
      }
      break;

    default:
      break;
    }

    py.misc.au    += (jobwage[i3]*8);
    py.flags.food -= 5760;
    zero_pyflag();
  }
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/* END FILE train.c */
