/* traps.c */
/**/

#include "boss.h"
#include "main.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void change_trap(integer y,integer x)
{
  /*{ Change a trap from invisible to visible               -RAK-   }*/
  /*{ Note: Secret doors are handled here                           }*/

  integer   i3;
  //  obj_set   little_things = {Unseen_trap,Secret_door,0};
  obj_set   little_things = {101,109,0};

  //with cave[y][x]. do;
  if (is_in(t_list[cave[y][x].tptr].tval, little_things)) {
    i3 = cave[y][x].tptr;
    place_trap(y,x,2,t_list[i3].subval);
    pusht(i3);
    lite_spot(y,x);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void chest_trap(integer y, integer x)
{
  /*
    { Chests have traps too.
    Note: Chest traps are based on the FLAGS value }
  */

  integer   i1,i2,i3;
  unsigned  flags;

  //with t_list[cave[y][x].tptr]. do;
  flags = t_list[cave[y][x].tptr].flags;

  if (uand(0x00000010,flags) != 0) {
    msg_print("A small needle has pricked you!");
    if (!py.flags.sustain_str) {
      py.stat.cstr = de_statp(py.stat.cstr);
      take_hit(damroll("1d4"),"a poison needle.");
      print_stat = uor(0x0001,print_stat);
      msg_print("You feel weakened!");
    } else {
      msg_print("You are unaffected.");
    }
  }
  
  if (uand(0x00000020,flags) != 0) {
    msg_print("A small needle has pricked you!");
    take_hit(damroll("1d6"),"a poison needle.");
    py.flags.poisoned = py.flags.poisoned + 10 + randint(20);
    Opusii_vomit(20);
  }
  
  if (uand(0x00000040,flags) != 0) {
    msg_print("A puff of yellow gas surrounds you!");
    if (py.flags.free_act) {
      msg_print("You are unaffected.");
    } else {
      msg_print("You choke and pass out.");
      py.flags.paralysis = 10 + randint(20);
    }
  }
  
  if (uand(0x00000080,flags) != 0) {
    msg_print("There is a sudden explosion!");
    explosion(0,y,x,damroll("3d8"),3,true,"an exploding chest.");
    delete_object(y,x);
  }
  
  if (uand(0x00000100,flags) != 0) {
    for (i1 = 1; i1 <= 3; i1++) {
      i2 = y;
      i3 = x;
      summon_monster(&i2,&i3,false);
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void hit_trap(integer *y, integer *x)
{
  /*{ Player hit a trap...  (Chuckle)}*/

  integer  i1,ty,tx,dam;
 
  change_trap(*y,*x);
  lite_spot(char_row,char_col);
  find_flag = false;

  //with cave[*y][*x]. do;
  //with py.misc. do;

  dam = damroll(t_list[cave[*y][*x].tptr].damage);

  switch (t_list[cave[*y][*x].tptr].subval) {
//////////////////////////////////////////////////////////////////////
  case 1 :  /*{ Open pit}*/
    msg_print("You fell into a pit!");
    if (py.flags.ffall) {
      msg_print("You gently float down.");
    } else {
      take_hit(dam,"an open pit.");
    }
    break;
//////////////////////////////////////////////////////////////////////
  case 2 : /*{ Arrow trap}*/
    if (test_hit(125,0,0,PM.pac+PM.ptoac)) {
      take_hit(dam,"an arrow trap.");
      msg_print("An arrow hits you.");
    } else {
      msg_print("An arrow barely misses you.");
    }
    break;
//////////////////////////////////////////////////////////////////////
  case 3 :  /*{ Covered pit}*/
    msg_print("You fell into a covered pit.");
    if (py.flags.ffall) {
      msg_print("You gently float down.");
    } else {
      take_hit(dam,"a covered pit.");
    }
    place_trap(*y,*x,2,1);
    break;
//////////////////////////////////////////////////////////////////////
  case 4 :  /*{ Trap door}*/
    msg_print("You fell through a trap door!");
    msg_print(" ");
    moria_flag = true;
    dun_level++;
    if (dun_level > townlist[town_num].max_depth) {
      dun_level = townlist[town_num].max_depth;
    }
    if (py.flags.ffall) {
      msg_print("You gently float down.");
    } else {
      take_hit(dam,"a trap door.");
    }
    break;
//////////////////////////////////////////////////////////////////////
  case 5 :  /*{ Sleep gas}*/
    if (py.flags.paralysis == 0) {
      msg_print("A strange white mist surrounds you!");
      if (py.flags.free_act) {
	msg_print("You are unaffected.");
      } else {
	msg_print("You fall asleep.");
	py.flags.paralysis += randint(10) + 4;
      }
    }
    break;
//////////////////////////////////////////////////////////////////////
  case 6 :  /*{ Hid Obj}*/
    cave[*y][*x].fm = false;
    pusht(cave[*y][*x].tptr);
    place_object(*y,*x);
    msg_print("Hey, there was something under this rock.");
    break;
//////////////////////////////////////////////////////////////////////
  case 7 :  /* { STR Dart}*/
    if (test_hit(125,0,0,PM.pac+PM.ptoac)) {
      if (! py.flags.sustain_str) {
	py.stat.cstr = de_statp(py.stat.cstr);
	take_hit(dam,"a dart trap.");
	print_stat |= 0x0001;
	msg_print("A small dart weakens you!");
      } else {
	msg_print("A small dart hits you.");
      }
    } else {
      msg_print("A small dart barely misses you.");
    }
    break;
//////////////////////////////////////////////////////////////////////
  case 8 :  /*{ Teleport}*/
    teleport_flag = true;
    msg_print("You hit a teleport trap!");
    break;
//////////////////////////////////////////////////////////////////////
  case 9 :  /*{ Rockfall}*/
    take_hit(dam,"falling rock.");
    pusht(cave[*y][*x].tptr);
    place_rubble(*y,*x);
    msg_print("You are hit by falling rock");
    break;
//////////////////////////////////////////////////////////////////////
  case 10: /*{ Corrode gas}*/
    corrode_gas(randint(8), "corrosion gas.");
    msg_print("A strange red gas surrounds you.");
    break;
//////////////////////////////////////////////////////////////////////
  case 11:  /*{ Summon mon}*/
    cave[*y][*x].fm = false;  /*{ Rune disappears...}*/
    pusht(cave[*y][*x].tptr);
    cave[*y][*x].tptr = 0;
    for (i1 = 1; i1 <= (2+randint(3)); i1++) {
      ty = char_row;
      tx = char_col;
      summon_monster(&ty,&tx,false);
    }
    break;
//////////////////////////////////////////////////////////////////////
  case 12:  /*{ Fire trap}*/
    explosion(5,char_row,char_col,dam,2,true,"a fire trap.");
    msg_print("You are enveloped in flames!");
    break;
//////////////////////////////////////////////////////////////////////
  case 13:  /*{ Acid trap}*/
    explosion(3,char_row,char_col,dam,2,true,"an acid trap.");
    msg_print("You are splashed with acid!");
    break;
//////////////////////////////////////////////////////////////////////
  case 14:  /*{ Poison gas}*/
    explosion(2,char_row,char_col,dam,2,true,"a poison gas trap.");
    msg_print("A pungent green gas surrounds you!");
    Opusii_vomit(5);
    break;
//////////////////////////////////////////////////////////////////////
  case 15:  /*{ Blind Gas }*/
    msg_print("A black gas surrounds you!");
    //with py.flags do;
    PF.blind += randint(50) + 50;
    break;
//////////////////////////////////////////////////////////////////////
  case 16:  /*{ H-Bomb }*/
    explosion(0,char_row,char_col,dam,5,true,"a bomb.");
    msg_print("You have set off a bomb!");
    //with py.flags do;
    PF.blind    += 1 + randint(10);
    PF.confused += 5 + randint(10);
    break;
//////////////////////////////////////////////////////////////////////
  case 17:  /*{ Slow Dart}*/
    if (test_hit(125,0,0,PM.pac+PM.ptoac)) {
      take_hit(dam,"a dart trap.");
      msg_print("A small dart hits you!");
      //with py.flags do;
      PF.slow += randint(20) + 10;
    } else {
      msg_print("A small dart barely misses you.");
    }
    break;
//////////////////////////////////////////////////////////////////////
  case 18:  /*{ CON Dart}*/
    if (test_hit(125,0,0,PM.pac+PM.ptoac)) {
      if (! py.flags.sustain_con) {
	py.stat.ccon = de_statp(py.stat.ccon);
	take_hit(dam,"a dart trap.");
	print_stat |= 0x0004;
	msg_print("A small dart weakens you!");
      } else {
	msg_print("A small dart hits you.");
      }
    } else {
      msg_print("A small dart barely misses you.");
    }
    break;
//////////////////////////////////////////////////////////////////////
  case 19:  /*{Secret Door}*/
    break;
//////////////////////////////////////////////////////////////////////
  case 20:  /*{Teleport levels}*/
    msg_print("You have a strange feeling...");
    msg_print("You slip into unconsciousness...");
    PF.paralysis |= 4 + randint(4);
    msg_print("You wake up confused.");
    PF.confused += 10 + randint(20);
    switch (randint(6)) {
    case 1:         dun_level +=  5; break;
    case 2: case 3: dun_level +=  2; break;
    case 4: case 5: dun_level -=  2; break;
    case 6:         dun_level -=  5; break;
    }
    
    if (dun_level<0) { dun_level = 0 ; }
    if (dun_level>townlist[town_num].max_depth) {
      dun_level = townlist[town_num].max_depth;
    }
    moria_flag = true;
    break;
//////////////////////////////////////////////////////////////////////
  case 99:  /*{Scare Mon}*/
    break;
//////////////////////////////////////////////////////////////////////
 
    /*{Town level traps are special, the stores.}*/
  case 101: enter_store( 1); break;   /*{ K-Mart        }*/
  case 102: enter_store( 2); break;   /*{ Leather       }*/
  case 103: enter_store( 3); break;   /*{ Weapons       }*/
  case 104: enter_store( 4); break;   /*{ Temple        }*/
  case 105: enter_store( 5); break;   /*{ Drug Store    }*/
  case 106: enter_store( 6); break;   /*{ Curio Store   }*/
  case 107: enter_store( 7); break;   /*{ Black Market  }*/
  case 108: enter_store( 8); break;   /*{ Cafeteria     }*/
  case 109: enter_store( 9); break;   /*{ Pro Shop      }*/
  case 110: enter_store(10); break;   /*{ Computer      }*/
  case 111: enter_store(11); break;   /*{ Guild         }*/

  case 201: enter_inn();     break;   /*{ Hotel Desk    }*/
  case 202: enter_bank();    break;   /*{ Bank Teller   }*/
  case 203: enter_clinic();  break;   /*{ Health Clinic }*/
  case 204: newsinc();       break;   /*{ Lotto         }*/

  case 112:                           /*{ Building      }*/
    office_char_row = char_row;
    office_char_col = char_col;
    exited_office = true;
    dun_level = -1;
    moria_flag = true;
    msg_print("You climb the front steps and enter a large lobby.");
    break;
//////////////////////////////////////////////////////////////////////
  default:
    msg_print("You see a 'Space for Rent' sign.");
    break;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE traps.c */
