/* treasure.c */
/**/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
static boolean mt__magik(integer chance)
{
  /*{ Boolean : is object enchanted }*/

  boolean return_value;

  if (randint(100) <= chance) {
    return_value = true;
  } else {
    return_value = false;
  }

  return return_value;
};
//////////////////////////////////////////////////////////////////////
static void mt__inc_damage(treasure_type *item, char *dice, integer amount)
{
  integer  num,sides,i1;

  for (i1 = 0; dice[i1]; i1++) {
    if (dice[i1] == 'd') {
      dice[i1] = ' ';
    }
  }

  num   = 0;
  sides = 0;
  sscanf(dice,"%ld %ld",&num,&sides);

  i1 = num*amount;

  if ((i1 > 9) && (sides > 99)) {
    i1 = 9;
  } else if ((i1 > 99) && (sides > 9)) {
    i1 = 99;
  }
  sprintf(dice,"%ldd%ld", i1,sides);
};
//////////////////////////////////////////////////////////////////////
static integer mt__m_bonus(integer base, integer max_std, integer power)
{
  /*{ Enchant a bonus based on degree desired   }*/

  integer   x,stand_dev, m_bonus;

  stand_dev = lesser(max_std,
		     trunc(OBJ_STD_ADJ*power) + OBJ_STD_MIN);

  x = trunc(abs(randnor(0,stand_dev))/10.0) + base;

  if (x < base) {
    m_bonus = base;
  } else {
    m_bonus = x;
  }

  return m_bonus;
};

//////////////////////////////////////////////////////////////////////
static void mt_get_chances(integer *power,   integer *chance, 
			   integer *special, integer *unique,
			   integer *cursed)
{
  if (*power == 999) {  /*{black market stuff}*/
    *chance  = 100;
    *special = 70;
    *unique  =  0;
    *cursed  =  0;
    *power  = 40;
  } else if (*power == 777) {  /*{beginning character inventory}*/
    *chance  = 50;
    *special = 10;
    *unique  =  0;
    *cursed  =  0;
    *power  =  5;
  } else {
    *chance  = lesser(OBJ_BASE_MAX, OBJ_BASE_MAGIC + *power);
    *special = *chance/OBJ_DIV_SPECIAL;
    *unique  = *chance/OBJ_DIV_UNIQUE;
    *cursed  = *chance/OBJ_DIV_CURSED;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__armor_and_shields(treasure_type *item, integer power,
			   integer chance, integer special, 
			   integer unique, integer cursed)
{
  //{ Armor and shields}
  if (mt__magik(chance)) {
    item->toac += mt__m_bonus(1,30,power);

    if (mt__magik(special)) {
      switch ( randint(12) ) {
      case 1: 
	item->flags |= 0x023C0000;
	strcat(item->name, " (Resist)");
	item->toac += 5;
	item->cost += 3500;
	break;

      case 2:
	item->flags |= 0x00100000;
	strcat(item->name, " (RA)");
	item->cost += 1000;
	break;

      case 3: case 4:
	item->flags |= 0x00080000;
	strcat(item->name, " (RF)");
	item->cost += 600;
	break;

      case 5: case 6:
	item->flags |= 0x00200000;
	strcat(item->name, " (RC)");
	item->cost += 600;
	break;

      case 7:
	item->flags |= 0x02000000;
	strcat(item->name, " (RL)");
	item->cost += 500;
	break;

      case 8:
	item->flags |= 0x00040000;
	strcat(item->name, " (RG)");
	item->cost += 1000;
	break;

      case 9:
	item->toac += 15;
	strcat(item->name, " (P)");
	item->weight = trunc(item->weight*1.50);
	break;

      case 10:
	item->tohit += mt__m_bonus(1,40,power);
	strcat(item->name, " (%P2) (CR)");
	item->weight = trunc(item->weight*0.75);
	break;

      case 11: case 12:
	strcat(item->name, " (W)");
	item->cost += item->weight*20;
	item->weight = 1;
	break;
      }
    } else if (mt__magik(unique)) {
      switch  (randint(4)) {
      case 1:
	strcat(item->name, " (Qwethleg)");
	item->ac += 10;
	item->toac += 10;
	item->tohit += mt__m_bonus(5,40,power);
	item->cost += 1000 + item->tohit*100;
	break;

      case 2:
	strcat(item->name, " (Fi-Yoh)");
	item->toac += mt__m_bonus(2,40,power);
	item->p1   += mt__m_bonus(1,30,power);
	//{Wisdom and Regeneration}
	item->flags |= 0x00000810;
	item->cost += 2000 + item->p1*200;
	break;

      case 3:
	strcat(item->name, " (Jarth)");
	item->toac += mt__m_bonus(2,40,power);
	item->p1 += mt__m_bonus(1,30,power);
	//{Dexterity and Resistance}
	item->flags |= 0x02380002;
	item->cost += 2500 + item->p1*200;
	break;
                                
      case 4:
	strcat(item->name, " (?????)");
	item->cost *= 10;
	break;
      }    
    }
  } else if (mt__magik(cursed)) {
    item->toac = -mt__m_bonus(1,40,power);
    item->cost = 0;
    item->flags |= 0x80000000;
  }
};

//////////////////////////////////////////////////////////////////////
void mt__weapons(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  //{ Weapons   }

  if (mt__magik(chance)) {
    
    item->tohit += mt__m_bonus(0,40,power);
    item->todam += mt__m_bonus(0,40,power);
    
    if (mt__magik(special)) {
      switch (randint(18)) {
      case 1:   
	/*{ Str,KS,KM,See-Invis}*/
	item->flags |= 0x01018001;
	item->tohit += 5;
	item->todam += 5;
	item->toac  += randint(4);
	item->p1     = 1 + randint(4);
	strcat(item->name, " (%P1) (HA)");
	item->cost  += item->p1*500;
	item->cost  += 10000;
	break;

      case 2 :  
	/*{Stl,Regen,See-Invis,FeatherFall}*/
	item->flags |= 0x05000900;
	item->tohit += 3;
	item->todam += 3;
	item->toac  += 5 + randint(5);
	strcat(item->name, " [%P4] (DF)");
	item->p1     = randint(3);
	item->weight = trunc(item->weight*1.25);
	item->cost  += item->p1*500;
	item->cost  += 7000;
	break;
                                
      case 3: case 4: 
	item->flags |= 0x00004000;
	item->tohit += 3;
	item->todam += 3;
	strcat(item->name, " (KC)");
	item->cost += 5000;
	break;
                                
      case 5: case 6: 
	item->flags |= 0x00002000;
	item->tohit += 3;
	item->todam += 3;
	strcat(item->name, " (KA)");
	item->cost += 4000;
	break;

      case 7: case 8: 
	item->flags |= 0x00008000;
	item->tohit += 3;
	item->todam += 3;
	strcat(item->name, " (KS)");
	item->cost += 4000;
	break;

      case 9: case 10 : 
	item->flags |= 0x00010000;
	item->tohit += 2;
	item->todam += 2;
	strcat(item->name, " (KM)");
	item->cost += 3000;
	break;
                                
      case 11: case 12 : 
	item->flags |= 0x00080000;
	item->tohit += 1;
	item->todam += 3;
	strcat(item->name, " (KR)");
	item->cost += 3500;
	break;

      case 13: case 14: 
	item->flags |= 0x00040000;
	item->tohit += 1;
	item->todam += 3;
	strcat(item->name, " (FT)");
	item->cost += 2000;
	break;
                                
      case 15: case 16:   
	item->flags |= 0x00020000;
	item->tohit += 1;
	item->todam += 3;
	strcat(item->name, " (FB)");
	item->cost += 2000;
	break;
        
      case 17 : 
	item->todam += 20;
	strcat(item->name, " (DST)");
	item->cost += 5000;
	item->weight = trunc(item->weight*1.5);
	break;

      case 18 : 
	/*{See-Invis}*/
	item->flags |= 0x01000000;
	strcat(item->name, "  :)");
	item->cost *= 2;
	break;
      }

    } else if (mt__magik(unique)) {
      switch (randint(3)) {
      case 1: case 2:
	mt__inc_damage(item,item->damage,2);
	strcat(item->name, " (Slicer)");
	item->cost *= 2;
	break;
      case 3: 
	mt__inc_damage(item,item->damage,4);
	strcat(item->name, " (Razor)");
	item->cost *= 4;
	break;
      }
    }
  } else if (mt__magik(cursed)) {
    item->tohit  = -mt__m_bonus(1,55,power);
    item->todam  = -mt__m_bonus(1,55,power);
    item->flags |= 0x80000000;
    item->cost = 0;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__guns(treasure_type *item, integer power,
	      integer chance, integer special, 
	      integer unique, integer cursed)
{
  /*{ Guns, Automatic Guns  }*/
  
  if (mt__magik(chance)) {
    item->tohit += mt__m_bonus(1,30,power);
  } else if (mt__magik(cursed)) {
    item->tohit = -mt__m_bonus(1,50,power);
    item->flags |= 0x80000000;
    item->cost = 0;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__thrown(treasure_type *item, integer power,
		integer chance, integer special, 
		integer unique, integer cursed)
{
  /* { Thrown  } */

  item->number = randint(4)+1;

  if (mt__magik(chance)) {
    item->tohit += mt__m_bonus(1,30,power);
    item->todam += mt__m_bonus(1,30,power);
  } else if (mt__magik(cursed)) {
    item->tohit  = -mt__m_bonus(1,50,power);
    item->flags |= 0x80000000;
    item->cost = 0;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__gernades(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  integer i1;

  /*{ Grenades  }*/
  if (mt__magik(chance)) {
    item->todam += mt__m_bonus(1,30,power);
  }
  item->number = 0;
  for (i1 = 1; i1 <= 3 ; i1++) {
    item->number += randint(2);
  }
};
//////////////////////////////////////////////////////////////////////
void mt__digging_tools(treasure_type *item, integer power,
		       integer chance, integer special, 
		       integer unique, integer cursed)
{
  /*{ Digging tools }*/
  if (mt__magik(chance)) {
    switch (randint(3)) {
    case 1: case 2:
      item->p1 = mt__m_bonus(2,25,power);
      item->cost += item->p1*100;
      break;
      
    case 3 :
      item->p1 = -mt__m_bonus(1,30,power);
      item->cost = 0;
      item->flags |= 0x80000000;
      break;
    }
  }
};
//////////////////////////////////////////////////////////////////////
void mt__gloves_and_gauntlets(treasure_type *item, integer power,
			      integer chance, integer special, 
			      integer unique, integer cursed)
{

  /* { Gloves and Gauntlets  }*/
  if (mt__magik(chance)) {

    item->toac += mt__m_bonus(1,20,power);

    if (mt__magik(special)) {
      switch (randint(4)) {
      case 1: case 2  :
	item->tohit += 1 + randint(3);
	item->todam += 1 + randint(3);
	strcat(item->name, " of Slaying");
	break;

      case 3  :
	item->flags |= 0x00800000;
	strcat(item->name, " of Free Action");
	item->cost += 1000;
	break;

      case 4  :
	/*{Dex,Stealth}*/
	item->flags |= 0x00000102;
	item->p1 = mt__m_bonus(1,30,power);
	strcat(item->name, " of Thievery");
	item->cost += item->p1*500;
	break;
      }
    }
  } else if (mt__magik(cursed)) {
    if (mt__magik(special)) {
      switch (randint(2)) {
      case 1 : 
	item->flags |= 0x80000002;
	strcat(item->name, " of Clumsiness");
	item->p1 = 1;
	break;

      case 2 : 
	item->flags |= 0x80000001;
	strcat(item->name, " of Weakness");
	item->p1 = 1;
	break;
      }
    }
    item->toac   = -mt__m_bonus(1,40,power);
    item->p1     = -mt__m_bonus(1,10,power);
    item->flags |= 0x80000000;
    item->cost = 0;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__boots(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  /*{ Boots }*/
  if (mt__magik(chance)) {
    item->toac += mt__m_bonus(1,20,power);

    if (mt__magik(special)) {
      switch (randint(12)) {
      case 1 : 
	item->flags |= 0x00001000;
	strcat(item->name, " of Speed");
	item->p1 = 1;
	item->cost += 5000;
	break;
	
      case 2: case 3: case 4: case 5: 
	item->flags |= 0x00000100;
	strcat(item->name, " of Stealth");
	item->cost += 500;
	break;
	
      default:
	item->flags |= 0x04000000;
	strcat(item->name, " of Slow decent");
	item->cost += 250;
	break;
      }
    }

  } else if (mt__magik(cursed)) {

    switch (randint(3)) {
    case 1 : 
      item->flags |= 0x80001000;
      strcat(item->name, " of Slowness");
      item->p1 = -1;
      break;

    case 2 : 
      item->flags |= 0x80000200;
      strcat(item->name, " of Noise");
      break;

    case 3 : 
      item->flags |= 0x80000000;
      strcat(item->name, " of Great Mass");
      item->weight = item->weight*5;
      break;
    }
    item->cost = 0;
    item->ac = -mt__m_bonus(2,45,power);
  }
};

//////////////////////////////////////////////////////////////////////
void mt__helms(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{

  /* { Helms }*/
  if (mt__magik(chance)) {

    item->toac += mt__m_bonus(1,20,power);
    if (mt__magik(special)) {
      switch (item->subval) {
      case 1: case 2: case 3: case 4: case 5:  
	switch (randint(3)) {
	case 1 : 
	  item->p1 = randint(2);
	  item->flags |= 0x00000008;
	  strcat(item->name, " (%P1) of Intelligence");
	  item->cost += item->p1*500;
	  break;
	case 2 : 
	  item->p1 = randint(2);
	  item->flags |= 0x00000010;
	  strcat(item->name, " (%P1) of Wisdom");
	  item->cost += item->p1*500;
	  break;
	case 3 : 
	  item->p1 = 1 + randint(4);
	  item->flags |= 0x40000000;
	  strcat(item->name, " (%P1) of Infra-Vision");
	  item->cost += item->p1*250;
	  break;
	}
	break;
      case 6: case 7: case 8:
	switch (randint(6)) {  /*{ Crowns }*/
	case 1 : 
	  item->p1 = randint(3);
	  /*{STR,CON,DEX,Free Action}*/
	  item->flags |= 0x00800007;
	  strcat(item->name, " (%P1) of Might");
	  item->cost += 1000 + item->p1*500;
	  break;
	case 2 : 
	  item->p1 = randint(3);
	  item->flags |= 0x00000030;
	  strcat(item->name, " (%P1) of Lordliness");
	  item->toac += randint(10);
	  item->cost += 1000 + item->p1*500;
	  break;
	case 3 : 
	  item->p1 = randint(3);
	  item->flags |= 0x01380008;
	  strcat(item->name, " (%P1) of Jarwangia");
	  item->cost += 3000 + item->p1*500;
	  break;
	case 4 : 
	  item->p1 = randint(3);
	  item->flags |= 0x00000020;
	  strcat(item->name, " (%P1) of Beauty");
	  item->cost += 750;
	  break;
	case 5 : 
	  item->p1 = 1 + randint(4);
	  item->flags |= 0x01000040;
	  strcat(item->name, " (%P1) of Seeing");
	  item->cost += 1000 + item->p1*100;
	  break;
	case 6 : 
	  item->flags |= 0x00000800;
	  strcat(item->name, " of Regeneration");
	  item->cost += 1500;
	  break;
	}
      }
    }
  } else if (mt__magik(cursed)) {
    
    item->toac   = -mt__m_bonus(1,45,power);
    item->flags |= 0x80000000;
    item->cost   = 0;
    if (mt__magik(special)) {
      switch (randint(7)) {
      case 1 : 
	item->p1 = -1;
	item->flags |= 0x00000008;
	strcat(item->name, " of Stupidity");
	break;
      case 2 : 
	item->p1 = -1;
	item->flags |= 0x00000010;
	strcat(item->name, " of Dullness");
	break;
      case 3 : 
	item->flags |= 0x08000000;
	strcat(item->name, " of Blindness");
	break;
      case 4 : 
	item->flags |= 0x10000000;
	strcat(item->name, " of Timidness");
	break;
      case 5 : 
	item->p1 = -1;
	item->flags |= 0x00000001;
	strcat(item->name, " of Weakness");
	break;
      case 6 : 
	item->flags |= 0x00000400;
	strcat(item->name, " of Teleportation");
	break;
      case 7 : 
	item->p1 = -1;
	item->flags |= 0x00000020;
	strcat(item->name, " of Ugliness");
	break;
      }
    }
    item->p1 *= randint(5);
  }
};


//////////////////////////////////////////////////////////////////////
void mt__rings(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  /* { Rings } */
  switch (item->subval) {
  case 1: case 2: case 3: case 4: case 5: case 6:   
    if (mt__magik(cursed)) {
      item->p1 = -mt__m_bonus(1,20,power);
      item->flags |= 0x80000000;
      item->cost *= -1;
    } else {
      item->p1 = mt__m_bonus(1,10,power);
      item->cost += item->p1*100;
    }
    break;

  case 7 :
    if (mt__magik(cursed)) {  /*{Speed}*/
      item->p1 = -randint(3);
      item->flags |= 0x80000000;
      item->cost *= -1;
    } else {
      item->p1 = mt__m_bonus(1,30,power);
      item->cost += item->p1*item->p1*10000;
    }
    break;

  case 8  :  
    item->p1 = mt__m_bonus(1,20,power);
    item->cost += item->p1*100;
    break;

  case 22 :  /* { Increase damage   }*/
    item->todam += mt__m_bonus(1,20,power);
    if (mt__magik(cursed)) {
      item->todam *= -1;
      item->flags |= 0x80000000;
      item->cost  *= -1;
    }
    break;

  case 23 :  /* { Increase To-Hit   }*/
    item->tohit += mt__m_bonus(1,20,power);
    item->cost  += item->tohit*100;
    if (mt__magik(cursed)) {
      item->tohit *= -1;
      item->flags |= 0x80000000;
      item->cost *= -1;
    }
    break;

  case 24 :  /*  { Protection    }*/
    item->toac += mt__m_bonus(1,20,power);
    if (mt__magik(cursed)) {
      item->toac *= -1;
      item->flags |= 0x80000000;
      item->cost *= -1;
    }
    break;

  case 33 :  /*  { Slaying   }*/
    item->tohit += mt__m_bonus(1,25,power);
    item->todam += mt__m_bonus(1,25,power);
    if (mt__magik(cursed)) {
      item->tohit *= -1;
      item->todam *= -1;
      item->flags |= 0x80000000;
      item->cost *= -1;
    }
    break;

  default:
    break;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__amulets(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  /* { Amulets   }*/
  if (mt__magik(cursed)) {
    item->p1 = -mt__m_bonus(1,20,power);
    item->flags |= 0x80000000;
    item->cost *= -1;
  } else {
    item->p1 = mt__m_bonus(1,10,power);
    item->cost += item->p1*100;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__lamps_and_torches(treasure_type *item, integer power,
			   integer chance, integer special, 
			   integer unique, integer cursed)
{
  /*{ Light sources -- Subval should be even for store, odd for dungeon
    Dungeon found ones will be partially charged    }*/

  if ((item->subval % 2) == 1) {
    item->p1 = randint(item->p1);
  }
};
//////////////////////////////////////////////////////////////////////
void mt__ray_guns(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  /* { Ray Guns }*/
  switch (item->subval) {
  case 1: case 2   :                    item->p1 = randint(9)  +  6; break;
  case 3           :                    item->p1 = randint(5)  +  6; break;
  case 4           :                    item->p1 = randint(8)  +  6; break;
  case 5           :                    item->p1 = randint(4)  +  3; break;
  case 6           :                    item->p1 = randint(8)  +  6; break;
  case 7: case 8   :                    item->p1 = randint(20) + 12; break;
  case 9: case 10  :                    item->p1 = randint(11) +  6; break;
  case 11          :                    item->p1 = randint(10) + 12; break;
  case 12          :                    item->p1 = randint(3)  +  3; break;
  case 13 : case 14:                    item->p1 = randint(9)  +  6; break;
  case 15: case 16 :                    item->p1 = randint(5)  +  3; break;
  case 17: case 18 :                    item->p1 = randint(5)  +  5; break;
  case 19: case 20: case 21  :          item->p1 = randint(8)  +  4; break;
  case 22:                              item->p1 = randint(24) + 12; break;
  case 23: case 24: case 25: case 26:   item->p1 = randint(9)  +  5; break;
  default:                              item->p1 = randint(10) +  2; break;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__devices(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  /*{ Devices    }*/
  switch (item->subval) {
  case 1   :                   item->p1 = randint(20) + 12; break;
  case 2   :                   item->p1 = randint(8)  +  6; break;
  case 3   :                   item->p1 = randint(5)  +  6; break;
  case 4   :                   item->p1 = randint(20) + 12; break;
  case 5   :                   item->p1 = randint(15) +  6; break;
  case 6: case 7   :           item->p1 = randint(4)  +  4; break;
  case 8: case 9: case 10  :   item->p1 = randint(3)  +  1; break;
  case 11  :                   item->p1 = randint(5)  +  6; break;
  case 12  :                   item->p1 = randint(10) + 12; break;
  case 13: case 14: case 15  : item->p1 = randint(5)  +  6; break;
  case 16  :                   item->p1 = randint(10) + 12; break;
  case 17  :                   item->p1 = randint(3)  +  4; break;
  case 18: case 19  :          item->p1 = randint(5)  +  6; break;
  case 20  :                   item->p1 = randint(3)  +  4; break;
  case 21  :                   item->p1 = randint(10) + 12; break;
  case 22: case 23  :          item->p1 = randint(3)  +  4; break;
  case 24  :                   item->p1 = randint(3)  +  1; break;
  case 25  :                   item->p1 = randint(10) +  6; break;
  default:                     item->p1 = randint(10) +  2; break;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__cloaks(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  /*{ Cloaks    }*/
  if (mt__magik(chance)) {
    if (mt__magik(special)) {
      switch (randint(2)) {
      case 1      : 
	strcat(item->name, " of Protection");
	item->toac += mt__m_bonus(2,40,power);
	item->cost += 250;
	break;
      case 2      : 
	item->toac += mt__m_bonus(1,20,power);
	item->p1 = randint(3);
	item->flags |= 0x00000100;
	strcat(item->name, " of Stealth (%P1)");
	item->cost += item->p1*500;
	break;
      }
    } else {
      item->toac += mt__m_bonus(1,20,power);
    }
  } else if (mt__magik(cursed)) {
    switch (randint(3)) {
    case 1 : 
      item->flags |= 0x80000200;
      strcat(item->name, " of Irritation");
      item->ac   =  0;
      item->toac  = -mt__m_bonus(1,10,power);
      item->tohit = -mt__m_bonus(1,10,power);
      item->todam = -mt__m_bonus(1,10,power);
      item->cost =  0;
      break;
    case 2 : 
      item->flags |= 0x80000000;
      strcat(item->name, " of Vulnerability");
      item->ac   = 0;
      item->toac = -mt__m_bonus(10,100,power+50);
      item->cost = 0;
      break;
    case 3 : 
      item->flags |= 0x80000000;
      strcat(item->name, " of Enveloping");
      item->toac  = -mt__m_bonus(1,10,power);
      item->tohit = -mt__m_bonus(2,40,power+10);
      item->todam = -mt__m_bonus(2,40,power+10);
      item->cost = 0;
      break;
    }
  }
};
//////////////////////////////////////////////////////////////////////
void mt__chests(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  /* { Chests    }*/
  switch (randint(power)+4) {
  case 1  : 
    strcat(item->name, "^ (Empty)");
    break;
  case 2  : 
    item->flags |= 0x00000001;
    strcat(item->name, "^ (Locked)");
    break;
  case 3: case 4       : 
    item->flags |= 0x00000011;
    strcat(item->name, "^ (Poison Needle)");
    break;
  case 5: case 6       : 
    item->flags |= 0x00000021;
    strcat(item->name, "^ (Poison Needle)");
    break;
  case 7: case 8: case 9     : 
    item->flags |= 0x00000041;
    strcat(item->name, "^ (Gas Trap)");
    break;
  case 10: case 11     : 
    item->flags |= 0x00000081;
    strcat(item->name, "^ (Explosion Device)");
    break;
  case 12: case 13: case 14  : 
    item->flags |= 0x00000101;
    strcat(item->name, "^ (Summoning Runes)");
    break;
  case 15: case 16: case 17  : 
    item->flags |= 0x00000071;
    strcat(item->name, "^ (Multiple Traps)");
    break;
  default:
    item->flags |= 0x00000181;
    strcat(item->name, "^ (Multiple Traps)");
    break;
  }
};
//////////////////////////////////////////////////////////////////////
  void mt__ammo_and_spikes(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  integer   i1;

  obj_set ten_to_twelve = {10,11,12,0};
  obj_set eleven_to_twelve = {11,12,0};

  /*      { Gun ammo and spikes}*/
  item->number = 0;
  for (i1 = 1 ; i1 <= 7 ; i1++) {
    item->number += randint(6);
  }  
  
  if (is_in(item->tval,ten_to_twelve)) {
    if (mt__magik(chance)) {
      item->tohit += mt__m_bonus(1,35,power);
      item->todam += mt__m_bonus(1,35,power);
      if ((mt__magik(special)) && (is_in(item->tval,eleven_to_twelve))) {
	switch (randint(12)) {
	case 1: case 2: case 3 :
	  strcat(item->name, "(high density)");
	  item->tohit += 5;
	  item->todam += 5;
	  item->cost += 20;
	  break;
	case 4: case 5   :
	  /*{Flame}*/
	  item->flags |= 0x00040000;
	  item->tohit += 2;
	  item->todam += 4;
	  strcat(item->name, "(explosive)");
	  item->cost += 25;
	  break;
	case 6: case 7   :
	  item->flags |= 0x00008000;
	  item->tohit += 3;
	  item->todam += 3;
	  strcat(item->name, " of Scum Killing");
	  item->cost += 25;
	  break;
	case 8: case 9   :
	  item->flags |= 0x00004000;
	  item->tohit += 2;
	  item->todam += 2;
	  strcat(item->name, " of Creature Killing");
	  item->cost += 30;
	  break;
	case 10: case 11 :
	  item->flags |= 0x00080000;
	  item->tohit += 5;
	  item->todam += 10;
	  strcat(item->name, " of Robot Slaying");
	  item->cost += 30;
	  break;
	case 12    :
	  item->flags |= 0x00002000;
	  item->tohit += 7;
	  item->todam += 7;
	  strcat(item->name, " of Alien Slaying");
	  item->cost += 35;
	  break;
	}
      }
    }
  } else if (is_in(item->tval,ten_to_twelve) && (mt__magik(cursed))) {
    item->tohit = -mt__m_bonus(5,55,power);
    item->todam = -mt__m_bonus(5,55,power);
    item->flags |= 0x80000000;
    item->cost = 0;
  }
};
//////////////////////////////////////////////////////////////////////
void mt__coupons(treasure_type *item, integer power,
		 integer chance, integer special, 
		 integer unique, integer cursed)
{
  /* {Coupons} */
  switch (randint(6)) {
  case 1: case 2: case 3: item->p1 = 20; break;
  case 4: case 5:         item->p1 = 30; break;
  case 6:                 item->p1 = 40; break;
  }
  if (mt__magik(special)) {
    item->p1 += 30;
  }
};
//////////////////////////////////////////////////////////////////////
void magic_treasure(treasure_type *item, integer power)
{
  integer    chance,special,unique,cursed;
  obj_set    multies = {9,10,11,12,13,82,84,0};

  mt_get_chances(&power, &chance, &special, &unique, &cursed);

  //{ Depending on treasure type, it can have certain magical properties}
  switch (item->tval) {
  case 34: case 35: case 36:
    mt__armor_and_shields(item, power, chance, special, unique, cursed);
    break;

  case 21: case 23:
    mt__weapons(item, power, chance, special, unique, cursed);
    break;

  case 19: case 20:
    mt__guns(item, power, chance, special, unique, cursed);
    break;

  case 82: 
    mt__thrown(item, power, chance, special, unique, cursed);
    break;

  case 84:
    mt__gernades(item, power, chance, special, unique, cursed);
    break;
    
  case 25: 
    mt__digging_tools(item, power, chance, special, unique, cursed);
    break;
    
  case 31:
    mt__gloves_and_gauntlets(item, power, chance, special, unique, cursed);
    break;
    
  case 30:
    mt__boots(item, power, chance, special, unique, cursed);
    break;
    
  case 33: 
    mt__helms(item, power, chance, special, unique, cursed);
    break;
    
  case 45: 
    mt__rings(item, power, chance, special, unique, cursed);
    break;
    
  case 40:
    mt__amulets(item, power, chance, special, unique, cursed);
    break;
    
  case 15:
    mt__lamps_and_torches(item, power, chance, special, unique, cursed);
    break;
    
  case 65:
    mt__ray_guns(item, power, chance, special, unique, cursed);
    break;
    
  case 55:
    mt__devices(item, power, chance, special, unique, cursed);
    break;
    
  case 32:
    mt__cloaks(item, power, chance, special, unique, cursed);
    break;
    
  case 2: 
    mt__chests(item, power, chance, special, unique, cursed);
    break;

  case 9: case 10: case 11: case 12: case 13:
    mt__ammo_and_spikes(item, power, chance, special, unique, cursed);
    break;

  case 3:
    mt__coupons(item, power, chance, special, unique, cursed);
    break;
    
  default:
    break;
  }

  //{Multiple Number Types.  Need to adjust subval.}

  if (is_in(item->tval, multies)) {
    missle_ctr++;
    if (missle_ctr > 65534) {
      missle_ctr = 1;
    }
    item->subval = missle_ctr + 512;
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

/* END FILE treasure.c */
