/* trick.c */
/*{ play a trick }*/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void trick_effects(integer effect, integer y, integer x)
{
  integer   dir, dumy, y_dumy, x_dumy;

  y_dumy = y;
  x_dumy = x;

  switch (effect) {
  case 1  : 
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_bolt(0,dir,char_row,char_col,
		damroll("2d4")+1,"Spit Ball");
    }
    break;
    
  case 2  :  detect_monsters();
    break;
    
    break;
    
  case 3  :  teleport(10);
    break;
    
  case 4  :  light_area(char_row,char_col);
    break;
    
  case 5  :  hp_player(damroll("4d4"),"a magic spell.");
    break;
    
  case 6  :  
    detect_sdoor();
    detect_trap();
    break;

  case 7  :  
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_ball(2,dir,char_row,char_col,7,2,false,"Stinking Gas");
    }
    break;
    
  case 8  :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      confuse_monster(dir,char_row,char_col);
    }
    break;
    
  case 9 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_bolt(1,dir,char_row,char_col,
		damroll("3d6")+1,"Terrible Insult");
    }
    break;
    
  case 10 :  td_destroy();
    break;
    
  case 11 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      sleep_monster(dir,char_row,char_col);
    }
    break;
    
  case 12 :  cure_poison();
    break;
    
  case 13 :  teleport(py.misc.lev*4);
    break;
    
  case 14 :  remove_curse();
    break;
    
  case 15 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_bolt(4,dir,char_row,char_col,
		damroll("4d6")+1,"Sharp Ice Cube");
    }
    break;
    
  case 16 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      wall_to_mud(dir,char_row,char_col);
    }
    break;
    
  case 17 :  ident_spell();
    break;
    
  case 18 :  recharge(16);
    break;
    
  case 19 :  sleep_monsters2_3(char_row,char_col,1);
    break;
    
  case 20 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      poly_monster(dir,char_row,char_col);
    }
    break;
    
  case 21 :  create_food();
    break;
    
  case 22 :  sleep_monsters2_3(char_row,char_col,20);
    break;
    
  case 23 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_bolt(5,dir,char_row,char_col,
		damroll("6d6")+1,"Roman Candle");
    }
    break;
    
  case 24 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      speed_monster(dir,char_row,char_col,-2);              
    }
    break;
    
  case 25 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_ball(4,dir,char_row,char_col,
		damroll("6d4")+1,2,false,"Deadly Ice Cubes");
    }
    break;
    
  case 26 :  recharge(40);
    break;
    
  case 27 :  
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      teleport_monster(dir,char_row,char_col);
    }
    break;
    
  case 28 :  
    //with py.flags do
    PF.fast += randint(20) + py.misc.lev*2;
    break;

  case 29 :
    if (get_dir("Which direction?",&dir,&dumy,&y_dumy,&x_dumy)) {
      fire_ball(5,dir,char_row,char_col,
		damroll("7d5")+1,2,false,"Blazing Inferno");
    }
    break;
    
  case 30 :  destroy_area(char_row,char_col);
    break;
    
  case 31 :  genocide();
    break;

  default:
    break;
  }
};
//////////////////////////////////////////////////////////////////////
void use_con_skills()
{
  integer   i1,i2,item_val;
  integer   choice,chance;
  integer   y_dumy,x_dumy;
  boolean   redraw;
  obj_set   cddr = {92};	

  reset_flag = true;

  if (py.flags.blind > 0) {
    msg_print("Help me, I'm blind!");
  } else if (no_light()) {
    msg_print("Look buddy, no light, no read, got it?");
  } else if (py.flags.confused > 0) {
    msg_print("Your mind is way too messed up right now...");
  } else if (py.misc.pskill == 5 || py.misc.pskill == 6) {
    if (inven_ctr > 0) {
      if (find_range(cddr,&i1,&i2)) {
	redraw = false;
	if (get_item(&item_val,"Use which con-manual?",&redraw,i1,i2)) {
	  if (use_skill("Try which trick?",item_val,&choice,&chance,&redraw)) {
	    //with skill_list[choice]. do;
	    reset_flag = false;
	    if (randint(100) < chance) {
	      msg_print("You are not very convincing!");
	    } else {
	      y_dumy = char_row;
	      x_dumy = char_col;
	      trick_effects(choice, y_dumy, x_dumy);
	      if (!reset_flag) {
		//with py.misc do;
		PM.exp += skill_list[choice].sexp;
		prt_experience();
		skill_list[choice].sexp = 0;
	      }
	    }
	    
	    //with py.misc do;
	    if (!reset_flag) {
	      if (skill_list[choice].smana > PM.cmana) {
		msg_print("You start to stutter!");
		py.flags.paralysis =
		  randint(5*trunc(skill_list[choice].smana-PM.cmana));
		PM.cmana = 0;
		if (randint(3) == 1) {
		  msg_print("You have damaged your reputation!");
		  py.stat.cchr = de_statp(py.stat.cchr);
		  prt_charisma();
		}
	      } else {
		PM.cmana -= skill_list[choice].smana;
	      }
	      prt_mana();
	    }
	    if (randint(10) == 1) {
	      reset_flag = true;  
	    }
	  } else {
	    if (redraw) { draw_cave(); }
	  }
	}
      } else {
	msg_print("But you are not carrying any con-manuals!");
      }
    } else {
      msg_print("But you are not carrying any con-manuals!");
    }
  } else {
    msg_print("You aren't tricky enough to confuse a tourist!");
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE trick.c */
