/* types.h */
/* The global types for boss */

typedef unsigned char byteint;          // [byte] 0..255
typedef	signed char bytlint;            // [byte] -128..127;
typedef	unsigned short wordint;		// [word] 0..65535;
typedef	short worlint;		        // [word] -32768..32767;

typedef	long            word;
typedef unsigned char   boolean;
typedef long            integer;
typedef float           real;

typedef struct quad_type
{
  unsigned short l0;
  unsigned short l1;
} quad_type;

typedef char atype[16+2];
typedef char btype[14+2];
typedef char ctype[28+2];
typedef char dtype[5+2];
typedef char etype[60+2];
typedef	char mtype[190+2];
typedef	char ntype[1024+2];
typedef	char ttype[68+2];
typedef	char utype[100+2];
typedef	char vtype[80+2];
typedef	char tentype[10+2];
typedef	char string[132+2];
typedef char stat_type[6+2]; //	= packed array [1..6] of char;
typedef	byteint obj_set[MAX_OBJ_SET];       	// = set of 0..255;
//	char_set	= set of 'A'..'z';
typedef	char stat_set;	// = 0..5;
typedef	char usernam_type[12+2]; // packed array [1..12] of char;

/***********************************************************************/

/*
typedef struct recj
{
  word unamelen;
  word jpi__username;
  usernam_type ptr_uname;
  integer ptr_unamelen;
  integer endlist;
} recj;
*/

/*
typedef struct key_type // { For char saver        }
{            
  ntype   file_id;
  integer seed;
} key_type;
*/

typedef struct creature_type
{
  ctype      name;       //{ Descrip of creature   }
  unsigned   cmove;      //{ Bit field             }
  unsigned   spells;     //{ Creature spells       }
  unsigned   cdefense;   //{ Bit field             }
  worlint    sleep;      //{ Inactive counter      }
  wordint    mexp;       //{ Exp value for kill    }
  byteint    aaf;        //{ Area affect radius    }
  byteint    ac;         //{ AC                    }
  bytlint    speed;      //{ Movement speed        }
  integer    reprod;	 //{ Reproduction Amount   }
  integer    size;	 //{ Relative Size         }
  integer    tt;  	 //{ Treasure Type -- Tval }
  integer    intel;      //{ Creature's Int  0-50  }
  integer    speaks;	 //{ Speaking Type?        }
  char       cchar;      //{ Character rep.        }
  dtype      hd;         //{ Creatures hit die     }
  etype      damage;     //{ Type attack and damage}
  byteint    level;      //{ Level of creature     }
} creature_type;

typedef struct monster_type
{
  worlint    hp;        //{ Hit points            }
  worlint    csleep;    //{ Inactive counter      }
  worlint    cdis;      //{ Cur dis from player   }
  wordint    mptr;      //{ Pointer into creature }
  wordint    nptr;      //{ Pointer to next block }
  bytlint    cspeed;    //{ Movement speed        }
                        //{ Note: FY and FX constrain dungeon size to 255 }
  byteint    fy;        //{ Y Pointer into map    }
  byteint    fx;        //{ X Pointer into map    }
 
  bytlint    stuned;    //{ Rounds stunned}
  boolean    ml;        //{ On if shown   }
  boolean    confused;  //{ On if confused}
  byteint    cur_reprod;//{ Current reproduction factor}
} monster_type;


typedef struct treasure_type
{
  utype    name;        //{ Object name           }
  byteint    tval;      //{ Catagory number       }
  char    tchar;         //{ Character representation}
  unsigned    flags;     //{ Special flags         }
  integer    p1;      //{ Misc. use variable    }
  integer    cost;      //{ Cost of item          }
  integer    subval;      //{ Sub-catagory number   }
  wordint    weight;      //{ Weight                }
  wordint    number;      //{ Number of items       }
  worlint    tohit;      //{ Pluses to hit         }
  worlint    todam;      //{ Pluses to damage      }
  worlint    ac;      //{ Normal AC             }
  worlint    toac;      //{ Pluses to AC          }
  dtype    damage;        //{ Damage when hits      }
  bytlint    level;      //{ Level item found      }
} treasure_type;


typedef struct p_misc
{
  vtype    name;        //{ Name of character }
  vtype    race;        //{ Race of character }
  vtype    sex;        //{ Sex of character }
  vtype    title;        //{ Character's title }
  vtype    tclass;        //{ Character's class }
  integer    max_exp;      //{ Max experience}
  integer    exp;      //{ Cur experienc }
  integer    au;      //{ Gold }
  wordint    age;      //{ Characters age}
  wordint    ht;      //{ Height }
  wordint    wt;      //{ Weight }
  wordint    lev;      //{ Level }
  wordint    max_lev;      //{ Max level explored}
  worlint    srh;      //{ Chance in search}
  worlint    perc;     //{ Perception }
  worlint    bth;      //{ Base to hit }
  worlint    bthb;      //{ BTH with bows }
  worlint    mana;      //{ Mana points }
  worlint    mhp;      //{ Max hit pts }
  worlint    ptohit;      //{ Pluses to hit }
  worlint    ptodam;      //{ Pluses to dam }
  worlint    pac;      //{ Total AC }
  worlint    ptoac;      //{ Magical AC }
  worlint    dis_th;      //{ Display +ToHit}
  worlint    dis_td;      //{ Display +ToDam}
  worlint    dis_ac;      //{ Display +ToAC }
  worlint    dis_tac;      //{ Display +ToTAC}
  worlint    disarm;      //{ % to Disarm }
  worlint    wierd;	//{ Wierd Devices}
  worlint    save;      //{ Saving throw }
  worlint    sc;      //{ Social Class }
  byteint    pclass;      //{ # of class }
  byteint    prace;      //{ # of race }
  byteint    pskill;	//{ skill#  ie: 1=scientist}
                        //{ 2=soldier, 0=none      }
  byteint    hitdie;      //{ Char hit die }
  bytlint    stl;      //{ Stealth factor}
  real    expfact;         //{ Experience factor}
  real    cmana;         //{ Cur mana pts }
  real    chp;         //{ Cur hit pts }
  vtype   history[5]; //array [1..5] of vtype;{ History record}

  time_t          creation_time;  // used as key in master file
  integer         save_count;     // compared to master file value
} p_misc;


typedef struct p_stat
{
  byteint    str;      //{ Max strength        }
  byteint    cstr;     //{ Current strength    }
  byteint    dex;      //{ Max dexterity       }
  byteint    cdex;     //{ Current dexterity   }
  byteint    con;      //{ Max constitution    }
  byteint    ccon;     //{ Current constitution}
  byteint    int_;     //{ Max intelligence    }
  byteint    cint;     //{ Current intelligence}
  byteint    wis;      //{ Max wisdom          }
  byteint    cwis;     //{ Current wisdom      }
  byteint    chr;      //{ Max charisma        }
  byteint    cchr;     //{ Current charisma    }
} p_stat;

typedef struct p_flags
{
  unsigned   status;           //{ Status of player    }
  integer    rest;             //{ Rest counter        }
  integer    blind;            //{ Blindness counter   }
  integer    paralysis;        //{ Paralysis counter   }
  integer    confused;         //{ Confusion counter   }
  integer    food;             //{ Food counter        }
  integer    food_digested;    //{ Food per round      }
  integer    protection;       //{ Protection fr. evil }
  integer    speed;            //{ Cur speed adjust    }
  integer    fast;             //{ Temp speed change   }
  integer    slow;             //{ Temp speed change   }
  integer    afraid;           //{ Fear                }
  integer    poisoned;         //{ Poisoned            }
  integer    image;            //{ Halucinate          }
  integer    protevil;         //{ Protect VS evil     }
  integer    invuln;           //{ Increases AC        }
  integer    hero;             //{ Heroism             }
  integer    shero;            //{ Super Heroism       }
  integer    blessed;          //{ Blessed             }
  integer    resist_heat;      //{ Timed heat resist   }
  integer    resist_cold;      //{ Timed cold resist   }
  integer    ring_blast;       //{ Fire/Frost Rings    }
  integer    special;	       //{ Special Abilities   }
  integer    petrified;	       //{ been stoned lately? }
  integer    diseased;	       //{ various ailments    }
  integer    detect_inv;       //{ Timed see invisible }
  integer    word_recall;      //{ Timed teleport level}
  integer    see_infra;        //{ See warm creatures  }
  integer    tim_infra;        //{ Timed infra vision  }
  boolean    see_inv;          //{ Can see invisible   }
  boolean    teleport;         //{ Random teleportation}
  boolean    free_act;         //{ Never paralyzed     }
  boolean    slow_digest;      //{ Lower food needs    }
  boolean    aggravate;        //{ Agravate monsters   }
  boolean    fire_resist;      //{ Resistance to fire  }
  boolean    cold_resist;      //{ Resistance to cold  }
  boolean    acid_resist;      //{ Resistance to acid  }
  boolean    regenerate;       //{ Regenerate hit pts  }
  boolean    lght_resist;      //{ Resistance to light }
  boolean    ffall;            //{ No damage falling   }
  boolean    sustain_str;      //{ Keep strength       }
  boolean    sustain_int;      //{ Keep intelligence   }
  boolean    sustain_wis;      //{ Keep wisdom         }
  boolean    sustain_con;      //{ Keep constitution   }
  boolean    sustain_dex;      //{ Keep dexterity      }
  boolean    sustain_chr;      //{ Keep charisma       }
  boolean    confuse_monster;  //{ Glowing hands...    }
  boolean    resist_gas;       //{ Duh                 }
} p_flags;

typedef struct player_type
{
  p_misc   misc;
  p_stat   stat;
  p_flags  flags;
} player_type;

typedef struct skill_type	// {Values in skill_values.inc}
{
  ctype      sname;
  byteint    slevel;
  byteint    smana;
  wordint    sexp;
  byteint    sfail;
  boolean    learned;
} skill_type;


typedef struct spl_rec
{
  integer splnum;
  integer splchn;
} spl_rec;


typedef spl_rec spl_type[22+1]; // = array [1..22] of spl_rec;


typedef struct race_type
{
  vtype      trace;   //{ Type of race }
  bytlint    str_adj; //{ adjustments }
  bytlint    int_adj;
  bytlint    wis_adj;
  bytlint    dex_adj;
  bytlint    con_adj;
  bytlint    chr_adj;
  wordint    b_age;  //{ Base age of character }
  wordint    m_age;  //{ Maximum age of character }
  wordint    m_b_ht; //{ base height for males }
  wordint    m_m_ht; //{ mod height for males       }
  wordint    m_b_wt; //{ base weight for males      }
  wordint    m_m_wt; //{ mod weight for males       }
  wordint    f_b_ht; //{ base height females        }
  wordint    f_m_ht; //{ mod height for females     }
  wordint    f_b_wt; //{ base weight for female     }
  wordint    f_m_wt; //{ mod weight for females     }
  real       b_exp;  //{ Base experience factor     }
  bytlint    b_dis;  //{ base chance to disarm      }
  bytlint    bsrh;   //{ base chance for search     }
  bytlint    bstl;   //{ Stealth of character       }
  bytlint    bperc;  //{ frequency of auto search   }
  bytlint    bbth;   //{ adj base chance to hit     }
  bytlint    bbthb;  //{ adj base to hit with bows  }
  bytlint    bwierd; //{ Race base for wierd device }
  bytlint    bsav;   //{ Race base for saving throw }
  bytlint    bhitdie;//{ Base hit points for race   }
  bytlint    binfra; //{ See infra-red              }
  unsigned   tclass; //{ Bit field for class types }
} race_type;


typedef struct class_type
{
  vtype      title;   //{ type of class }
  real       m_exp;   //{ Class experience factor }
  bytlint    adj_hd;  //{ Adjust hit points }
  bytlint    mdis;    //{ mod disarming traps }
  bytlint    msrh;    //{ modifier to searching }
  bytlint    mstl;    //{ modifier to stealth }
  bytlint    mperc;   //{ modifier to freq-of-search  }
  bytlint    mbth;    //{ modifier to base to hit     }
  bytlint    mbthb;   //{ modifier to base to hit - bows}
  bytlint    mwierd;  //{ Class modifier for wierd devices}
  bytlint    msav;    //{ Class modifier to save      }
  bytlint    madj_str;//{ Class modifier for strength}
  bytlint    madj_int;//{ Class modifier for intelligence}
  bytlint    madj_wis;//{ Class modifier for wisdom   }
  bytlint    madj_dex;//{ Class modifier for dexterity}
  bytlint    madj_con;//{ Class modifier for constitution}
  bytlint    madj_chr;//{ Class modifier for charisma}
  byteint    skill_no;//{ Class Skill Number.  0=none}
                      //{ 1=sci, 2=sold, 3=guru, 4=wanderer, }
                      //{ 5=con-artist, 6=thief}
} class_type;


typedef struct background_type
{
  vtype      info;  //{ History information         }
  byteint    roll;  //{ Die roll needed for history }
  byteint    chart; //{ Table number                }
  bytlint    next;  //{ Pointer to next table       }
  bytlint    bonus; //{ Bonus to the Social Class   }
} background_type;

typedef struct floor_type
{
  byteint ftval;   //  : [bit(7),pos(0)] 0..15;
  boolean ftopen;  //  : [bit(1),pos(7)] boolean;
} floor_type;


typedef struct cave_type
{
  byteint    cptr;
  byteint    tptr;
  byteint    fval;
  boolean    fopen;
  boolean    fm;
  boolean    pl;
  boolean    tl;
} cave_type;

typedef cave_type row_floor[MAX_WIDTH+1]; //array [1..max_width] of cave_type

typedef struct owner_type
{
  vtype     owner_name;
  byteint   beg_effect;
  real      buy_inflate;
  real      sell_deflate;
  byteint   owner_class;
} owner_type;

typedef struct inven_record
{
  integer        scost;
  treasure_type  sitem;
} inven_record;

typedef struct store_type
{
  worlint      store_open;
  byteint      owner;       //{now just a dummy variable}
  bytlint      insult_cur;
  byteint      store_ctr;
  inven_record store_inven[STORE_INVEN_MAX+1];
} store_type;

typedef struct town_type
{
  atype    town_name;
  integer  max_depth;
  byteint  lev_plus;
} town_type;

/* needs to be a multiple of 8 */
#define ENCRYPT_STAT_BUF_SIZE 1024
typedef struct encrypt_state
{
  byteint     des_key[8];
  byteint     des_ivec[8];
  boolean     doit;

  boolean     got_eof;                 /* out of bytes and hit eof         */
  int         buf_pos;                 /* for read/write, current position */
  int         buf_size;                /* for reading, bytes in buffer     */
  char        data_buf[ENCRYPT_STAT_BUF_SIZE+8];
} encrypt_state;

typedef struct master_key
{
  time_t      creation_time;
} master_key;

typedef struct master_entry
{
  integer     save_count;
  integer     deaths;
  time_t      updated;
} master_entry;

/* END FILE  types.h */
