/* wizard.c */
/**/

#include "boss.h"

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void toggle_wizard_mode()
{
  if (wizard) {
    msg_print("Wizard mode off.");
    wizard = false;
    no_controly();
  } else {
    if (validuser) {
      msg_print("Wizard mode on.");
      controly();
      wizard = true;
    } else {
      wizard = check_pswd();
      if (wizard) {
	msg_print("Don't do the tan van plan, man.");
	controly();
      } else {
	/*{poor sap}*/
	aggravate_monster(30);
	prt("Type '?' for help...",1,1);
      }
    }
  }
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
boolean check_pswd()
{
  /*{ Function returns true if proper password is given.   -RLG }*/

  integer  i1;
  char     x;
  char     tpw[13];  //   : packed array [1..12] of char;
  boolean  flag = false;
 
  i1 = 0;
  strcpy(tpw, "            ");
  prt("Password : ",1,1);
  do {
    x = inkey();
    switch (x) {
    case 10 :
    case 13 :
      break;
    default : 
      tpw[i1++] = x;
      break;
    }
  } while (!((i1 == 12) || (x == 13) || (x == 10)));
    
  tpw[i1]   = 0;

  if (!strcmp(tpw, GURGLE)) { flag = true; }
  msg_flag = false;
  erase_line(msg_line,msg_line);

  return flag;
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void game_version()
{
  /* { Print Moria credits } */

  /* why is this in the wizard code? */

  vtype    tmp_str;

clear_from(1);
prt("  BOSS : Beyond Moria",1,1);
prt("Version 0.1  : 11/13/90",2,1);
prt("Version 1.0  : 05/01/91",3,1);
prt("Version 2.0  : 03/01/92",4,1);
prt("Robert L. Gulledge                 Jason E. Black",5,1);
prt("raoul@u.washington.edu             cloister@u.washington.edu",6,1);
prt("Univ. of Washington                Univ. of Washington",7,1);
prt("Moria Modules :",8,1);
prt("     V1.0  Dungeon Generator      - RAK",9,1);
prt("           Character Generator    - RAK & JWT",10,1);
prt("           Moria Module           - RAK",11,1);
prt("           Miscellaneous          - RAK & JWT",12,1);
prt("     V2.0  Town Level & Misc      - RAK",13,1);
prt("     V3.0  Internal Help & Misc   - RAK",14,1);
prt("     V4.0  Source Release Version - RAK",15,1);
prt("Robert Alan Koeneke               Jimmey Wayne Todd Jr.",17,1);
prt("Student/University of Oklahoma    Student/University of Oklahoma",18,1);
prt("119 Crystal Bend                  1912 Tiffany Dr.",19,1);
prt("Norman, OK 73069                  Norman, OK  73071",20,1);
prt("(405)-321-2925                    (405) 360-6792",21,1);

        pause_game(24);
	clear_from(1);


  sprintf(tmp_str,"          Linux Boss Version %3.1f, patch level %d",
	  CUR_VERSION, PATCH_LEVEL);
prt(tmp_str,1,1);
prt("Version 2.4 : ??/??/00       Finished porting from pascal" ,3,1);
prt(" "                                                         ,4,1);
prt("Linux port by Stephen Kertes, 1999-2000."                  ,5,1);
prt(" "                                                         ,6,1);
prt(" "                                                         ,7,1);
prt("Random stuff taken from Imoria 4.85"                       ,8,1);
prt("Terminal code taken from umoria 5.5"                       ,9,1);
prt("                                        "                  ,10,1);
#if USE_MTWIST
prt("Boss uses the `Mersenne Twister' random number library"    ,11,1);
prt("Copyright (C) 1997 Makoto Matsumoto and Takuji Nishimura." ,12,1);
prt("This library is covered by the GNU Library GPL version 2." ,13,1);
prt("See the file mtwist/COPYING for more information."         ,14,1);
#endif  

        pause_game(24);
        draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void force_wierdness()
{
  integer i1, tmp1; 
  vtype   out_val;

  tmp1 = query_max_wierd();
  prt_num("Which One (0-",tmp1,1,1);
  prt(") ? ",1,16);
  get_string(out_val,1,20,3);
  i1 = -1;
  sscanf(out_val,"%ld",&i1);
  if (i1 >= 0 && i1 <= tmp1) {
    random_wierdness(i1,true);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void wizard_alloc_object()
{
  alloc_object(floor_set,5,10);
  draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void wizard_exp()
{
  py.misc.exp = trunc(1.5*py.misc.exp);
  if (py.misc.exp <= 1) { py.misc.exp = 2; }
  prt_experience();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void wizard_summon()
{
  integer   y,x;

  y = char_row;
  x = char_col;
  summon_monster(&y,&x,true);
  creatures(false);
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void really_heal_character()
{
  remove_curse();
  cure_blindness();
  cure_confusion();
  cure_poison();
  remove_fear();
  py.misc.chp = py.misc.mhp;
  //with py.stat do;
  PS.cstr = PS.str;  PS.cint = PS.int_; PS.cwis = PS.wis;
  PS.cdex = PS.dex;  PS.ccon = PS.con;  PS.cchr = PS.chr;
  zero_pyflag();
  prt_stat_block();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void beckon_creature()
{
  integer monster,y,x;
  vtype   tmp_str;         

  prt_num("Summon Which Creature (1-",max_creatures,1,1); 
  prt(") ? ",1,29);
  get_string(tmp_str,1,33,4);
  monster = atoi(tmp_str);
  if (monster > 0) {
    do {
      y = char_row + randint(10) - 5;
      x = char_col + randint(10) - 5;
    } while ((cave[y][x].cptr == 0) && (cave[y][x].fopen));
    place_monster(y,x,monster,true);
    creatures(false);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void wizard_light()
{
  /*{ Light up the dungeon                                  -RAK-   }*/

  integer  i1,i2,i3,i4;
  boolean  flag;

  if (cave[char_row][char_col].pl) {
    flag = false;
  } else {
    flag = true;
  }

  for (i1 = 1; i1 <= cur_height; i1++) {
    for (i2 = 1; i2 <= cur_width; i2++) {
      if (is_in(cave[i1][i2].fval, floor_set)) {
	for (i3 = i1-1; i3 <= i1+1; i3++) {
	  for (i4 = i2-1; i4 <= i2+1; i4++) {
	    //with cave[i3][i4]. do;
	    cave[i3][i4].pl = flag;
	    if (!flag) {
	      cave[i3][i4].fm = false;
	    }
	  }
	}
      }
    }
  }
  
  draw_cave();
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void identify_all()
{
  integer i1;

  msg_print("All items identified, master.");
  for (i1 = 1; i1 <= INVEN_MAX; i1++) {
    unquote(inventory[i1].name);
    known1(inventory[i1].name);
    known2(inventory[i1].name);
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void do_mon_out (integer moncode)
{
  /*{Displays a particular monster's "character sheet" -NBT}*/

  vtype    nbt_out_val, attstr, attx;
  integer  cur_line, a_type, adesc;
  dtype    damstr;
  char    *otw, *achar, this_bites[2];

   clear_from(1);
   //with c_list[moncode]. do;

   prt (c_list[moncode].name,1,1);
   prt ("Screen Code:",1,60);
   sprintf(this_bites, "%c", c_list[moncode].cchar);
   prt (this_bites,1,72);
   prt_num ("Cur. Creature Number:",moncode,1,30);
   prt_num ("Speed =",c_list[moncode].speed,2,3);
   prt_num ("Level =",c_list[moncode].level,2,13);
   prt_num ("Exp =",c_list[moncode].mexp,2,24);
   prt_num ("AC =",c_list[moncode].ac,2,36);
   prt_num ("Eye-sight =",c_list[moncode].aaf,2,44);
   sprintf(nbt_out_val, "HD = %s", c_list[moncode].hd);
   prt (nbt_out_val,2,58);
   cur_line = 5;

   if (uand(0x80000000,c_list[moncode].cmove) != 0) {
     cur_line = 7;
     prt ("This creature is a ***Win Creature***",3,20);
   }

   if (uand(0x00080000,c_list[moncode].cmove) != 0) {
     prt("Creature eats/kills other creatures.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x0001,c_list[moncode].cdefense) != 0) {
     prt("Creature is an Alien.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x0002,c_list[moncode].cdefense) != 0) {
     prt("Creature is a Creature.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x0004,c_list[moncode].cdefense) != 0) {
     prt("Creature is Scum.",((cur_line + 1) div 2),(41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x0008,c_list[moncode].cdefense) != 0) {
     prt("Creature is a Mutant.",((cur_line + 1) div 2),(41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x0010,c_list[moncode].cdefense) != 0) {
     prt("Creature harmed by cold.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x0020,c_list[moncode].cdefense) != 0) {
     prt("Creature harmed by fire.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x0040,c_list[moncode].cdefense) != 0) {
     prt("Creature harmed by poison.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x0080,c_list[moncode].cdefense) != 0) {
     prt("Creature harmed by acid.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x0100,c_list[moncode].cdefense) != 0) {
     prt("Creature harmed by blue light.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x0200,c_list[moncode].cdefense) != 0) {
     prt("Creature harmed by erosion",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x1000,c_list[moncode].cdefense) != 0) {
     prt("Creature can't be charmed/slept.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x2000,c_list[moncode].cdefense) != 0) {
     prt("Creature seen with Infra-Vision.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x4000,c_list[moncode].cdefense) != 0) {
     prt("hit points",2,69);
     prt("Creature has MAX hit points",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if ((cur_line % 2) == 0) { cur_line++; }

   if (uand(0x00010000,c_list[moncode].cmove) != 0) {
     prt("Creature is invisible.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00100000,c_list[moncode].cmove) != 0) {
     prt("Creature picks up objects.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00200000,c_list[moncode].cmove) != 0) {
     prt("Creature multiplies.",((cur_line + 1) div 2),(41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x01000000,c_list[moncode].cmove) != 0) {
     prt("Creature carries objects.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x02000000,c_list[moncode].cmove) != 0) {
     prt("Creature carries gold, gems, etc.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x04000000,c_list[moncode].cmove) != 0) {
     prt("Has object/gold 60% of time.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x08000000,c_list[moncode].cmove) != 0) {
     prt("Has object/gold 90% of time.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x10000000,c_list[moncode].cmove) != 0) {
     prt("Has 1d2 object(s)/gold.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x20000000,c_list[moncode].cmove) != 0) {
     prt("Has 2d2 object(s)/gold.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x40000000,c_list[moncode].cmove) != 0) {
     prt("Has 4d2 object(s)/gold.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if ((cur_line % 2) == 0) { cur_line++; }
   
   prt("--- Creature Skills ---",((cur_line + 1) div 2),1);
   cur_line += 2;
   sprintf(nbt_out_val, "    Uses skills 1 out of every %d turns.",
	   (int)(uand(0xF,c_list[moncode].spells)));
   prt(nbt_out_val,((cur_line + 1) div 2),1);
   cur_line += 2;

   if (uand(0x00000010,c_list[moncode].spells) != 0) {
     prt("Can teleport short.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00000020,c_list[moncode].spells) != 0) {
     prt("Can teleport long.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00000040,c_list[moncode].spells) != 0) {
     prt("Teleport player to itself.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00000080,c_list[moncode].spells) != 0) {
     prt("Cause light wounds.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00000100,c_list[moncode].spells) != 0) {
     prt("Cause serious wounds.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00000200,c_list[moncode].spells) != 0) {
     prt("Hold person.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00000400,c_list[moncode].spells) != 0) {
     prt("Cause blindness.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00000800,c_list[moncode].spells) != 0) {
     prt("Cause confusion.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00001000,c_list[moncode].spells) != 0) {
     prt("Cause fear.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00002000,c_list[moncode].spells) != 0) {
     prt("Summon a creature.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00004000,c_list[moncode].spells) != 0) {
     prt("Summon a mutant.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00008000,c_list[moncode].spells) != 0) {
     prt("Slow person.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00010000,c_list[moncode].spells) != 0) {
     prt("Drains resources for healing.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00020000,c_list[moncode].spells) != 0) {
     prt("**Unknown spell value**",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00040000,c_list[moncode].spells) != 0) {
     prt("**Unknown spell value**",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00080000,c_list[moncode].spells) != 0) {
     prt("Breathes Lightning Breath.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00100000,c_list[moncode].spells) != 0) {
     prt("Breathes Gas Breath.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00200000,c_list[moncode].spells) != 0) {
     prt("Breathes Acid Breath.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00400000,c_list[moncode].spells) != 0) {
     prt("Breathes Frost Breath.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00800000,c_list[moncode].spells) != 0) {
     prt("Breathes Fire Breath.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if ((cur_line % 2) == 0) { cur_line++; }

   prt("-- Movement:",((cur_line + 1) div 2),1);
   cur_line += 2;

   if (uand(0x00000001,c_list[moncode].cmove) != 0) {
     prt("Moves only to attack.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }

   if (uand(0x00000002,c_list[moncode].cmove) != 0) {
     prt("Moves and attacks normally.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00000008,c_list[moncode].cmove) != 0) {
     prt("20% random movement.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00000010,c_list[moncode].cmove) != 0) {
     prt("40% random movement.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00000020,c_list[moncode].cmove) != 0) {
     prt("75% random movement.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00020000,c_list[moncode].cmove) != 0) {
     prt("Can open doors.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if (uand(0x00040000,c_list[moncode].cmove) != 0) {
     prt("Can phase through walls.",((cur_line + 1) div 2),
	 (41 - 40*(cur_line % 2)));
     cur_line++;
   }
   
   if ((cur_line % 2) == 0) { cur_line++; }
   prt("-- Creature attacks:",((cur_line + 1) div 2),1);
   cur_line += 2;

   strcpy(attstr, c_list[moncode].damage);

   for ( ; attstr[0] != 0 ; ) {

     if ( cur_line > 2*22 ) {
       pause_game(24);
       clear_from(3);
       cur_line = 2*4;
     }

     achar = strchr(attstr,'|');
     if (achar != NULL) {
       strcpy(attx, attstr);
       achar = strchr(attx, '|');
       (*achar) = 0;
       achar++;
       strcpy(attstr, achar);
     } else {
       strcpy(attx, attstr);
       attstr[0] = 0;
     }

     sscanf(attx, "%ld %ld %s", &a_type, &adesc, damstr);
    
     switch (a_type) {
     case  1: otw = "normal damage.";                 break;// Normal attack  
     case  2: otw = "lowering strength.";             break;// Poison Strength
     case  3: otw = "confusion.";                     break;// Confusion attack
     case  4: otw = "fear.";                          break;// Fear attack    
     case  5: otw = "fire damage.";                   break;// Fire attack    
     case  6: otw = "acid damage.";                   break;// Acid attack    
     case  7: otw = "cold damage.";                   break;// Cold attack    
     case  8: otw = "lightning damage.";              break;// Lightning attack
     case  9: otw = "corrosion damage.";              break;// Corrosion attack
     case 10: otw = "blindness.";                     break;// Blindness attack
     case 11: otw = "paralyzation.";                  break;// Paralysis attack
     case 12: otw = "stealing money.";                break;// Steal Money    
     case 13: otw = "stealing object.";               break;// Steal Object   
     case 14: otw = "poison damage.";                 break;// Poison         
     case 15: otw = "lose dexterity.";                break;// Lose Dex       
     case 16: otw = "lose constitution.";             break;// Lose Con       
     case 17: otw = "lose intelligence.";             break;// Lose Int       
     case 18: otw = "lose wisdom.";                   break;// Lose Wis       
     case 19: otw = "lose experience.";               break;// Lose Exp       
     case 20: otw = "aggravates monsters.";           break;// Aggravation    
     case 21: otw = "disenchants objects.";           break;// Disenchant     
     case 22: otw = "eating food.";                   break;// Eats food      
     case 23: otw = "eating light source.";           break;// Eats light     
     case 24: otw = "absorbing charges.";             break;// Eats charges   
     case 25: otw = "losing strength and experience"; break;// Vampire Bite 
     case 26: otw = "turning to stone.";              break;// Turn to Stone  
     case 27: otw = "sucking your brain out.";        break;// Mind Flayer    
     case 28: otw = "NightMare blindness.";           break;// Hell Horse     
     case 29: otw = "draining max hit points.";       break;// Vargouille     
     case 30: otw = "causes disease.";                break;// Diseases       
     case 31: otw = "lose charisma.";                 break;// Lose Charisma  
     case 99: otw = "blank message.";                 break;// Special        
     default: otw = "**Unknown value**";              break;// ???
     }

     sprintf(nbt_out_val, "It %sfor %s (%s)",attack_desc[adesc],otw,damstr);
     prt(nbt_out_val,((cur_line + 1) div 2),1);
     cur_line += 2;
   }
   pause_game(24);
   draw_cave();
};
//////////////////////////////////////////////////////////////////////
void mon_info()
{
  /*{Displays info about monsters -NBT}*/

  char     choice = ' ';
  boolean  quitflag = true;
  integer  howmany,i,j,moncode,aux_code;
  vtype    namestr,dummy;

  do {
    if (get_com("Enter creature code for information, "
		"? for the list, or <Esc> to abort: ",&choice)) {
      quitflag = false;
      if (choice == '?') {
	do_all_mons();
      }
    }
  } while (! ((choice != '?') || quitflag));

  if (!quitflag) {
    clear_from(1);
    howmany = 0;
    for (i = 1; i <= max_creatures; i++) {
      if (c_list[i].cchar == choice) {
	howmany++;;
      }
    }
    if (howmany == 0) {
      prt ("That character is not used for any creatures.",12,1);
      pause_game(24);
      draw_cave();
    } else {
      if (howmany == 1) {
	for (i = 1; i <= max_creatures; i++) {
	  if (c_list[i].cchar == choice) { 
	    moncode = i;
	  }
	}
	do_mon_out(moncode);
      } else {
	/*{ there's more than one creature in the list using that code }*/
	howmany = 0;
	j = 1;
	
	for (i = 1; i <= max_creatures; i++) {
	  if (c_list[i].cchar == choice) {
	    sprintf(namestr, "    %s                       ",c_list[i].name);
	    prt(namestr,(4+(howmany div 2)),(1+(40*(howmany % 2))));
	    prt_num ( "",j,(4+(howmany div 2)),(1+40*(howmany % 2)));
	    howmany++;
	    j++;
	  }
	}
	
	do {
	  erase_line(msg_line,msg_line);
	  msg_print("Enter the number for your choice:");
	  get_string(dummy,1,36,10);
	  aux_code = atoi(dummy);
	} while (! ((aux_code > 0) && (aux_code <= howmany)) );
	
	howmany = 0;
	i = 0;
	
	for( ;  howmany != aux_code ; ) {
	  i++;
	  if (c_list[i].cchar == choice) {
	    howmany++;
	  }
	}
	
	moncode = i;
	do_mon_out(moncode);
      }
    }
  }
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
/* END FILE wizard.c */
